// Generated by Futhark 0.22.0
// git: ed22762 (Sat Jan 15 01:09:59 2022 +0100)

// We need to define _GNU_SOURCE before
// _any_ headers files are imported to get
// the usage statistics of a thread (i.e. have RUSAGE_THREAD) on GNU/Linux
// https://manpages.courier-mta.org/htmlman2/getrusage.2.html
#ifndef _GNU_SOURCE // Avoid possible double-definition warning.
#define _GNU_SOURCE
#endif

#ifdef __clang__
#pragma clang diagnostic ignored "-Wunused-function"
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wparentheses"
#pragma clang diagnostic ignored "-Wunused-label"
#elif __GNUC__
#pragma GCC diagnostic ignored "-Wunused-function"
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wparentheses"
#pragma GCC diagnostic ignored "-Wunused-label"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif

// Headers\n")
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdio.h>
#include <float.h>

#ifdef __cplusplus
extern "C" {
#endif

// Initialisation
struct futhark_context_config;
struct futhark_context_config *futhark_context_config_new(void);
void futhark_context_config_free(struct futhark_context_config *cfg);
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int flag);
struct futhark_context;
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg);
void futhark_context_free(struct futhark_context *ctx);
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t param_value);
int futhark_get_tuning_param_count(void);
const char *futhark_get_tuning_param_name(int);
const char *futhark_get_tuning_param_class(int);

// Arrays
struct futhark_f32_2d;
struct futhark_f32_2d *futhark_new_f32_2d(struct futhark_context *ctx, const
                                          float *data, int64_t dim0,
                                          int64_t dim1);
struct futhark_f32_2d *futhark_new_raw_f32_2d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0,
                                              int64_t dim1);
int futhark_free_f32_2d(struct futhark_context *ctx,
                        struct futhark_f32_2d *arr);
int futhark_values_f32_2d(struct futhark_context *ctx,
                          struct futhark_f32_2d *arr, float *data);
unsigned char *futhark_values_raw_f32_2d(struct futhark_context *ctx,
                                         struct futhark_f32_2d *arr);
const int64_t *futhark_shape_f32_2d(struct futhark_context *ctx,
                                    struct futhark_f32_2d *arr);

// Opaque values


// Entry points
int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f32_2d **out0, const
                       struct futhark_f32_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5);

// Miscellaneous
int futhark_context_sync(struct futhark_context *ctx);
char *futhark_context_report(struct futhark_context *ctx);
char *futhark_context_get_error(struct futhark_context *ctx);
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f);
void futhark_context_pause_profiling(struct futhark_context *ctx);
void futhark_context_unpause_profiling(struct futhark_context *ctx);
int futhark_context_clear_caches(struct futhark_context *ctx);
#define FUTHARK_BACKEND_c

#ifdef __cplusplus
}
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>
#include <stdint.h>
// If NDEBUG is set, the assert() macro will do nothing. Since Futhark
// (unfortunately) makes use of assert() for error detection (and even some
// side effects), we want to avoid that.
#undef NDEBUG
#include <assert.h>
#include <stdarg.h>
// Start of util.h.
//
// Various helper functions that are useful in all generated C code.

#include <errno.h>
#include <string.h>

static const char *fut_progname = "(embedded Futhark)";

static void futhark_panic(int eval, const char *fmt, ...) __attribute__((noreturn));
static char* msgprintf(const char *s, ...);
static void* slurp_file(const char *filename, size_t *size);
static int dump_file(const char *file, const void *buf, size_t n);
struct str_builder;
static void str_builder_init(struct str_builder *b);
static void str_builder(struct str_builder *b, const char *s, ...);

static void futhark_panic(int eval, const char *fmt, ...) {
  va_list ap;
  va_start(ap, fmt);
  fprintf(stderr, "%s: ", fut_progname);
  vfprintf(stderr, fmt, ap);
  va_end(ap);
  exit(eval);
}

// For generating arbitrary-sized error messages.  It is the callers
// responsibility to free the buffer at some point.
static char* msgprintf(const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = 1 + (size_t)vsnprintf(NULL, 0, s, vl);
  char *buffer = (char*) malloc(needed);
  va_start(vl, s); // Must re-init.
  vsnprintf(buffer, needed, s, vl);
  return buffer;
}

static inline void check_err(int errval, int sets_errno, const char *fun, int line,
                            const char *msg, ...) {
  if (errval) {
    char errnum[10];

    va_list vl;
    va_start(vl, msg);

    fprintf(stderr, "ERROR: ");
    vfprintf(stderr, msg, vl);
    fprintf(stderr, " in %s() at line %d with error code %s\n",
            fun, line,
            sets_errno ? strerror(errno) : errnum);
    exit(errval);
  }
}

#define CHECK_ERR(err, ...) check_err(err, 0, __func__, __LINE__, __VA_ARGS__)
#define CHECK_ERRNO(err, ...) check_err(err, 1, __func__, __LINE__, __VA_ARGS__)

// Read the rest of an open file into a NUL-terminated string; returns
// NULL on error.
static void* fslurp_file(FILE *f, size_t *size) {
  long start = ftell(f);
  fseek(f, 0, SEEK_END);
  long src_size = ftell(f)-start;
  fseek(f, start, SEEK_SET);
  unsigned char *s = (unsigned char*) malloc((size_t)src_size + 1);
  if (fread(s, 1, (size_t)src_size, f) != (size_t)src_size) {
    free(s);
    s = NULL;
  } else {
    s[src_size] = '\0';
  }

  if (size) {
    *size = (size_t)src_size;
  }

  return s;
}

// Read a file into a NUL-terminated string; returns NULL on error.
static void* slurp_file(const char *filename, size_t *size) {
  FILE *f = fopen(filename, "rb"); // To avoid Windows messing with linebreaks.
  if (f == NULL) return NULL;
  unsigned char *s = fslurp_file(f, size);
  fclose(f);
  return s;
}

// Dump 'n' bytes from 'buf' into the file at the designated location.
// Returns 0 on success.
static int dump_file(const char *file, const void *buf, size_t n) {
  FILE *f = fopen(file, "w");

  if (f == NULL) {
    return 1;
  }

  if (fwrite(buf, sizeof(char), n, f) != n) {
    return 1;
  }

  if (fclose(f) != 0) {
    return 1;
  }

  return 0;
}

struct str_builder {
  char *str;
  size_t capacity; // Size of buffer.
  size_t used; // Bytes used, *not* including final zero.
};

static void str_builder_init(struct str_builder *b) {
  b->capacity = 10;
  b->used = 0;
  b->str = malloc(b->capacity);
  b->str[0] = 0;
}

static void str_builder(struct str_builder *b, const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = (size_t)vsnprintf(NULL, 0, s, vl);

  while (b->capacity < b->used + needed + 1) {
    b->capacity *= 2;
    b->str = realloc(b->str, b->capacity);
  }

  va_start(vl, s); // Must re-init.
  vsnprintf(b->str+b->used, b->capacity-b->used, s, vl);
  b->used += needed;
}

// End of util.h.
// Start of half.h.

// Conversion functions are from http://half.sourceforge.net/, but
// translated to C.
//
// Copyright (c) 2012-2021 Christian Rau
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

#ifndef __OPENCL_VERSION__
#define __constant
#endif

__constant static const uint16_t base_table[512] = {
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0002, 0x0004, 0x0008, 0x0010, 0x0020, 0x0040, 0x0080, 0x0100,
  0x0200, 0x0400, 0x0800, 0x0C00, 0x1000, 0x1400, 0x1800, 0x1C00, 0x2000, 0x2400, 0x2800, 0x2C00, 0x3000, 0x3400, 0x3800, 0x3C00,
  0x4000, 0x4400, 0x4800, 0x4C00, 0x5000, 0x5400, 0x5800, 0x5C00, 0x6000, 0x6400, 0x6800, 0x6C00, 0x7000, 0x7400, 0x7800, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8001, 0x8002, 0x8004, 0x8008, 0x8010, 0x8020, 0x8040, 0x8080, 0x8100,
  0x8200, 0x8400, 0x8800, 0x8C00, 0x9000, 0x9400, 0x9800, 0x9C00, 0xA000, 0xA400, 0xA800, 0xAC00, 0xB000, 0xB400, 0xB800, 0xBC00,
  0xC000, 0xC400, 0xC800, 0xCC00, 0xD000, 0xD400, 0xD800, 0xDC00, 0xE000, 0xE400, 0xE800, 0xEC00, 0xF000, 0xF400, 0xF800, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00 };

__constant static const unsigned char shift_table[512] = {
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13 };

__constant static const uint32_t mantissa_table[2048] = {
  0x00000000, 0x33800000, 0x34000000, 0x34400000, 0x34800000, 0x34A00000, 0x34C00000, 0x34E00000, 0x35000000, 0x35100000, 0x35200000, 0x35300000, 0x35400000, 0x35500000, 0x35600000, 0x35700000,
  0x35800000, 0x35880000, 0x35900000, 0x35980000, 0x35A00000, 0x35A80000, 0x35B00000, 0x35B80000, 0x35C00000, 0x35C80000, 0x35D00000, 0x35D80000, 0x35E00000, 0x35E80000, 0x35F00000, 0x35F80000,
  0x36000000, 0x36040000, 0x36080000, 0x360C0000, 0x36100000, 0x36140000, 0x36180000, 0x361C0000, 0x36200000, 0x36240000, 0x36280000, 0x362C0000, 0x36300000, 0x36340000, 0x36380000, 0x363C0000,
  0x36400000, 0x36440000, 0x36480000, 0x364C0000, 0x36500000, 0x36540000, 0x36580000, 0x365C0000, 0x36600000, 0x36640000, 0x36680000, 0x366C0000, 0x36700000, 0x36740000, 0x36780000, 0x367C0000,
  0x36800000, 0x36820000, 0x36840000, 0x36860000, 0x36880000, 0x368A0000, 0x368C0000, 0x368E0000, 0x36900000, 0x36920000, 0x36940000, 0x36960000, 0x36980000, 0x369A0000, 0x369C0000, 0x369E0000,
  0x36A00000, 0x36A20000, 0x36A40000, 0x36A60000, 0x36A80000, 0x36AA0000, 0x36AC0000, 0x36AE0000, 0x36B00000, 0x36B20000, 0x36B40000, 0x36B60000, 0x36B80000, 0x36BA0000, 0x36BC0000, 0x36BE0000,
  0x36C00000, 0x36C20000, 0x36C40000, 0x36C60000, 0x36C80000, 0x36CA0000, 0x36CC0000, 0x36CE0000, 0x36D00000, 0x36D20000, 0x36D40000, 0x36D60000, 0x36D80000, 0x36DA0000, 0x36DC0000, 0x36DE0000,
  0x36E00000, 0x36E20000, 0x36E40000, 0x36E60000, 0x36E80000, 0x36EA0000, 0x36EC0000, 0x36EE0000, 0x36F00000, 0x36F20000, 0x36F40000, 0x36F60000, 0x36F80000, 0x36FA0000, 0x36FC0000, 0x36FE0000,
  0x37000000, 0x37010000, 0x37020000, 0x37030000, 0x37040000, 0x37050000, 0x37060000, 0x37070000, 0x37080000, 0x37090000, 0x370A0000, 0x370B0000, 0x370C0000, 0x370D0000, 0x370E0000, 0x370F0000,
  0x37100000, 0x37110000, 0x37120000, 0x37130000, 0x37140000, 0x37150000, 0x37160000, 0x37170000, 0x37180000, 0x37190000, 0x371A0000, 0x371B0000, 0x371C0000, 0x371D0000, 0x371E0000, 0x371F0000,
  0x37200000, 0x37210000, 0x37220000, 0x37230000, 0x37240000, 0x37250000, 0x37260000, 0x37270000, 0x37280000, 0x37290000, 0x372A0000, 0x372B0000, 0x372C0000, 0x372D0000, 0x372E0000, 0x372F0000,
  0x37300000, 0x37310000, 0x37320000, 0x37330000, 0x37340000, 0x37350000, 0x37360000, 0x37370000, 0x37380000, 0x37390000, 0x373A0000, 0x373B0000, 0x373C0000, 0x373D0000, 0x373E0000, 0x373F0000,
  0x37400000, 0x37410000, 0x37420000, 0x37430000, 0x37440000, 0x37450000, 0x37460000, 0x37470000, 0x37480000, 0x37490000, 0x374A0000, 0x374B0000, 0x374C0000, 0x374D0000, 0x374E0000, 0x374F0000,
  0x37500000, 0x37510000, 0x37520000, 0x37530000, 0x37540000, 0x37550000, 0x37560000, 0x37570000, 0x37580000, 0x37590000, 0x375A0000, 0x375B0000, 0x375C0000, 0x375D0000, 0x375E0000, 0x375F0000,
  0x37600000, 0x37610000, 0x37620000, 0x37630000, 0x37640000, 0x37650000, 0x37660000, 0x37670000, 0x37680000, 0x37690000, 0x376A0000, 0x376B0000, 0x376C0000, 0x376D0000, 0x376E0000, 0x376F0000,
  0x37700000, 0x37710000, 0x37720000, 0x37730000, 0x37740000, 0x37750000, 0x37760000, 0x37770000, 0x37780000, 0x37790000, 0x377A0000, 0x377B0000, 0x377C0000, 0x377D0000, 0x377E0000, 0x377F0000,
  0x37800000, 0x37808000, 0x37810000, 0x37818000, 0x37820000, 0x37828000, 0x37830000, 0x37838000, 0x37840000, 0x37848000, 0x37850000, 0x37858000, 0x37860000, 0x37868000, 0x37870000, 0x37878000,
  0x37880000, 0x37888000, 0x37890000, 0x37898000, 0x378A0000, 0x378A8000, 0x378B0000, 0x378B8000, 0x378C0000, 0x378C8000, 0x378D0000, 0x378D8000, 0x378E0000, 0x378E8000, 0x378F0000, 0x378F8000,
  0x37900000, 0x37908000, 0x37910000, 0x37918000, 0x37920000, 0x37928000, 0x37930000, 0x37938000, 0x37940000, 0x37948000, 0x37950000, 0x37958000, 0x37960000, 0x37968000, 0x37970000, 0x37978000,
  0x37980000, 0x37988000, 0x37990000, 0x37998000, 0x379A0000, 0x379A8000, 0x379B0000, 0x379B8000, 0x379C0000, 0x379C8000, 0x379D0000, 0x379D8000, 0x379E0000, 0x379E8000, 0x379F0000, 0x379F8000,
  0x37A00000, 0x37A08000, 0x37A10000, 0x37A18000, 0x37A20000, 0x37A28000, 0x37A30000, 0x37A38000, 0x37A40000, 0x37A48000, 0x37A50000, 0x37A58000, 0x37A60000, 0x37A68000, 0x37A70000, 0x37A78000,
  0x37A80000, 0x37A88000, 0x37A90000, 0x37A98000, 0x37AA0000, 0x37AA8000, 0x37AB0000, 0x37AB8000, 0x37AC0000, 0x37AC8000, 0x37AD0000, 0x37AD8000, 0x37AE0000, 0x37AE8000, 0x37AF0000, 0x37AF8000,
  0x37B00000, 0x37B08000, 0x37B10000, 0x37B18000, 0x37B20000, 0x37B28000, 0x37B30000, 0x37B38000, 0x37B40000, 0x37B48000, 0x37B50000, 0x37B58000, 0x37B60000, 0x37B68000, 0x37B70000, 0x37B78000,
  0x37B80000, 0x37B88000, 0x37B90000, 0x37B98000, 0x37BA0000, 0x37BA8000, 0x37BB0000, 0x37BB8000, 0x37BC0000, 0x37BC8000, 0x37BD0000, 0x37BD8000, 0x37BE0000, 0x37BE8000, 0x37BF0000, 0x37BF8000,
  0x37C00000, 0x37C08000, 0x37C10000, 0x37C18000, 0x37C20000, 0x37C28000, 0x37C30000, 0x37C38000, 0x37C40000, 0x37C48000, 0x37C50000, 0x37C58000, 0x37C60000, 0x37C68000, 0x37C70000, 0x37C78000,
  0x37C80000, 0x37C88000, 0x37C90000, 0x37C98000, 0x37CA0000, 0x37CA8000, 0x37CB0000, 0x37CB8000, 0x37CC0000, 0x37CC8000, 0x37CD0000, 0x37CD8000, 0x37CE0000, 0x37CE8000, 0x37CF0000, 0x37CF8000,
  0x37D00000, 0x37D08000, 0x37D10000, 0x37D18000, 0x37D20000, 0x37D28000, 0x37D30000, 0x37D38000, 0x37D40000, 0x37D48000, 0x37D50000, 0x37D58000, 0x37D60000, 0x37D68000, 0x37D70000, 0x37D78000,
  0x37D80000, 0x37D88000, 0x37D90000, 0x37D98000, 0x37DA0000, 0x37DA8000, 0x37DB0000, 0x37DB8000, 0x37DC0000, 0x37DC8000, 0x37DD0000, 0x37DD8000, 0x37DE0000, 0x37DE8000, 0x37DF0000, 0x37DF8000,
  0x37E00000, 0x37E08000, 0x37E10000, 0x37E18000, 0x37E20000, 0x37E28000, 0x37E30000, 0x37E38000, 0x37E40000, 0x37E48000, 0x37E50000, 0x37E58000, 0x37E60000, 0x37E68000, 0x37E70000, 0x37E78000,
  0x37E80000, 0x37E88000, 0x37E90000, 0x37E98000, 0x37EA0000, 0x37EA8000, 0x37EB0000, 0x37EB8000, 0x37EC0000, 0x37EC8000, 0x37ED0000, 0x37ED8000, 0x37EE0000, 0x37EE8000, 0x37EF0000, 0x37EF8000,
  0x37F00000, 0x37F08000, 0x37F10000, 0x37F18000, 0x37F20000, 0x37F28000, 0x37F30000, 0x37F38000, 0x37F40000, 0x37F48000, 0x37F50000, 0x37F58000, 0x37F60000, 0x37F68000, 0x37F70000, 0x37F78000,
  0x37F80000, 0x37F88000, 0x37F90000, 0x37F98000, 0x37FA0000, 0x37FA8000, 0x37FB0000, 0x37FB8000, 0x37FC0000, 0x37FC8000, 0x37FD0000, 0x37FD8000, 0x37FE0000, 0x37FE8000, 0x37FF0000, 0x37FF8000,
  0x38000000, 0x38004000, 0x38008000, 0x3800C000, 0x38010000, 0x38014000, 0x38018000, 0x3801C000, 0x38020000, 0x38024000, 0x38028000, 0x3802C000, 0x38030000, 0x38034000, 0x38038000, 0x3803C000,
  0x38040000, 0x38044000, 0x38048000, 0x3804C000, 0x38050000, 0x38054000, 0x38058000, 0x3805C000, 0x38060000, 0x38064000, 0x38068000, 0x3806C000, 0x38070000, 0x38074000, 0x38078000, 0x3807C000,
  0x38080000, 0x38084000, 0x38088000, 0x3808C000, 0x38090000, 0x38094000, 0x38098000, 0x3809C000, 0x380A0000, 0x380A4000, 0x380A8000, 0x380AC000, 0x380B0000, 0x380B4000, 0x380B8000, 0x380BC000,
  0x380C0000, 0x380C4000, 0x380C8000, 0x380CC000, 0x380D0000, 0x380D4000, 0x380D8000, 0x380DC000, 0x380E0000, 0x380E4000, 0x380E8000, 0x380EC000, 0x380F0000, 0x380F4000, 0x380F8000, 0x380FC000,
  0x38100000, 0x38104000, 0x38108000, 0x3810C000, 0x38110000, 0x38114000, 0x38118000, 0x3811C000, 0x38120000, 0x38124000, 0x38128000, 0x3812C000, 0x38130000, 0x38134000, 0x38138000, 0x3813C000,
  0x38140000, 0x38144000, 0x38148000, 0x3814C000, 0x38150000, 0x38154000, 0x38158000, 0x3815C000, 0x38160000, 0x38164000, 0x38168000, 0x3816C000, 0x38170000, 0x38174000, 0x38178000, 0x3817C000,
  0x38180000, 0x38184000, 0x38188000, 0x3818C000, 0x38190000, 0x38194000, 0x38198000, 0x3819C000, 0x381A0000, 0x381A4000, 0x381A8000, 0x381AC000, 0x381B0000, 0x381B4000, 0x381B8000, 0x381BC000,
  0x381C0000, 0x381C4000, 0x381C8000, 0x381CC000, 0x381D0000, 0x381D4000, 0x381D8000, 0x381DC000, 0x381E0000, 0x381E4000, 0x381E8000, 0x381EC000, 0x381F0000, 0x381F4000, 0x381F8000, 0x381FC000,
  0x38200000, 0x38204000, 0x38208000, 0x3820C000, 0x38210000, 0x38214000, 0x38218000, 0x3821C000, 0x38220000, 0x38224000, 0x38228000, 0x3822C000, 0x38230000, 0x38234000, 0x38238000, 0x3823C000,
  0x38240000, 0x38244000, 0x38248000, 0x3824C000, 0x38250000, 0x38254000, 0x38258000, 0x3825C000, 0x38260000, 0x38264000, 0x38268000, 0x3826C000, 0x38270000, 0x38274000, 0x38278000, 0x3827C000,
  0x38280000, 0x38284000, 0x38288000, 0x3828C000, 0x38290000, 0x38294000, 0x38298000, 0x3829C000, 0x382A0000, 0x382A4000, 0x382A8000, 0x382AC000, 0x382B0000, 0x382B4000, 0x382B8000, 0x382BC000,
  0x382C0000, 0x382C4000, 0x382C8000, 0x382CC000, 0x382D0000, 0x382D4000, 0x382D8000, 0x382DC000, 0x382E0000, 0x382E4000, 0x382E8000, 0x382EC000, 0x382F0000, 0x382F4000, 0x382F8000, 0x382FC000,
  0x38300000, 0x38304000, 0x38308000, 0x3830C000, 0x38310000, 0x38314000, 0x38318000, 0x3831C000, 0x38320000, 0x38324000, 0x38328000, 0x3832C000, 0x38330000, 0x38334000, 0x38338000, 0x3833C000,
  0x38340000, 0x38344000, 0x38348000, 0x3834C000, 0x38350000, 0x38354000, 0x38358000, 0x3835C000, 0x38360000, 0x38364000, 0x38368000, 0x3836C000, 0x38370000, 0x38374000, 0x38378000, 0x3837C000,
  0x38380000, 0x38384000, 0x38388000, 0x3838C000, 0x38390000, 0x38394000, 0x38398000, 0x3839C000, 0x383A0000, 0x383A4000, 0x383A8000, 0x383AC000, 0x383B0000, 0x383B4000, 0x383B8000, 0x383BC000,
  0x383C0000, 0x383C4000, 0x383C8000, 0x383CC000, 0x383D0000, 0x383D4000, 0x383D8000, 0x383DC000, 0x383E0000, 0x383E4000, 0x383E8000, 0x383EC000, 0x383F0000, 0x383F4000, 0x383F8000, 0x383FC000,
  0x38400000, 0x38404000, 0x38408000, 0x3840C000, 0x38410000, 0x38414000, 0x38418000, 0x3841C000, 0x38420000, 0x38424000, 0x38428000, 0x3842C000, 0x38430000, 0x38434000, 0x38438000, 0x3843C000,
  0x38440000, 0x38444000, 0x38448000, 0x3844C000, 0x38450000, 0x38454000, 0x38458000, 0x3845C000, 0x38460000, 0x38464000, 0x38468000, 0x3846C000, 0x38470000, 0x38474000, 0x38478000, 0x3847C000,
  0x38480000, 0x38484000, 0x38488000, 0x3848C000, 0x38490000, 0x38494000, 0x38498000, 0x3849C000, 0x384A0000, 0x384A4000, 0x384A8000, 0x384AC000, 0x384B0000, 0x384B4000, 0x384B8000, 0x384BC000,
  0x384C0000, 0x384C4000, 0x384C8000, 0x384CC000, 0x384D0000, 0x384D4000, 0x384D8000, 0x384DC000, 0x384E0000, 0x384E4000, 0x384E8000, 0x384EC000, 0x384F0000, 0x384F4000, 0x384F8000, 0x384FC000,
  0x38500000, 0x38504000, 0x38508000, 0x3850C000, 0x38510000, 0x38514000, 0x38518000, 0x3851C000, 0x38520000, 0x38524000, 0x38528000, 0x3852C000, 0x38530000, 0x38534000, 0x38538000, 0x3853C000,
  0x38540000, 0x38544000, 0x38548000, 0x3854C000, 0x38550000, 0x38554000, 0x38558000, 0x3855C000, 0x38560000, 0x38564000, 0x38568000, 0x3856C000, 0x38570000, 0x38574000, 0x38578000, 0x3857C000,
  0x38580000, 0x38584000, 0x38588000, 0x3858C000, 0x38590000, 0x38594000, 0x38598000, 0x3859C000, 0x385A0000, 0x385A4000, 0x385A8000, 0x385AC000, 0x385B0000, 0x385B4000, 0x385B8000, 0x385BC000,
  0x385C0000, 0x385C4000, 0x385C8000, 0x385CC000, 0x385D0000, 0x385D4000, 0x385D8000, 0x385DC000, 0x385E0000, 0x385E4000, 0x385E8000, 0x385EC000, 0x385F0000, 0x385F4000, 0x385F8000, 0x385FC000,
  0x38600000, 0x38604000, 0x38608000, 0x3860C000, 0x38610000, 0x38614000, 0x38618000, 0x3861C000, 0x38620000, 0x38624000, 0x38628000, 0x3862C000, 0x38630000, 0x38634000, 0x38638000, 0x3863C000,
  0x38640000, 0x38644000, 0x38648000, 0x3864C000, 0x38650000, 0x38654000, 0x38658000, 0x3865C000, 0x38660000, 0x38664000, 0x38668000, 0x3866C000, 0x38670000, 0x38674000, 0x38678000, 0x3867C000,
  0x38680000, 0x38684000, 0x38688000, 0x3868C000, 0x38690000, 0x38694000, 0x38698000, 0x3869C000, 0x386A0000, 0x386A4000, 0x386A8000, 0x386AC000, 0x386B0000, 0x386B4000, 0x386B8000, 0x386BC000,
  0x386C0000, 0x386C4000, 0x386C8000, 0x386CC000, 0x386D0000, 0x386D4000, 0x386D8000, 0x386DC000, 0x386E0000, 0x386E4000, 0x386E8000, 0x386EC000, 0x386F0000, 0x386F4000, 0x386F8000, 0x386FC000,
  0x38700000, 0x38704000, 0x38708000, 0x3870C000, 0x38710000, 0x38714000, 0x38718000, 0x3871C000, 0x38720000, 0x38724000, 0x38728000, 0x3872C000, 0x38730000, 0x38734000, 0x38738000, 0x3873C000,
  0x38740000, 0x38744000, 0x38748000, 0x3874C000, 0x38750000, 0x38754000, 0x38758000, 0x3875C000, 0x38760000, 0x38764000, 0x38768000, 0x3876C000, 0x38770000, 0x38774000, 0x38778000, 0x3877C000,
  0x38780000, 0x38784000, 0x38788000, 0x3878C000, 0x38790000, 0x38794000, 0x38798000, 0x3879C000, 0x387A0000, 0x387A4000, 0x387A8000, 0x387AC000, 0x387B0000, 0x387B4000, 0x387B8000, 0x387BC000,
  0x387C0000, 0x387C4000, 0x387C8000, 0x387CC000, 0x387D0000, 0x387D4000, 0x387D8000, 0x387DC000, 0x387E0000, 0x387E4000, 0x387E8000, 0x387EC000, 0x387F0000, 0x387F4000, 0x387F8000, 0x387FC000,
  0x38000000, 0x38002000, 0x38004000, 0x38006000, 0x38008000, 0x3800A000, 0x3800C000, 0x3800E000, 0x38010000, 0x38012000, 0x38014000, 0x38016000, 0x38018000, 0x3801A000, 0x3801C000, 0x3801E000,
  0x38020000, 0x38022000, 0x38024000, 0x38026000, 0x38028000, 0x3802A000, 0x3802C000, 0x3802E000, 0x38030000, 0x38032000, 0x38034000, 0x38036000, 0x38038000, 0x3803A000, 0x3803C000, 0x3803E000,
  0x38040000, 0x38042000, 0x38044000, 0x38046000, 0x38048000, 0x3804A000, 0x3804C000, 0x3804E000, 0x38050000, 0x38052000, 0x38054000, 0x38056000, 0x38058000, 0x3805A000, 0x3805C000, 0x3805E000,
  0x38060000, 0x38062000, 0x38064000, 0x38066000, 0x38068000, 0x3806A000, 0x3806C000, 0x3806E000, 0x38070000, 0x38072000, 0x38074000, 0x38076000, 0x38078000, 0x3807A000, 0x3807C000, 0x3807E000,
  0x38080000, 0x38082000, 0x38084000, 0x38086000, 0x38088000, 0x3808A000, 0x3808C000, 0x3808E000, 0x38090000, 0x38092000, 0x38094000, 0x38096000, 0x38098000, 0x3809A000, 0x3809C000, 0x3809E000,
  0x380A0000, 0x380A2000, 0x380A4000, 0x380A6000, 0x380A8000, 0x380AA000, 0x380AC000, 0x380AE000, 0x380B0000, 0x380B2000, 0x380B4000, 0x380B6000, 0x380B8000, 0x380BA000, 0x380BC000, 0x380BE000,
  0x380C0000, 0x380C2000, 0x380C4000, 0x380C6000, 0x380C8000, 0x380CA000, 0x380CC000, 0x380CE000, 0x380D0000, 0x380D2000, 0x380D4000, 0x380D6000, 0x380D8000, 0x380DA000, 0x380DC000, 0x380DE000,
  0x380E0000, 0x380E2000, 0x380E4000, 0x380E6000, 0x380E8000, 0x380EA000, 0x380EC000, 0x380EE000, 0x380F0000, 0x380F2000, 0x380F4000, 0x380F6000, 0x380F8000, 0x380FA000, 0x380FC000, 0x380FE000,
  0x38100000, 0x38102000, 0x38104000, 0x38106000, 0x38108000, 0x3810A000, 0x3810C000, 0x3810E000, 0x38110000, 0x38112000, 0x38114000, 0x38116000, 0x38118000, 0x3811A000, 0x3811C000, 0x3811E000,
  0x38120000, 0x38122000, 0x38124000, 0x38126000, 0x38128000, 0x3812A000, 0x3812C000, 0x3812E000, 0x38130000, 0x38132000, 0x38134000, 0x38136000, 0x38138000, 0x3813A000, 0x3813C000, 0x3813E000,
  0x38140000, 0x38142000, 0x38144000, 0x38146000, 0x38148000, 0x3814A000, 0x3814C000, 0x3814E000, 0x38150000, 0x38152000, 0x38154000, 0x38156000, 0x38158000, 0x3815A000, 0x3815C000, 0x3815E000,
  0x38160000, 0x38162000, 0x38164000, 0x38166000, 0x38168000, 0x3816A000, 0x3816C000, 0x3816E000, 0x38170000, 0x38172000, 0x38174000, 0x38176000, 0x38178000, 0x3817A000, 0x3817C000, 0x3817E000,
  0x38180000, 0x38182000, 0x38184000, 0x38186000, 0x38188000, 0x3818A000, 0x3818C000, 0x3818E000, 0x38190000, 0x38192000, 0x38194000, 0x38196000, 0x38198000, 0x3819A000, 0x3819C000, 0x3819E000,
  0x381A0000, 0x381A2000, 0x381A4000, 0x381A6000, 0x381A8000, 0x381AA000, 0x381AC000, 0x381AE000, 0x381B0000, 0x381B2000, 0x381B4000, 0x381B6000, 0x381B8000, 0x381BA000, 0x381BC000, 0x381BE000,
  0x381C0000, 0x381C2000, 0x381C4000, 0x381C6000, 0x381C8000, 0x381CA000, 0x381CC000, 0x381CE000, 0x381D0000, 0x381D2000, 0x381D4000, 0x381D6000, 0x381D8000, 0x381DA000, 0x381DC000, 0x381DE000,
  0x381E0000, 0x381E2000, 0x381E4000, 0x381E6000, 0x381E8000, 0x381EA000, 0x381EC000, 0x381EE000, 0x381F0000, 0x381F2000, 0x381F4000, 0x381F6000, 0x381F8000, 0x381FA000, 0x381FC000, 0x381FE000,
  0x38200000, 0x38202000, 0x38204000, 0x38206000, 0x38208000, 0x3820A000, 0x3820C000, 0x3820E000, 0x38210000, 0x38212000, 0x38214000, 0x38216000, 0x38218000, 0x3821A000, 0x3821C000, 0x3821E000,
  0x38220000, 0x38222000, 0x38224000, 0x38226000, 0x38228000, 0x3822A000, 0x3822C000, 0x3822E000, 0x38230000, 0x38232000, 0x38234000, 0x38236000, 0x38238000, 0x3823A000, 0x3823C000, 0x3823E000,
  0x38240000, 0x38242000, 0x38244000, 0x38246000, 0x38248000, 0x3824A000, 0x3824C000, 0x3824E000, 0x38250000, 0x38252000, 0x38254000, 0x38256000, 0x38258000, 0x3825A000, 0x3825C000, 0x3825E000,
  0x38260000, 0x38262000, 0x38264000, 0x38266000, 0x38268000, 0x3826A000, 0x3826C000, 0x3826E000, 0x38270000, 0x38272000, 0x38274000, 0x38276000, 0x38278000, 0x3827A000, 0x3827C000, 0x3827E000,
  0x38280000, 0x38282000, 0x38284000, 0x38286000, 0x38288000, 0x3828A000, 0x3828C000, 0x3828E000, 0x38290000, 0x38292000, 0x38294000, 0x38296000, 0x38298000, 0x3829A000, 0x3829C000, 0x3829E000,
  0x382A0000, 0x382A2000, 0x382A4000, 0x382A6000, 0x382A8000, 0x382AA000, 0x382AC000, 0x382AE000, 0x382B0000, 0x382B2000, 0x382B4000, 0x382B6000, 0x382B8000, 0x382BA000, 0x382BC000, 0x382BE000,
  0x382C0000, 0x382C2000, 0x382C4000, 0x382C6000, 0x382C8000, 0x382CA000, 0x382CC000, 0x382CE000, 0x382D0000, 0x382D2000, 0x382D4000, 0x382D6000, 0x382D8000, 0x382DA000, 0x382DC000, 0x382DE000,
  0x382E0000, 0x382E2000, 0x382E4000, 0x382E6000, 0x382E8000, 0x382EA000, 0x382EC000, 0x382EE000, 0x382F0000, 0x382F2000, 0x382F4000, 0x382F6000, 0x382F8000, 0x382FA000, 0x382FC000, 0x382FE000,
  0x38300000, 0x38302000, 0x38304000, 0x38306000, 0x38308000, 0x3830A000, 0x3830C000, 0x3830E000, 0x38310000, 0x38312000, 0x38314000, 0x38316000, 0x38318000, 0x3831A000, 0x3831C000, 0x3831E000,
  0x38320000, 0x38322000, 0x38324000, 0x38326000, 0x38328000, 0x3832A000, 0x3832C000, 0x3832E000, 0x38330000, 0x38332000, 0x38334000, 0x38336000, 0x38338000, 0x3833A000, 0x3833C000, 0x3833E000,
  0x38340000, 0x38342000, 0x38344000, 0x38346000, 0x38348000, 0x3834A000, 0x3834C000, 0x3834E000, 0x38350000, 0x38352000, 0x38354000, 0x38356000, 0x38358000, 0x3835A000, 0x3835C000, 0x3835E000,
  0x38360000, 0x38362000, 0x38364000, 0x38366000, 0x38368000, 0x3836A000, 0x3836C000, 0x3836E000, 0x38370000, 0x38372000, 0x38374000, 0x38376000, 0x38378000, 0x3837A000, 0x3837C000, 0x3837E000,
  0x38380000, 0x38382000, 0x38384000, 0x38386000, 0x38388000, 0x3838A000, 0x3838C000, 0x3838E000, 0x38390000, 0x38392000, 0x38394000, 0x38396000, 0x38398000, 0x3839A000, 0x3839C000, 0x3839E000,
  0x383A0000, 0x383A2000, 0x383A4000, 0x383A6000, 0x383A8000, 0x383AA000, 0x383AC000, 0x383AE000, 0x383B0000, 0x383B2000, 0x383B4000, 0x383B6000, 0x383B8000, 0x383BA000, 0x383BC000, 0x383BE000,
  0x383C0000, 0x383C2000, 0x383C4000, 0x383C6000, 0x383C8000, 0x383CA000, 0x383CC000, 0x383CE000, 0x383D0000, 0x383D2000, 0x383D4000, 0x383D6000, 0x383D8000, 0x383DA000, 0x383DC000, 0x383DE000,
  0x383E0000, 0x383E2000, 0x383E4000, 0x383E6000, 0x383E8000, 0x383EA000, 0x383EC000, 0x383EE000, 0x383F0000, 0x383F2000, 0x383F4000, 0x383F6000, 0x383F8000, 0x383FA000, 0x383FC000, 0x383FE000,
  0x38400000, 0x38402000, 0x38404000, 0x38406000, 0x38408000, 0x3840A000, 0x3840C000, 0x3840E000, 0x38410000, 0x38412000, 0x38414000, 0x38416000, 0x38418000, 0x3841A000, 0x3841C000, 0x3841E000,
  0x38420000, 0x38422000, 0x38424000, 0x38426000, 0x38428000, 0x3842A000, 0x3842C000, 0x3842E000, 0x38430000, 0x38432000, 0x38434000, 0x38436000, 0x38438000, 0x3843A000, 0x3843C000, 0x3843E000,
  0x38440000, 0x38442000, 0x38444000, 0x38446000, 0x38448000, 0x3844A000, 0x3844C000, 0x3844E000, 0x38450000, 0x38452000, 0x38454000, 0x38456000, 0x38458000, 0x3845A000, 0x3845C000, 0x3845E000,
  0x38460000, 0x38462000, 0x38464000, 0x38466000, 0x38468000, 0x3846A000, 0x3846C000, 0x3846E000, 0x38470000, 0x38472000, 0x38474000, 0x38476000, 0x38478000, 0x3847A000, 0x3847C000, 0x3847E000,
  0x38480000, 0x38482000, 0x38484000, 0x38486000, 0x38488000, 0x3848A000, 0x3848C000, 0x3848E000, 0x38490000, 0x38492000, 0x38494000, 0x38496000, 0x38498000, 0x3849A000, 0x3849C000, 0x3849E000,
  0x384A0000, 0x384A2000, 0x384A4000, 0x384A6000, 0x384A8000, 0x384AA000, 0x384AC000, 0x384AE000, 0x384B0000, 0x384B2000, 0x384B4000, 0x384B6000, 0x384B8000, 0x384BA000, 0x384BC000, 0x384BE000,
  0x384C0000, 0x384C2000, 0x384C4000, 0x384C6000, 0x384C8000, 0x384CA000, 0x384CC000, 0x384CE000, 0x384D0000, 0x384D2000, 0x384D4000, 0x384D6000, 0x384D8000, 0x384DA000, 0x384DC000, 0x384DE000,
  0x384E0000, 0x384E2000, 0x384E4000, 0x384E6000, 0x384E8000, 0x384EA000, 0x384EC000, 0x384EE000, 0x384F0000, 0x384F2000, 0x384F4000, 0x384F6000, 0x384F8000, 0x384FA000, 0x384FC000, 0x384FE000,
  0x38500000, 0x38502000, 0x38504000, 0x38506000, 0x38508000, 0x3850A000, 0x3850C000, 0x3850E000, 0x38510000, 0x38512000, 0x38514000, 0x38516000, 0x38518000, 0x3851A000, 0x3851C000, 0x3851E000,
  0x38520000, 0x38522000, 0x38524000, 0x38526000, 0x38528000, 0x3852A000, 0x3852C000, 0x3852E000, 0x38530000, 0x38532000, 0x38534000, 0x38536000, 0x38538000, 0x3853A000, 0x3853C000, 0x3853E000,
  0x38540000, 0x38542000, 0x38544000, 0x38546000, 0x38548000, 0x3854A000, 0x3854C000, 0x3854E000, 0x38550000, 0x38552000, 0x38554000, 0x38556000, 0x38558000, 0x3855A000, 0x3855C000, 0x3855E000,
  0x38560000, 0x38562000, 0x38564000, 0x38566000, 0x38568000, 0x3856A000, 0x3856C000, 0x3856E000, 0x38570000, 0x38572000, 0x38574000, 0x38576000, 0x38578000, 0x3857A000, 0x3857C000, 0x3857E000,
  0x38580000, 0x38582000, 0x38584000, 0x38586000, 0x38588000, 0x3858A000, 0x3858C000, 0x3858E000, 0x38590000, 0x38592000, 0x38594000, 0x38596000, 0x38598000, 0x3859A000, 0x3859C000, 0x3859E000,
  0x385A0000, 0x385A2000, 0x385A4000, 0x385A6000, 0x385A8000, 0x385AA000, 0x385AC000, 0x385AE000, 0x385B0000, 0x385B2000, 0x385B4000, 0x385B6000, 0x385B8000, 0x385BA000, 0x385BC000, 0x385BE000,
  0x385C0000, 0x385C2000, 0x385C4000, 0x385C6000, 0x385C8000, 0x385CA000, 0x385CC000, 0x385CE000, 0x385D0000, 0x385D2000, 0x385D4000, 0x385D6000, 0x385D8000, 0x385DA000, 0x385DC000, 0x385DE000,
  0x385E0000, 0x385E2000, 0x385E4000, 0x385E6000, 0x385E8000, 0x385EA000, 0x385EC000, 0x385EE000, 0x385F0000, 0x385F2000, 0x385F4000, 0x385F6000, 0x385F8000, 0x385FA000, 0x385FC000, 0x385FE000,
  0x38600000, 0x38602000, 0x38604000, 0x38606000, 0x38608000, 0x3860A000, 0x3860C000, 0x3860E000, 0x38610000, 0x38612000, 0x38614000, 0x38616000, 0x38618000, 0x3861A000, 0x3861C000, 0x3861E000,
  0x38620000, 0x38622000, 0x38624000, 0x38626000, 0x38628000, 0x3862A000, 0x3862C000, 0x3862E000, 0x38630000, 0x38632000, 0x38634000, 0x38636000, 0x38638000, 0x3863A000, 0x3863C000, 0x3863E000,
  0x38640000, 0x38642000, 0x38644000, 0x38646000, 0x38648000, 0x3864A000, 0x3864C000, 0x3864E000, 0x38650000, 0x38652000, 0x38654000, 0x38656000, 0x38658000, 0x3865A000, 0x3865C000, 0x3865E000,
  0x38660000, 0x38662000, 0x38664000, 0x38666000, 0x38668000, 0x3866A000, 0x3866C000, 0x3866E000, 0x38670000, 0x38672000, 0x38674000, 0x38676000, 0x38678000, 0x3867A000, 0x3867C000, 0x3867E000,
  0x38680000, 0x38682000, 0x38684000, 0x38686000, 0x38688000, 0x3868A000, 0x3868C000, 0x3868E000, 0x38690000, 0x38692000, 0x38694000, 0x38696000, 0x38698000, 0x3869A000, 0x3869C000, 0x3869E000,
  0x386A0000, 0x386A2000, 0x386A4000, 0x386A6000, 0x386A8000, 0x386AA000, 0x386AC000, 0x386AE000, 0x386B0000, 0x386B2000, 0x386B4000, 0x386B6000, 0x386B8000, 0x386BA000, 0x386BC000, 0x386BE000,
  0x386C0000, 0x386C2000, 0x386C4000, 0x386C6000, 0x386C8000, 0x386CA000, 0x386CC000, 0x386CE000, 0x386D0000, 0x386D2000, 0x386D4000, 0x386D6000, 0x386D8000, 0x386DA000, 0x386DC000, 0x386DE000,
  0x386E0000, 0x386E2000, 0x386E4000, 0x386E6000, 0x386E8000, 0x386EA000, 0x386EC000, 0x386EE000, 0x386F0000, 0x386F2000, 0x386F4000, 0x386F6000, 0x386F8000, 0x386FA000, 0x386FC000, 0x386FE000,
  0x38700000, 0x38702000, 0x38704000, 0x38706000, 0x38708000, 0x3870A000, 0x3870C000, 0x3870E000, 0x38710000, 0x38712000, 0x38714000, 0x38716000, 0x38718000, 0x3871A000, 0x3871C000, 0x3871E000,
  0x38720000, 0x38722000, 0x38724000, 0x38726000, 0x38728000, 0x3872A000, 0x3872C000, 0x3872E000, 0x38730000, 0x38732000, 0x38734000, 0x38736000, 0x38738000, 0x3873A000, 0x3873C000, 0x3873E000,
  0x38740000, 0x38742000, 0x38744000, 0x38746000, 0x38748000, 0x3874A000, 0x3874C000, 0x3874E000, 0x38750000, 0x38752000, 0x38754000, 0x38756000, 0x38758000, 0x3875A000, 0x3875C000, 0x3875E000,
  0x38760000, 0x38762000, 0x38764000, 0x38766000, 0x38768000, 0x3876A000, 0x3876C000, 0x3876E000, 0x38770000, 0x38772000, 0x38774000, 0x38776000, 0x38778000, 0x3877A000, 0x3877C000, 0x3877E000,
  0x38780000, 0x38782000, 0x38784000, 0x38786000, 0x38788000, 0x3878A000, 0x3878C000, 0x3878E000, 0x38790000, 0x38792000, 0x38794000, 0x38796000, 0x38798000, 0x3879A000, 0x3879C000, 0x3879E000,
  0x387A0000, 0x387A2000, 0x387A4000, 0x387A6000, 0x387A8000, 0x387AA000, 0x387AC000, 0x387AE000, 0x387B0000, 0x387B2000, 0x387B4000, 0x387B6000, 0x387B8000, 0x387BA000, 0x387BC000, 0x387BE000,
  0x387C0000, 0x387C2000, 0x387C4000, 0x387C6000, 0x387C8000, 0x387CA000, 0x387CC000, 0x387CE000, 0x387D0000, 0x387D2000, 0x387D4000, 0x387D6000, 0x387D8000, 0x387DA000, 0x387DC000, 0x387DE000,
  0x387E0000, 0x387E2000, 0x387E4000, 0x387E6000, 0x387E8000, 0x387EA000, 0x387EC000, 0x387EE000, 0x387F0000, 0x387F2000, 0x387F4000, 0x387F6000, 0x387F8000, 0x387FA000, 0x387FC000, 0x387FE000 };
__constant static const uint32_t exponent_table[64] = {
  0x00000000, 0x00800000, 0x01000000, 0x01800000, 0x02000000, 0x02800000, 0x03000000, 0x03800000, 0x04000000, 0x04800000, 0x05000000, 0x05800000, 0x06000000, 0x06800000, 0x07000000, 0x07800000,
  0x08000000, 0x08800000, 0x09000000, 0x09800000, 0x0A000000, 0x0A800000, 0x0B000000, 0x0B800000, 0x0C000000, 0x0C800000, 0x0D000000, 0x0D800000, 0x0E000000, 0x0E800000, 0x0F000000, 0x47800000,
  0x80000000, 0x80800000, 0x81000000, 0x81800000, 0x82000000, 0x82800000, 0x83000000, 0x83800000, 0x84000000, 0x84800000, 0x85000000, 0x85800000, 0x86000000, 0x86800000, 0x87000000, 0x87800000,
  0x88000000, 0x88800000, 0x89000000, 0x89800000, 0x8A000000, 0x8A800000, 0x8B000000, 0x8B800000, 0x8C000000, 0x8C800000, 0x8D000000, 0x8D800000, 0x8E000000, 0x8E800000, 0x8F000000, 0xC7800000 };
__constant static const unsigned short offset_table[64] = {
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024 };

static uint16_t float2halfbits(float value) {
  union { float x; uint32_t y; } u;
  u.x = value;
  uint32_t bits = u.y;

  uint16_t hbits = base_table[bits>>23] + (uint16_t)((bits&0x7FFFFF)>>shift_table[bits>>23]);;

  return hbits;
}

static float halfbits2float(uint16_t value) {
  uint32_t bits = mantissa_table[offset_table[value>>10]+(value&0x3FF)] + exponent_table[value>>10];

  union { uint32_t x; float y; } u;
  u.x = bits;
  return u.y;
}

// End of half.h.
// Start of timing.h.

// The function get_wall_time() returns the wall time in microseconds
// (with an unspecified offset).

#ifdef _WIN32

#include <windows.h>

static int64_t get_wall_time(void) {
  LARGE_INTEGER time,freq;
  assert(QueryPerformanceFrequency(&freq));
  assert(QueryPerformanceCounter(&time));
  return ((double)time.QuadPart / freq.QuadPart) * 1000000;
}

#else
// Assuming POSIX

#include <time.h>
#include <sys/time.h>

static int64_t get_wall_time(void) {
  struct timeval time;
  assert(gettimeofday(&time,NULL) == 0);
  return time.tv_sec * 1000000 + time.tv_usec;
}

static int64_t get_wall_time_ns(void) {
  struct timespec time;
  assert(clock_gettime(CLOCK_REALTIME, &time) == 0);
  return time.tv_sec * 1000000000 + time.tv_nsec;
}

#endif

// End of timing.h.

#ifdef _MSC_VER
#define inline __inline
#endif
#include <string.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include <ctype.h>



// Start of lock.h.

// A very simple cross-platform implementation of locks.  Uses
// pthreads on Unix and some Windows thing there.  Futhark's
// host-level code is not multithreaded, but user code may be, so we
// need some mechanism for ensuring atomic access to API functions.
// This is that mechanism.  It is not exposed to user code at all, so
// we do not have to worry about name collisions.

#ifdef _WIN32

typedef HANDLE lock_t;

static void create_lock(lock_t *lock) {
  *lock = CreateMutex(NULL,  // Default security attributes.
                      FALSE, // Initially unlocked.
                      NULL); // Unnamed.
}

static void lock_lock(lock_t *lock) {
  assert(WaitForSingleObject(*lock, INFINITE) == WAIT_OBJECT_0);
}

static void lock_unlock(lock_t *lock) {
  assert(ReleaseMutex(*lock));
}

static void free_lock(lock_t *lock) {
  CloseHandle(*lock);
}

#else
// Assuming POSIX

#include <pthread.h>

typedef pthread_mutex_t lock_t;

static void create_lock(lock_t *lock) {
  int r = pthread_mutex_init(lock, NULL);
  assert(r == 0);
}

static void lock_lock(lock_t *lock) {
  int r = pthread_mutex_lock(lock);
  assert(r == 0);
}

static void lock_unlock(lock_t *lock) {
  int r = pthread_mutex_unlock(lock);
  assert(r == 0);
}

static void free_lock(lock_t *lock) {
  // Nothing to do for pthreads.
  (void)lock;
}

#endif

// End of lock.h.

#define FUTHARK_F64_ENABLED

// Start of scalar.h.

// Implementation of the primitive scalar operations.  Very
// repetitive.  This code is inserted directly into both CUDA and
// OpenCL programs, as well as the CPU code, so it has some #ifdefs to
// work everywhere.  Some operations are defined as macros because
// this allows us to use them as constant expressions in things like
// array sizes and static initialisers.

// Some of the #ifdefs are because OpenCL uses type-generic functions
// for some operations (e.g. sqrt), while C and CUDA sensibly use
// distinct functions for different precisions (e.g. sqrtf() and
// sqrt()).  This is quite annoying.  Due to C's unfortunate casting
// rules, it is also really easy to accidentally implement
// floating-point functions in the wrong precision, so be careful.

// Double-precision definitions are only included if the preprocessor
// macro FUTHARK_F64_ENABLED is set.

static inline uint8_t add8(uint8_t x, uint8_t y) {
  return x + y;
}

static inline uint16_t add16(uint16_t x, uint16_t y) {
  return x + y;
}

static inline uint32_t add32(uint32_t x, uint32_t y) {
  return x + y;
}

static inline uint64_t add64(uint64_t x, uint64_t y) {
  return x + y;
}

static inline uint8_t sub8(uint8_t x, uint8_t y) {
  return x - y;
}

static inline uint16_t sub16(uint16_t x, uint16_t y) {
  return x - y;
}

static inline uint32_t sub32(uint32_t x, uint32_t y) {
  return x - y;
}

static inline uint64_t sub64(uint64_t x, uint64_t y) {
  return x - y;
}

static inline uint8_t mul8(uint8_t x, uint8_t y) {
  return x * y;
}

static inline uint16_t mul16(uint16_t x, uint16_t y) {
  return x * y;
}

static inline uint32_t mul32(uint32_t x, uint32_t y) {
  return x * y;
}

static inline uint64_t mul64(uint64_t x, uint64_t y) {
  return x * y;
}

static inline uint8_t udiv8(uint8_t x, uint8_t y) {
  return x / y;
}

static inline uint16_t udiv16(uint16_t x, uint16_t y) {
  return x / y;
}

static inline uint32_t udiv32(uint32_t x, uint32_t y) {
  return x / y;
}

static inline uint64_t udiv64(uint64_t x, uint64_t y) {
  return x / y;
}

static inline uint8_t udiv_up8(uint8_t x, uint8_t y) {
  return (x + y - 1) / y;
}

static inline uint16_t udiv_up16(uint16_t x, uint16_t y) {
  return (x + y - 1) / y;
}

static inline uint32_t udiv_up32(uint32_t x, uint32_t y) {
  return (x + y - 1) / y;
}

static inline uint64_t udiv_up64(uint64_t x, uint64_t y) {
  return (x + y - 1) / y;
}

static inline uint8_t umod8(uint8_t x, uint8_t y) {
  return x % y;
}

static inline uint16_t umod16(uint16_t x, uint16_t y) {
  return x % y;
}

static inline uint32_t umod32(uint32_t x, uint32_t y) {
  return x % y;
}

static inline uint64_t umod64(uint64_t x, uint64_t y) {
  return x % y;
}

static inline uint8_t udiv_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint16_t udiv_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint32_t udiv_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint64_t udiv_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint8_t udiv_up_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint16_t udiv_up_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint32_t udiv_up_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint64_t udiv_up_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint8_t umod_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint16_t umod_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint32_t umod_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint64_t umod_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t sdiv8(int8_t x, int8_t y) {
  int8_t q = x / y;
  int8_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int16_t sdiv16(int16_t x, int16_t y) {
  int16_t q = x / y;
  int16_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int32_t sdiv32(int32_t x, int32_t y) {
  int32_t q = x / y;
  int32_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int64_t sdiv64(int64_t x, int64_t y) {
  int64_t q = x / y;
  int64_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int8_t sdiv_up8(int8_t x, int8_t y) {
  return sdiv8(x + y - 1, y);
}

static inline int16_t sdiv_up16(int16_t x, int16_t y) {
  return sdiv16(x + y - 1, y);
}

static inline int32_t sdiv_up32(int32_t x, int32_t y) {
  return sdiv32(x + y - 1, y);
}

static inline int64_t sdiv_up64(int64_t x, int64_t y) {
  return sdiv64(x + y - 1, y);
}

static inline int8_t smod8(int8_t x, int8_t y) {
  int8_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int16_t smod16(int16_t x, int16_t y) {
  int16_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int32_t smod32(int32_t x, int32_t y) {
  int32_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int64_t smod64(int64_t x, int64_t y) {
  int64_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int8_t sdiv_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : sdiv8(x, y);
}

static inline int16_t sdiv_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : sdiv16(x, y);
}

static inline int32_t sdiv_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : sdiv32(x, y);
}

static inline int64_t sdiv_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : sdiv64(x, y);
}

static inline int8_t sdiv_up_safe8(int8_t x, int8_t y) {
  return sdiv_safe8(x + y - 1, y);
}

static inline int16_t sdiv_up_safe16(int16_t x, int16_t y) {
  return sdiv_safe16(x + y - 1, y);
}

static inline int32_t sdiv_up_safe32(int32_t x, int32_t y) {
  return sdiv_safe32(x + y - 1, y);
}

static inline int64_t sdiv_up_safe64(int64_t x, int64_t y) {
  return sdiv_safe64(x + y - 1, y);
}

static inline int8_t smod_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : smod8(x, y);
}

static inline int16_t smod_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : smod16(x, y);
}

static inline int32_t smod_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : smod32(x, y);
}

static inline int64_t smod_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : smod64(x, y);
}

static inline int8_t squot8(int8_t x, int8_t y) {
  return x / y;
}

static inline int16_t squot16(int16_t x, int16_t y) {
  return x / y;
}

static inline int32_t squot32(int32_t x, int32_t y) {
  return x / y;
}

static inline int64_t squot64(int64_t x, int64_t y) {
  return x / y;
}

static inline int8_t srem8(int8_t x, int8_t y) {
  return x % y;
}

static inline int16_t srem16(int16_t x, int16_t y) {
  return x % y;
}

static inline int32_t srem32(int32_t x, int32_t y) {
  return x % y;
}

static inline int64_t srem64(int64_t x, int64_t y) {
  return x % y;
}

static inline int8_t squot_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int16_t squot_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int32_t squot_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int64_t squot_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int8_t srem_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int16_t srem_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int32_t srem_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int64_t srem_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t smin8(int8_t x, int8_t y) {
  return x < y ? x : y;
}

static inline int16_t smin16(int16_t x, int16_t y) {
  return x < y ? x : y;
}

static inline int32_t smin32(int32_t x, int32_t y) {
  return x < y ? x : y;
}

static inline int64_t smin64(int64_t x, int64_t y) {
  return x < y ? x : y;
}

static inline uint8_t umin8(uint8_t x, uint8_t y) {
  return x < y ? x : y;
}

static inline uint16_t umin16(uint16_t x, uint16_t y) {
  return x < y ? x : y;
}

static inline uint32_t umin32(uint32_t x, uint32_t y) {
  return x < y ? x : y;
}

static inline uint64_t umin64(uint64_t x, uint64_t y) {
  return x < y ? x : y;
}

static inline int8_t smax8(int8_t x, int8_t y) {
  return x < y ? y : x;
}

static inline int16_t smax16(int16_t x, int16_t y) {
  return x < y ? y : x;
}

static inline int32_t smax32(int32_t x, int32_t y) {
  return x < y ? y : x;
}

static inline int64_t smax64(int64_t x, int64_t y) {
  return x < y ? y : x;
}

static inline uint8_t umax8(uint8_t x, uint8_t y) {
  return x < y ? y : x;
}

static inline uint16_t umax16(uint16_t x, uint16_t y) {
  return x < y ? y : x;
}

static inline uint32_t umax32(uint32_t x, uint32_t y) {
  return x < y ? y : x;
}

static inline uint64_t umax64(uint64_t x, uint64_t y) {
  return x < y ? y : x;
}

static inline uint8_t shl8(uint8_t x, uint8_t y) {
  return (uint8_t)(x << y);
}

static inline uint16_t shl16(uint16_t x, uint16_t y) {
  return (uint16_t)(x << y);
}

static inline uint32_t shl32(uint32_t x, uint32_t y) {
  return x << y;
}

static inline uint64_t shl64(uint64_t x, uint64_t y) {
  return x << y;
}

static inline uint8_t lshr8(uint8_t x, uint8_t y) {
  return x >> y;
}

static inline uint16_t lshr16(uint16_t x, uint16_t y) {
  return x >> y;
}

static inline uint32_t lshr32(uint32_t x, uint32_t y) {
  return x >> y;
}

static inline uint64_t lshr64(uint64_t x, uint64_t y) {
  return x >> y;
}

static inline int8_t ashr8(int8_t x, int8_t y) {
  return x >> y;
}

static inline int16_t ashr16(int16_t x, int16_t y) {
  return x >> y;
}

static inline int32_t ashr32(int32_t x, int32_t y) {
  return x >> y;
}

static inline int64_t ashr64(int64_t x, int64_t y) {
  return x >> y;
}

static inline uint8_t and8(uint8_t x, uint8_t y) {
  return x & y;
}

static inline uint16_t and16(uint16_t x, uint16_t y) {
  return x & y;
}

static inline uint32_t and32(uint32_t x, uint32_t y) {
  return x & y;
}

static inline uint64_t and64(uint64_t x, uint64_t y) {
  return x & y;
}

static inline uint8_t or8(uint8_t x, uint8_t y) {
  return x | y;
}

static inline uint16_t or16(uint16_t x, uint16_t y) {
  return x | y;
}

static inline uint32_t or32(uint32_t x, uint32_t y) {
  return x | y;
}

static inline uint64_t or64(uint64_t x, uint64_t y) {
  return x | y;
}

static inline uint8_t xor8(uint8_t x, uint8_t y) {
  return x ^ y;
}

static inline uint16_t xor16(uint16_t x, uint16_t y) {
  return x ^ y;
}

static inline uint32_t xor32(uint32_t x, uint32_t y) {
  return x ^ y;
}

static inline uint64_t xor64(uint64_t x, uint64_t y) {
  return x ^ y;
}

static inline bool ult8(uint8_t x, uint8_t y) {
  return x < y;
}

static inline bool ult16(uint16_t x, uint16_t y) {
  return x < y;
}

static inline bool ult32(uint32_t x, uint32_t y) {
  return x < y;
}

static inline bool ult64(uint64_t x, uint64_t y) {
  return x < y;
}

static inline bool ule8(uint8_t x, uint8_t y) {
  return x <= y;
}

static inline bool ule16(uint16_t x, uint16_t y) {
  return x <= y;
}

static inline bool ule32(uint32_t x, uint32_t y) {
  return x <= y;
}

static inline bool ule64(uint64_t x, uint64_t y) {
  return x <= y;
}

static inline bool slt8(int8_t x, int8_t y) {
  return x < y;
}

static inline bool slt16(int16_t x, int16_t y) {
  return x < y;
}

static inline bool slt32(int32_t x, int32_t y) {
  return x < y;
}

static inline bool slt64(int64_t x, int64_t y) {
  return x < y;
}

static inline bool sle8(int8_t x, int8_t y) {
  return x <= y;
}

static inline bool sle16(int16_t x, int16_t y) {
  return x <= y;
}

static inline bool sle32(int32_t x, int32_t y) {
  return x <= y;
}

static inline bool sle64(int64_t x, int64_t y) {
  return x <= y;
}

static inline uint8_t pow8(uint8_t x, uint8_t y) {
  uint8_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint16_t pow16(uint16_t x, uint16_t y) {
  uint16_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint32_t pow32(uint32_t x, uint32_t y) {
  uint32_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint64_t pow64(uint64_t x, uint64_t y) {
  uint64_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline bool itob_i8_bool(int8_t x) {
  return x;
}

static inline bool itob_i16_bool(int16_t x) {
  return x;
}

static inline bool itob_i32_bool(int32_t x) {
  return x;
}

static inline bool itob_i64_bool(int64_t x) {
  return x;
}

static inline int8_t btoi_bool_i8(bool x) {
  return x;
}

static inline int16_t btoi_bool_i16(bool x) {
  return x;
}

static inline int32_t btoi_bool_i32(bool x) {
  return x;
}

static inline int64_t btoi_bool_i64(bool x) {
  return x;
}

#define sext_i8_i8(x) ((int8_t) (int8_t) (x))
#define sext_i8_i16(x) ((int16_t) (int8_t) (x))
#define sext_i8_i32(x) ((int32_t) (int8_t) (x))
#define sext_i8_i64(x) ((int64_t) (int8_t) (x))
#define sext_i16_i8(x) ((int8_t) (int16_t) (x))
#define sext_i16_i16(x) ((int16_t) (int16_t) (x))
#define sext_i16_i32(x) ((int32_t) (int16_t) (x))
#define sext_i16_i64(x) ((int64_t) (int16_t) (x))
#define sext_i32_i8(x) ((int8_t) (int32_t) (x))
#define sext_i32_i16(x) ((int16_t) (int32_t) (x))
#define sext_i32_i32(x) ((int32_t) (int32_t) (x))
#define sext_i32_i64(x) ((int64_t) (int32_t) (x))
#define sext_i64_i8(x) ((int8_t) (int64_t) (x))
#define sext_i64_i16(x) ((int16_t) (int64_t) (x))
#define sext_i64_i32(x) ((int32_t) (int64_t) (x))
#define sext_i64_i64(x) ((int64_t) (int64_t) (x))
#define zext_i8_i8(x) ((int8_t) (uint8_t) (x))
#define zext_i8_i16(x) ((int16_t) (uint8_t) (x))
#define zext_i8_i32(x) ((int32_t) (uint8_t) (x))
#define zext_i8_i64(x) ((int64_t) (uint8_t) (x))
#define zext_i16_i8(x) ((int8_t) (uint16_t) (x))
#define zext_i16_i16(x) ((int16_t) (uint16_t) (x))
#define zext_i16_i32(x) ((int32_t) (uint16_t) (x))
#define zext_i16_i64(x) ((int64_t) (uint16_t) (x))
#define zext_i32_i8(x) ((int8_t) (uint32_t) (x))
#define zext_i32_i16(x) ((int16_t) (uint32_t) (x))
#define zext_i32_i32(x) ((int32_t) (uint32_t) (x))
#define zext_i32_i64(x) ((int64_t) (uint32_t) (x))
#define zext_i64_i8(x) ((int8_t) (uint64_t) (x))
#define zext_i64_i16(x) ((int16_t) (uint64_t) (x))
#define zext_i64_i32(x) ((int32_t) (uint64_t) (x))
#define zext_i64_i64(x) ((int64_t) (uint64_t) (x))

static int8_t abs8(int8_t x) {
  return (int8_t)abs(x);
}

static int16_t abs16(int16_t x) {
  return (int16_t)abs(x);
}

static int32_t abs32(int32_t x) {
  return abs(x);
}

static int64_t abs64(int64_t x) {
#if defined(__OPENCL_VERSION__)
  return abs(x);
#else
  return llabs(x);
#endif
}

#if defined(__OPENCL_VERSION__)
static int32_t futrts_popc8(int8_t x) {
  return popcount(x);
}

static int32_t futrts_popc16(int16_t x) {
  return popcount(x);
}

static int32_t futrts_popc32(int32_t x) {
  return popcount(x);
}

static int32_t futrts_popc64(int64_t x) {
  return popcount(x);
}
#elif defined(__CUDA_ARCH__)

static int32_t futrts_popc8(int8_t x) {
  return __popc(zext_i8_i32(x));
}

static int32_t futrts_popc16(int16_t x) {
  return __popc(zext_i16_i32(x));
}

static int32_t futrts_popc32(int32_t x) {
  return __popc(x);
}

static int32_t futrts_popc64(int64_t x) {
  return __popcll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_popc8(uint8_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc16(uint16_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc32(uint32_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc64(uint64_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  return mul_hi(a, b);
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  return mul_hi(a, b);
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mul_hi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul_hi(a, b);
}

#elif defined(__CUDA_ARCH__)

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mulhi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul64hi(a, b);
}

#else // Not OpenCL or CUDA, but plain C.

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  uint64_t aa = a;
  uint64_t bb = b;

  return aa * bb >> 32;
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  __uint128_t aa = a;
  __uint128_t bb = b;

  return aa * bb >> 64;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return mad_hi(a, b, c);
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return mad_hi(a, b, c);
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return mad_hi(a, b, c);
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return mad_hi(a, b, c);
}

#else // Not OpenCL

static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return futrts_mul_hi8(a, b) + c;
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return futrts_mul_hi16(a, b) + c;
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return futrts_mul_hi32(a, b) + c;
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return futrts_mul_hi64(a, b) + c;
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_clzz8(int8_t x) {
  return clz(x);
}

static int32_t futrts_clzz16(int16_t x) {
  return clz(x);
}

static int32_t futrts_clzz32(int32_t x) {
  return clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return clz(x);
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_clzz8(int8_t x) {
  return __clz(zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return __clz(zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return __clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return __clzll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_clzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_clz((uint32_t)zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_clz((uint32_t)zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_clz((uint32_t)x);
}

static int32_t futrts_clzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_clzll((uint64_t)x);
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_ctzz8(int8_t x) {
  int i = 0;
  for (; i < 8 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz16(int16_t x) {
  int i = 0;
  for (; i < 16 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz32(int32_t x) {
  int i = 0;
  for (; i < 32 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz64(int64_t x) {
  int i = 0;
  for (; i < 64 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_ctzz8(int8_t x) {
  int y = __ffs(x);
  return y == 0 ? 8 : y - 1;
}

static int32_t futrts_ctzz16(int16_t x) {
  int y = __ffs(x);
  return y == 0 ? 16 : y - 1;
}

static int32_t futrts_ctzz32(int32_t x) {
  int y = __ffs(x);
  return y == 0 ? 32 : y - 1;
}

static int32_t futrts_ctzz64(int64_t x) {
  int y = __ffsll(x);
  return y == 0 ? 64 : y - 1;
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_ctzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_ctzll((uint64_t)x);
}
#endif

static inline float fdiv32(float x, float y) {
  return x / y;
}

static inline float fadd32(float x, float y) {
  return x + y;
}

static inline float fsub32(float x, float y) {
  return x - y;
}

static inline float fmul32(float x, float y) {
  return x * y;
}

static inline bool cmplt32(float x, float y) {
  return x < y;
}

static inline bool cmple32(float x, float y) {
  return x <= y;
}

static inline float sitofp_i8_f32(int8_t x) {
  return (float) x;
}

static inline float sitofp_i16_f32(int16_t x) {
  return (float) x;
}

static inline float sitofp_i32_f32(int32_t x) {
  return (float) x;
}

static inline float sitofp_i64_f32(int64_t x) {
  return (float) x;
}

static inline float uitofp_i8_f32(uint8_t x) {
  return (float) x;
}

static inline float uitofp_i16_f32(uint16_t x) {
  return (float) x;
}

static inline float uitofp_i32_f32(uint32_t x) {
  return (float) x;
}

static inline float uitofp_i64_f32(uint64_t x) {
  return (float) x;
}

static inline int8_t fptosi_f32_i8(float x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f32_i16(float x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f32_i32(float x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f32_i64(float x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f32_i8(float x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f32_i16(float x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f32_i32(float x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f32_i64(float x) {
  return (uint64_t) x;
}

#ifdef __OPENCL_VERSION__
static inline float fabs32(float x) {
  return fabs(x);
}

static inline float fmax32(float x, float y) {
  return fmax(x, y);
}

static inline float fmin32(float x, float y) {
  return fmin(x, y);
}

static inline float fpow32(float x, float y) {
  return pow(x, y);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float fabs32(float x) {
  return fabsf(x);
}

static inline float fmax32(float x, float y) {
  return fmaxf(x, y);
}

static inline float fmin32(float x, float y) {
  return fminf(x, y);
}

static inline float fpow32(float x, float y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan32(float x) {
  return isnan(x);
}

static inline bool futrts_isinf32(float x) {
  return isinf(x);
}

#ifdef __OPENCL_VERSION__
static inline float futrts_log32(float x) {
  return log(x);
}

static inline float futrts_log2_32(float x) {
  return log2(x);
}

static inline float futrts_log10_32(float x) {
  return log10(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrt(x);
}

static inline float futrts_exp32(float x) {
  return exp(x);
}

static inline float futrts_cos32(float x) {
  return cos(x);
}

static inline float futrts_sin32(float x) {
  return sin(x);
}

static inline float futrts_tan32(float x) {
  return tan(x);
}

static inline float futrts_acos32(float x) {
  return acos(x);
}

static inline float futrts_asin32(float x) {
  return asin(x);
}

static inline float futrts_atan32(float x) {
  return atan(x);
}

static inline float futrts_cosh32(float x) {
  return cosh(x);
}

static inline float futrts_sinh32(float x) {
  return sinh(x);
}

static inline float futrts_tanh32(float x) {
  return tanh(x);
}

static inline float futrts_acosh32(float x) {
  return acosh(x);
}

static inline float futrts_asinh32(float x) {
  return asinh(x);
}

static inline float futrts_atanh32(float x) {
  return atanh(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypot(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgamma(x);
}

static inline float futrts_lgamma32(float x) {
  return lgamma(x);
}

static inline float fmod32(float x, float y) {
  return fmod(x, y);
}

static inline float futrts_round32(float x) {
  return rint(x);
}

static inline float futrts_floor32(float x) {
  return floor(x);
}

static inline float futrts_ceil32(float x) {
  return ceil(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return mix(v0, v1, t);
}

static inline float futrts_mad32(float a, float b, float c) {
  return mad(a, b, c);
}

static inline float futrts_fma32(float a, float b, float c) {
  return fma(a, b, c);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float futrts_log32(float x) {
  return logf(x);
}

static inline float futrts_log2_32(float x) {
  return log2f(x);
}

static inline float futrts_log10_32(float x) {
  return log10f(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrtf(x);
}

static inline float futrts_exp32(float x) {
  return expf(x);
}

static inline float futrts_cos32(float x) {
  return cosf(x);
}

static inline float futrts_sin32(float x) {
  return sinf(x);
}

static inline float futrts_tan32(float x) {
  return tanf(x);
}

static inline float futrts_acos32(float x) {
  return acosf(x);
}

static inline float futrts_asin32(float x) {
  return asinf(x);
}

static inline float futrts_atan32(float x) {
  return atanf(x);
}

static inline float futrts_cosh32(float x) {
  return coshf(x);
}

static inline float futrts_sinh32(float x) {
  return sinhf(x);
}

static inline float futrts_tanh32(float x) {
  return tanhf(x);
}

static inline float futrts_acosh32(float x) {
  return acoshf(x);
}

static inline float futrts_asinh32(float x) {
  return asinhf(x);
}

static inline float futrts_atanh32(float x) {
  return atanhf(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2f(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypotf(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgammaf(x);
}

static inline float futrts_lgamma32(float x) {
  return lgammaf(x);
}

static inline float fmod32(float x, float y) {
  return fmodf(x, y);
}

static inline float futrts_round32(float x) {
  return rintf(x);
}

static inline float futrts_floor32(float x) {
  return floorf(x);
}

static inline float futrts_ceil32(float x) {
  return ceilf(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return v0 + (v1 - v0) * t;
}

static inline float futrts_mad32(float a, float b, float c) {
  return a * b + c;
}

static inline float futrts_fma32(float a, float b, float c) {
  return fmaf(a, b, c);
}
#endif

static inline int32_t futrts_to_bits32(float x) {
  union {
    float f;
    int32_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline float futrts_from_bits32(int32_t x) {
  union {
    int32_t f;
    float t;
  } p;

  p.f = x;
  return p.t;
}

static inline float fsignum32(float x) {
  return futrts_isnan32(x) ? x : (x > 0) - (x < 0);
}

#ifdef FUTHARK_F64_ENABLED

static inline double fdiv64(double x, double y) {
  return x / y;
}

static inline double fadd64(double x, double y) {
  return x + y;
}

static inline double fsub64(double x, double y) {
  return x - y;
}

static inline double fmul64(double x, double y) {
  return x * y;
}

static inline bool cmplt64(double x, double y) {
  return x < y;
}

static inline bool cmple64(double x, double y) {
  return x <= y;
}

static inline double sitofp_i8_f64(int8_t x) {
  return (double) x;
}

static inline double sitofp_i16_f64(int16_t x) {
  return (double) x;
}

static inline double sitofp_i32_f64(int32_t x) {
  return (double) x;
}

static inline double sitofp_i64_f64(int64_t x) {
  return (double) x;
}

static inline double uitofp_i8_f64(uint8_t x) {
  return (double) x;
}

static inline double uitofp_i16_f64(uint16_t x) {
  return (double) x;
}

static inline double uitofp_i32_f64(uint32_t x) {
  return (double) x;
}

static inline double uitofp_i64_f64(uint64_t x) {
  return (double) x;
}

static inline int8_t fptosi_f64_i8(double x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f64_i16(double x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f64_i32(double x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f64_i64(double x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f64_i8(double x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f64_i16(double x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f64_i32(double x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f64_i64(double x) {
  return (uint64_t) x;
}

static inline double fabs64(double x) {
  return fabs(x);
}

static inline double fmax64(double x, double y) {
  return fmax(x, y);
}

static inline double fmin64(double x, double y) {
  return fmin(x, y);
}

static inline double fpow64(double x, double y) {
  return pow(x, y);
}

static inline double futrts_log64(double x) {
  return log(x);
}

static inline double futrts_log2_64(double x) {
  return log2(x);
}

static inline double futrts_log10_64(double x) {
  return log10(x);
}

static inline double futrts_sqrt64(double x) {
  return sqrt(x);
}

static inline double futrts_exp64(double x) {
  return exp(x);
}

static inline double futrts_cos64(double x) {
  return cos(x);
}

static inline double futrts_sin64(double x) {
  return sin(x);
}

static inline double futrts_tan64(double x) {
  return tan(x);
}

static inline double futrts_acos64(double x) {
  return acos(x);
}

static inline double futrts_asin64(double x) {
  return asin(x);
}

static inline double futrts_atan64(double x) {
  return atan(x);
}

static inline double futrts_cosh64(double x) {
  return cosh(x);
}

static inline double futrts_sinh64(double x) {
  return sinh(x);
}

static inline double futrts_tanh64(double x) {
  return tanh(x);
}

static inline double futrts_acosh64(double x) {
  return acosh(x);
}

static inline double futrts_asinh64(double x) {
  return asinh(x);
}

static inline double futrts_atanh64(double x) {
  return atanh(x);
}

static inline double futrts_atan2_64(double x, double y) {
  return atan2(x, y);
}

static inline double futrts_hypot64(double x, double y) {
  return hypot(x, y);
}

static inline double futrts_gamma64(double x) {
  return tgamma(x);
}

static inline double futrts_lgamma64(double x) {
  return lgamma(x);
}

static inline double futrts_fma64(double a, double b, double c) {
  return fma(a, b, c);
}

static inline double futrts_round64(double x) {
  return rint(x);
}

static inline double futrts_ceil64(double x) {
  return ceil(x);
}

static inline double futrts_floor64(double x) {
  return floor(x);
}

static inline bool futrts_isnan64(double x) {
  return isnan(x);
}

static inline bool futrts_isinf64(double x) {
  return isinf(x);
}

static inline int64_t futrts_to_bits64(double x) {
  union {
    double f;
    int64_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline double futrts_from_bits64(int64_t x) {
  union {
    int64_t f;
    double t;
  } p;

  p.f = x;
  return p.t;
}

static inline double fmod64(double x, double y) {
  return fmod(x, y);
}

static inline double fsignum64(double x) {
  return futrts_isnan64(x) ? x : (x > 0) - (x < 0);
}

static inline double futrts_lerp64(double v0, double v1, double t) {
#ifdef __OPENCL_VERSION__
  return mix(v0, v1, t);
#else
  return v0 + (v1 - v0) * t;
#endif
}

static inline double futrts_mad64(double a, double b, double c) {
#ifdef __OPENCL_VERSION__
  return mad(a, b, c);
#else
  return a * b + c;
#endif
}

static inline float fpconv_f32_f32(float x) {
  return (float) x;
}

static inline double fpconv_f32_f64(float x) {
  return (double) x;
}

static inline float fpconv_f64_f32(double x) {
  return (float) x;
}

static inline double fpconv_f64_f64(double x) {
  return (double) x;
}

#endif

// End of scalar.h.
// Start of scalar_f16.h.

// Half-precision is emulated if needed (e.g. in straight C) with the
// native type used if possible.  The emulation works by typedef'ing
// 'float' to 'f16', and then implementing all operations on single
// precision.  To cut down on duplication, we use the same code for
// those Futhark functions that require just operators or casts.  The
// in-memory representation for arrays will still be 16 bits even
// under emulation, so the compiler will have to be careful when
// generating reads or writes.

#if !defined(cl_khr_fp16) && !(defined(__CUDA_ARCH__) && __CUDA_ARCH__ >= 600)
#define EMULATE_F16
#endif

#if !defined(EMULATE_F16) && defined(__OPENCL_VERSION__)
#pragma OPENCL EXTENSION cl_khr_fp16 : enable
#endif

#ifdef EMULATE_F16

// Note that the half-precision storage format is still 16 bits - the
// compiler will have to be real careful!
typedef float f16;

#else

#ifdef __CUDA_ARCH__
#include <cuda_fp16.h>
#endif

typedef half f16;

#endif

// Some of these functions convert to single precision because half
// precision versions are not available.

static inline f16 fadd16(f16 x, f16 y) {
  return x + y;
}

static inline f16 fsub16(f16 x, f16 y) {
  return x - y;
}

static inline f16 fmul16(f16 x, f16 y) {
  return x * y;
}

static inline bool cmplt16(f16 x, f16 y) {
  return x < y;
}

static inline bool cmple16(f16 x, f16 y) {
  return x <= y;
}

static inline f16 sitofp_i8_f16(int8_t x) {
  return (f16) x;
}

static inline f16 sitofp_i16_f16(int16_t x) {
  return (f16) x;
}

static inline f16 sitofp_i32_f16(int32_t x) {
  return (f16) x;
}

static inline f16 sitofp_i64_f16(int64_t x) {
  return (f16) x;
}

static inline f16 uitofp_i8_f16(uint8_t x) {
  return (f16) x;
}

static inline f16 uitofp_i16_f16(uint16_t x) {
  return (f16) x;
}

static inline f16 uitofp_i32_f16(uint32_t x) {
  return (f16) x;
}

static inline f16 uitofp_i64_f16(uint64_t x) {
  return (f16) x;
}

static inline int8_t fptosi_f16_i8(f16 x) {
  return (int8_t) (float) x;
}

static inline int16_t fptosi_f16_i16(f16 x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f16_i32(f16 x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f16_i64(f16 x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f16_i8(f16 x) {
  return (uint8_t) (float) x;
}

static inline uint16_t fptoui_f16_i16(f16 x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f16_i32(f16 x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f16_i64(f16 x) {
  return (uint64_t) x;
}

#ifndef EMULATE_F16

#ifdef __OPENCL_VERSION__
static inline f16 fabs16(f16 x) {
  return fabs(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return pow(x, y);
}

#else // Assuming CUDA.

static inline f16 fabs16(f16 x) {
  return fabsf(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmaxf(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fminf(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan16(f16 x) {
  return isnan((float)x);
}

static inline bool futrts_isinf16(f16 x) {
  return isinf((float)x);
}

#ifdef __OPENCL_VERSION__
static inline f16 futrts_log16(f16 x) {
  return log(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return log2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return log10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return sqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return exp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return cos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return sin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tan(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acos(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asin(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atan(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return cosh(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinh(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanh(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acosh(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinh(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanh(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypot(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgamma(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgamma(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rint(x);
}

static inline f16 futrts_floor16(f16 x) {
  return floor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return ceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return mix(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return mad(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fma(a, b, c);
}

#else // Assume CUDA.

static inline f16 futrts_log16(f16 x) {
  return hlog(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return hlog2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return hlog10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return hsqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return hexp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return hcos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return hsin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tanf(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acosf(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asinf(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atanf(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return coshf(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinhf(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanhf(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acoshf(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinhf(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanhf(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2f(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypotf(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgammaf(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgammaf(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmodf(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rintf(x);
}

static inline f16 futrts_floor16(f16 x) {
  return hfloor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return hceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return v0 + (v1 - v0) * t;
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return a * b + c;
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fmaf(a, b, c);
}

#endif

// The CUDA __half type cannot be put in unions for some reason, so we
// use bespoke conversion functions instead.
#ifdef __CUDA_ARCH__
static inline int16_t futrts_to_bits16(f16 x) {
  return __half_as_ushort(x);
}
static inline f16 futrts_from_bits16(int16_t x) {
  return __ushort_as_half(x);
}
#else
static inline int16_t futrts_to_bits16(f16 x) {
  union {
    f16 f;
    int16_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline f16 futrts_from_bits16(int16_t x) {
  union {
    int16_t f;
    f16 t;
  } p;

  p.f = x;
  return p.t;
}
#endif

#else // No native f16 - emulate.

static inline f16 fabs16(f16 x) {
  return fabs32(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax32(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin32(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return fpow32(x, y);
}

static inline bool futrts_isnan16(f16 x) {
  return futrts_isnan32(x);
}

static inline bool futrts_isinf16(f16 x) {
  return futrts_isinf32(x);
}

static inline f16 futrts_log16(f16 x) {
  return futrts_log32(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return futrts_log2_32(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return futrts_log10_32(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return futrts_sqrt32(x);
}

static inline f16 futrts_exp16(f16 x) {
  return futrts_exp32(x);
}

static inline f16 futrts_cos16(f16 x) {
  return futrts_cos32(x);
}

static inline f16 futrts_sin16(f16 x) {
  return futrts_sin32(x);
}

static inline f16 futrts_tan16(f16 x) {
  return futrts_tan32(x);
}

static inline f16 futrts_acos16(f16 x) {
  return futrts_acos32(x);
}

static inline f16 futrts_asin16(f16 x) {
  return futrts_asin32(x);
}

static inline f16 futrts_atan16(f16 x) {
  return futrts_atan32(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return futrts_cosh32(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return futrts_sinh32(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return futrts_tanh32(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return futrts_acosh32(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return futrts_asinh32(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return futrts_atanh32(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return futrts_atan2_32(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return futrts_hypot32(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return futrts_gamma32(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return futrts_lgamma32(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod32(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return futrts_round32(x);
}

static inline f16 futrts_floor16(f16 x) {
  return futrts_floor32(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return futrts_ceil32(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return futrts_lerp32(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return futrts_mad32(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return futrts_fma32(a, b, c);
}

// Even when we are using an OpenCL that does not support cl_khr_fp16,
// it must still support vload_half for actually creating a
// half-precision number, which can then be efficiently converted to a
// float.  Similarly for vstore_half.
#ifdef __OPENCL_VERSION__

static inline int16_t futrts_to_bits16(f16 x) {
  int16_t y;
  // Violating strict aliasing here.
  vstore_half((float)x, 0, (half*)&y);
  return y;
}

static inline f16 futrts_from_bits16(int16_t x) {
  return (f16)vload_half(0, (half*)&x);
}

#else

static inline int16_t futrts_to_bits16(f16 x) {
  return (int16_t)float2halfbits(x);
}

static inline f16 futrts_from_bits16(int16_t x) {
  return halfbits2float((uint16_t)x);
}

static inline f16 fsignum16(f16 x) {
  return futrts_isnan16(x) ? x : (x > 0) - (x < 0);
}

#endif

#endif

static inline float fpconv_f16_f16(f16 x) {
  return x;
}

static inline float fpconv_f16_f32(f16 x) {
  return x;
}

static inline f16 fpconv_f32_f16(float x) {
  return x;
}

#ifdef FUTHARK_F64_ENABLED

static inline double fpconv_f16_f64(f16 x) {
  return (double) x;
}

static inline f16 fpconv_f64_f16(double x) {
  return (f16) x;
}

#endif


// End of scalar_f16.h.

static int init_constants(struct futhark_context *);
static int free_constants(struct futhark_context *);
struct memblock {
    int *references;
    unsigned char *mem;
    int64_t size;
    const char *desc;
};
struct futhark_context_config {
    int debugging;
    int in_use;
};
struct futhark_context_config *futhark_context_config_new(void)
{
    struct futhark_context_config *cfg =
                                  (struct futhark_context_config *) malloc(sizeof(struct futhark_context_config));
    
    if (cfg == NULL)
        return NULL;
    cfg->in_use = 0;
    cfg->debugging = 0;
    return cfg;
}
void futhark_context_config_free(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    free(cfg);
}
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int detail)
{
    cfg->debugging = detail;
}
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag)
{
    (void) cfg;
    (void) flag;
}
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int detail)
{
    // Does nothing for this backend.
    (void) cfg;
    (void) detail;
}
struct futhark_context {
    struct futhark_context_config *cfg;
    int detail_memory;
    int debugging;
    int profiling;
    int logging;
    lock_t lock;
    char *error;
    FILE *log;
    int profiling_paused;
    int64_t peak_mem_usage_default;
    int64_t cur_mem_usage_default;
    struct {
        int dummy;
    } constants;
};
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    
    struct futhark_context *ctx =
                           (struct futhark_context *) malloc(sizeof(struct futhark_context));
    
    if (ctx == NULL)
        return NULL;
    ctx->cfg = cfg;
    ctx->cfg->in_use = 1;
    ctx->detail_memory = cfg->debugging;
    ctx->debugging = cfg->debugging;
    ctx->profiling = cfg->debugging;
    ctx->logging = cfg->debugging;
    ctx->error = NULL;
    ctx->log = stderr;
    create_lock(&ctx->lock);
    ctx->peak_mem_usage_default = 0;
    ctx->cur_mem_usage_default = 0;
    init_constants(ctx);
    return ctx;
}
void futhark_context_free(struct futhark_context *ctx)
{
    free_constants(ctx);
    free_lock(&ctx->lock);
    ctx->cfg->in_use = 0;
    free(ctx);
}
int futhark_context_sync(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
static const char *tuning_param_names[0];
static const char *tuning_param_vars[0];
static const char *tuning_param_classes[0];
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t param_value)
{
    (void) cfg;
    (void) param_name;
    (void) param_value;
    return 1;
}
static int memblock_unref(struct futhark_context *ctx, struct memblock *block,
                          const char *desc)
{
    if (block->references != NULL) {
        *block->references -= 1;
        if (ctx->detail_memory)
            fprintf(ctx->log,
                    "Unreferencing block %s (allocated as %s) in %s: %d references remaining.\n",
                    desc, block->desc, "default space", *block->references);
        if (*block->references == 0) {
            ctx->cur_mem_usage_default -= block->size;
            free(block->mem);
            free(block->references);
            if (ctx->detail_memory)
                fprintf(ctx->log,
                        "%lld bytes freed (now allocated: %lld bytes)\n",
                        (long long) block->size,
                        (long long) ctx->cur_mem_usage_default);
        }
        block->references = NULL;
    }
    return 0;
}
static int memblock_alloc(struct futhark_context *ctx, struct memblock *block,
                          int64_t size, const char *desc)
{
    if (size < 0)
        futhark_panic(1,
                      "Negative allocation of %lld bytes attempted for %s in %s.\n",
                      (long long) size, desc, "default space",
                      ctx->cur_mem_usage_default);
    
    int ret = memblock_unref(ctx, block, desc);
    
    ctx->cur_mem_usage_default += size;
    if (ctx->detail_memory)
        fprintf(ctx->log,
                "Allocating %lld bytes for %s in %s (then allocated: %lld bytes)",
                (long long) size, desc, "default space",
                (long long) ctx->cur_mem_usage_default);
    if (ctx->cur_mem_usage_default > ctx->peak_mem_usage_default) {
        ctx->peak_mem_usage_default = ctx->cur_mem_usage_default;
        if (ctx->detail_memory)
            fprintf(ctx->log, " (new peak).\n");
    } else if (ctx->detail_memory)
        fprintf(ctx->log, ".\n");
    block->mem = (unsigned char *) malloc((size_t) size);
    block->references = (int *) malloc(sizeof(int));
    *block->references = 1;
    block->size = size;
    block->desc = desc;
    return ret;
}
static int memblock_set(struct futhark_context *ctx, struct memblock *lhs,
                        struct memblock *rhs, const char *lhs_desc)
{
    int ret = memblock_unref(ctx, lhs, lhs_desc);
    
    if (rhs->references != NULL)
        (*rhs->references)++;
    *lhs = *rhs;
    return ret;
}
int futhark_get_tuning_param_count(void)
{
    return sizeof(tuning_param_names) / sizeof(tuning_param_names[0]);
}
const char *futhark_get_tuning_param_name(int i)
{
    return tuning_param_names[i];
}
const char *futhark_get_tuning_param_class(int i)
{
    return tuning_param_classes[i];
}
char *futhark_context_report(struct futhark_context *ctx)
{
    if (futhark_context_sync(ctx) != 0)
        return NULL;
    
    struct str_builder builder;
    
    str_builder_init(&builder);
    if (ctx->detail_memory || ctx->profiling || ctx->logging) {
        { }
    }
    if (ctx->profiling) { }
    return builder.str;
}
char *futhark_context_get_error(struct futhark_context *ctx)
{
    char *error = ctx->error;
    
    ctx->error = NULL;
    return error;
}
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f)
{
    ctx->log = f;
}
void futhark_context_pause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 1;
}
void futhark_context_unpause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 0;
}
int futhark_context_clear_caches(struct futhark_context *ctx)
{
    lock_lock(&ctx->lock);
    ctx->peak_mem_usage_default = 0;
    lock_unlock(&ctx->lock);
    return ctx->error != NULL;
}

static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock *mem_out_p_68448,
                             struct memblock Y_mem_67095, int64_t m_65343,
                             int64_t n_65344, int64_t q_65346,
                             int64_t degree_65347, int64_t jump_65348,
                             int64_t jump_threshold_65349,
                             int64_t q_threshold_65350);

static int init_constants(struct futhark_context *ctx)
{
    (void) ctx;
    
    int err = 0;
    
    
  cleanup:
    return err;
}
static int free_constants(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
struct futhark_f32_2d {
    struct memblock mem;
    int64_t shape[2];
};
struct futhark_f32_2d *futhark_new_f32_2d(struct futhark_context *ctx, const
                                          float *data, int64_t dim0,
                                          int64_t dim1)
{
    struct futhark_f32_2d *bad = NULL;
    struct futhark_f32_2d *arr =
                          (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * dim1 * 4, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    if ((size_t) (dim0 * dim1) * 4 > 0)
        memmove(arr->mem.mem + 0, data + 0, (size_t) (dim0 * dim1) * 4);
    lock_unlock(&ctx->lock);
    return arr;
}
struct futhark_f32_2d *futhark_new_raw_f32_2d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0,
                                              int64_t dim1)
{
    struct futhark_f32_2d *bad = NULL;
    struct futhark_f32_2d *arr =
                          (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * dim1 * 4, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    if ((size_t) (dim0 * dim1) * 4 > 0)
        memmove(arr->mem.mem + 0, data + offset, (size_t) (dim0 * dim1) * 4);
    lock_unlock(&ctx->lock);
    return arr;
}
int futhark_free_f32_2d(struct futhark_context *ctx, struct futhark_f32_2d *arr)
{
    lock_lock(&ctx->lock);
    if (memblock_unref(ctx, &arr->mem, "arr->mem") != 0)
        return 1;
    lock_unlock(&ctx->lock);
    free(arr);
    return 0;
}
int futhark_values_f32_2d(struct futhark_context *ctx,
                          struct futhark_f32_2d *arr, float *data)
{
    lock_lock(&ctx->lock);
    if ((size_t) (arr->shape[0] * arr->shape[1]) * 4 > 0)
        memmove(data + 0, arr->mem.mem + 0, (size_t) (arr->shape[0] *
                                                      arr->shape[1]) * 4);
    lock_unlock(&ctx->lock);
    return 0;
}
unsigned char *futhark_values_raw_f32_2d(struct futhark_context *ctx,
                                         struct futhark_f32_2d *arr)
{
    (void) ctx;
    return arr->mem.mem;
}
const int64_t *futhark_shape_f32_2d(struct futhark_context *ctx,
                                    struct futhark_f32_2d *arr)
{
    (void) ctx;
    return arr->shape;
}

static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock *mem_out_p_68448,
                             struct memblock Y_mem_67095, int64_t m_65343,
                             int64_t n_65344, int64_t q_65346,
                             int64_t degree_65347, int64_t jump_65348,
                             int64_t jump_threshold_65349,
                             int64_t q_threshold_65350)
{
    (void) ctx;
    
    int err = 0;
    size_t mem_67116_cached_sizze_68449 = 0;
    unsigned char *mem_67116 = NULL;
    size_t mem_67131_cached_sizze_68450 = 0;
    unsigned char *mem_67131 = NULL;
    size_t mem_67134_cached_sizze_68451 = 0;
    unsigned char *mem_67134 = NULL;
    size_t mem_67161_cached_sizze_68452 = 0;
    unsigned char *mem_67161 = NULL;
    size_t mem_67176_cached_sizze_68453 = 0;
    unsigned char *mem_67176 = NULL;
    size_t mem_67249_cached_sizze_68454 = 0;
    unsigned char *mem_67249 = NULL;
    size_t mem_67264_cached_sizze_68455 = 0;
    unsigned char *mem_67264 = NULL;
    size_t mem_67267_cached_sizze_68456 = 0;
    unsigned char *mem_67267 = NULL;
    size_t mem_67294_cached_sizze_68457 = 0;
    unsigned char *mem_67294 = NULL;
    size_t mem_67309_cached_sizze_68458 = 0;
    unsigned char *mem_67309 = NULL;
    size_t mem_67412_cached_sizze_68459 = 0;
    unsigned char *mem_67412 = NULL;
    size_t mem_67427_cached_sizze_68460 = 0;
    unsigned char *mem_67427 = NULL;
    size_t mem_67430_cached_sizze_68461 = 0;
    unsigned char *mem_67430 = NULL;
    size_t mem_67457_cached_sizze_68462 = 0;
    unsigned char *mem_67457 = NULL;
    size_t mem_67472_cached_sizze_68463 = 0;
    unsigned char *mem_67472 = NULL;
    size_t mem_67597_cached_sizze_68464 = 0;
    unsigned char *mem_67597 = NULL;
    size_t mem_67612_cached_sizze_68465 = 0;
    unsigned char *mem_67612 = NULL;
    size_t mem_67615_cached_sizze_68466 = 0;
    unsigned char *mem_67615 = NULL;
    size_t mem_67642_cached_sizze_68467 = 0;
    unsigned char *mem_67642 = NULL;
    size_t mem_67657_cached_sizze_68468 = 0;
    unsigned char *mem_67657 = NULL;
    size_t mem_67683_cached_sizze_68469 = 0;
    unsigned char *mem_67683 = NULL;
    size_t mem_67745_cached_sizze_68470 = 0;
    unsigned char *mem_67745 = NULL;
    size_t mem_67760_cached_sizze_68471 = 0;
    unsigned char *mem_67760 = NULL;
    size_t mem_67763_cached_sizze_68472 = 0;
    unsigned char *mem_67763 = NULL;
    size_t mem_67790_cached_sizze_68473 = 0;
    unsigned char *mem_67790 = NULL;
    size_t mem_67805_cached_sizze_68474 = 0;
    unsigned char *mem_67805 = NULL;
    size_t mem_67842_cached_sizze_68475 = 0;
    unsigned char *mem_67842 = NULL;
    size_t mem_67845_cached_sizze_68476 = 0;
    unsigned char *mem_67845 = NULL;
    size_t mem_67938_cached_sizze_68477 = 0;
    unsigned char *mem_67938 = NULL;
    size_t mem_67953_cached_sizze_68478 = 0;
    unsigned char *mem_67953 = NULL;
    size_t mem_67956_cached_sizze_68479 = 0;
    unsigned char *mem_67956 = NULL;
    size_t mem_67983_cached_sizze_68480 = 0;
    unsigned char *mem_67983 = NULL;
    size_t mem_67998_cached_sizze_68481 = 0;
    unsigned char *mem_67998 = NULL;
    size_t mem_68035_cached_sizze_68482 = 0;
    unsigned char *mem_68035 = NULL;
    size_t mem_68038_cached_sizze_68483 = 0;
    unsigned char *mem_68038 = NULL;
    size_t mem_68065_cached_sizze_68484 = 0;
    unsigned char *mem_68065 = NULL;
    size_t mem_68068_cached_sizze_68485 = 0;
    unsigned char *mem_68068 = NULL;
    struct memblock mem_out_68296;
    
    mem_out_68296.references = NULL;
    
    bool cond_65351 = jump_65348 == (int64_t) 1;
    int64_t n_m_65352;
    
    if (cond_65351) {
        n_m_65352 = n_65344;
    } else {
        bool zzero_65353 = jump_65348 == (int64_t) 0;
        bool nonzzero_65354 = !zzero_65353;
        bool nonzzero_cert_65355;
        
        if (!nonzzero_65354) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  loess.fut:579:38-45\n   #1  loess.fut:572:1-611:26\n");
            if (memblock_unref(ctx, &mem_out_68296, "mem_out_68296") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t x_65356 = sdiv64(n_65344, jump_65348);
        int64_t n_m_f_res_65357 = add64((int64_t) 1, x_65356);
        
        n_m_65352 = n_m_f_res_65357;
    }
    
    int64_t i_65358 = sub64(n_65344, (int64_t) 1);
    bool x_65359 = sle64((int64_t) 0, i_65358);
    bool y_65360 = slt64(i_65358, n_65344);
    bool bounds_check_65361 = x_65359 && y_65360;
    bool index_certs_65362;
    
    if (!bounds_check_65361) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) i_65358,
                               "] out of bounds for array of shape [",
                               (long long) n_65344, "].",
                               "-> #0  /prelude/array.fut:26:29-34\n   #1  utils.fut:45:13-20\n   #2  loess.fut:584:5-54\n   #3  loess.fut:572:1-611:26\n");
        if (memblock_unref(ctx, &mem_out_68296, "mem_out_68296") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t min_res_65364 = smin64(n_65344, q_65346);
    bool bounds_invalid_upwards_65365 = slt64(n_m_65352, (int64_t) 0);
    bool valid_65366 = !bounds_invalid_upwards_65365;
    bool range_valid_c_65367;
    
    if (!valid_65366) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) n_m_65352, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:442:3-469:10\n   #4  loess.fut:502:15-61\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
        if (memblock_unref(ctx, &mem_out_68296, "mem_out_68296") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool loop_cond_65369 = slt64((int64_t) 1, min_res_65364);
    float i64_res_65370 = sitofp_i64_f32(q_65346);
    bool cond_65371 = slt64(jump_65348, jump_threshold_65349);
    bool cond_f_res_65372 = slt64(q_threshold_65350, q_65346);
    bool x_65373 = !cond_65371;
    bool y_65374 = cond_f_res_65372 && x_65373;
    bool cond_65375 = cond_65371 || y_65374;
    struct memblock ext_mem_68171;
    
    ext_mem_68171.references = NULL;
    
    struct memblock ext_mem_68163;
    
    ext_mem_68163.references = NULL;
    if (cond_65375) {
        bool match_lit_65378 = (int64_t) 0 == degree_65347;
        int64_t binop_x_67096 = m_65343 * n_m_65352;
        int64_t binop_y_67097 = (int64_t) 4 * binop_x_67096;
        int64_t bytes_67098 = smax64((int64_t) 0, binop_y_67097);
        int64_t binop_y_67114 = (int64_t) 8 * n_65344;
        int64_t bytes_67115 = smax64((int64_t) 0, binop_y_67114);
        int64_t binop_y_67129 = (int64_t) 4 * n_65344;
        int64_t bytes_67130 = smax64((int64_t) 0, binop_y_67129);
        int64_t binop_y_67174 = (int64_t) 4 * q_65346;
        int64_t bytes_67175 = smax64((int64_t) 0, binop_y_67174);
        struct memblock ext_mem_67569;
        
        ext_mem_67569.references = NULL;
        
        struct memblock ext_mem_67561;
        
        ext_mem_67561.references = NULL;
        if (match_lit_65378) {
            struct memblock mem_67099;
            
            mem_67099.references = NULL;
            if (memblock_alloc(ctx, &mem_67099, bytes_67098, "mem_67099")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_68297 = 0; i_68297 < m_65343; i_68297++) {
                for (int64_t i_68298 = 0; i_68298 < n_m_65352; i_68298++) {
                    ((float *) mem_67099.mem)[i_68297 * n_m_65352 + i_68298] =
                        0.0F;
                }
            }
            
            struct memblock mem_67103;
            
            mem_67103.references = NULL;
            if (memblock_alloc(ctx, &mem_67103, bytes_67098, "mem_67103")) {
                err = 1;
                goto cleanup;
            }
            if (mem_67116_cached_sizze_68449 < (size_t) bytes_67115) {
                mem_67116 = realloc(mem_67116, bytes_67115);
                mem_67116_cached_sizze_68449 = bytes_67115;
            }
            if (mem_67131_cached_sizze_68450 < (size_t) bytes_67130) {
                mem_67131 = realloc(mem_67131, bytes_67130);
                mem_67131_cached_sizze_68450 = bytes_67130;
            }
            if (mem_67134_cached_sizze_68451 < (size_t) bytes_67115) {
                mem_67134 = realloc(mem_67134, bytes_67115);
                mem_67134_cached_sizze_68451 = bytes_67115;
            }
            if (mem_67161_cached_sizze_68452 < (size_t) bytes_67115) {
                mem_67161 = realloc(mem_67161, bytes_67115);
                mem_67161_cached_sizze_68452 = bytes_67115;
            }
            if (mem_67176_cached_sizze_68453 < (size_t) bytes_67175) {
                mem_67176 = realloc(mem_67176, bytes_67175);
                mem_67176_cached_sizze_68453 = bytes_67175;
            }
            for (int64_t i_66724 = 0; i_66724 < m_65343; i_66724++) {
                int64_t discard_66697;
                int64_t scanacc_66693 = (int64_t) 0;
                
                for (int64_t i_66695 = 0; i_66695 < n_65344; i_66695++) {
                    float x_65389;
                    
                    x_65389 = ((float *) Y_mem_67095.mem)[i_66724 * n_65344 +
                                                          i_66695];
                    
                    bool isnan_res_65390;
                    
                    isnan_res_65390 = futrts_isnan32(x_65389);
                    
                    bool defunc_0_p_res_65391 = !isnan_res_65390;
                    int64_t defunc_0_f_res_65392 =
                            btoi_bool_i64(defunc_0_p_res_65391);
                    int64_t defunc_1_op_res_65388 = add64(defunc_0_f_res_65392,
                                                          scanacc_66693);
                    
                    ((int64_t *) mem_67116)[i_66695] = defunc_1_op_res_65388;
                    
                    int64_t scanacc_tmp_68300 = defunc_1_op_res_65388;
                    
                    scanacc_66693 = scanacc_tmp_68300;
                }
                discard_66697 = scanacc_66693;
                
                int64_t last_res_65393;
                
                last_res_65393 = ((int64_t *) mem_67116)[i_65358];
                for (int64_t i_68302 = 0; i_68302 < n_65344; i_68302++) {
                    ((float *) mem_67131)[i_68302] = 0.0F;
                }
                for (int64_t i_68303 = 0; i_68303 < n_65344; i_68303++) {
                    ((int64_t *) mem_67134)[i_68303] = (int64_t) -1;
                }
                for (int64_t write_iter_66698 = 0; write_iter_66698 < n_65344;
                     write_iter_66698++) {
                    float write_iv_66701;
                    
                    write_iv_66701 = ((float *) Y_mem_67095.mem)[i_66724 *
                                                                 n_65344 +
                                                                 write_iter_66698];
                    
                    int64_t write_iv_66702;
                    
                    write_iv_66702 = ((int64_t *) mem_67116)[write_iter_66698];
                    
                    bool isnan_res_65401;
                    
                    isnan_res_65401 = futrts_isnan32(write_iv_66701);
                    
                    bool defunc_0_p_res_65402 = !isnan_res_65401;
                    int64_t defunc_1_f_res_65403;
                    
                    if (defunc_0_p_res_65402) {
                        int64_t defunc_1_f_res_t_res_65404 =
                                sub64(write_iv_66702, (int64_t) 1);
                        
                        defunc_1_f_res_65403 = defunc_1_f_res_t_res_65404;
                    } else {
                        defunc_1_f_res_65403 = (int64_t) -1;
                    }
                    if (sle64((int64_t) 0, defunc_1_f_res_65403) &&
                        slt64(defunc_1_f_res_65403, n_65344)) {
                        ((int64_t *) mem_67134)[defunc_1_f_res_65403] =
                            write_iter_66698;
                    }
                    if (sle64((int64_t) 0, defunc_1_f_res_65403) &&
                        slt64(defunc_1_f_res_65403, n_65344)) {
                        if ((int64_t) 4 > 0)
                            memmove(mem_67131 + defunc_1_f_res_65403 *
                                    (int64_t) 4, Y_mem_67095.mem + (i_66724 *
                                                                    n_65344 +
                                                                    write_iter_66698) *
                                    (int64_t) 4, (int64_t) 4);
                    }
                }
                for (int64_t i_66708 = 0; i_66708 < n_65344; i_66708++) {
                    int64_t x_65406;
                    
                    x_65406 = ((int64_t *) mem_67134)[i_66708];
                    
                    int64_t defunc_0_f_res_65407 = add64((int64_t) 1, x_65406);
                    
                    ((int64_t *) mem_67161)[i_66708] = defunc_0_f_res_65407;
                }
                
                int64_t min_arg_65408 = sub64(last_res_65393, (int64_t) 1);
                int64_t min_arg_65409 = sub64(last_res_65393, min_res_65364);
                int64_t min_res_65410 = smin64(q_65346, last_res_65393);
                float i64_res_65411 = sitofp_i64_f32(last_res_65393);
                float x_65412 = i64_res_65370 - i64_res_65411;
                float max_arg_65413 = x_65412 / 2.0F;
                float max_res_65414 = fmax32(0.0F, max_arg_65413);
                
                for (int64_t i_66712 = 0; i_66712 < q_65346; i_66712++) {
                    bool cond_65417 = sle64(last_res_65393, i_66712);
                    float defunc_0_f_res_65418;
                    
                    if (cond_65417) {
                        defunc_0_f_res_65418 = 0.0F;
                    } else {
                        defunc_0_f_res_65418 = 1.0F;
                    }
                    ((float *) mem_67176)[i_66712] = defunc_0_f_res_65418;
                }
                for (int64_t i_66720 = 0; i_66720 < n_m_65352; i_66720++) {
                    int64_t min_arg_65421 = mul64(jump_65348, i_66720);
                    int64_t min_res_65422 = smin64(i_65358, min_arg_65421);
                    int64_t defunc_0_g_res_65423 = add64((int64_t) 1,
                                                         min_res_65422);
                    bool init_idx_65424;
                    int64_t init_idx_65425;
                    int64_t init_idx_65426;
                    bool loop_while_65427;
                    int64_t low_65428;
                    int64_t high_65429;
                    
                    loop_while_65427 = x_65359;
                    low_65428 = (int64_t) 0;
                    high_65429 = i_65358;
                    while (loop_while_65427) {
                        int64_t x_65430 = add64(low_65428, high_65429);
                        int64_t mid_65431 = sdiv64(x_65430, (int64_t) 2);
                        bool x_65432 = sle64((int64_t) 0, mid_65431);
                        bool y_65433 = slt64(mid_65431, n_65344);
                        bool bounds_check_65434 = x_65432 && y_65433;
                        bool index_certs_65435;
                        
                        if (!bounds_check_65434) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) mid_65431,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:449:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67103, "mem_67103") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67099, "mem_67099") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67561,
                                               "ext_mem_67561") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67569,
                                               "ext_mem_67569") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t mid_id_65436;
                        
                        mid_id_65436 = ((int64_t *) mem_67161)[mid_65431];
                        
                        bool cond_65437 = slt64(mid_id_65436, (int64_t) 0);
                        int64_t mid_idx_65438;
                        
                        if (cond_65437) {
                            mid_idx_65438 = (int64_t) 9223372036854775807;
                        } else {
                            mid_idx_65438 = mid_id_65436;
                        }
                        
                        bool cond_65439 = sle64(defunc_0_g_res_65423,
                                                mid_idx_65438);
                        int64_t loopres_65440;
                        int64_t loopres_65441;
                        
                        if (cond_65439) {
                            int64_t loopres_t_res_65442 = sub64(mid_65431,
                                                                (int64_t) 1);
                            
                            loopres_65440 = low_65428;
                            loopres_65441 = loopres_t_res_65442;
                        } else {
                            int64_t loopres_f_res_65443 = add64((int64_t) 1,
                                                                mid_65431);
                            
                            loopres_65440 = loopres_f_res_65443;
                            loopres_65441 = high_65429;
                        }
                        
                        bool loop_cond_65444 = sle64(loopres_65440,
                                                     loopres_65441);
                        bool loop_while_tmp_68309 = loop_cond_65444;
                        int64_t low_tmp_68310 = loopres_65440;
                        int64_t high_tmp_68311 = loopres_65441;
                        
                        loop_while_65427 = loop_while_tmp_68309;
                        low_65428 = low_tmp_68310;
                        high_65429 = high_tmp_68311;
                    }
                    init_idx_65424 = loop_while_65427;
                    init_idx_65425 = low_65428;
                    init_idx_65426 = high_65429;
                    
                    bool idx_65445;
                    int64_t idx_65446;
                    int64_t idx_65447;
                    int64_t idx_65448;
                    bool loop_while_65449;
                    int64_t l_idx_65450;
                    int64_t r_idx_65451;
                    int64_t span_65452;
                    
                    loop_while_65449 = loop_cond_65369;
                    l_idx_65450 = init_idx_65425;
                    r_idx_65451 = init_idx_65425;
                    span_65452 = (int64_t) 1;
                    while (loop_while_65449) {
                        int64_t max_arg_65453 = sub64(l_idx_65450, (int64_t) 1);
                        int64_t max_res_65454 = smax64((int64_t) 0,
                                                       max_arg_65453);
                        int64_t min_arg_65455 = add64((int64_t) 1, r_idx_65451);
                        int64_t min_res_65456 = smin64(min_arg_65408,
                                                       min_arg_65455);
                        bool x_65457 = sle64((int64_t) 0, max_res_65454);
                        bool y_65458 = slt64(max_res_65454, n_65344);
                        bool bounds_check_65459 = x_65457 && y_65458;
                        bool index_certs_65460;
                        
                        if (!bounds_check_65459) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) max_res_65454,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:459:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67103, "mem_67103") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67099, "mem_67099") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67561,
                                               "ext_mem_67561") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67569,
                                               "ext_mem_67569") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_65461;
                        
                        x_65461 = ((int64_t *) mem_67161)[max_res_65454];
                        
                        int64_t abs_arg_65462 = sub64(x_65461,
                                                      defunc_0_g_res_65423);
                        int64_t abs_res_65463 = abs64(abs_arg_65462);
                        bool x_65464 = sle64((int64_t) 0, min_res_65456);
                        bool y_65465 = slt64(min_res_65456, n_65344);
                        bool bounds_check_65466 = x_65464 && y_65465;
                        bool index_certs_65467;
                        
                        if (!bounds_check_65466) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) min_res_65456,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67103, "mem_67103") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67099, "mem_67099") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67561,
                                               "ext_mem_67561") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67569,
                                               "ext_mem_67569") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_65468;
                        
                        x_65468 = ((int64_t *) mem_67161)[min_res_65456];
                        
                        int64_t abs_arg_65469 = sub64(x_65468,
                                                      defunc_0_g_res_65423);
                        int64_t abs_res_65470 = abs64(abs_arg_65469);
                        bool cond_65471 = max_res_65454 == l_idx_65450;
                        int64_t loopres_65472;
                        int64_t loopres_65473;
                        int64_t loopres_65474;
                        
                        if (cond_65471) {
                            loopres_65472 = l_idx_65450;
                            loopres_65473 = r_idx_65451;
                            loopres_65474 = min_res_65364;
                        } else {
                            bool cond_65475 = slt64(abs_res_65463,
                                                    abs_res_65470);
                            bool cond_f_res_65476 = min_res_65456 ==
                                 r_idx_65451;
                            bool x_65477 = !cond_65475;
                            bool y_65478 = cond_f_res_65476 && x_65477;
                            bool cond_65479 = cond_65475 || y_65478;
                            int64_t loopres_f_res_65480;
                            
                            if (cond_65479) {
                                loopres_f_res_65480 = max_res_65454;
                            } else {
                                loopres_f_res_65480 = l_idx_65450;
                            }
                            
                            int64_t loopres_f_res_65481;
                            
                            if (cond_65479) {
                                loopres_f_res_65481 = r_idx_65451;
                            } else {
                                loopres_f_res_65481 = min_res_65456;
                            }
                            
                            int64_t loopres_f_res_65482;
                            
                            if (cond_65479) {
                                int64_t loopres_f_res_t_res_65483 =
                                        add64((int64_t) 1, span_65452);
                                
                                loopres_f_res_65482 = loopres_f_res_t_res_65483;
                            } else {
                                int64_t loopres_f_res_f_res_65484 =
                                        add64((int64_t) 1, span_65452);
                                
                                loopres_f_res_65482 = loopres_f_res_f_res_65484;
                            }
                            loopres_65472 = loopres_f_res_65480;
                            loopres_65473 = loopres_f_res_65481;
                            loopres_65474 = loopres_f_res_65482;
                        }
                        
                        bool loop_cond_65485 = slt64(loopres_65474,
                                                     min_res_65364);
                        bool loop_while_tmp_68312 = loop_cond_65485;
                        int64_t l_idx_tmp_68313 = loopres_65472;
                        int64_t r_idx_tmp_68314 = loopres_65473;
                        int64_t span_tmp_68315 = loopres_65474;
                        
                        loop_while_65449 = loop_while_tmp_68312;
                        l_idx_65450 = l_idx_tmp_68313;
                        r_idx_65451 = r_idx_tmp_68314;
                        span_65452 = span_tmp_68315;
                    }
                    idx_65445 = loop_while_65449;
                    idx_65446 = l_idx_65450;
                    idx_65447 = r_idx_65451;
                    idx_65448 = span_65452;
                    
                    int64_t min_res_65486 = smin64(min_arg_65409, idx_65446);
                    int64_t max_res_65487 = smax64((int64_t) 0, min_res_65486);
                    int64_t x_65488 = add64(min_res_65410, max_res_65487);
                    int64_t r_65489 = sub64(x_65488, (int64_t) 1);
                    bool x_65490 = sle64((int64_t) 0, r_65489);
                    bool y_65491 = slt64(r_65489, n_65344);
                    bool bounds_check_65492 = x_65490 && y_65491;
                    bool index_certs_65493;
                    
                    if (!bounds_check_65492) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) r_65489,
                                      "] out of bounds for array of shape [",
                                      (long long) n_65344, "].",
                                      "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
                        if (memblock_unref(ctx, &mem_67103, "mem_67103") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_67099, "mem_67099") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_67561,
                                           "ext_mem_67561") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_67569,
                                           "ext_mem_67569") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68163,
                                           "ext_mem_68163") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68171,
                                           "ext_mem_68171") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_68296,
                                           "mem_out_68296") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_65494;
                    
                    x_65494 = ((int64_t *) mem_67134)[r_65489];
                    
                    int64_t abs_arg_65495 = sub64(x_65494, min_res_65422);
                    int64_t abs_res_65496 = abs64(abs_arg_65495);
                    bool x_65497 = sle64((int64_t) 0, max_res_65487);
                    bool y_65498 = slt64(max_res_65487, n_65344);
                    bool bounds_check_65499 = x_65497 && y_65498;
                    bool index_certs_65500;
                    
                    if (!bounds_check_65499) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) max_res_65487,
                                      "] out of bounds for array of shape [",
                                      (long long) n_65344, "].",
                                      "-> #0  loess.fut:483:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
                        if (memblock_unref(ctx, &mem_67103, "mem_67103") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_67099, "mem_67099") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_67561,
                                           "ext_mem_67561") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_67569,
                                           "ext_mem_67569") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68163,
                                           "ext_mem_68163") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68171,
                                           "ext_mem_68171") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_68296,
                                           "mem_out_68296") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_65501;
                    
                    x_65501 = ((int64_t *) mem_67134)[max_res_65487];
                    
                    int64_t abs_arg_65502 = sub64(x_65501, min_res_65422);
                    int64_t abs_res_65503 = abs64(abs_arg_65502);
                    int64_t max_res_65504 = smax64(abs_res_65496,
                                                   abs_res_65503);
                    float defunc_0_f_res_65505 = sitofp_i64_f32(max_res_65504);
                    float defunc_1_f_res_65506 = max_res_65414 +
                          defunc_0_f_res_65505;
                    float defunc_2_reduce_res_65507;
                    float redout_66714 = 0.0F;
                    
                    for (int64_t i_66715 = 0; i_66715 < q_65346; i_66715++) {
                        float x_65512;
                        
                        x_65512 = ((float *) mem_67176)[i_66715];
                        
                        bool cond_65513 = sle64(last_res_65393, i_66715);
                        int64_t defunc_0_f_res_65514;
                        
                        if (cond_65513) {
                            defunc_0_f_res_65514 = (int64_t) 0;
                        } else {
                            int64_t i_65515 = add64(max_res_65487, i_66715);
                            int64_t defunc_0_add_arg_65516;
                            
                            defunc_0_add_arg_65516 =
                                ((int64_t *) mem_67134)[i_65515];
                            
                            int64_t defunc_1_add_res_65517 = add64((int64_t) 1,
                                                                   defunc_0_add_arg_65516);
                            
                            defunc_0_f_res_65514 = defunc_1_add_res_65517;
                        }
                        
                        int64_t binop_p_65518 = sub64(defunc_0_f_res_65514,
                                                      min_res_65422);
                        float defunc_0_f_res_65519 =
                              sitofp_i64_f32(binop_p_65518);
                        float abs_res_65520 =
                              (float) fabs(defunc_0_f_res_65519);
                        float tmp1_65521 = abs_res_65520 / defunc_1_f_res_65506;
                        float x_65522 = tmp1_65521 * tmp1_65521;
                        float y_65523 = tmp1_65521 * x_65522;
                        float tmp2_65524 = 1.0F - y_65523;
                        float x_65525 = tmp2_65524 * tmp2_65524;
                        float tmp3_65526 = tmp2_65524 * x_65525;
                        float w_j_65527 = x_65512 * tmp3_65526;
                        float defunc_1_op_res_65510 = w_j_65527 + redout_66714;
                        float redout_tmp_68316 = defunc_1_op_res_65510;
                        
                        redout_66714 = redout_tmp_68316;
                    }
                    defunc_2_reduce_res_65507 = redout_66714;
                    
                    float a0_65528 = 1.0F / defunc_2_reduce_res_65507;
                    float defunc_2_reduce_res_65529;
                    float redout_66716 = 0.0F;
                    
                    for (int64_t i_66717 = 0; i_66717 < q_65346; i_66717++) {
                        float x_65534;
                        
                        x_65534 = ((float *) mem_67176)[i_66717];
                        
                        bool cond_65535 = sle64(last_res_65393, i_66717);
                        int64_t defunc_0_f_res_65536;
                        
                        if (cond_65535) {
                            defunc_0_f_res_65536 = (int64_t) 0;
                        } else {
                            int64_t i_65537 = add64(max_res_65487, i_66717);
                            int64_t defunc_0_add_arg_65538;
                            
                            defunc_0_add_arg_65538 =
                                ((int64_t *) mem_67134)[i_65537];
                            
                            int64_t defunc_1_add_res_65539 = add64((int64_t) 1,
                                                                   defunc_0_add_arg_65538);
                            
                            defunc_0_f_res_65536 = defunc_1_add_res_65539;
                        }
                        
                        int64_t binop_p_65540 = sub64(defunc_0_f_res_65536,
                                                      min_res_65422);
                        float defunc_0_f_res_65541 =
                              sitofp_i64_f32(binop_p_65540);
                        float abs_res_65542 =
                              (float) fabs(defunc_0_f_res_65541);
                        float tmp1_65543 = abs_res_65542 / defunc_1_f_res_65506;
                        float x_65544 = tmp1_65543 * tmp1_65543;
                        float y_65545 = tmp1_65543 * x_65544;
                        float tmp2_65546 = 1.0F - y_65545;
                        float x_65547 = tmp2_65546 * tmp2_65546;
                        float tmp3_65548 = tmp2_65546 * x_65547;
                        float tmp4_65549 = x_65534 * tmp3_65548;
                        float defunc_0_f_res_65550;
                        
                        if (cond_65535) {
                            defunc_0_f_res_65550 = 0.0F;
                        } else {
                            int64_t i_65551 = add64(max_res_65487, i_66717);
                            float defunc_0_add_arg_65552;
                            
                            defunc_0_add_arg_65552 =
                                ((float *) mem_67131)[i_65551];
                            defunc_0_f_res_65550 = defunc_0_add_arg_65552;
                        }
                        
                        float x_65553 = a0_65528 * tmp4_65549;
                        float defunc_9_fit_fun_res_65554 =
                              defunc_0_f_res_65550 * x_65553;
                        float defunc_1_op_res_65532 =
                              defunc_9_fit_fun_res_65554 + redout_66716;
                        float redout_tmp_68317 = defunc_1_op_res_65532;
                        
                        redout_66716 = redout_tmp_68317;
                    }
                    defunc_2_reduce_res_65529 = redout_66716;
                    ((float *) mem_67103.mem)[i_66724 * n_m_65352 + i_66720] =
                        defunc_2_reduce_res_65529;
                }
            }
            if (memblock_set(ctx, &ext_mem_67569, &mem_67103, "mem_67103") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_67561, &mem_67099, "mem_67099") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_67103, "mem_67103") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_67099, "mem_67099") != 0)
                return 1;
        } else {
            bool match_lit_65557 = (int64_t) 1 == degree_65347;
            int64_t binop_x_67219 = m_65343 * n_m_65352;
            int64_t binop_y_67220 = (int64_t) 4 * binop_x_67219;
            int64_t bytes_67221 = smax64((int64_t) 0, binop_y_67220);
            int64_t binop_y_67247 = (int64_t) 8 * n_65344;
            int64_t bytes_67248 = smax64((int64_t) 0, binop_y_67247);
            int64_t binop_y_67262 = (int64_t) 4 * n_65344;
            int64_t bytes_67263 = smax64((int64_t) 0, binop_y_67262);
            int64_t binop_y_67307 = (int64_t) 4 * q_65346;
            int64_t bytes_67308 = smax64((int64_t) 0, binop_y_67307);
            int64_t binop_x_67382 = m_65343 * n_m_65352;
            int64_t binop_y_67383 = (int64_t) 4 * binop_x_67382;
            int64_t bytes_67384 = smax64((int64_t) 0, binop_y_67383);
            int64_t binop_y_67410 = (int64_t) 8 * n_65344;
            int64_t bytes_67411 = smax64((int64_t) 0, binop_y_67410);
            int64_t binop_y_67425 = (int64_t) 4 * n_65344;
            int64_t bytes_67426 = smax64((int64_t) 0, binop_y_67425);
            int64_t binop_y_67470 = (int64_t) 4 * q_65346;
            int64_t bytes_67471 = smax64((int64_t) 0, binop_y_67470);
            struct memblock ext_mem_67553;
            
            ext_mem_67553.references = NULL;
            
            struct memblock ext_mem_67545;
            
            ext_mem_67545.references = NULL;
            if (match_lit_65557) {
                struct memblock mem_67222;
                
                mem_67222.references = NULL;
                if (memblock_alloc(ctx, &mem_67222, bytes_67221, "mem_67222")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock mem_67226;
                
                mem_67226.references = NULL;
                if (memblock_alloc(ctx, &mem_67226, bytes_67221, "mem_67226")) {
                    err = 1;
                    goto cleanup;
                }
                if (mem_67249_cached_sizze_68454 < (size_t) bytes_67248) {
                    mem_67249 = realloc(mem_67249, bytes_67248);
                    mem_67249_cached_sizze_68454 = bytes_67248;
                }
                if (mem_67264_cached_sizze_68455 < (size_t) bytes_67263) {
                    mem_67264 = realloc(mem_67264, bytes_67263);
                    mem_67264_cached_sizze_68455 = bytes_67263;
                }
                if (mem_67267_cached_sizze_68456 < (size_t) bytes_67248) {
                    mem_67267 = realloc(mem_67267, bytes_67248);
                    mem_67267_cached_sizze_68456 = bytes_67248;
                }
                if (mem_67294_cached_sizze_68457 < (size_t) bytes_67248) {
                    mem_67294 = realloc(mem_67294, bytes_67248);
                    mem_67294_cached_sizze_68457 = bytes_67248;
                }
                if (mem_67309_cached_sizze_68458 < (size_t) bytes_67308) {
                    mem_67309 = realloc(mem_67309, bytes_67308);
                    mem_67309_cached_sizze_68458 = bytes_67308;
                }
                for (int64_t i_66766 = 0; i_66766 < m_65343; i_66766++) {
                    int64_t discard_66731;
                    int64_t scanacc_66727 = (int64_t) 0;
                    
                    for (int64_t i_66729 = 0; i_66729 < n_65344; i_66729++) {
                        float x_65568;
                        
                        x_65568 = ((float *) Y_mem_67095.mem)[i_66766 *
                                                              n_65344 +
                                                              i_66729];
                        
                        bool isnan_res_65569;
                        
                        isnan_res_65569 = futrts_isnan32(x_65568);
                        
                        bool defunc_0_p_res_65570 = !isnan_res_65569;
                        int64_t defunc_0_f_res_65571 =
                                btoi_bool_i64(defunc_0_p_res_65570);
                        int64_t defunc_1_op_res_65567 =
                                add64(defunc_0_f_res_65571, scanacc_66727);
                        
                        ((int64_t *) mem_67249)[i_66729] =
                            defunc_1_op_res_65567;
                        
                        int64_t scanacc_tmp_68320 = defunc_1_op_res_65567;
                        
                        scanacc_66727 = scanacc_tmp_68320;
                    }
                    discard_66731 = scanacc_66727;
                    
                    int64_t last_res_65572;
                    
                    last_res_65572 = ((int64_t *) mem_67249)[i_65358];
                    for (int64_t i_68322 = 0; i_68322 < n_65344; i_68322++) {
                        ((float *) mem_67264)[i_68322] = 0.0F;
                    }
                    for (int64_t i_68323 = 0; i_68323 < n_65344; i_68323++) {
                        ((int64_t *) mem_67267)[i_68323] = (int64_t) -1;
                    }
                    for (int64_t write_iter_66732 = 0; write_iter_66732 <
                         n_65344; write_iter_66732++) {
                        float write_iv_66735;
                        
                        write_iv_66735 = ((float *) Y_mem_67095.mem)[i_66766 *
                                                                     n_65344 +
                                                                     write_iter_66732];
                        
                        int64_t write_iv_66736;
                        
                        write_iv_66736 =
                            ((int64_t *) mem_67249)[write_iter_66732];
                        
                        bool isnan_res_65580;
                        
                        isnan_res_65580 = futrts_isnan32(write_iv_66735);
                        
                        bool defunc_0_p_res_65581 = !isnan_res_65580;
                        int64_t defunc_1_f_res_65582;
                        
                        if (defunc_0_p_res_65581) {
                            int64_t defunc_1_f_res_t_res_65583 =
                                    sub64(write_iv_66736, (int64_t) 1);
                            
                            defunc_1_f_res_65582 = defunc_1_f_res_t_res_65583;
                        } else {
                            defunc_1_f_res_65582 = (int64_t) -1;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_65582) &&
                            slt64(defunc_1_f_res_65582, n_65344)) {
                            ((int64_t *) mem_67267)[defunc_1_f_res_65582] =
                                write_iter_66732;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_65582) &&
                            slt64(defunc_1_f_res_65582, n_65344)) {
                            if ((int64_t) 4 > 0)
                                memmove(mem_67264 + defunc_1_f_res_65582 *
                                        (int64_t) 4, Y_mem_67095.mem +
                                        (i_66766 * n_65344 + write_iter_66732) *
                                        (int64_t) 4, (int64_t) 4);
                        }
                    }
                    for (int64_t i_66742 = 0; i_66742 < n_65344; i_66742++) {
                        int64_t x_65585;
                        
                        x_65585 = ((int64_t *) mem_67267)[i_66742];
                        
                        int64_t defunc_0_f_res_65586 = add64((int64_t) 1,
                                                             x_65585);
                        
                        ((int64_t *) mem_67294)[i_66742] = defunc_0_f_res_65586;
                    }
                    
                    int64_t min_arg_65587 = sub64(last_res_65572, (int64_t) 1);
                    int64_t min_arg_65588 = sub64(last_res_65572,
                                                  min_res_65364);
                    int64_t min_res_65589 = smin64(q_65346, last_res_65572);
                    float i64_res_65590 = sitofp_i64_f32(last_res_65572);
                    float x_65591 = i64_res_65370 - i64_res_65590;
                    float max_arg_65592 = x_65591 / 2.0F;
                    float max_res_65593 = fmax32(0.0F, max_arg_65592);
                    
                    for (int64_t i_66746 = 0; i_66746 < q_65346; i_66746++) {
                        bool cond_65596 = sle64(last_res_65572, i_66746);
                        float defunc_0_f_res_65597;
                        
                        if (cond_65596) {
                            defunc_0_f_res_65597 = 0.0F;
                        } else {
                            defunc_0_f_res_65597 = 1.0F;
                        }
                        ((float *) mem_67309)[i_66746] = defunc_0_f_res_65597;
                    }
                    for (int64_t i_66759 = 0; i_66759 < n_m_65352; i_66759++) {
                        int64_t min_arg_65601 = mul64(jump_65348, i_66759);
                        int64_t min_res_65602 = smin64(i_65358, min_arg_65601);
                        int64_t defunc_0_g_res_65603 = add64((int64_t) 1,
                                                             min_res_65602);
                        bool init_idx_65604;
                        int64_t init_idx_65605;
                        int64_t init_idx_65606;
                        bool loop_while_65607;
                        int64_t low_65608;
                        int64_t high_65609;
                        
                        loop_while_65607 = x_65359;
                        low_65608 = (int64_t) 0;
                        high_65609 = i_65358;
                        while (loop_while_65607) {
                            int64_t x_65610 = add64(low_65608, high_65609);
                            int64_t mid_65611 = sdiv64(x_65610, (int64_t) 2);
                            bool x_65612 = sle64((int64_t) 0, mid_65611);
                            bool y_65613 = slt64(mid_65611, n_65344);
                            bool bounds_check_65614 = x_65612 && y_65613;
                            bool index_certs_65615;
                            
                            if (!bounds_check_65614) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [", (long long) mid_65611,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65344, "].",
                                              "-> #0  loess.fut:449:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                                if (memblock_unref(ctx, &mem_67226,
                                                   "mem_67226") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67222,
                                                   "mem_67222") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67545,
                                                   "ext_mem_67545") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67553,
                                                   "ext_mem_67553") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67561,
                                                   "ext_mem_67561") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67569,
                                                   "ext_mem_67569") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68163,
                                                   "ext_mem_68163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68171,
                                                   "ext_mem_68171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68296,
                                                   "mem_out_68296") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t mid_id_65616;
                            
                            mid_id_65616 = ((int64_t *) mem_67294)[mid_65611];
                            
                            bool cond_65617 = slt64(mid_id_65616, (int64_t) 0);
                            int64_t mid_idx_65618;
                            
                            if (cond_65617) {
                                mid_idx_65618 = (int64_t) 9223372036854775807;
                            } else {
                                mid_idx_65618 = mid_id_65616;
                            }
                            
                            bool cond_65619 = sle64(defunc_0_g_res_65603,
                                                    mid_idx_65618);
                            int64_t loopres_65620;
                            int64_t loopres_65621;
                            
                            if (cond_65619) {
                                int64_t loopres_t_res_65622 = sub64(mid_65611,
                                                                    (int64_t) 1);
                                
                                loopres_65620 = low_65608;
                                loopres_65621 = loopres_t_res_65622;
                            } else {
                                int64_t loopres_f_res_65623 = add64((int64_t) 1,
                                                                    mid_65611);
                                
                                loopres_65620 = loopres_f_res_65623;
                                loopres_65621 = high_65609;
                            }
                            
                            bool loop_cond_65624 = sle64(loopres_65620,
                                                         loopres_65621);
                            bool loop_while_tmp_68330 = loop_cond_65624;
                            int64_t low_tmp_68331 = loopres_65620;
                            int64_t high_tmp_68332 = loopres_65621;
                            
                            loop_while_65607 = loop_while_tmp_68330;
                            low_65608 = low_tmp_68331;
                            high_65609 = high_tmp_68332;
                        }
                        init_idx_65604 = loop_while_65607;
                        init_idx_65605 = low_65608;
                        init_idx_65606 = high_65609;
                        
                        bool idx_65625;
                        int64_t idx_65626;
                        int64_t idx_65627;
                        int64_t idx_65628;
                        bool loop_while_65629;
                        int64_t l_idx_65630;
                        int64_t r_idx_65631;
                        int64_t span_65632;
                        
                        loop_while_65629 = loop_cond_65369;
                        l_idx_65630 = init_idx_65605;
                        r_idx_65631 = init_idx_65605;
                        span_65632 = (int64_t) 1;
                        while (loop_while_65629) {
                            int64_t max_arg_65633 = sub64(l_idx_65630,
                                                          (int64_t) 1);
                            int64_t max_res_65634 = smax64((int64_t) 0,
                                                           max_arg_65633);
                            int64_t min_arg_65635 = add64((int64_t) 1,
                                                          r_idx_65631);
                            int64_t min_res_65636 = smin64(min_arg_65587,
                                                           min_arg_65635);
                            bool x_65637 = sle64((int64_t) 0, max_res_65634);
                            bool y_65638 = slt64(max_res_65634, n_65344);
                            bool bounds_check_65639 = x_65637 && y_65638;
                            bool index_certs_65640;
                            
                            if (!bounds_check_65639) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) max_res_65634,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65344, "].",
                                              "-> #0  loess.fut:459:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                                if (memblock_unref(ctx, &mem_67226,
                                                   "mem_67226") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67222,
                                                   "mem_67222") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67545,
                                                   "ext_mem_67545") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67553,
                                                   "ext_mem_67553") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67561,
                                                   "ext_mem_67561") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67569,
                                                   "ext_mem_67569") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68163,
                                                   "ext_mem_68163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68171,
                                                   "ext_mem_68171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68296,
                                                   "mem_out_68296") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_65641;
                            
                            x_65641 = ((int64_t *) mem_67294)[max_res_65634];
                            
                            int64_t abs_arg_65642 = sub64(x_65641,
                                                          defunc_0_g_res_65603);
                            int64_t abs_res_65643 = abs64(abs_arg_65642);
                            bool x_65644 = sle64((int64_t) 0, min_res_65636);
                            bool y_65645 = slt64(min_res_65636, n_65344);
                            bool bounds_check_65646 = x_65644 && y_65645;
                            bool index_certs_65647;
                            
                            if (!bounds_check_65646) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) min_res_65636,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65344, "].",
                                              "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                                if (memblock_unref(ctx, &mem_67226,
                                                   "mem_67226") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67222,
                                                   "mem_67222") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67545,
                                                   "ext_mem_67545") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67553,
                                                   "ext_mem_67553") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67561,
                                                   "ext_mem_67561") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67569,
                                                   "ext_mem_67569") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68163,
                                                   "ext_mem_68163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68171,
                                                   "ext_mem_68171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68296,
                                                   "mem_out_68296") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_65648;
                            
                            x_65648 = ((int64_t *) mem_67294)[min_res_65636];
                            
                            int64_t abs_arg_65649 = sub64(x_65648,
                                                          defunc_0_g_res_65603);
                            int64_t abs_res_65650 = abs64(abs_arg_65649);
                            bool cond_65651 = max_res_65634 == l_idx_65630;
                            int64_t loopres_65652;
                            int64_t loopres_65653;
                            int64_t loopres_65654;
                            
                            if (cond_65651) {
                                loopres_65652 = l_idx_65630;
                                loopres_65653 = r_idx_65631;
                                loopres_65654 = min_res_65364;
                            } else {
                                bool cond_65655 = slt64(abs_res_65643,
                                                        abs_res_65650);
                                bool cond_f_res_65656 = min_res_65636 ==
                                     r_idx_65631;
                                bool x_65657 = !cond_65655;
                                bool y_65658 = cond_f_res_65656 && x_65657;
                                bool cond_65659 = cond_65655 || y_65658;
                                int64_t loopres_f_res_65660;
                                
                                if (cond_65659) {
                                    loopres_f_res_65660 = max_res_65634;
                                } else {
                                    loopres_f_res_65660 = l_idx_65630;
                                }
                                
                                int64_t loopres_f_res_65661;
                                
                                if (cond_65659) {
                                    loopres_f_res_65661 = r_idx_65631;
                                } else {
                                    loopres_f_res_65661 = min_res_65636;
                                }
                                
                                int64_t loopres_f_res_65662;
                                
                                if (cond_65659) {
                                    int64_t loopres_f_res_t_res_65663 =
                                            add64((int64_t) 1, span_65632);
                                    
                                    loopres_f_res_65662 =
                                        loopres_f_res_t_res_65663;
                                } else {
                                    int64_t loopres_f_res_f_res_65664 =
                                            add64((int64_t) 1, span_65632);
                                    
                                    loopres_f_res_65662 =
                                        loopres_f_res_f_res_65664;
                                }
                                loopres_65652 = loopres_f_res_65660;
                                loopres_65653 = loopres_f_res_65661;
                                loopres_65654 = loopres_f_res_65662;
                            }
                            
                            bool loop_cond_65665 = slt64(loopres_65654,
                                                         min_res_65364);
                            bool loop_while_tmp_68333 = loop_cond_65665;
                            int64_t l_idx_tmp_68334 = loopres_65652;
                            int64_t r_idx_tmp_68335 = loopres_65653;
                            int64_t span_tmp_68336 = loopres_65654;
                            
                            loop_while_65629 = loop_while_tmp_68333;
                            l_idx_65630 = l_idx_tmp_68334;
                            r_idx_65631 = r_idx_tmp_68335;
                            span_65632 = span_tmp_68336;
                        }
                        idx_65625 = loop_while_65629;
                        idx_65626 = l_idx_65630;
                        idx_65627 = r_idx_65631;
                        idx_65628 = span_65632;
                        
                        int64_t min_res_65666 = smin64(min_arg_65588,
                                                       idx_65626);
                        int64_t max_res_65667 = smax64((int64_t) 0,
                                                       min_res_65666);
                        int64_t x_65668 = add64(min_res_65589, max_res_65667);
                        int64_t r_65669 = sub64(x_65668, (int64_t) 1);
                        bool x_65670 = sle64((int64_t) 0, r_65669);
                        bool y_65671 = slt64(r_65669, n_65344);
                        bool bounds_check_65672 = x_65670 && y_65671;
                        bool index_certs_65673;
                        
                        if (!bounds_check_65672) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) r_65669,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67226, "mem_67226") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67222, "mem_67222") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67545,
                                               "ext_mem_67545") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67553,
                                               "ext_mem_67553") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67561,
                                               "ext_mem_67561") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67569,
                                               "ext_mem_67569") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_65674;
                        
                        x_65674 = ((int64_t *) mem_67267)[r_65669];
                        
                        int64_t abs_arg_65675 = sub64(x_65674, min_res_65602);
                        int64_t abs_res_65676 = abs64(abs_arg_65675);
                        bool x_65677 = sle64((int64_t) 0, max_res_65667);
                        bool y_65678 = slt64(max_res_65667, n_65344);
                        bool bounds_check_65679 = x_65677 && y_65678;
                        bool index_certs_65680;
                        
                        if (!bounds_check_65679) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) max_res_65667,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:483:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67226, "mem_67226") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67222, "mem_67222") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67545,
                                               "ext_mem_67545") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67553,
                                               "ext_mem_67553") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67561,
                                               "ext_mem_67561") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67569,
                                               "ext_mem_67569") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_65681;
                        
                        x_65681 = ((int64_t *) mem_67267)[max_res_65667];
                        
                        int64_t abs_arg_65682 = sub64(x_65681, min_res_65602);
                        int64_t abs_res_65683 = abs64(abs_arg_65682);
                        int64_t max_res_65684 = smax64(abs_res_65676,
                                                       abs_res_65683);
                        float defunc_0_f_res_65685 =
                              sitofp_i64_f32(max_res_65684);
                        float defunc_1_f_res_65686 = max_res_65593 +
                              defunc_0_f_res_65685;
                        float defunc_2_reduce_res_65687;
                        float defunc_2_reduce_res_65688;
                        float defunc_2_reduce_res_65689;
                        float redout_66748;
                        float redout_66749;
                        float redout_66750;
                        
                        redout_66748 = 0.0F;
                        redout_66749 = 0.0F;
                        redout_66750 = 0.0F;
                        for (int64_t i_66751 = 0; i_66751 < q_65346;
                             i_66751++) {
                            float x_65700;
                            
                            x_65700 = ((float *) mem_67309)[i_66751];
                            
                            bool cond_65701 = sle64(last_res_65572, i_66751);
                            int64_t defunc_0_f_res_65702;
                            
                            if (cond_65701) {
                                defunc_0_f_res_65702 = (int64_t) 0;
                            } else {
                                int64_t i_65703 = add64(max_res_65667, i_66751);
                                int64_t defunc_0_add_arg_65704;
                                
                                defunc_0_add_arg_65704 =
                                    ((int64_t *) mem_67267)[i_65703];
                                
                                int64_t defunc_1_add_res_65705 =
                                        add64((int64_t) 1,
                                              defunc_0_add_arg_65704);
                                
                                defunc_0_f_res_65702 = defunc_1_add_res_65705;
                            }
                            
                            int64_t binop_p_65706 = sub64(defunc_0_f_res_65702,
                                                          min_res_65602);
                            float defunc_0_f_res_65707 =
                                  sitofp_i64_f32(binop_p_65706);
                            float abs_res_65708 =
                                  (float) fabs(defunc_0_f_res_65707);
                            float tmp1_65709 = abs_res_65708 /
                                  defunc_1_f_res_65686;
                            float x_65710 = tmp1_65709 * tmp1_65709;
                            float y_65711 = tmp1_65709 * x_65710;
                            float tmp2_65712 = 1.0F - y_65711;
                            float x_65713 = tmp2_65712 * tmp2_65712;
                            float tmp3_65714 = tmp2_65712 * x_65713;
                            float w_j_65715 = x_65700 * tmp3_65714;
                            float xw_j_65716 = defunc_0_f_res_65707 * w_j_65715;
                            float x2w_j_65717 = defunc_0_f_res_65707 *
                                  xw_j_65716;
                            float defunc_1_op_res_65692 = w_j_65715 +
                                  redout_66748;
                            float defunc_1_op_res_65695 = xw_j_65716 +
                                  redout_66749;
                            float defunc_1_op_res_65698 = x2w_j_65717 +
                                  redout_66750;
                            float redout_tmp_68337 = defunc_1_op_res_65692;
                            float redout_tmp_68338 = defunc_1_op_res_65695;
                            float redout_tmp_68339 = defunc_1_op_res_65698;
                            
                            redout_66748 = redout_tmp_68337;
                            redout_66749 = redout_tmp_68338;
                            redout_66750 = redout_tmp_68339;
                        }
                        defunc_2_reduce_res_65687 = redout_66748;
                        defunc_2_reduce_res_65688 = redout_66749;
                        defunc_2_reduce_res_65689 = redout_66750;
                        
                        float x_65718 = defunc_2_reduce_res_65687 *
                              defunc_2_reduce_res_65689;
                        float y_65719 = defunc_2_reduce_res_65688 *
                              defunc_2_reduce_res_65688;
                        float y_65720 = x_65718 - y_65719;
                        float det1_65721 = 1.0F / y_65720;
                        float a11_65722 = defunc_2_reduce_res_65689 *
                              det1_65721;
                        float x_65723 = 0.0F - defunc_2_reduce_res_65688;
                        float b11_65724 = det1_65721 * x_65723;
                        float c11_65725 = defunc_2_reduce_res_65687 *
                              det1_65721;
                        float defunc_2_reduce_res_65726;
                        float defunc_2_reduce_res_65727;
                        float redout_66752;
                        float redout_66753;
                        
                        redout_66752 = 0.0F;
                        redout_66753 = 0.0F;
                        for (int64_t i_66754 = 0; i_66754 < q_65346;
                             i_66754++) {
                            float x_65735;
                            
                            x_65735 = ((float *) mem_67309)[i_66754];
                            
                            bool cond_65736 = sle64(last_res_65572, i_66754);
                            int64_t defunc_0_f_res_65737;
                            
                            if (cond_65736) {
                                defunc_0_f_res_65737 = (int64_t) 0;
                            } else {
                                int64_t i_65738 = add64(max_res_65667, i_66754);
                                int64_t defunc_0_add_arg_65739;
                                
                                defunc_0_add_arg_65739 =
                                    ((int64_t *) mem_67267)[i_65738];
                                
                                int64_t defunc_1_add_res_65740 =
                                        add64((int64_t) 1,
                                              defunc_0_add_arg_65739);
                                
                                defunc_0_f_res_65737 = defunc_1_add_res_65740;
                            }
                            
                            int64_t binop_p_65741 = sub64(defunc_0_f_res_65737,
                                                          min_res_65602);
                            float defunc_0_f_res_65742 =
                                  sitofp_i64_f32(binop_p_65741);
                            float abs_res_65743 =
                                  (float) fabs(defunc_0_f_res_65742);
                            float tmp1_65744 = abs_res_65743 /
                                  defunc_1_f_res_65686;
                            float x_65745 = tmp1_65744 * tmp1_65744;
                            float y_65746 = tmp1_65744 * x_65745;
                            float tmp2_65747 = 1.0F - y_65746;
                            float x_65748 = tmp2_65747 * tmp2_65747;
                            float tmp3_65749 = tmp2_65747 * x_65748;
                            float tmp4_65750 = x_65735 * tmp3_65749;
                            float defunc_1_f_res_65751 = defunc_0_f_res_65742 *
                                  tmp4_65750;
                            float defunc_0_f_res_65752;
                            
                            if (cond_65736) {
                                defunc_0_f_res_65752 = 0.0F;
                            } else {
                                int64_t i_65753 = add64(max_res_65667, i_66754);
                                float defunc_0_add_arg_65754;
                                
                                defunc_0_add_arg_65754 =
                                    ((float *) mem_67264)[i_65753];
                                defunc_0_f_res_65752 = defunc_0_add_arg_65754;
                            }
                            
                            float x_65755 = a11_65722 * tmp4_65750;
                            float y_65756 = b11_65724 * defunc_1_f_res_65751;
                            float x_65757 = x_65755 + y_65756;
                            float defunc_9_fit_fun_res_65758 =
                                  defunc_0_f_res_65752 * x_65757;
                            float x_65759 = b11_65724 * tmp4_65750;
                            float y_65760 = c11_65725 * defunc_1_f_res_65751;
                            float x_65761 = x_65759 + y_65760;
                            float defunc_9_slope_fun_res_65762 =
                                  defunc_0_f_res_65752 * x_65761;
                            float defunc_1_op_res_65730 =
                                  defunc_9_fit_fun_res_65758 + redout_66752;
                            float defunc_1_op_res_65733 =
                                  defunc_9_slope_fun_res_65762 + redout_66753;
                            float redout_tmp_68340 = defunc_1_op_res_65730;
                            float redout_tmp_68341 = defunc_1_op_res_65733;
                            
                            redout_66752 = redout_tmp_68340;
                            redout_66753 = redout_tmp_68341;
                        }
                        defunc_2_reduce_res_65726 = redout_66752;
                        defunc_2_reduce_res_65727 = redout_66753;
                        ((float *) mem_67222.mem)[i_66766 * n_m_65352 +
                                                  i_66759] =
                            defunc_2_reduce_res_65726;
                        ((float *) mem_67226.mem)[i_66766 * n_m_65352 +
                                                  i_66759] =
                            defunc_2_reduce_res_65727;
                    }
                }
                if (memblock_set(ctx, &ext_mem_67553, &mem_67222,
                                 "mem_67222") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_67545, &mem_67226,
                                 "mem_67226") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67226, "mem_67226") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67222, "mem_67222") != 0)
                    return 1;
            } else {
                struct memblock mem_67385;
                
                mem_67385.references = NULL;
                if (memblock_alloc(ctx, &mem_67385, bytes_67384, "mem_67385")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock mem_67389;
                
                mem_67389.references = NULL;
                if (memblock_alloc(ctx, &mem_67389, bytes_67384, "mem_67389")) {
                    err = 1;
                    goto cleanup;
                }
                if (mem_67412_cached_sizze_68459 < (size_t) bytes_67411) {
                    mem_67412 = realloc(mem_67412, bytes_67411);
                    mem_67412_cached_sizze_68459 = bytes_67411;
                }
                if (mem_67427_cached_sizze_68460 < (size_t) bytes_67426) {
                    mem_67427 = realloc(mem_67427, bytes_67426);
                    mem_67427_cached_sizze_68460 = bytes_67426;
                }
                if (mem_67430_cached_sizze_68461 < (size_t) bytes_67411) {
                    mem_67430 = realloc(mem_67430, bytes_67411);
                    mem_67430_cached_sizze_68461 = bytes_67411;
                }
                if (mem_67457_cached_sizze_68462 < (size_t) bytes_67411) {
                    mem_67457 = realloc(mem_67457, bytes_67411);
                    mem_67457_cached_sizze_68462 = bytes_67411;
                }
                if (mem_67472_cached_sizze_68463 < (size_t) bytes_67471) {
                    mem_67472 = realloc(mem_67472, bytes_67471);
                    mem_67472_cached_sizze_68463 = bytes_67471;
                }
                for (int64_t i_66811 = 0; i_66811 < m_65343; i_66811++) {
                    int64_t discard_66774;
                    int64_t scanacc_66770 = (int64_t) 0;
                    
                    for (int64_t i_66772 = 0; i_66772 < n_65344; i_66772++) {
                        float x_65773;
                        
                        x_65773 = ((float *) Y_mem_67095.mem)[i_66811 *
                                                              n_65344 +
                                                              i_66772];
                        
                        bool isnan_res_65774;
                        
                        isnan_res_65774 = futrts_isnan32(x_65773);
                        
                        bool defunc_0_p_res_65775 = !isnan_res_65774;
                        int64_t defunc_0_f_res_65776 =
                                btoi_bool_i64(defunc_0_p_res_65775);
                        int64_t defunc_1_op_res_65772 =
                                add64(defunc_0_f_res_65776, scanacc_66770);
                        
                        ((int64_t *) mem_67412)[i_66772] =
                            defunc_1_op_res_65772;
                        
                        int64_t scanacc_tmp_68344 = defunc_1_op_res_65772;
                        
                        scanacc_66770 = scanacc_tmp_68344;
                    }
                    discard_66774 = scanacc_66770;
                    
                    int64_t last_res_65777;
                    
                    last_res_65777 = ((int64_t *) mem_67412)[i_65358];
                    for (int64_t i_68346 = 0; i_68346 < n_65344; i_68346++) {
                        ((float *) mem_67427)[i_68346] = 0.0F;
                    }
                    for (int64_t i_68347 = 0; i_68347 < n_65344; i_68347++) {
                        ((int64_t *) mem_67430)[i_68347] = (int64_t) -1;
                    }
                    for (int64_t write_iter_66775 = 0; write_iter_66775 <
                         n_65344; write_iter_66775++) {
                        float write_iv_66778;
                        
                        write_iv_66778 = ((float *) Y_mem_67095.mem)[i_66811 *
                                                                     n_65344 +
                                                                     write_iter_66775];
                        
                        int64_t write_iv_66779;
                        
                        write_iv_66779 =
                            ((int64_t *) mem_67412)[write_iter_66775];
                        
                        bool isnan_res_65785;
                        
                        isnan_res_65785 = futrts_isnan32(write_iv_66778);
                        
                        bool defunc_0_p_res_65786 = !isnan_res_65785;
                        int64_t defunc_1_f_res_65787;
                        
                        if (defunc_0_p_res_65786) {
                            int64_t defunc_1_f_res_t_res_65788 =
                                    sub64(write_iv_66779, (int64_t) 1);
                            
                            defunc_1_f_res_65787 = defunc_1_f_res_t_res_65788;
                        } else {
                            defunc_1_f_res_65787 = (int64_t) -1;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_65787) &&
                            slt64(defunc_1_f_res_65787, n_65344)) {
                            ((int64_t *) mem_67430)[defunc_1_f_res_65787] =
                                write_iter_66775;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_65787) &&
                            slt64(defunc_1_f_res_65787, n_65344)) {
                            if ((int64_t) 4 > 0)
                                memmove(mem_67427 + defunc_1_f_res_65787 *
                                        (int64_t) 4, Y_mem_67095.mem +
                                        (i_66811 * n_65344 + write_iter_66775) *
                                        (int64_t) 4, (int64_t) 4);
                        }
                    }
                    for (int64_t i_66785 = 0; i_66785 < n_65344; i_66785++) {
                        int64_t x_65790;
                        
                        x_65790 = ((int64_t *) mem_67430)[i_66785];
                        
                        int64_t defunc_0_f_res_65791 = add64((int64_t) 1,
                                                             x_65790);
                        
                        ((int64_t *) mem_67457)[i_66785] = defunc_0_f_res_65791;
                    }
                    
                    int64_t min_arg_65792 = sub64(last_res_65777, (int64_t) 1);
                    int64_t min_arg_65793 = sub64(last_res_65777,
                                                  min_res_65364);
                    int64_t min_res_65794 = smin64(q_65346, last_res_65777);
                    float i64_res_65795 = sitofp_i64_f32(last_res_65777);
                    float x_65796 = i64_res_65370 - i64_res_65795;
                    float max_arg_65797 = x_65796 / 2.0F;
                    float max_res_65798 = fmax32(0.0F, max_arg_65797);
                    
                    for (int64_t i_66789 = 0; i_66789 < q_65346; i_66789++) {
                        bool cond_65801 = sle64(last_res_65777, i_66789);
                        float defunc_0_f_res_65802;
                        
                        if (cond_65801) {
                            defunc_0_f_res_65802 = 0.0F;
                        } else {
                            defunc_0_f_res_65802 = 1.0F;
                        }
                        ((float *) mem_67472)[i_66789] = defunc_0_f_res_65802;
                    }
                    for (int64_t i_66804 = 0; i_66804 < n_m_65352; i_66804++) {
                        int64_t min_arg_65806 = mul64(jump_65348, i_66804);
                        int64_t min_res_65807 = smin64(i_65358, min_arg_65806);
                        int64_t defunc_0_g_res_65808 = add64((int64_t) 1,
                                                             min_res_65807);
                        bool init_idx_65809;
                        int64_t init_idx_65810;
                        int64_t init_idx_65811;
                        bool loop_while_65812;
                        int64_t low_65813;
                        int64_t high_65814;
                        
                        loop_while_65812 = x_65359;
                        low_65813 = (int64_t) 0;
                        high_65814 = i_65358;
                        while (loop_while_65812) {
                            int64_t x_65815 = add64(low_65813, high_65814);
                            int64_t mid_65816 = sdiv64(x_65815, (int64_t) 2);
                            bool x_65817 = sle64((int64_t) 0, mid_65816);
                            bool y_65818 = slt64(mid_65816, n_65344);
                            bool bounds_check_65819 = x_65817 && y_65818;
                            bool index_certs_65820;
                            
                            if (!bounds_check_65819) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [", (long long) mid_65816,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65344, "].",
                                              "-> #0  loess.fut:449:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                                if (memblock_unref(ctx, &mem_67389,
                                                   "mem_67389") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67385,
                                                   "mem_67385") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67545,
                                                   "ext_mem_67545") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67553,
                                                   "ext_mem_67553") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67561,
                                                   "ext_mem_67561") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67569,
                                                   "ext_mem_67569") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68163,
                                                   "ext_mem_68163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68171,
                                                   "ext_mem_68171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68296,
                                                   "mem_out_68296") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t mid_id_65821;
                            
                            mid_id_65821 = ((int64_t *) mem_67457)[mid_65816];
                            
                            bool cond_65822 = slt64(mid_id_65821, (int64_t) 0);
                            int64_t mid_idx_65823;
                            
                            if (cond_65822) {
                                mid_idx_65823 = (int64_t) 9223372036854775807;
                            } else {
                                mid_idx_65823 = mid_id_65821;
                            }
                            
                            bool cond_65824 = sle64(defunc_0_g_res_65808,
                                                    mid_idx_65823);
                            int64_t loopres_65825;
                            int64_t loopres_65826;
                            
                            if (cond_65824) {
                                int64_t loopres_t_res_65827 = sub64(mid_65816,
                                                                    (int64_t) 1);
                                
                                loopres_65825 = low_65813;
                                loopres_65826 = loopres_t_res_65827;
                            } else {
                                int64_t loopres_f_res_65828 = add64((int64_t) 1,
                                                                    mid_65816);
                                
                                loopres_65825 = loopres_f_res_65828;
                                loopres_65826 = high_65814;
                            }
                            
                            bool loop_cond_65829 = sle64(loopres_65825,
                                                         loopres_65826);
                            bool loop_while_tmp_68354 = loop_cond_65829;
                            int64_t low_tmp_68355 = loopres_65825;
                            int64_t high_tmp_68356 = loopres_65826;
                            
                            loop_while_65812 = loop_while_tmp_68354;
                            low_65813 = low_tmp_68355;
                            high_65814 = high_tmp_68356;
                        }
                        init_idx_65809 = loop_while_65812;
                        init_idx_65810 = low_65813;
                        init_idx_65811 = high_65814;
                        
                        bool idx_65830;
                        int64_t idx_65831;
                        int64_t idx_65832;
                        int64_t idx_65833;
                        bool loop_while_65834;
                        int64_t l_idx_65835;
                        int64_t r_idx_65836;
                        int64_t span_65837;
                        
                        loop_while_65834 = loop_cond_65369;
                        l_idx_65835 = init_idx_65810;
                        r_idx_65836 = init_idx_65810;
                        span_65837 = (int64_t) 1;
                        while (loop_while_65834) {
                            int64_t max_arg_65838 = sub64(l_idx_65835,
                                                          (int64_t) 1);
                            int64_t max_res_65839 = smax64((int64_t) 0,
                                                           max_arg_65838);
                            int64_t min_arg_65840 = add64((int64_t) 1,
                                                          r_idx_65836);
                            int64_t min_res_65841 = smin64(min_arg_65792,
                                                           min_arg_65840);
                            bool x_65842 = sle64((int64_t) 0, max_res_65839);
                            bool y_65843 = slt64(max_res_65839, n_65344);
                            bool bounds_check_65844 = x_65842 && y_65843;
                            bool index_certs_65845;
                            
                            if (!bounds_check_65844) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) max_res_65839,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65344, "].",
                                              "-> #0  loess.fut:459:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                                if (memblock_unref(ctx, &mem_67389,
                                                   "mem_67389") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67385,
                                                   "mem_67385") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67545,
                                                   "ext_mem_67545") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67553,
                                                   "ext_mem_67553") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67561,
                                                   "ext_mem_67561") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67569,
                                                   "ext_mem_67569") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68163,
                                                   "ext_mem_68163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68171,
                                                   "ext_mem_68171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68296,
                                                   "mem_out_68296") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_65846;
                            
                            x_65846 = ((int64_t *) mem_67457)[max_res_65839];
                            
                            int64_t abs_arg_65847 = sub64(x_65846,
                                                          defunc_0_g_res_65808);
                            int64_t abs_res_65848 = abs64(abs_arg_65847);
                            bool x_65849 = sle64((int64_t) 0, min_res_65841);
                            bool y_65850 = slt64(min_res_65841, n_65344);
                            bool bounds_check_65851 = x_65849 && y_65850;
                            bool index_certs_65852;
                            
                            if (!bounds_check_65851) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) min_res_65841,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65344, "].",
                                              "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                                if (memblock_unref(ctx, &mem_67389,
                                                   "mem_67389") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67385,
                                                   "mem_67385") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67545,
                                                   "ext_mem_67545") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67553,
                                                   "ext_mem_67553") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67561,
                                                   "ext_mem_67561") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67569,
                                                   "ext_mem_67569") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68163,
                                                   "ext_mem_68163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68171,
                                                   "ext_mem_68171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68296,
                                                   "mem_out_68296") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_65853;
                            
                            x_65853 = ((int64_t *) mem_67457)[min_res_65841];
                            
                            int64_t abs_arg_65854 = sub64(x_65853,
                                                          defunc_0_g_res_65808);
                            int64_t abs_res_65855 = abs64(abs_arg_65854);
                            bool cond_65856 = max_res_65839 == l_idx_65835;
                            int64_t loopres_65857;
                            int64_t loopres_65858;
                            int64_t loopres_65859;
                            
                            if (cond_65856) {
                                loopres_65857 = l_idx_65835;
                                loopres_65858 = r_idx_65836;
                                loopres_65859 = min_res_65364;
                            } else {
                                bool cond_65860 = slt64(abs_res_65848,
                                                        abs_res_65855);
                                bool cond_f_res_65861 = min_res_65841 ==
                                     r_idx_65836;
                                bool x_65862 = !cond_65860;
                                bool y_65863 = cond_f_res_65861 && x_65862;
                                bool cond_65864 = cond_65860 || y_65863;
                                int64_t loopres_f_res_65865;
                                
                                if (cond_65864) {
                                    loopres_f_res_65865 = max_res_65839;
                                } else {
                                    loopres_f_res_65865 = l_idx_65835;
                                }
                                
                                int64_t loopres_f_res_65866;
                                
                                if (cond_65864) {
                                    loopres_f_res_65866 = r_idx_65836;
                                } else {
                                    loopres_f_res_65866 = min_res_65841;
                                }
                                
                                int64_t loopres_f_res_65867;
                                
                                if (cond_65864) {
                                    int64_t loopres_f_res_t_res_65868 =
                                            add64((int64_t) 1, span_65837);
                                    
                                    loopres_f_res_65867 =
                                        loopres_f_res_t_res_65868;
                                } else {
                                    int64_t loopres_f_res_f_res_65869 =
                                            add64((int64_t) 1, span_65837);
                                    
                                    loopres_f_res_65867 =
                                        loopres_f_res_f_res_65869;
                                }
                                loopres_65857 = loopres_f_res_65865;
                                loopres_65858 = loopres_f_res_65866;
                                loopres_65859 = loopres_f_res_65867;
                            }
                            
                            bool loop_cond_65870 = slt64(loopres_65859,
                                                         min_res_65364);
                            bool loop_while_tmp_68357 = loop_cond_65870;
                            int64_t l_idx_tmp_68358 = loopres_65857;
                            int64_t r_idx_tmp_68359 = loopres_65858;
                            int64_t span_tmp_68360 = loopres_65859;
                            
                            loop_while_65834 = loop_while_tmp_68357;
                            l_idx_65835 = l_idx_tmp_68358;
                            r_idx_65836 = r_idx_tmp_68359;
                            span_65837 = span_tmp_68360;
                        }
                        idx_65830 = loop_while_65834;
                        idx_65831 = l_idx_65835;
                        idx_65832 = r_idx_65836;
                        idx_65833 = span_65837;
                        
                        int64_t min_res_65871 = smin64(min_arg_65793,
                                                       idx_65831);
                        int64_t max_res_65872 = smax64((int64_t) 0,
                                                       min_res_65871);
                        int64_t x_65873 = add64(min_res_65794, max_res_65872);
                        int64_t r_65874 = sub64(x_65873, (int64_t) 1);
                        bool x_65875 = sle64((int64_t) 0, r_65874);
                        bool y_65876 = slt64(r_65874, n_65344);
                        bool bounds_check_65877 = x_65875 && y_65876;
                        bool index_certs_65878;
                        
                        if (!bounds_check_65877) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) r_65874,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67389, "mem_67389") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67385, "mem_67385") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67545,
                                               "ext_mem_67545") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67553,
                                               "ext_mem_67553") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67561,
                                               "ext_mem_67561") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67569,
                                               "ext_mem_67569") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_65879;
                        
                        x_65879 = ((int64_t *) mem_67430)[r_65874];
                        
                        int64_t abs_arg_65880 = sub64(x_65879, min_res_65807);
                        int64_t abs_res_65881 = abs64(abs_arg_65880);
                        bool x_65882 = sle64((int64_t) 0, max_res_65872);
                        bool y_65883 = slt64(max_res_65872, n_65344);
                        bool bounds_check_65884 = x_65882 && y_65883;
                        bool index_certs_65885;
                        
                        if (!bounds_check_65884) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) max_res_65872,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:483:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67389, "mem_67389") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67385, "mem_67385") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67545,
                                               "ext_mem_67545") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67553,
                                               "ext_mem_67553") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67561,
                                               "ext_mem_67561") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67569,
                                               "ext_mem_67569") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_65886;
                        
                        x_65886 = ((int64_t *) mem_67430)[max_res_65872];
                        
                        int64_t abs_arg_65887 = sub64(x_65886, min_res_65807);
                        int64_t abs_res_65888 = abs64(abs_arg_65887);
                        int64_t max_res_65889 = smax64(abs_res_65881,
                                                       abs_res_65888);
                        float defunc_0_f_res_65890 =
                              sitofp_i64_f32(max_res_65889);
                        float defunc_1_f_res_65891 = max_res_65798 +
                              defunc_0_f_res_65890;
                        float defunc_2_reduce_res_65892;
                        float defunc_2_reduce_res_65893;
                        float defunc_2_reduce_res_65894;
                        float defunc_2_reduce_res_65895;
                        float defunc_2_reduce_res_65896;
                        float redout_66791;
                        float redout_66792;
                        float redout_66793;
                        float redout_66794;
                        float redout_66795;
                        
                        redout_66791 = 0.0F;
                        redout_66792 = 0.0F;
                        redout_66793 = 0.0F;
                        redout_66794 = 0.0F;
                        redout_66795 = 0.0F;
                        for (int64_t i_66796 = 0; i_66796 < q_65346;
                             i_66796++) {
                            float x_65913;
                            
                            x_65913 = ((float *) mem_67472)[i_66796];
                            
                            bool cond_65914 = sle64(last_res_65777, i_66796);
                            int64_t defunc_0_f_res_65915;
                            
                            if (cond_65914) {
                                defunc_0_f_res_65915 = (int64_t) 0;
                            } else {
                                int64_t i_65916 = add64(max_res_65872, i_66796);
                                int64_t defunc_0_add_arg_65917;
                                
                                defunc_0_add_arg_65917 =
                                    ((int64_t *) mem_67430)[i_65916];
                                
                                int64_t defunc_1_add_res_65918 =
                                        add64((int64_t) 1,
                                              defunc_0_add_arg_65917);
                                
                                defunc_0_f_res_65915 = defunc_1_add_res_65918;
                            }
                            
                            int64_t binop_p_65919 = sub64(defunc_0_f_res_65915,
                                                          min_res_65807);
                            float defunc_0_f_res_65920 =
                                  sitofp_i64_f32(binop_p_65919);
                            float abs_res_65921 =
                                  (float) fabs(defunc_0_f_res_65920);
                            float tmp1_65922 = abs_res_65921 /
                                  defunc_1_f_res_65891;
                            float x_65923 = tmp1_65922 * tmp1_65922;
                            float y_65924 = tmp1_65922 * x_65923;
                            float tmp2_65925 = 1.0F - y_65924;
                            float x_65926 = tmp2_65925 * tmp2_65925;
                            float tmp3_65927 = tmp2_65925 * x_65926;
                            float w_j_65928 = x_65913 * tmp3_65927;
                            float xw_j_65929 = defunc_0_f_res_65920 * w_j_65928;
                            float x2w_j_65930 = defunc_0_f_res_65920 *
                                  xw_j_65929;
                            float x3w_j_65931 = defunc_0_f_res_65920 *
                                  x2w_j_65930;
                            float x4w_j_65932 = defunc_0_f_res_65920 *
                                  x3w_j_65931;
                            float defunc_1_op_res_65899 = w_j_65928 +
                                  redout_66791;
                            float defunc_1_op_res_65902 = xw_j_65929 +
                                  redout_66792;
                            float defunc_1_op_res_65905 = x2w_j_65930 +
                                  redout_66793;
                            float defunc_1_op_res_65908 = x3w_j_65931 +
                                  redout_66794;
                            float defunc_1_op_res_65911 = x4w_j_65932 +
                                  redout_66795;
                            float redout_tmp_68361 = defunc_1_op_res_65899;
                            float redout_tmp_68362 = defunc_1_op_res_65902;
                            float redout_tmp_68363 = defunc_1_op_res_65905;
                            float redout_tmp_68364 = defunc_1_op_res_65908;
                            float redout_tmp_68365 = defunc_1_op_res_65911;
                            
                            redout_66791 = redout_tmp_68361;
                            redout_66792 = redout_tmp_68362;
                            redout_66793 = redout_tmp_68363;
                            redout_66794 = redout_tmp_68364;
                            redout_66795 = redout_tmp_68365;
                        }
                        defunc_2_reduce_res_65892 = redout_66791;
                        defunc_2_reduce_res_65893 = redout_66792;
                        defunc_2_reduce_res_65894 = redout_66793;
                        defunc_2_reduce_res_65895 = redout_66794;
                        defunc_2_reduce_res_65896 = redout_66795;
                        
                        float x_65933 = defunc_2_reduce_res_65894 *
                              defunc_2_reduce_res_65896;
                        float y_65934 = defunc_2_reduce_res_65895 *
                              defunc_2_reduce_res_65895;
                        float a12_65935 = x_65933 - y_65934;
                        float x_65936 = defunc_2_reduce_res_65894 *
                              defunc_2_reduce_res_65895;
                        float y_65937 = defunc_2_reduce_res_65893 *
                              defunc_2_reduce_res_65896;
                        float b12_65938 = x_65936 - y_65937;
                        float x_65939 = defunc_2_reduce_res_65893 *
                              defunc_2_reduce_res_65895;
                        float y_65940 = defunc_2_reduce_res_65894 *
                              defunc_2_reduce_res_65894;
                        float c12_65941 = x_65939 - y_65940;
                        float x_65942 = defunc_2_reduce_res_65892 *
                              defunc_2_reduce_res_65896;
                        float b2_65943 = x_65942 - y_65940;
                        float x_65944 = defunc_2_reduce_res_65893 *
                              defunc_2_reduce_res_65894;
                        float y_65945 = defunc_2_reduce_res_65892 *
                              defunc_2_reduce_res_65895;
                        float c2_65946 = x_65944 - y_65945;
                        float x_65947 = defunc_2_reduce_res_65892 * a12_65935;
                        float y_65948 = defunc_2_reduce_res_65893 * b12_65938;
                        float x_65949 = x_65947 + y_65948;
                        float y_65950 = defunc_2_reduce_res_65894 * c12_65941;
                        float y_65951 = x_65949 + y_65950;
                        float det_65952 = 1.0F / y_65951;
                        float a12_65953 = a12_65935 * det_65952;
                        float b12_65954 = b12_65938 * det_65952;
                        float c12_65955 = c12_65941 * det_65952;
                        float b2_65956 = b2_65943 * det_65952;
                        float c2_65957 = c2_65946 * det_65952;
                        float defunc_2_reduce_res_65958;
                        float defunc_2_reduce_res_65959;
                        float redout_66797;
                        float redout_66798;
                        
                        redout_66797 = 0.0F;
                        redout_66798 = 0.0F;
                        for (int64_t i_66799 = 0; i_66799 < q_65346;
                             i_66799++) {
                            float x_65967;
                            
                            x_65967 = ((float *) mem_67472)[i_66799];
                            
                            bool cond_65968 = sle64(last_res_65777, i_66799);
                            int64_t defunc_0_f_res_65969;
                            
                            if (cond_65968) {
                                defunc_0_f_res_65969 = (int64_t) 0;
                            } else {
                                int64_t i_65970 = add64(max_res_65872, i_66799);
                                int64_t defunc_0_add_arg_65971;
                                
                                defunc_0_add_arg_65971 =
                                    ((int64_t *) mem_67430)[i_65970];
                                
                                int64_t defunc_1_add_res_65972 =
                                        add64((int64_t) 1,
                                              defunc_0_add_arg_65971);
                                
                                defunc_0_f_res_65969 = defunc_1_add_res_65972;
                            }
                            
                            int64_t binop_p_65973 = sub64(defunc_0_f_res_65969,
                                                          min_res_65807);
                            float defunc_0_f_res_65974 =
                                  sitofp_i64_f32(binop_p_65973);
                            float abs_res_65975 =
                                  (float) fabs(defunc_0_f_res_65974);
                            float tmp1_65976 = abs_res_65975 /
                                  defunc_1_f_res_65891;
                            float x_65977 = tmp1_65976 * tmp1_65976;
                            float y_65978 = tmp1_65976 * x_65977;
                            float tmp2_65979 = 1.0F - y_65978;
                            float x_65980 = tmp2_65979 * tmp2_65979;
                            float tmp3_65981 = tmp2_65979 * x_65980;
                            float tmp4_65982 = x_65967 * tmp3_65981;
                            float defunc_1_f_res_65983 = defunc_0_f_res_65974 *
                                  tmp4_65982;
                            float defunc_1_f_res_65984 = defunc_0_f_res_65974 *
                                  defunc_1_f_res_65983;
                            float defunc_0_f_res_65985;
                            
                            if (cond_65968) {
                                defunc_0_f_res_65985 = 0.0F;
                            } else {
                                int64_t i_65986 = add64(max_res_65872, i_66799);
                                float defunc_0_add_arg_65987;
                                
                                defunc_0_add_arg_65987 =
                                    ((float *) mem_67427)[i_65986];
                                defunc_0_f_res_65985 = defunc_0_add_arg_65987;
                            }
                            
                            float x_65988 = a12_65953 * tmp4_65982;
                            float y_65989 = b12_65954 * defunc_1_f_res_65983;
                            float x_65990 = x_65988 + y_65989;
                            float y_65991 = c12_65955 * defunc_1_f_res_65984;
                            float x_65992 = x_65990 + y_65991;
                            float defunc_9_fit_fun_res_65993 =
                                  defunc_0_f_res_65985 * x_65992;
                            float x_65994 = b12_65954 * tmp4_65982;
                            float y_65995 = b2_65956 * defunc_1_f_res_65983;
                            float x_65996 = x_65994 + y_65995;
                            float y_65997 = c2_65957 * defunc_1_f_res_65984;
                            float x_65998 = x_65996 + y_65997;
                            float defunc_9_slope_fun_res_65999 =
                                  defunc_0_f_res_65985 * x_65998;
                            float defunc_1_op_res_65962 =
                                  defunc_9_fit_fun_res_65993 + redout_66797;
                            float defunc_1_op_res_65965 =
                                  defunc_9_slope_fun_res_65999 + redout_66798;
                            float redout_tmp_68366 = defunc_1_op_res_65962;
                            float redout_tmp_68367 = defunc_1_op_res_65965;
                            
                            redout_66797 = redout_tmp_68366;
                            redout_66798 = redout_tmp_68367;
                        }
                        defunc_2_reduce_res_65958 = redout_66797;
                        defunc_2_reduce_res_65959 = redout_66798;
                        ((float *) mem_67385.mem)[i_66811 * n_m_65352 +
                                                  i_66804] =
                            defunc_2_reduce_res_65958;
                        ((float *) mem_67389.mem)[i_66811 * n_m_65352 +
                                                  i_66804] =
                            defunc_2_reduce_res_65959;
                    }
                }
                if (memblock_set(ctx, &ext_mem_67553, &mem_67385,
                                 "mem_67385") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_67545, &mem_67389,
                                 "mem_67389") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67389, "mem_67389") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67385, "mem_67385") != 0)
                    return 1;
            }
            if (memblock_set(ctx, &ext_mem_67569, &ext_mem_67553,
                             "ext_mem_67553") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_67561, &ext_mem_67545,
                             "ext_mem_67545") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_67545, "ext_mem_67545") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_67553, "ext_mem_67553") != 0)
                return 1;
        }
        if (memblock_set(ctx, &ext_mem_68171, &ext_mem_67569,
                         "ext_mem_67569") != 0)
            return 1;
        if (memblock_set(ctx, &ext_mem_68163, &ext_mem_67561,
                         "ext_mem_67561") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_67561, "ext_mem_67561") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_67569, "ext_mem_67569") != 0)
            return 1;
    } else {
        bool match_lit_66002 = (int64_t) 0 == degree_65347;
        int64_t binop_x_67577 = m_65343 * n_m_65352;
        int64_t binop_y_67578 = (int64_t) 4 * binop_x_67577;
        int64_t bytes_67579 = smax64((int64_t) 0, binop_y_67578);
        int64_t binop_y_67595 = (int64_t) 8 * n_65344;
        int64_t bytes_67596 = smax64((int64_t) 0, binop_y_67595);
        int64_t binop_y_67610 = (int64_t) 4 * n_65344;
        int64_t bytes_67611 = smax64((int64_t) 0, binop_y_67610);
        int64_t binop_y_67655 = (int64_t) 4 * q_65346;
        int64_t bytes_67656 = smax64((int64_t) 0, binop_y_67655);
        struct memblock ext_mem_68155;
        
        ext_mem_68155.references = NULL;
        
        struct memblock ext_mem_68147;
        
        ext_mem_68147.references = NULL;
        if (match_lit_66002) {
            struct memblock mem_67580;
            
            mem_67580.references = NULL;
            if (memblock_alloc(ctx, &mem_67580, bytes_67579, "mem_67580")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_68368 = 0; i_68368 < m_65343; i_68368++) {
                for (int64_t i_68369 = 0; i_68369 < n_m_65352; i_68369++) {
                    ((float *) mem_67580.mem)[i_68368 * n_m_65352 + i_68369] =
                        0.0F;
                }
            }
            
            struct memblock mem_67584;
            
            mem_67584.references = NULL;
            if (memblock_alloc(ctx, &mem_67584, bytes_67579, "mem_67584")) {
                err = 1;
                goto cleanup;
            }
            if (mem_67597_cached_sizze_68464 < (size_t) bytes_67596) {
                mem_67597 = realloc(mem_67597, bytes_67596);
                mem_67597_cached_sizze_68464 = bytes_67596;
            }
            if (mem_67612_cached_sizze_68465 < (size_t) bytes_67611) {
                mem_67612 = realloc(mem_67612, bytes_67611);
                mem_67612_cached_sizze_68465 = bytes_67611;
            }
            if (mem_67615_cached_sizze_68466 < (size_t) bytes_67596) {
                mem_67615 = realloc(mem_67615, bytes_67596);
                mem_67615_cached_sizze_68466 = bytes_67596;
            }
            if (mem_67642_cached_sizze_68467 < (size_t) bytes_67596) {
                mem_67642 = realloc(mem_67642, bytes_67596);
                mem_67642_cached_sizze_68467 = bytes_67596;
            }
            if (mem_67657_cached_sizze_68468 < (size_t) bytes_67656) {
                mem_67657 = realloc(mem_67657, bytes_67656);
                mem_67657_cached_sizze_68468 = bytes_67656;
            }
            if (mem_67683_cached_sizze_68469 < (size_t) bytes_67656) {
                mem_67683 = realloc(mem_67683, bytes_67656);
                mem_67683_cached_sizze_68469 = bytes_67656;
            }
            for (int64_t i_66849 = 0; i_66849 < m_65343; i_66849++) {
                int64_t discard_66819;
                int64_t scanacc_66815 = (int64_t) 0;
                
                for (int64_t i_66817 = 0; i_66817 < n_65344; i_66817++) {
                    float x_66013;
                    
                    x_66013 = ((float *) Y_mem_67095.mem)[i_66849 * n_65344 +
                                                          i_66817];
                    
                    bool isnan_res_66014;
                    
                    isnan_res_66014 = futrts_isnan32(x_66013);
                    
                    bool defunc_0_p_res_66015 = !isnan_res_66014;
                    int64_t defunc_0_f_res_66016 =
                            btoi_bool_i64(defunc_0_p_res_66015);
                    int64_t defunc_1_op_res_66012 = add64(defunc_0_f_res_66016,
                                                          scanacc_66815);
                    
                    ((int64_t *) mem_67597)[i_66817] = defunc_1_op_res_66012;
                    
                    int64_t scanacc_tmp_68371 = defunc_1_op_res_66012;
                    
                    scanacc_66815 = scanacc_tmp_68371;
                }
                discard_66819 = scanacc_66815;
                
                int64_t last_res_66017;
                
                last_res_66017 = ((int64_t *) mem_67597)[i_65358];
                for (int64_t i_68373 = 0; i_68373 < n_65344; i_68373++) {
                    ((float *) mem_67612)[i_68373] = 0.0F;
                }
                for (int64_t i_68374 = 0; i_68374 < n_65344; i_68374++) {
                    ((int64_t *) mem_67615)[i_68374] = (int64_t) -1;
                }
                for (int64_t write_iter_66820 = 0; write_iter_66820 < n_65344;
                     write_iter_66820++) {
                    float write_iv_66823;
                    
                    write_iv_66823 = ((float *) Y_mem_67095.mem)[i_66849 *
                                                                 n_65344 +
                                                                 write_iter_66820];
                    
                    int64_t write_iv_66824;
                    
                    write_iv_66824 = ((int64_t *) mem_67597)[write_iter_66820];
                    
                    bool isnan_res_66025;
                    
                    isnan_res_66025 = futrts_isnan32(write_iv_66823);
                    
                    bool defunc_0_p_res_66026 = !isnan_res_66025;
                    int64_t defunc_1_f_res_66027;
                    
                    if (defunc_0_p_res_66026) {
                        int64_t defunc_1_f_res_t_res_66028 =
                                sub64(write_iv_66824, (int64_t) 1);
                        
                        defunc_1_f_res_66027 = defunc_1_f_res_t_res_66028;
                    } else {
                        defunc_1_f_res_66027 = (int64_t) -1;
                    }
                    if (sle64((int64_t) 0, defunc_1_f_res_66027) &&
                        slt64(defunc_1_f_res_66027, n_65344)) {
                        ((int64_t *) mem_67615)[defunc_1_f_res_66027] =
                            write_iter_66820;
                    }
                    if (sle64((int64_t) 0, defunc_1_f_res_66027) &&
                        slt64(defunc_1_f_res_66027, n_65344)) {
                        if ((int64_t) 4 > 0)
                            memmove(mem_67612 + defunc_1_f_res_66027 *
                                    (int64_t) 4, Y_mem_67095.mem + (i_66849 *
                                                                    n_65344 +
                                                                    write_iter_66820) *
                                    (int64_t) 4, (int64_t) 4);
                    }
                }
                for (int64_t i_66830 = 0; i_66830 < n_65344; i_66830++) {
                    int64_t x_66030;
                    
                    x_66030 = ((int64_t *) mem_67615)[i_66830];
                    
                    int64_t defunc_0_f_res_66031 = add64((int64_t) 1, x_66030);
                    
                    ((int64_t *) mem_67642)[i_66830] = defunc_0_f_res_66031;
                }
                
                int64_t min_arg_66032 = sub64(last_res_66017, (int64_t) 1);
                int64_t min_arg_66033 = sub64(last_res_66017, min_res_65364);
                int64_t min_res_66034 = smin64(q_65346, last_res_66017);
                float i64_res_66035 = sitofp_i64_f32(last_res_66017);
                float x_66036 = i64_res_65370 - i64_res_66035;
                float max_arg_66037 = x_66036 / 2.0F;
                float max_res_66038 = fmax32(0.0F, max_arg_66037);
                
                for (int64_t i_66834 = 0; i_66834 < q_65346; i_66834++) {
                    bool cond_66041 = sle64(last_res_66017, i_66834);
                    float defunc_0_f_res_66042;
                    
                    if (cond_66041) {
                        defunc_0_f_res_66042 = 0.0F;
                    } else {
                        defunc_0_f_res_66042 = 1.0F;
                    }
                    ((float *) mem_67657)[i_66834] = defunc_0_f_res_66042;
                }
                for (int64_t i_66845 = 0; i_66845 < n_m_65352; i_66845++) {
                    int64_t min_arg_66045 = mul64(jump_65348, i_66845);
                    int64_t min_res_66046 = smin64(i_65358, min_arg_66045);
                    int64_t defunc_0_g_res_66047 = add64((int64_t) 1,
                                                         min_res_66046);
                    bool init_idx_66048;
                    int64_t init_idx_66049;
                    int64_t init_idx_66050;
                    bool loop_while_66051;
                    int64_t low_66052;
                    int64_t high_66053;
                    
                    loop_while_66051 = x_65359;
                    low_66052 = (int64_t) 0;
                    high_66053 = i_65358;
                    while (loop_while_66051) {
                        int64_t x_66054 = add64(low_66052, high_66053);
                        int64_t mid_66055 = sdiv64(x_66054, (int64_t) 2);
                        bool x_66056 = sle64((int64_t) 0, mid_66055);
                        bool y_66057 = slt64(mid_66055, n_65344);
                        bool bounds_check_66058 = x_66056 && y_66057;
                        bool index_certs_66059;
                        
                        if (!bounds_check_66058) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) mid_66055,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:449:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67584, "mem_67584") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67580, "mem_67580") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68147,
                                               "ext_mem_68147") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68155,
                                               "ext_mem_68155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t mid_id_66060;
                        
                        mid_id_66060 = ((int64_t *) mem_67642)[mid_66055];
                        
                        bool cond_66061 = slt64(mid_id_66060, (int64_t) 0);
                        int64_t mid_idx_66062;
                        
                        if (cond_66061) {
                            mid_idx_66062 = (int64_t) 9223372036854775807;
                        } else {
                            mid_idx_66062 = mid_id_66060;
                        }
                        
                        bool cond_66063 = sle64(defunc_0_g_res_66047,
                                                mid_idx_66062);
                        int64_t loopres_66064;
                        int64_t loopres_66065;
                        
                        if (cond_66063) {
                            int64_t loopres_t_res_66066 = sub64(mid_66055,
                                                                (int64_t) 1);
                            
                            loopres_66064 = low_66052;
                            loopres_66065 = loopres_t_res_66066;
                        } else {
                            int64_t loopres_f_res_66067 = add64((int64_t) 1,
                                                                mid_66055);
                            
                            loopres_66064 = loopres_f_res_66067;
                            loopres_66065 = high_66053;
                        }
                        
                        bool loop_cond_66068 = sle64(loopres_66064,
                                                     loopres_66065);
                        bool loop_while_tmp_68380 = loop_cond_66068;
                        int64_t low_tmp_68381 = loopres_66064;
                        int64_t high_tmp_68382 = loopres_66065;
                        
                        loop_while_66051 = loop_while_tmp_68380;
                        low_66052 = low_tmp_68381;
                        high_66053 = high_tmp_68382;
                    }
                    init_idx_66048 = loop_while_66051;
                    init_idx_66049 = low_66052;
                    init_idx_66050 = high_66053;
                    
                    bool idx_66069;
                    int64_t idx_66070;
                    int64_t idx_66071;
                    int64_t idx_66072;
                    bool loop_while_66073;
                    int64_t l_idx_66074;
                    int64_t r_idx_66075;
                    int64_t span_66076;
                    
                    loop_while_66073 = loop_cond_65369;
                    l_idx_66074 = init_idx_66049;
                    r_idx_66075 = init_idx_66049;
                    span_66076 = (int64_t) 1;
                    while (loop_while_66073) {
                        int64_t max_arg_66077 = sub64(l_idx_66074, (int64_t) 1);
                        int64_t max_res_66078 = smax64((int64_t) 0,
                                                       max_arg_66077);
                        int64_t min_arg_66079 = add64((int64_t) 1, r_idx_66075);
                        int64_t min_res_66080 = smin64(min_arg_66032,
                                                       min_arg_66079);
                        bool x_66081 = sle64((int64_t) 0, max_res_66078);
                        bool y_66082 = slt64(max_res_66078, n_65344);
                        bool bounds_check_66083 = x_66081 && y_66082;
                        bool index_certs_66084;
                        
                        if (!bounds_check_66083) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) max_res_66078,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:459:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67584, "mem_67584") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67580, "mem_67580") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68147,
                                               "ext_mem_68147") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68155,
                                               "ext_mem_68155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_66085;
                        
                        x_66085 = ((int64_t *) mem_67642)[max_res_66078];
                        
                        int64_t abs_arg_66086 = sub64(x_66085,
                                                      defunc_0_g_res_66047);
                        int64_t abs_res_66087 = abs64(abs_arg_66086);
                        bool x_66088 = sle64((int64_t) 0, min_res_66080);
                        bool y_66089 = slt64(min_res_66080, n_65344);
                        bool bounds_check_66090 = x_66088 && y_66089;
                        bool index_certs_66091;
                        
                        if (!bounds_check_66090) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) min_res_66080,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67584, "mem_67584") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67580, "mem_67580") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68147,
                                               "ext_mem_68147") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68155,
                                               "ext_mem_68155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_66092;
                        
                        x_66092 = ((int64_t *) mem_67642)[min_res_66080];
                        
                        int64_t abs_arg_66093 = sub64(x_66092,
                                                      defunc_0_g_res_66047);
                        int64_t abs_res_66094 = abs64(abs_arg_66093);
                        bool cond_66095 = max_res_66078 == l_idx_66074;
                        int64_t loopres_66096;
                        int64_t loopres_66097;
                        int64_t loopres_66098;
                        
                        if (cond_66095) {
                            loopres_66096 = l_idx_66074;
                            loopres_66097 = r_idx_66075;
                            loopres_66098 = min_res_65364;
                        } else {
                            bool cond_66099 = slt64(abs_res_66087,
                                                    abs_res_66094);
                            bool cond_f_res_66100 = min_res_66080 ==
                                 r_idx_66075;
                            bool x_66101 = !cond_66099;
                            bool y_66102 = cond_f_res_66100 && x_66101;
                            bool cond_66103 = cond_66099 || y_66102;
                            int64_t loopres_f_res_66104;
                            
                            if (cond_66103) {
                                loopres_f_res_66104 = max_res_66078;
                            } else {
                                loopres_f_res_66104 = l_idx_66074;
                            }
                            
                            int64_t loopres_f_res_66105;
                            
                            if (cond_66103) {
                                loopres_f_res_66105 = r_idx_66075;
                            } else {
                                loopres_f_res_66105 = min_res_66080;
                            }
                            
                            int64_t loopres_f_res_66106;
                            
                            if (cond_66103) {
                                int64_t loopres_f_res_t_res_66107 =
                                        add64((int64_t) 1, span_66076);
                                
                                loopres_f_res_66106 = loopres_f_res_t_res_66107;
                            } else {
                                int64_t loopres_f_res_f_res_66108 =
                                        add64((int64_t) 1, span_66076);
                                
                                loopres_f_res_66106 = loopres_f_res_f_res_66108;
                            }
                            loopres_66096 = loopres_f_res_66104;
                            loopres_66097 = loopres_f_res_66105;
                            loopres_66098 = loopres_f_res_66106;
                        }
                        
                        bool loop_cond_66109 = slt64(loopres_66098,
                                                     min_res_65364);
                        bool loop_while_tmp_68383 = loop_cond_66109;
                        int64_t l_idx_tmp_68384 = loopres_66096;
                        int64_t r_idx_tmp_68385 = loopres_66097;
                        int64_t span_tmp_68386 = loopres_66098;
                        
                        loop_while_66073 = loop_while_tmp_68383;
                        l_idx_66074 = l_idx_tmp_68384;
                        r_idx_66075 = r_idx_tmp_68385;
                        span_66076 = span_tmp_68386;
                    }
                    idx_66069 = loop_while_66073;
                    idx_66070 = l_idx_66074;
                    idx_66071 = r_idx_66075;
                    idx_66072 = span_66076;
                    
                    int64_t min_res_66110 = smin64(min_arg_66033, idx_66070);
                    int64_t max_res_66111 = smax64((int64_t) 0, min_res_66110);
                    int64_t x_66112 = add64(min_res_66034, max_res_66111);
                    int64_t r_66113 = sub64(x_66112, (int64_t) 1);
                    bool x_66114 = sle64((int64_t) 0, r_66113);
                    bool y_66115 = slt64(r_66113, n_65344);
                    bool bounds_check_66116 = x_66114 && y_66115;
                    bool index_certs_66117;
                    
                    if (!bounds_check_66116) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) r_66113,
                                      "] out of bounds for array of shape [",
                                      (long long) n_65344, "].",
                                      "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
                        if (memblock_unref(ctx, &mem_67584, "mem_67584") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_67580, "mem_67580") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68147,
                                           "ext_mem_68147") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68155,
                                           "ext_mem_68155") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68163,
                                           "ext_mem_68163") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68171,
                                           "ext_mem_68171") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_68296,
                                           "mem_out_68296") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_66118;
                    
                    x_66118 = ((int64_t *) mem_67615)[r_66113];
                    
                    int64_t abs_arg_66119 = sub64(x_66118, min_res_66046);
                    int64_t abs_res_66120 = abs64(abs_arg_66119);
                    bool x_66121 = sle64((int64_t) 0, max_res_66111);
                    bool y_66122 = slt64(max_res_66111, n_65344);
                    bool bounds_check_66123 = x_66121 && y_66122;
                    bool index_certs_66124;
                    
                    if (!bounds_check_66123) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) max_res_66111,
                                      "] out of bounds for array of shape [",
                                      (long long) n_65344, "].",
                                      "-> #0  loess.fut:483:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
                        if (memblock_unref(ctx, &mem_67584, "mem_67584") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_67580, "mem_67580") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68147,
                                           "ext_mem_68147") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68155,
                                           "ext_mem_68155") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68163,
                                           "ext_mem_68163") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68171,
                                           "ext_mem_68171") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_68296,
                                           "mem_out_68296") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_66125;
                    
                    x_66125 = ((int64_t *) mem_67615)[max_res_66111];
                    
                    int64_t abs_arg_66126 = sub64(x_66125, min_res_66046);
                    int64_t abs_res_66127 = abs64(abs_arg_66126);
                    int64_t max_res_66128 = smax64(abs_res_66120,
                                                   abs_res_66127);
                    float defunc_0_f_res_66129 = sitofp_i64_f32(max_res_66128);
                    float defunc_1_f_res_66130 = max_res_66038 +
                          defunc_0_f_res_66129;
                    float defunc_2_reduce_res_66131;
                    float redout_66837 = 0.0F;
                    
                    for (int64_t i_66839 = 0; i_66839 < q_65346; i_66839++) {
                        float x_66137;
                        
                        x_66137 = ((float *) mem_67657)[i_66839];
                        
                        bool cond_66138 = sle64(last_res_66017, i_66839);
                        int64_t defunc_0_f_res_66139;
                        
                        if (cond_66138) {
                            defunc_0_f_res_66139 = (int64_t) 0;
                        } else {
                            int64_t i_66140 = add64(max_res_66111, i_66839);
                            int64_t defunc_0_add_arg_66141;
                            
                            defunc_0_add_arg_66141 =
                                ((int64_t *) mem_67615)[i_66140];
                            
                            int64_t defunc_1_add_res_66142 = add64((int64_t) 1,
                                                                   defunc_0_add_arg_66141);
                            
                            defunc_0_f_res_66139 = defunc_1_add_res_66142;
                        }
                        
                        int64_t binop_p_66143 = sub64(defunc_0_f_res_66139,
                                                      min_res_66046);
                        float defunc_0_f_res_66144 =
                              sitofp_i64_f32(binop_p_66143);
                        float abs_res_66145 =
                              (float) fabs(defunc_0_f_res_66144);
                        float tmp1_66146 = abs_res_66145 / defunc_1_f_res_66130;
                        float x_66147 = tmp1_66146 * tmp1_66146;
                        float y_66148 = tmp1_66146 * x_66147;
                        float tmp2_66149 = 1.0F - y_66148;
                        float x_66150 = tmp2_66149 * tmp2_66149;
                        float tmp3_66151 = tmp2_66149 * x_66150;
                        float tmp4_66152 = x_66137 * tmp3_66151;
                        float defunc_1_op_res_66135 = tmp4_66152 + redout_66837;
                        
                        ((float *) mem_67683)[i_66839] = tmp4_66152;
                        
                        float redout_tmp_68387 = defunc_1_op_res_66135;
                        
                        redout_66837 = redout_tmp_68387;
                    }
                    defunc_2_reduce_res_66131 = redout_66837;
                    
                    float a0_66153 = 1.0F / defunc_2_reduce_res_66131;
                    float defunc_2_reduce_res_66154;
                    float redout_66841 = 0.0F;
                    
                    for (int64_t i_66842 = 0; i_66842 < q_65346; i_66842++) {
                        float x_66159;
                        
                        x_66159 = ((float *) mem_67683)[i_66842];
                        
                        bool cond_66160 = sle64(last_res_66017, i_66842);
                        float defunc_0_f_res_66161;
                        
                        if (cond_66160) {
                            defunc_0_f_res_66161 = 0.0F;
                        } else {
                            int64_t i_66162 = add64(max_res_66111, i_66842);
                            float defunc_0_add_arg_66163;
                            
                            defunc_0_add_arg_66163 =
                                ((float *) mem_67612)[i_66162];
                            defunc_0_f_res_66161 = defunc_0_add_arg_66163;
                        }
                        
                        float x_66164 = a0_66153 * x_66159;
                        float defunc_9_fit_fun_res_66165 =
                              defunc_0_f_res_66161 * x_66164;
                        float defunc_1_op_res_66157 =
                              defunc_9_fit_fun_res_66165 + redout_66841;
                        float redout_tmp_68389 = defunc_1_op_res_66157;
                        
                        redout_66841 = redout_tmp_68389;
                    }
                    defunc_2_reduce_res_66154 = redout_66841;
                    ((float *) mem_67584.mem)[i_66849 * n_m_65352 + i_66845] =
                        defunc_2_reduce_res_66154;
                }
            }
            if (memblock_set(ctx, &ext_mem_68155, &mem_67584, "mem_67584") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_68147, &mem_67580, "mem_67580") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_67584, "mem_67584") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_67580, "mem_67580") != 0)
                return 1;
        } else {
            bool match_lit_66168 = (int64_t) 1 == degree_65347;
            int64_t binop_x_67715 = m_65343 * n_m_65352;
            int64_t binop_y_67716 = (int64_t) 4 * binop_x_67715;
            int64_t bytes_67717 = smax64((int64_t) 0, binop_y_67716);
            int64_t binop_y_67743 = (int64_t) 8 * n_65344;
            int64_t bytes_67744 = smax64((int64_t) 0, binop_y_67743);
            int64_t binop_y_67758 = (int64_t) 4 * n_65344;
            int64_t bytes_67759 = smax64((int64_t) 0, binop_y_67758);
            int64_t binop_y_67803 = (int64_t) 4 * q_65346;
            int64_t bytes_67804 = smax64((int64_t) 0, binop_y_67803);
            int64_t binop_x_67908 = m_65343 * n_m_65352;
            int64_t binop_y_67909 = (int64_t) 4 * binop_x_67908;
            int64_t bytes_67910 = smax64((int64_t) 0, binop_y_67909);
            int64_t binop_y_67936 = (int64_t) 8 * n_65344;
            int64_t bytes_67937 = smax64((int64_t) 0, binop_y_67936);
            int64_t binop_y_67951 = (int64_t) 4 * n_65344;
            int64_t bytes_67952 = smax64((int64_t) 0, binop_y_67951);
            int64_t binop_y_67996 = (int64_t) 4 * q_65346;
            int64_t bytes_67997 = smax64((int64_t) 0, binop_y_67996);
            struct memblock ext_mem_68139;
            
            ext_mem_68139.references = NULL;
            
            struct memblock ext_mem_68131;
            
            ext_mem_68131.references = NULL;
            if (match_lit_66168) {
                struct memblock mem_67718;
                
                mem_67718.references = NULL;
                if (memblock_alloc(ctx, &mem_67718, bytes_67717, "mem_67718")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock mem_67722;
                
                mem_67722.references = NULL;
                if (memblock_alloc(ctx, &mem_67722, bytes_67717, "mem_67722")) {
                    err = 1;
                    goto cleanup;
                }
                if (mem_67745_cached_sizze_68470 < (size_t) bytes_67744) {
                    mem_67745 = realloc(mem_67745, bytes_67744);
                    mem_67745_cached_sizze_68470 = bytes_67744;
                }
                if (mem_67760_cached_sizze_68471 < (size_t) bytes_67759) {
                    mem_67760 = realloc(mem_67760, bytes_67759);
                    mem_67760_cached_sizze_68471 = bytes_67759;
                }
                if (mem_67763_cached_sizze_68472 < (size_t) bytes_67744) {
                    mem_67763 = realloc(mem_67763, bytes_67744);
                    mem_67763_cached_sizze_68472 = bytes_67744;
                }
                if (mem_67790_cached_sizze_68473 < (size_t) bytes_67744) {
                    mem_67790 = realloc(mem_67790, bytes_67744);
                    mem_67790_cached_sizze_68473 = bytes_67744;
                }
                if (mem_67805_cached_sizze_68474 < (size_t) bytes_67804) {
                    mem_67805 = realloc(mem_67805, bytes_67804);
                    mem_67805_cached_sizze_68474 = bytes_67804;
                }
                if (mem_67842_cached_sizze_68475 < (size_t) bytes_67804) {
                    mem_67842 = realloc(mem_67842, bytes_67804);
                    mem_67842_cached_sizze_68475 = bytes_67804;
                }
                if (mem_67845_cached_sizze_68476 < (size_t) bytes_67804) {
                    mem_67845 = realloc(mem_67845, bytes_67804);
                    mem_67845_cached_sizze_68476 = bytes_67804;
                }
                for (int64_t i_66897 = 0; i_66897 < m_65343; i_66897++) {
                    int64_t discard_66856;
                    int64_t scanacc_66852 = (int64_t) 0;
                    
                    for (int64_t i_66854 = 0; i_66854 < n_65344; i_66854++) {
                        float x_66179;
                        
                        x_66179 = ((float *) Y_mem_67095.mem)[i_66897 *
                                                              n_65344 +
                                                              i_66854];
                        
                        bool isnan_res_66180;
                        
                        isnan_res_66180 = futrts_isnan32(x_66179);
                        
                        bool defunc_0_p_res_66181 = !isnan_res_66180;
                        int64_t defunc_0_f_res_66182 =
                                btoi_bool_i64(defunc_0_p_res_66181);
                        int64_t defunc_1_op_res_66178 =
                                add64(defunc_0_f_res_66182, scanacc_66852);
                        
                        ((int64_t *) mem_67745)[i_66854] =
                            defunc_1_op_res_66178;
                        
                        int64_t scanacc_tmp_68392 = defunc_1_op_res_66178;
                        
                        scanacc_66852 = scanacc_tmp_68392;
                    }
                    discard_66856 = scanacc_66852;
                    
                    int64_t last_res_66183;
                    
                    last_res_66183 = ((int64_t *) mem_67745)[i_65358];
                    for (int64_t i_68394 = 0; i_68394 < n_65344; i_68394++) {
                        ((float *) mem_67760)[i_68394] = 0.0F;
                    }
                    for (int64_t i_68395 = 0; i_68395 < n_65344; i_68395++) {
                        ((int64_t *) mem_67763)[i_68395] = (int64_t) -1;
                    }
                    for (int64_t write_iter_66857 = 0; write_iter_66857 <
                         n_65344; write_iter_66857++) {
                        float write_iv_66860;
                        
                        write_iv_66860 = ((float *) Y_mem_67095.mem)[i_66897 *
                                                                     n_65344 +
                                                                     write_iter_66857];
                        
                        int64_t write_iv_66861;
                        
                        write_iv_66861 =
                            ((int64_t *) mem_67745)[write_iter_66857];
                        
                        bool isnan_res_66191;
                        
                        isnan_res_66191 = futrts_isnan32(write_iv_66860);
                        
                        bool defunc_0_p_res_66192 = !isnan_res_66191;
                        int64_t defunc_1_f_res_66193;
                        
                        if (defunc_0_p_res_66192) {
                            int64_t defunc_1_f_res_t_res_66194 =
                                    sub64(write_iv_66861, (int64_t) 1);
                            
                            defunc_1_f_res_66193 = defunc_1_f_res_t_res_66194;
                        } else {
                            defunc_1_f_res_66193 = (int64_t) -1;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_66193) &&
                            slt64(defunc_1_f_res_66193, n_65344)) {
                            ((int64_t *) mem_67763)[defunc_1_f_res_66193] =
                                write_iter_66857;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_66193) &&
                            slt64(defunc_1_f_res_66193, n_65344)) {
                            if ((int64_t) 4 > 0)
                                memmove(mem_67760 + defunc_1_f_res_66193 *
                                        (int64_t) 4, Y_mem_67095.mem +
                                        (i_66897 * n_65344 + write_iter_66857) *
                                        (int64_t) 4, (int64_t) 4);
                        }
                    }
                    for (int64_t i_66867 = 0; i_66867 < n_65344; i_66867++) {
                        int64_t x_66196;
                        
                        x_66196 = ((int64_t *) mem_67763)[i_66867];
                        
                        int64_t defunc_0_f_res_66197 = add64((int64_t) 1,
                                                             x_66196);
                        
                        ((int64_t *) mem_67790)[i_66867] = defunc_0_f_res_66197;
                    }
                    
                    int64_t min_arg_66198 = sub64(last_res_66183, (int64_t) 1);
                    int64_t min_arg_66199 = sub64(last_res_66183,
                                                  min_res_65364);
                    int64_t min_res_66200 = smin64(q_65346, last_res_66183);
                    float i64_res_66201 = sitofp_i64_f32(last_res_66183);
                    float x_66202 = i64_res_65370 - i64_res_66201;
                    float max_arg_66203 = x_66202 / 2.0F;
                    float max_res_66204 = fmax32(0.0F, max_arg_66203);
                    
                    for (int64_t i_66871 = 0; i_66871 < q_65346; i_66871++) {
                        bool cond_66207 = sle64(last_res_66183, i_66871);
                        float defunc_0_f_res_66208;
                        
                        if (cond_66207) {
                            defunc_0_f_res_66208 = 0.0F;
                        } else {
                            defunc_0_f_res_66208 = 1.0F;
                        }
                        ((float *) mem_67805)[i_66871] = defunc_0_f_res_66208;
                    }
                    for (int64_t i_66890 = 0; i_66890 < n_m_65352; i_66890++) {
                        int64_t min_arg_66212 = mul64(jump_65348, i_66890);
                        int64_t min_res_66213 = smin64(i_65358, min_arg_66212);
                        int64_t defunc_0_g_res_66214 = add64((int64_t) 1,
                                                             min_res_66213);
                        bool init_idx_66215;
                        int64_t init_idx_66216;
                        int64_t init_idx_66217;
                        bool loop_while_66218;
                        int64_t low_66219;
                        int64_t high_66220;
                        
                        loop_while_66218 = x_65359;
                        low_66219 = (int64_t) 0;
                        high_66220 = i_65358;
                        while (loop_while_66218) {
                            int64_t x_66221 = add64(low_66219, high_66220);
                            int64_t mid_66222 = sdiv64(x_66221, (int64_t) 2);
                            bool x_66223 = sle64((int64_t) 0, mid_66222);
                            bool y_66224 = slt64(mid_66222, n_65344);
                            bool bounds_check_66225 = x_66223 && y_66224;
                            bool index_certs_66226;
                            
                            if (!bounds_check_66225) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [", (long long) mid_66222,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65344, "].",
                                              "-> #0  loess.fut:449:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                                if (memblock_unref(ctx, &mem_67722,
                                                   "mem_67722") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67718,
                                                   "mem_67718") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68131,
                                                   "ext_mem_68131") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68139,
                                                   "ext_mem_68139") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68147,
                                                   "ext_mem_68147") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68155,
                                                   "ext_mem_68155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68163,
                                                   "ext_mem_68163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68171,
                                                   "ext_mem_68171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68296,
                                                   "mem_out_68296") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t mid_id_66227;
                            
                            mid_id_66227 = ((int64_t *) mem_67790)[mid_66222];
                            
                            bool cond_66228 = slt64(mid_id_66227, (int64_t) 0);
                            int64_t mid_idx_66229;
                            
                            if (cond_66228) {
                                mid_idx_66229 = (int64_t) 9223372036854775807;
                            } else {
                                mid_idx_66229 = mid_id_66227;
                            }
                            
                            bool cond_66230 = sle64(defunc_0_g_res_66214,
                                                    mid_idx_66229);
                            int64_t loopres_66231;
                            int64_t loopres_66232;
                            
                            if (cond_66230) {
                                int64_t loopres_t_res_66233 = sub64(mid_66222,
                                                                    (int64_t) 1);
                                
                                loopres_66231 = low_66219;
                                loopres_66232 = loopres_t_res_66233;
                            } else {
                                int64_t loopres_f_res_66234 = add64((int64_t) 1,
                                                                    mid_66222);
                                
                                loopres_66231 = loopres_f_res_66234;
                                loopres_66232 = high_66220;
                            }
                            
                            bool loop_cond_66235 = sle64(loopres_66231,
                                                         loopres_66232);
                            bool loop_while_tmp_68402 = loop_cond_66235;
                            int64_t low_tmp_68403 = loopres_66231;
                            int64_t high_tmp_68404 = loopres_66232;
                            
                            loop_while_66218 = loop_while_tmp_68402;
                            low_66219 = low_tmp_68403;
                            high_66220 = high_tmp_68404;
                        }
                        init_idx_66215 = loop_while_66218;
                        init_idx_66216 = low_66219;
                        init_idx_66217 = high_66220;
                        
                        bool idx_66236;
                        int64_t idx_66237;
                        int64_t idx_66238;
                        int64_t idx_66239;
                        bool loop_while_66240;
                        int64_t l_idx_66241;
                        int64_t r_idx_66242;
                        int64_t span_66243;
                        
                        loop_while_66240 = loop_cond_65369;
                        l_idx_66241 = init_idx_66216;
                        r_idx_66242 = init_idx_66216;
                        span_66243 = (int64_t) 1;
                        while (loop_while_66240) {
                            int64_t max_arg_66244 = sub64(l_idx_66241,
                                                          (int64_t) 1);
                            int64_t max_res_66245 = smax64((int64_t) 0,
                                                           max_arg_66244);
                            int64_t min_arg_66246 = add64((int64_t) 1,
                                                          r_idx_66242);
                            int64_t min_res_66247 = smin64(min_arg_66198,
                                                           min_arg_66246);
                            bool x_66248 = sle64((int64_t) 0, max_res_66245);
                            bool y_66249 = slt64(max_res_66245, n_65344);
                            bool bounds_check_66250 = x_66248 && y_66249;
                            bool index_certs_66251;
                            
                            if (!bounds_check_66250) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) max_res_66245,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65344, "].",
                                              "-> #0  loess.fut:459:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                                if (memblock_unref(ctx, &mem_67722,
                                                   "mem_67722") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67718,
                                                   "mem_67718") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68131,
                                                   "ext_mem_68131") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68139,
                                                   "ext_mem_68139") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68147,
                                                   "ext_mem_68147") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68155,
                                                   "ext_mem_68155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68163,
                                                   "ext_mem_68163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68171,
                                                   "ext_mem_68171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68296,
                                                   "mem_out_68296") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_66252;
                            
                            x_66252 = ((int64_t *) mem_67790)[max_res_66245];
                            
                            int64_t abs_arg_66253 = sub64(x_66252,
                                                          defunc_0_g_res_66214);
                            int64_t abs_res_66254 = abs64(abs_arg_66253);
                            bool x_66255 = sle64((int64_t) 0, min_res_66247);
                            bool y_66256 = slt64(min_res_66247, n_65344);
                            bool bounds_check_66257 = x_66255 && y_66256;
                            bool index_certs_66258;
                            
                            if (!bounds_check_66257) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) min_res_66247,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65344, "].",
                                              "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                                if (memblock_unref(ctx, &mem_67722,
                                                   "mem_67722") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67718,
                                                   "mem_67718") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68131,
                                                   "ext_mem_68131") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68139,
                                                   "ext_mem_68139") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68147,
                                                   "ext_mem_68147") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68155,
                                                   "ext_mem_68155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68163,
                                                   "ext_mem_68163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68171,
                                                   "ext_mem_68171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68296,
                                                   "mem_out_68296") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_66259;
                            
                            x_66259 = ((int64_t *) mem_67790)[min_res_66247];
                            
                            int64_t abs_arg_66260 = sub64(x_66259,
                                                          defunc_0_g_res_66214);
                            int64_t abs_res_66261 = abs64(abs_arg_66260);
                            bool cond_66262 = max_res_66245 == l_idx_66241;
                            int64_t loopres_66263;
                            int64_t loopres_66264;
                            int64_t loopres_66265;
                            
                            if (cond_66262) {
                                loopres_66263 = l_idx_66241;
                                loopres_66264 = r_idx_66242;
                                loopres_66265 = min_res_65364;
                            } else {
                                bool cond_66266 = slt64(abs_res_66254,
                                                        abs_res_66261);
                                bool cond_f_res_66267 = min_res_66247 ==
                                     r_idx_66242;
                                bool x_66268 = !cond_66266;
                                bool y_66269 = cond_f_res_66267 && x_66268;
                                bool cond_66270 = cond_66266 || y_66269;
                                int64_t loopres_f_res_66271;
                                
                                if (cond_66270) {
                                    loopres_f_res_66271 = max_res_66245;
                                } else {
                                    loopres_f_res_66271 = l_idx_66241;
                                }
                                
                                int64_t loopres_f_res_66272;
                                
                                if (cond_66270) {
                                    loopres_f_res_66272 = r_idx_66242;
                                } else {
                                    loopres_f_res_66272 = min_res_66247;
                                }
                                
                                int64_t loopres_f_res_66273;
                                
                                if (cond_66270) {
                                    int64_t loopres_f_res_t_res_66274 =
                                            add64((int64_t) 1, span_66243);
                                    
                                    loopres_f_res_66273 =
                                        loopres_f_res_t_res_66274;
                                } else {
                                    int64_t loopres_f_res_f_res_66275 =
                                            add64((int64_t) 1, span_66243);
                                    
                                    loopres_f_res_66273 =
                                        loopres_f_res_f_res_66275;
                                }
                                loopres_66263 = loopres_f_res_66271;
                                loopres_66264 = loopres_f_res_66272;
                                loopres_66265 = loopres_f_res_66273;
                            }
                            
                            bool loop_cond_66276 = slt64(loopres_66265,
                                                         min_res_65364);
                            bool loop_while_tmp_68405 = loop_cond_66276;
                            int64_t l_idx_tmp_68406 = loopres_66263;
                            int64_t r_idx_tmp_68407 = loopres_66264;
                            int64_t span_tmp_68408 = loopres_66265;
                            
                            loop_while_66240 = loop_while_tmp_68405;
                            l_idx_66241 = l_idx_tmp_68406;
                            r_idx_66242 = r_idx_tmp_68407;
                            span_66243 = span_tmp_68408;
                        }
                        idx_66236 = loop_while_66240;
                        idx_66237 = l_idx_66241;
                        idx_66238 = r_idx_66242;
                        idx_66239 = span_66243;
                        
                        int64_t min_res_66277 = smin64(min_arg_66199,
                                                       idx_66237);
                        int64_t max_res_66278 = smax64((int64_t) 0,
                                                       min_res_66277);
                        int64_t x_66279 = add64(min_res_66200, max_res_66278);
                        int64_t r_66280 = sub64(x_66279, (int64_t) 1);
                        bool x_66281 = sle64((int64_t) 0, r_66280);
                        bool y_66282 = slt64(r_66280, n_65344);
                        bool bounds_check_66283 = x_66281 && y_66282;
                        bool index_certs_66284;
                        
                        if (!bounds_check_66283) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) r_66280,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67722, "mem_67722") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67718, "mem_67718") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68131,
                                               "ext_mem_68131") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68139,
                                               "ext_mem_68139") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68147,
                                               "ext_mem_68147") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68155,
                                               "ext_mem_68155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_66285;
                        
                        x_66285 = ((int64_t *) mem_67763)[r_66280];
                        
                        int64_t abs_arg_66286 = sub64(x_66285, min_res_66213);
                        int64_t abs_res_66287 = abs64(abs_arg_66286);
                        bool x_66288 = sle64((int64_t) 0, max_res_66278);
                        bool y_66289 = slt64(max_res_66278, n_65344);
                        bool bounds_check_66290 = x_66288 && y_66289;
                        bool index_certs_66291;
                        
                        if (!bounds_check_66290) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) max_res_66278,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:483:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67722, "mem_67722") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67718, "mem_67718") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68131,
                                               "ext_mem_68131") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68139,
                                               "ext_mem_68139") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68147,
                                               "ext_mem_68147") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68155,
                                               "ext_mem_68155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_66292;
                        
                        x_66292 = ((int64_t *) mem_67763)[max_res_66278];
                        
                        int64_t abs_arg_66293 = sub64(x_66292, min_res_66213);
                        int64_t abs_res_66294 = abs64(abs_arg_66293);
                        int64_t max_res_66295 = smax64(abs_res_66287,
                                                       abs_res_66294);
                        float defunc_0_f_res_66296 =
                              sitofp_i64_f32(max_res_66295);
                        float defunc_1_f_res_66297 = max_res_66204 +
                              defunc_0_f_res_66296;
                        float defunc_2_reduce_res_66319;
                        float defunc_2_reduce_res_66320;
                        float defunc_2_reduce_res_66321;
                        float redout_66875;
                        float redout_66876;
                        float redout_66877;
                        
                        redout_66875 = 0.0F;
                        redout_66876 = 0.0F;
                        redout_66877 = 0.0F;
                        for (int64_t i_66880 = 0; i_66880 < q_65346;
                             i_66880++) {
                            float x_66334;
                            
                            x_66334 = ((float *) mem_67805)[i_66880];
                            
                            bool cond_66335 = sle64(last_res_66183, i_66880);
                            int64_t defunc_0_f_res_66336;
                            
                            if (cond_66335) {
                                defunc_0_f_res_66336 = (int64_t) 0;
                            } else {
                                int64_t i_66337 = add64(max_res_66278, i_66880);
                                int64_t defunc_0_add_arg_66338;
                                
                                defunc_0_add_arg_66338 =
                                    ((int64_t *) mem_67763)[i_66337];
                                
                                int64_t defunc_1_add_res_66339 =
                                        add64((int64_t) 1,
                                              defunc_0_add_arg_66338);
                                
                                defunc_0_f_res_66336 = defunc_1_add_res_66339;
                            }
                            
                            int64_t binop_p_66340 = sub64(defunc_0_f_res_66336,
                                                          min_res_66213);
                            float defunc_0_f_res_66341 =
                                  sitofp_i64_f32(binop_p_66340);
                            float abs_res_66342 =
                                  (float) fabs(defunc_0_f_res_66341);
                            float tmp1_66343 = abs_res_66342 /
                                  defunc_1_f_res_66297;
                            float x_66344 = tmp1_66343 * tmp1_66343;
                            float y_66345 = tmp1_66343 * x_66344;
                            float tmp2_66346 = 1.0F - y_66345;
                            float x_66347 = tmp2_66346 * tmp2_66346;
                            float tmp3_66348 = tmp2_66346 * x_66347;
                            float tmp4_66349 = x_66334 * tmp3_66348;
                            float defunc_1_f_res_66350 = defunc_0_f_res_66341 *
                                  tmp4_66349;
                            float defunc_1_f_res_66351 = defunc_0_f_res_66341 *
                                  defunc_1_f_res_66350;
                            float defunc_1_op_res_66326 = tmp4_66349 +
                                  redout_66875;
                            float defunc_1_op_res_66329 = defunc_1_f_res_66350 +
                                  redout_66876;
                            float defunc_1_op_res_66332 = defunc_1_f_res_66351 +
                                  redout_66877;
                            
                            ((float *) mem_67842)[i_66880] =
                                defunc_1_f_res_66350;
                            ((float *) mem_67845)[i_66880] = tmp4_66349;
                            
                            float redout_tmp_68409 = defunc_1_op_res_66326;
                            float redout_tmp_68410 = defunc_1_op_res_66329;
                            float redout_tmp_68411 = defunc_1_op_res_66332;
                            
                            redout_66875 = redout_tmp_68409;
                            redout_66876 = redout_tmp_68410;
                            redout_66877 = redout_tmp_68411;
                        }
                        defunc_2_reduce_res_66319 = redout_66875;
                        defunc_2_reduce_res_66320 = redout_66876;
                        defunc_2_reduce_res_66321 = redout_66877;
                        
                        float x_66357 = defunc_2_reduce_res_66319 *
                              defunc_2_reduce_res_66321;
                        float y_66358 = defunc_2_reduce_res_66320 *
                              defunc_2_reduce_res_66320;
                        float y_66359 = x_66357 - y_66358;
                        float det1_66360 = 1.0F / y_66359;
                        float a11_66361 = defunc_2_reduce_res_66321 *
                              det1_66360;
                        float x_66362 = 0.0F - defunc_2_reduce_res_66320;
                        float b11_66363 = det1_66360 * x_66362;
                        float c11_66364 = defunc_2_reduce_res_66319 *
                              det1_66360;
                        float defunc_2_reduce_res_66365;
                        float defunc_2_reduce_res_66366;
                        float redout_66883;
                        float redout_66884;
                        
                        redout_66883 = 0.0F;
                        redout_66884 = 0.0F;
                        for (int64_t i_66885 = 0; i_66885 < q_65346;
                             i_66885++) {
                            float x_66374;
                            
                            x_66374 = ((float *) mem_67845)[i_66885];
                            
                            float x_66375;
                            
                            x_66375 = ((float *) mem_67842)[i_66885];
                            
                            bool cond_66376 = sle64(last_res_66183, i_66885);
                            float defunc_0_f_res_66377;
                            
                            if (cond_66376) {
                                defunc_0_f_res_66377 = 0.0F;
                            } else {
                                int64_t i_66378 = add64(max_res_66278, i_66885);
                                float defunc_0_add_arg_66379;
                                
                                defunc_0_add_arg_66379 =
                                    ((float *) mem_67760)[i_66378];
                                defunc_0_f_res_66377 = defunc_0_add_arg_66379;
                            }
                            
                            float x_66380 = a11_66361 * x_66374;
                            float y_66381 = b11_66363 * x_66375;
                            float x_66382 = x_66380 + y_66381;
                            float defunc_9_fit_fun_res_66383 =
                                  defunc_0_f_res_66377 * x_66382;
                            float x_66384 = b11_66363 * x_66374;
                            float y_66385 = c11_66364 * x_66375;
                            float x_66386 = x_66384 + y_66385;
                            float defunc_9_slope_fun_res_66387 =
                                  defunc_0_f_res_66377 * x_66386;
                            float defunc_1_op_res_66369 =
                                  defunc_9_fit_fun_res_66383 + redout_66883;
                            float defunc_1_op_res_66372 =
                                  defunc_9_slope_fun_res_66387 + redout_66884;
                            float redout_tmp_68414 = defunc_1_op_res_66369;
                            float redout_tmp_68415 = defunc_1_op_res_66372;
                            
                            redout_66883 = redout_tmp_68414;
                            redout_66884 = redout_tmp_68415;
                        }
                        defunc_2_reduce_res_66365 = redout_66883;
                        defunc_2_reduce_res_66366 = redout_66884;
                        ((float *) mem_67718.mem)[i_66897 * n_m_65352 +
                                                  i_66890] =
                            defunc_2_reduce_res_66365;
                        ((float *) mem_67722.mem)[i_66897 * n_m_65352 +
                                                  i_66890] =
                            defunc_2_reduce_res_66366;
                    }
                }
                if (memblock_set(ctx, &ext_mem_68139, &mem_67718,
                                 "mem_67718") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_68131, &mem_67722,
                                 "mem_67722") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67722, "mem_67722") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67718, "mem_67718") != 0)
                    return 1;
            } else {
                struct memblock mem_67911;
                
                mem_67911.references = NULL;
                if (memblock_alloc(ctx, &mem_67911, bytes_67910, "mem_67911")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock mem_67915;
                
                mem_67915.references = NULL;
                if (memblock_alloc(ctx, &mem_67915, bytes_67910, "mem_67915")) {
                    err = 1;
                    goto cleanup;
                }
                if (mem_67938_cached_sizze_68477 < (size_t) bytes_67937) {
                    mem_67938 = realloc(mem_67938, bytes_67937);
                    mem_67938_cached_sizze_68477 = bytes_67937;
                }
                if (mem_67953_cached_sizze_68478 < (size_t) bytes_67952) {
                    mem_67953 = realloc(mem_67953, bytes_67952);
                    mem_67953_cached_sizze_68478 = bytes_67952;
                }
                if (mem_67956_cached_sizze_68479 < (size_t) bytes_67937) {
                    mem_67956 = realloc(mem_67956, bytes_67937);
                    mem_67956_cached_sizze_68479 = bytes_67937;
                }
                if (mem_67983_cached_sizze_68480 < (size_t) bytes_67937) {
                    mem_67983 = realloc(mem_67983, bytes_67937);
                    mem_67983_cached_sizze_68480 = bytes_67937;
                }
                if (mem_67998_cached_sizze_68481 < (size_t) bytes_67997) {
                    mem_67998 = realloc(mem_67998, bytes_67997);
                    mem_67998_cached_sizze_68481 = bytes_67997;
                }
                if (mem_68035_cached_sizze_68482 < (size_t) bytes_67997) {
                    mem_68035 = realloc(mem_68035, bytes_67997);
                    mem_68035_cached_sizze_68482 = bytes_67997;
                }
                if (mem_68038_cached_sizze_68483 < (size_t) bytes_67997) {
                    mem_68038 = realloc(mem_68038, bytes_67997);
                    mem_68038_cached_sizze_68483 = bytes_67997;
                }
                if (mem_68065_cached_sizze_68484 < (size_t) bytes_67997) {
                    mem_68065 = realloc(mem_68065, bytes_67997);
                    mem_68065_cached_sizze_68484 = bytes_67997;
                }
                if (mem_68068_cached_sizze_68485 < (size_t) bytes_67997) {
                    mem_68068 = realloc(mem_68068, bytes_67997);
                    mem_68068_cached_sizze_68485 = bytes_67997;
                }
                for (int64_t i_66955 = 0; i_66955 < m_65343; i_66955++) {
                    int64_t discard_66905;
                    int64_t scanacc_66901 = (int64_t) 0;
                    
                    for (int64_t i_66903 = 0; i_66903 < n_65344; i_66903++) {
                        float x_66398;
                        
                        x_66398 = ((float *) Y_mem_67095.mem)[i_66955 *
                                                              n_65344 +
                                                              i_66903];
                        
                        bool isnan_res_66399;
                        
                        isnan_res_66399 = futrts_isnan32(x_66398);
                        
                        bool defunc_0_p_res_66400 = !isnan_res_66399;
                        int64_t defunc_0_f_res_66401 =
                                btoi_bool_i64(defunc_0_p_res_66400);
                        int64_t defunc_1_op_res_66397 =
                                add64(defunc_0_f_res_66401, scanacc_66901);
                        
                        ((int64_t *) mem_67938)[i_66903] =
                            defunc_1_op_res_66397;
                        
                        int64_t scanacc_tmp_68418 = defunc_1_op_res_66397;
                        
                        scanacc_66901 = scanacc_tmp_68418;
                    }
                    discard_66905 = scanacc_66901;
                    
                    int64_t last_res_66402;
                    
                    last_res_66402 = ((int64_t *) mem_67938)[i_65358];
                    for (int64_t i_68420 = 0; i_68420 < n_65344; i_68420++) {
                        ((float *) mem_67953)[i_68420] = 0.0F;
                    }
                    for (int64_t i_68421 = 0; i_68421 < n_65344; i_68421++) {
                        ((int64_t *) mem_67956)[i_68421] = (int64_t) -1;
                    }
                    for (int64_t write_iter_66906 = 0; write_iter_66906 <
                         n_65344; write_iter_66906++) {
                        float write_iv_66909;
                        
                        write_iv_66909 = ((float *) Y_mem_67095.mem)[i_66955 *
                                                                     n_65344 +
                                                                     write_iter_66906];
                        
                        int64_t write_iv_66910;
                        
                        write_iv_66910 =
                            ((int64_t *) mem_67938)[write_iter_66906];
                        
                        bool isnan_res_66410;
                        
                        isnan_res_66410 = futrts_isnan32(write_iv_66909);
                        
                        bool defunc_0_p_res_66411 = !isnan_res_66410;
                        int64_t defunc_1_f_res_66412;
                        
                        if (defunc_0_p_res_66411) {
                            int64_t defunc_1_f_res_t_res_66413 =
                                    sub64(write_iv_66910, (int64_t) 1);
                            
                            defunc_1_f_res_66412 = defunc_1_f_res_t_res_66413;
                        } else {
                            defunc_1_f_res_66412 = (int64_t) -1;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_66412) &&
                            slt64(defunc_1_f_res_66412, n_65344)) {
                            ((int64_t *) mem_67956)[defunc_1_f_res_66412] =
                                write_iter_66906;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_66412) &&
                            slt64(defunc_1_f_res_66412, n_65344)) {
                            if ((int64_t) 4 > 0)
                                memmove(mem_67953 + defunc_1_f_res_66412 *
                                        (int64_t) 4, Y_mem_67095.mem +
                                        (i_66955 * n_65344 + write_iter_66906) *
                                        (int64_t) 4, (int64_t) 4);
                        }
                    }
                    for (int64_t i_66916 = 0; i_66916 < n_65344; i_66916++) {
                        int64_t x_66415;
                        
                        x_66415 = ((int64_t *) mem_67956)[i_66916];
                        
                        int64_t defunc_0_f_res_66416 = add64((int64_t) 1,
                                                             x_66415);
                        
                        ((int64_t *) mem_67983)[i_66916] = defunc_0_f_res_66416;
                    }
                    
                    int64_t min_arg_66417 = sub64(last_res_66402, (int64_t) 1);
                    int64_t min_arg_66418 = sub64(last_res_66402,
                                                  min_res_65364);
                    int64_t min_res_66419 = smin64(q_65346, last_res_66402);
                    float i64_res_66420 = sitofp_i64_f32(last_res_66402);
                    float x_66421 = i64_res_65370 - i64_res_66420;
                    float max_arg_66422 = x_66421 / 2.0F;
                    float max_res_66423 = fmax32(0.0F, max_arg_66422);
                    
                    for (int64_t i_66920 = 0; i_66920 < q_65346; i_66920++) {
                        bool cond_66426 = sle64(last_res_66402, i_66920);
                        float defunc_0_f_res_66427;
                        
                        if (cond_66426) {
                            defunc_0_f_res_66427 = 0.0F;
                        } else {
                            defunc_0_f_res_66427 = 1.0F;
                        }
                        ((float *) mem_67998)[i_66920] = defunc_0_f_res_66427;
                    }
                    for (int64_t i_66948 = 0; i_66948 < n_m_65352; i_66948++) {
                        int64_t min_arg_66431 = mul64(jump_65348, i_66948);
                        int64_t min_res_66432 = smin64(i_65358, min_arg_66431);
                        int64_t defunc_0_g_res_66433 = add64((int64_t) 1,
                                                             min_res_66432);
                        bool init_idx_66434;
                        int64_t init_idx_66435;
                        int64_t init_idx_66436;
                        bool loop_while_66437;
                        int64_t low_66438;
                        int64_t high_66439;
                        
                        loop_while_66437 = x_65359;
                        low_66438 = (int64_t) 0;
                        high_66439 = i_65358;
                        while (loop_while_66437) {
                            int64_t x_66440 = add64(low_66438, high_66439);
                            int64_t mid_66441 = sdiv64(x_66440, (int64_t) 2);
                            bool x_66442 = sle64((int64_t) 0, mid_66441);
                            bool y_66443 = slt64(mid_66441, n_65344);
                            bool bounds_check_66444 = x_66442 && y_66443;
                            bool index_certs_66445;
                            
                            if (!bounds_check_66444) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [", (long long) mid_66441,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65344, "].",
                                              "-> #0  loess.fut:449:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                                if (memblock_unref(ctx, &mem_67915,
                                                   "mem_67915") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67911,
                                                   "mem_67911") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68131,
                                                   "ext_mem_68131") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68139,
                                                   "ext_mem_68139") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68147,
                                                   "ext_mem_68147") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68155,
                                                   "ext_mem_68155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68163,
                                                   "ext_mem_68163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68171,
                                                   "ext_mem_68171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68296,
                                                   "mem_out_68296") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t mid_id_66446;
                            
                            mid_id_66446 = ((int64_t *) mem_67983)[mid_66441];
                            
                            bool cond_66447 = slt64(mid_id_66446, (int64_t) 0);
                            int64_t mid_idx_66448;
                            
                            if (cond_66447) {
                                mid_idx_66448 = (int64_t) 9223372036854775807;
                            } else {
                                mid_idx_66448 = mid_id_66446;
                            }
                            
                            bool cond_66449 = sle64(defunc_0_g_res_66433,
                                                    mid_idx_66448);
                            int64_t loopres_66450;
                            int64_t loopres_66451;
                            
                            if (cond_66449) {
                                int64_t loopres_t_res_66452 = sub64(mid_66441,
                                                                    (int64_t) 1);
                                
                                loopres_66450 = low_66438;
                                loopres_66451 = loopres_t_res_66452;
                            } else {
                                int64_t loopres_f_res_66453 = add64((int64_t) 1,
                                                                    mid_66441);
                                
                                loopres_66450 = loopres_f_res_66453;
                                loopres_66451 = high_66439;
                            }
                            
                            bool loop_cond_66454 = sle64(loopres_66450,
                                                         loopres_66451);
                            bool loop_while_tmp_68428 = loop_cond_66454;
                            int64_t low_tmp_68429 = loopres_66450;
                            int64_t high_tmp_68430 = loopres_66451;
                            
                            loop_while_66437 = loop_while_tmp_68428;
                            low_66438 = low_tmp_68429;
                            high_66439 = high_tmp_68430;
                        }
                        init_idx_66434 = loop_while_66437;
                        init_idx_66435 = low_66438;
                        init_idx_66436 = high_66439;
                        
                        bool idx_66455;
                        int64_t idx_66456;
                        int64_t idx_66457;
                        int64_t idx_66458;
                        bool loop_while_66459;
                        int64_t l_idx_66460;
                        int64_t r_idx_66461;
                        int64_t span_66462;
                        
                        loop_while_66459 = loop_cond_65369;
                        l_idx_66460 = init_idx_66435;
                        r_idx_66461 = init_idx_66435;
                        span_66462 = (int64_t) 1;
                        while (loop_while_66459) {
                            int64_t max_arg_66463 = sub64(l_idx_66460,
                                                          (int64_t) 1);
                            int64_t max_res_66464 = smax64((int64_t) 0,
                                                           max_arg_66463);
                            int64_t min_arg_66465 = add64((int64_t) 1,
                                                          r_idx_66461);
                            int64_t min_res_66466 = smin64(min_arg_66417,
                                                           min_arg_66465);
                            bool x_66467 = sle64((int64_t) 0, max_res_66464);
                            bool y_66468 = slt64(max_res_66464, n_65344);
                            bool bounds_check_66469 = x_66467 && y_66468;
                            bool index_certs_66470;
                            
                            if (!bounds_check_66469) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) max_res_66464,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65344, "].",
                                              "-> #0  loess.fut:459:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                                if (memblock_unref(ctx, &mem_67915,
                                                   "mem_67915") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67911,
                                                   "mem_67911") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68131,
                                                   "ext_mem_68131") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68139,
                                                   "ext_mem_68139") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68147,
                                                   "ext_mem_68147") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68155,
                                                   "ext_mem_68155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68163,
                                                   "ext_mem_68163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68171,
                                                   "ext_mem_68171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68296,
                                                   "mem_out_68296") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_66471;
                            
                            x_66471 = ((int64_t *) mem_67983)[max_res_66464];
                            
                            int64_t abs_arg_66472 = sub64(x_66471,
                                                          defunc_0_g_res_66433);
                            int64_t abs_res_66473 = abs64(abs_arg_66472);
                            bool x_66474 = sle64((int64_t) 0, min_res_66466);
                            bool y_66475 = slt64(min_res_66466, n_65344);
                            bool bounds_check_66476 = x_66474 && y_66475;
                            bool index_certs_66477;
                            
                            if (!bounds_check_66476) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) min_res_66466,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65344, "].",
                                              "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  loess.fut:589:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:588:5-590:26\n   #10 loess.fut:572:1-611:26\n");
                                if (memblock_unref(ctx, &mem_67915,
                                                   "mem_67915") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67911,
                                                   "mem_67911") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68131,
                                                   "ext_mem_68131") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68139,
                                                   "ext_mem_68139") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68147,
                                                   "ext_mem_68147") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68155,
                                                   "ext_mem_68155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68163,
                                                   "ext_mem_68163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68171,
                                                   "ext_mem_68171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68296,
                                                   "mem_out_68296") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_66478;
                            
                            x_66478 = ((int64_t *) mem_67983)[min_res_66466];
                            
                            int64_t abs_arg_66479 = sub64(x_66478,
                                                          defunc_0_g_res_66433);
                            int64_t abs_res_66480 = abs64(abs_arg_66479);
                            bool cond_66481 = max_res_66464 == l_idx_66460;
                            int64_t loopres_66482;
                            int64_t loopres_66483;
                            int64_t loopres_66484;
                            
                            if (cond_66481) {
                                loopres_66482 = l_idx_66460;
                                loopres_66483 = r_idx_66461;
                                loopres_66484 = min_res_65364;
                            } else {
                                bool cond_66485 = slt64(abs_res_66473,
                                                        abs_res_66480);
                                bool cond_f_res_66486 = min_res_66466 ==
                                     r_idx_66461;
                                bool x_66487 = !cond_66485;
                                bool y_66488 = cond_f_res_66486 && x_66487;
                                bool cond_66489 = cond_66485 || y_66488;
                                int64_t loopres_f_res_66490;
                                
                                if (cond_66489) {
                                    loopres_f_res_66490 = max_res_66464;
                                } else {
                                    loopres_f_res_66490 = l_idx_66460;
                                }
                                
                                int64_t loopres_f_res_66491;
                                
                                if (cond_66489) {
                                    loopres_f_res_66491 = r_idx_66461;
                                } else {
                                    loopres_f_res_66491 = min_res_66466;
                                }
                                
                                int64_t loopres_f_res_66492;
                                
                                if (cond_66489) {
                                    int64_t loopres_f_res_t_res_66493 =
                                            add64((int64_t) 1, span_66462);
                                    
                                    loopres_f_res_66492 =
                                        loopres_f_res_t_res_66493;
                                } else {
                                    int64_t loopres_f_res_f_res_66494 =
                                            add64((int64_t) 1, span_66462);
                                    
                                    loopres_f_res_66492 =
                                        loopres_f_res_f_res_66494;
                                }
                                loopres_66482 = loopres_f_res_66490;
                                loopres_66483 = loopres_f_res_66491;
                                loopres_66484 = loopres_f_res_66492;
                            }
                            
                            bool loop_cond_66495 = slt64(loopres_66484,
                                                         min_res_65364);
                            bool loop_while_tmp_68431 = loop_cond_66495;
                            int64_t l_idx_tmp_68432 = loopres_66482;
                            int64_t r_idx_tmp_68433 = loopres_66483;
                            int64_t span_tmp_68434 = loopres_66484;
                            
                            loop_while_66459 = loop_while_tmp_68431;
                            l_idx_66460 = l_idx_tmp_68432;
                            r_idx_66461 = r_idx_tmp_68433;
                            span_66462 = span_tmp_68434;
                        }
                        idx_66455 = loop_while_66459;
                        idx_66456 = l_idx_66460;
                        idx_66457 = r_idx_66461;
                        idx_66458 = span_66462;
                        
                        int64_t min_res_66496 = smin64(min_arg_66418,
                                                       idx_66456);
                        int64_t max_res_66497 = smax64((int64_t) 0,
                                                       min_res_66496);
                        int64_t x_66498 = add64(min_res_66419, max_res_66497);
                        int64_t r_66499 = sub64(x_66498, (int64_t) 1);
                        bool x_66500 = sle64((int64_t) 0, r_66499);
                        bool y_66501 = slt64(r_66499, n_65344);
                        bool bounds_check_66502 = x_66500 && y_66501;
                        bool index_certs_66503;
                        
                        if (!bounds_check_66502) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) r_66499,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67915, "mem_67915") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67911, "mem_67911") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68131,
                                               "ext_mem_68131") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68139,
                                               "ext_mem_68139") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68147,
                                               "ext_mem_68147") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68155,
                                               "ext_mem_68155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_66504;
                        
                        x_66504 = ((int64_t *) mem_67956)[r_66499];
                        
                        int64_t abs_arg_66505 = sub64(x_66504, min_res_66432);
                        int64_t abs_res_66506 = abs64(abs_arg_66505);
                        bool x_66507 = sle64((int64_t) 0, max_res_66497);
                        bool y_66508 = slt64(max_res_66497, n_65344);
                        bool bounds_check_66509 = x_66507 && y_66508;
                        bool index_certs_66510;
                        
                        if (!bounds_check_66509) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) max_res_66497,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65344, "].",
                                          "-> #0  loess.fut:483:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  loess.fut:589:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:588:5-590:26\n   #9  loess.fut:572:1-611:26\n");
                            if (memblock_unref(ctx, &mem_67915, "mem_67915") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67911, "mem_67911") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68131,
                                               "ext_mem_68131") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68139,
                                               "ext_mem_68139") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68147,
                                               "ext_mem_68147") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68155,
                                               "ext_mem_68155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68163,
                                               "ext_mem_68163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68171,
                                               "ext_mem_68171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68296,
                                               "mem_out_68296") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_66511;
                        
                        x_66511 = ((int64_t *) mem_67956)[max_res_66497];
                        
                        int64_t abs_arg_66512 = sub64(x_66511, min_res_66432);
                        int64_t abs_res_66513 = abs64(abs_arg_66512);
                        int64_t max_res_66514 = smax64(abs_res_66506,
                                                       abs_res_66513);
                        float defunc_0_f_res_66515 =
                              sitofp_i64_f32(max_res_66514);
                        float defunc_1_f_res_66516 = max_res_66423 +
                              defunc_0_f_res_66515;
                        
                        for (int64_t i_66926 = 0; i_66926 < q_65346;
                             i_66926++) {
                            float x_66520;
                            
                            x_66520 = ((float *) mem_67998)[i_66926];
                            
                            bool cond_66521 = sle64(last_res_66402, i_66926);
                            int64_t defunc_0_f_res_66522;
                            
                            if (cond_66521) {
                                defunc_0_f_res_66522 = (int64_t) 0;
                            } else {
                                int64_t i_66523 = add64(max_res_66497, i_66926);
                                int64_t defunc_0_add_arg_66524;
                                
                                defunc_0_add_arg_66524 =
                                    ((int64_t *) mem_67956)[i_66523];
                                
                                int64_t defunc_1_add_res_66525 =
                                        add64((int64_t) 1,
                                              defunc_0_add_arg_66524);
                                
                                defunc_0_f_res_66522 = defunc_1_add_res_66525;
                            }
                            
                            int64_t binop_p_66526 = sub64(defunc_0_f_res_66522,
                                                          min_res_66432);
                            float defunc_0_f_res_66527 =
                                  sitofp_i64_f32(binop_p_66526);
                            float abs_res_66528 =
                                  (float) fabs(defunc_0_f_res_66527);
                            float tmp1_66529 = abs_res_66528 /
                                  defunc_1_f_res_66516;
                            float x_66530 = tmp1_66529 * tmp1_66529;
                            float y_66531 = tmp1_66529 * x_66530;
                            float tmp2_66532 = 1.0F - y_66531;
                            float x_66533 = tmp2_66532 * tmp2_66532;
                            float tmp3_66534 = tmp2_66532 * x_66533;
                            float tmp4_66535 = x_66520 * tmp3_66534;
                            
                            ((float *) mem_68035)[i_66926] =
                                defunc_0_f_res_66527;
                            ((float *) mem_68038)[i_66926] = tmp4_66535;
                        }
                        
                        float defunc_2_reduce_res_66542;
                        float defunc_2_reduce_res_66543;
                        float defunc_2_reduce_res_66544;
                        float defunc_2_reduce_res_66545;
                        float defunc_2_reduce_res_66546;
                        float redout_66931;
                        float redout_66932;
                        float redout_66933;
                        float redout_66934;
                        float redout_66935;
                        
                        redout_66931 = 0.0F;
                        redout_66932 = 0.0F;
                        redout_66933 = 0.0F;
                        redout_66934 = 0.0F;
                        redout_66935 = 0.0F;
                        for (int64_t i_66938 = 0; i_66938 < q_65346;
                             i_66938++) {
                            float x_66564;
                            
                            x_66564 = ((float *) mem_68035)[i_66938];
                            
                            float x_66565;
                            
                            x_66565 = ((float *) mem_68038)[i_66938];
                            
                            float defunc_1_f_res_66566 = x_66564 * x_66565;
                            float defunc_1_f_res_66567 = x_66564 *
                                  defunc_1_f_res_66566;
                            float defunc_1_f_res_66568 = x_66564 *
                                  defunc_1_f_res_66567;
                            float defunc_1_f_res_66569 = x_66564 *
                                  defunc_1_f_res_66568;
                            float defunc_1_op_res_66551 = x_66565 +
                                  redout_66931;
                            float defunc_1_op_res_66554 = defunc_1_f_res_66566 +
                                  redout_66932;
                            float defunc_1_op_res_66557 = defunc_1_f_res_66567 +
                                  redout_66933;
                            float defunc_1_op_res_66560 = defunc_1_f_res_66568 +
                                  redout_66934;
                            float defunc_1_op_res_66563 = defunc_1_f_res_66569 +
                                  redout_66935;
                            
                            ((float *) mem_68065)[i_66938] =
                                defunc_1_f_res_66567;
                            ((float *) mem_68068)[i_66938] =
                                defunc_1_f_res_66566;
                            
                            float redout_tmp_68437 = defunc_1_op_res_66551;
                            float redout_tmp_68438 = defunc_1_op_res_66554;
                            float redout_tmp_68439 = defunc_1_op_res_66557;
                            float redout_tmp_68440 = defunc_1_op_res_66560;
                            float redout_tmp_68441 = defunc_1_op_res_66563;
                            
                            redout_66931 = redout_tmp_68437;
                            redout_66932 = redout_tmp_68438;
                            redout_66933 = redout_tmp_68439;
                            redout_66934 = redout_tmp_68440;
                            redout_66935 = redout_tmp_68441;
                        }
                        defunc_2_reduce_res_66542 = redout_66931;
                        defunc_2_reduce_res_66543 = redout_66932;
                        defunc_2_reduce_res_66544 = redout_66933;
                        defunc_2_reduce_res_66545 = redout_66934;
                        defunc_2_reduce_res_66546 = redout_66935;
                        
                        float x_66577 = defunc_2_reduce_res_66544 *
                              defunc_2_reduce_res_66546;
                        float y_66578 = defunc_2_reduce_res_66545 *
                              defunc_2_reduce_res_66545;
                        float a12_66579 = x_66577 - y_66578;
                        float x_66580 = defunc_2_reduce_res_66544 *
                              defunc_2_reduce_res_66545;
                        float y_66581 = defunc_2_reduce_res_66543 *
                              defunc_2_reduce_res_66546;
                        float b12_66582 = x_66580 - y_66581;
                        float x_66583 = defunc_2_reduce_res_66543 *
                              defunc_2_reduce_res_66545;
                        float y_66584 = defunc_2_reduce_res_66544 *
                              defunc_2_reduce_res_66544;
                        float c12_66585 = x_66583 - y_66584;
                        float x_66586 = defunc_2_reduce_res_66542 *
                              defunc_2_reduce_res_66546;
                        float b2_66587 = x_66586 - y_66584;
                        float x_66588 = defunc_2_reduce_res_66543 *
                              defunc_2_reduce_res_66544;
                        float y_66589 = defunc_2_reduce_res_66542 *
                              defunc_2_reduce_res_66545;
                        float c2_66590 = x_66588 - y_66589;
                        float x_66591 = defunc_2_reduce_res_66542 * a12_66579;
                        float y_66592 = defunc_2_reduce_res_66543 * b12_66582;
                        float x_66593 = x_66591 + y_66592;
                        float y_66594 = defunc_2_reduce_res_66544 * c12_66585;
                        float y_66595 = x_66593 + y_66594;
                        float det_66596 = 1.0F / y_66595;
                        float a12_66597 = a12_66579 * det_66596;
                        float b12_66598 = b12_66582 * det_66596;
                        float c12_66599 = c12_66585 * det_66596;
                        float b2_66600 = b2_66587 * det_66596;
                        float c2_66601 = c2_66590 * det_66596;
                        float defunc_2_reduce_res_66602;
                        float defunc_2_reduce_res_66603;
                        float redout_66941;
                        float redout_66942;
                        
                        redout_66941 = 0.0F;
                        redout_66942 = 0.0F;
                        for (int64_t i_66943 = 0; i_66943 < q_65346;
                             i_66943++) {
                            float x_66611;
                            
                            x_66611 = ((float *) mem_68038)[i_66943];
                            
                            float x_66612;
                            
                            x_66612 = ((float *) mem_68068)[i_66943];
                            
                            float x_66613;
                            
                            x_66613 = ((float *) mem_68065)[i_66943];
                            
                            bool cond_66614 = sle64(last_res_66402, i_66943);
                            float defunc_0_f_res_66615;
                            
                            if (cond_66614) {
                                defunc_0_f_res_66615 = 0.0F;
                            } else {
                                int64_t i_66616 = add64(max_res_66497, i_66943);
                                float defunc_0_add_arg_66617;
                                
                                defunc_0_add_arg_66617 =
                                    ((float *) mem_67953)[i_66616];
                                defunc_0_f_res_66615 = defunc_0_add_arg_66617;
                            }
                            
                            float x_66618 = a12_66597 * x_66611;
                            float y_66619 = b12_66598 * x_66612;
                            float x_66620 = x_66618 + y_66619;
                            float y_66621 = c12_66599 * x_66613;
                            float x_66622 = x_66620 + y_66621;
                            float defunc_9_fit_fun_res_66623 =
                                  defunc_0_f_res_66615 * x_66622;
                            float x_66624 = b12_66598 * x_66611;
                            float y_66625 = b2_66600 * x_66612;
                            float x_66626 = x_66624 + y_66625;
                            float y_66627 = c2_66601 * x_66613;
                            float x_66628 = x_66626 + y_66627;
                            float defunc_9_slope_fun_res_66629 =
                                  defunc_0_f_res_66615 * x_66628;
                            float defunc_1_op_res_66606 =
                                  defunc_9_fit_fun_res_66623 + redout_66941;
                            float defunc_1_op_res_66609 =
                                  defunc_9_slope_fun_res_66629 + redout_66942;
                            float redout_tmp_68444 = defunc_1_op_res_66606;
                            float redout_tmp_68445 = defunc_1_op_res_66609;
                            
                            redout_66941 = redout_tmp_68444;
                            redout_66942 = redout_tmp_68445;
                        }
                        defunc_2_reduce_res_66602 = redout_66941;
                        defunc_2_reduce_res_66603 = redout_66942;
                        ((float *) mem_67911.mem)[i_66955 * n_m_65352 +
                                                  i_66948] =
                            defunc_2_reduce_res_66602;
                        ((float *) mem_67915.mem)[i_66955 * n_m_65352 +
                                                  i_66948] =
                            defunc_2_reduce_res_66603;
                    }
                }
                if (memblock_set(ctx, &ext_mem_68139, &mem_67911,
                                 "mem_67911") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_68131, &mem_67915,
                                 "mem_67915") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67915, "mem_67915") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67911, "mem_67911") != 0)
                    return 1;
            }
            if (memblock_set(ctx, &ext_mem_68155, &ext_mem_68139,
                             "ext_mem_68139") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_68147, &ext_mem_68131,
                             "ext_mem_68131") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_68131, "ext_mem_68131") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_68139, "ext_mem_68139") != 0)
                return 1;
        }
        if (memblock_set(ctx, &ext_mem_68171, &ext_mem_68155,
                         "ext_mem_68155") != 0)
            return 1;
        if (memblock_set(ctx, &ext_mem_68163, &ext_mem_68147,
                         "ext_mem_68147") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_68147, "ext_mem_68147") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_68155, "ext_mem_68155") != 0)
            return 1;
    }
    
    bool cond_66632 = slt64((int64_t) 1, jump_65348);
    int64_t binop_x_68179 = m_65343 * n_65344;
    int64_t binop_y_68180 = (int64_t) 4 * binop_x_68179;
    int64_t bytes_68181 = smax64((int64_t) 0, binop_y_68180);
    int64_t ext_68227;
    
    if (cond_66632) {
        ext_68227 = n_65344;
    } else {
        ext_68227 = n_m_65352;
    }
    
    int64_t ext_68226;
    
    if (cond_66632) {
        ext_68226 = n_65344;
    } else {
        ext_68226 = n_m_65352;
    }
    
    struct memblock ext_mem_68223;
    
    ext_mem_68223.references = NULL;
    if (cond_66632) {
        bool zzero_66634 = jump_65348 == (int64_t) 0;
        bool nonzzero_66635 = !zzero_66634;
        bool nonzzero_cert_66636;
        
        if (!nonzzero_66635) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  loess.fut:546:20-27\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:545:3-549:9\n   #5  loess.fut:608:13-59\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:607:5-609:29\n   #9  loess.fut:572:1-611:26\n");
            if (memblock_unref(ctx, &ext_mem_68223, "ext_mem_68223") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_68163, "ext_mem_68163") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_68171, "ext_mem_68171") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_68296, "mem_out_68296") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t y_66637 = sub64(n_m_65352, (int64_t) 1);
        struct memblock mem_68182;
        
        mem_68182.references = NULL;
        if (memblock_alloc(ctx, &mem_68182, bytes_68181, "mem_68182")) {
            err = 1;
            goto cleanup;
        }
        for (int64_t i_66964 = 0; i_66964 < m_65343; i_66964++) {
            for (int64_t i_66960 = 0; i_66960 < n_65344; i_66960++) {
                int64_t m_v_66643 = sdiv64(i_66960, jump_65348);
                bool cond_66644 = m_v_66643 == y_66637;
                int64_t j_66645;
                
                if (cond_66644) {
                    int64_t j_t_res_66646 = sub64(m_v_66643, (int64_t) 1);
                    
                    j_66645 = j_t_res_66646;
                } else {
                    j_66645 = m_v_66643;
                }
                
                int64_t min_arg_66647 = mul64(jump_65348, j_66645);
                int64_t min_res_66648 = smin64(i_65358, min_arg_66647);
                int64_t defunc_0_m_fun_arg_66649 = add64((int64_t) 1, j_66645);
                int64_t min_arg_66650 = mul64(jump_65348,
                                              defunc_0_m_fun_arg_66649);
                int64_t min_res_66651 = smin64(i_65358, min_arg_66650);
                int64_t i64_arg_66652 = sub64(min_res_66651, min_res_66648);
                float i64_res_66653 = sitofp_i64_f32(i64_arg_66652);
                int64_t i64_arg_66654 = sub64(i_66960, min_res_66648);
                float i64_res_66655 = sitofp_i64_f32(i64_arg_66654);
                float u_66656 = i64_res_66655 / i64_res_66653;
                float u2_66657 = u_66656 * u_66656;
                float u3_66658 = u_66656 * u2_66657;
                float x_66659 = 2.0F * u3_66658;
                float y_66660 = 3.0F * u2_66657;
                float x_66661 = x_66659 - y_66660;
                float x_66662 = 1.0F + x_66661;
                bool x_66663 = sle64((int64_t) 0, j_66645);
                bool y_66664 = slt64(j_66645, n_m_65352);
                bool bounds_check_66665 = x_66663 && y_66664;
                bool index_certs_66666;
                
                if (!bounds_check_66665) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) j_66645,
                                  "] out of bounds for array of shape [",
                                  (long long) n_m_65352, "].",
                                  "-> #0  loess.fut:535:27-33\n   #1  loess.fut:548:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:545:3-549:9\n   #6  loess.fut:608:13-59\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:607:5-609:29\n   #10 loess.fut:572:1-611:26\n");
                    if (memblock_unref(ctx, &mem_68182, "mem_68182") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_68223, "ext_mem_68223") !=
                        0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_68163, "ext_mem_68163") !=
                        0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_68171, "ext_mem_68171") !=
                        0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_68296, "mem_out_68296") !=
                        0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                float y_66667;
                
                y_66667 = ((float *) ext_mem_68171.mem)[i_66964 * n_m_65352 +
                                                        j_66645];
                
                float x_66668 = x_66662 * y_66667;
                float x_66669 = y_66660 - x_66659;
                bool x_66670 = sle64((int64_t) 0, defunc_0_m_fun_arg_66649);
                bool y_66671 = slt64(defunc_0_m_fun_arg_66649, n_m_65352);
                bool bounds_check_66672 = x_66670 && y_66671;
                bool index_certs_66673;
                
                if (!bounds_check_66672) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [",
                                  (long long) defunc_0_m_fun_arg_66649,
                                  "] out of bounds for array of shape [",
                                  (long long) n_m_65352, "].",
                                  "-> #0  loess.fut:536:27-37\n   #1  loess.fut:548:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:545:3-549:9\n   #6  loess.fut:608:13-59\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:607:5-609:29\n   #10 loess.fut:572:1-611:26\n");
                    if (memblock_unref(ctx, &mem_68182, "mem_68182") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_68223, "ext_mem_68223") !=
                        0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_68163, "ext_mem_68163") !=
                        0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_68171, "ext_mem_68171") !=
                        0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_68296, "mem_out_68296") !=
                        0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                float y_66674;
                
                y_66674 = ((float *) ext_mem_68171.mem)[i_66964 * n_m_65352 +
                                                        defunc_0_m_fun_arg_66649];
                
                float y_66675 = x_66669 * y_66674;
                float x_66676 = x_66668 + y_66675;
                float y_66677 = 2.0F * u2_66657;
                float x_66678 = u3_66658 - y_66677;
                float x_66679 = u_66656 + x_66678;
                float y_66680;
                
                y_66680 = ((float *) ext_mem_68163.mem)[i_66964 * n_m_65352 +
                                                        j_66645];
                
                float x_66681 = x_66679 * y_66680;
                float y_66682 = i64_res_66653 * x_66681;
                float x_66683 = x_66676 + y_66682;
                float x_66684 = u3_66658 - u2_66657;
                float y_66685;
                
                y_66685 = ((float *) ext_mem_68163.mem)[i_66964 * n_m_65352 +
                                                        defunc_0_m_fun_arg_66649];
                
                float x_66686 = x_66684 * y_66685;
                float y_66687 = i64_res_66653 * x_66686;
                float defunc_4_interpolate_proc_res_66688 = x_66683 + y_66687;
                
                ((float *) mem_68182.mem)[i_66964 * n_65344 + i_66960] =
                    defunc_4_interpolate_proc_res_66688;
            }
        }
        if (memblock_set(ctx, &ext_mem_68223, &mem_68182, "mem_68182") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_68182, "mem_68182") != 0)
            return 1;
    } else {
        bool dim_match_66689 = n_65344 == n_m_65352;
        bool empty_or_match_cert_66690;
        
        if (!dim_match_66689) {
            ctx->error =
                msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                          "Value of (core language) shape (",
                          (long long) m_65343, ", ", (long long) n_m_65352,
                          ") cannot match shape of type `[",
                          (long long) m_65343, "][", (long long) n_65344,
                          "]f32`.",
                          "-> #0  loess.fut:611:5-26\n   #1  loess.fut:572:1-611:26\n");
            if (memblock_unref(ctx, &ext_mem_68223, "ext_mem_68223") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_68163, "ext_mem_68163") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_68171, "ext_mem_68171") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_68296, "mem_out_68296") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        if (memblock_set(ctx, &ext_mem_68223, &ext_mem_68171,
                         "ext_mem_68171") != 0)
            return 1;
    }
    if (memblock_unref(ctx, &ext_mem_68163, "ext_mem_68163") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_68171, "ext_mem_68171") != 0)
        return 1;
    
    int64_t binop_x_68231 = m_65343 * n_65344;
    int64_t binop_y_68232 = (int64_t) 4 * binop_x_68231;
    int64_t bytes_68233 = smax64((int64_t) 0, binop_y_68232);
    struct memblock mem_68234;
    
    mem_68234.references = NULL;
    if (memblock_alloc(ctx, &mem_68234, bytes_68233, "mem_68234")) {
        err = 1;
        goto cleanup;
    }
    if (m_65343 * n_65344 * (int64_t) 4 > 0)
        memmove(mem_68234.mem + (int64_t) 0, ext_mem_68223.mem + (int64_t) 0,
                m_65343 * n_65344 * (int64_t) 4);
    if (memblock_unref(ctx, &ext_mem_68223, "ext_mem_68223") != 0)
        return 1;
    if (memblock_set(ctx, &mem_out_68296, &mem_68234, "mem_68234") != 0)
        return 1;
    (*mem_out_p_68448).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_68448, &mem_out_68296, "mem_out_68296") !=
        0)
        return 1;
    if (memblock_unref(ctx, &mem_68234, "mem_68234") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_68223, "ext_mem_68223") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_68163, "ext_mem_68163") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_68171, "ext_mem_68171") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_68296, "mem_out_68296") != 0)
        return 1;
    
  cleanup:
    { }
    free(mem_67116);
    free(mem_67131);
    free(mem_67134);
    free(mem_67161);
    free(mem_67176);
    free(mem_67249);
    free(mem_67264);
    free(mem_67267);
    free(mem_67294);
    free(mem_67309);
    free(mem_67412);
    free(mem_67427);
    free(mem_67430);
    free(mem_67457);
    free(mem_67472);
    free(mem_67597);
    free(mem_67612);
    free(mem_67615);
    free(mem_67642);
    free(mem_67657);
    free(mem_67683);
    free(mem_67745);
    free(mem_67760);
    free(mem_67763);
    free(mem_67790);
    free(mem_67805);
    free(mem_67842);
    free(mem_67845);
    free(mem_67938);
    free(mem_67953);
    free(mem_67956);
    free(mem_67983);
    free(mem_67998);
    free(mem_68035);
    free(mem_68038);
    free(mem_68065);
    free(mem_68068);
    return err;
}

int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f32_2d **out0, const
                       struct futhark_f32_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5)
{
    struct memblock Y_mem_67095;
    
    Y_mem_67095.references = NULL;
    
    int64_t m_65343;
    int64_t n_65344;
    int64_t q_65346;
    int64_t degree_65347;
    int64_t jump_65348;
    int64_t jump_threshold_65349;
    int64_t q_threshold_65350;
    struct memblock mem_out_68296;
    
    mem_out_68296.references = NULL;
    
    int ret = 0;
    
    lock_lock(&ctx->lock);
    Y_mem_67095 = in0->mem;
    m_65343 = in0->shape[0];
    n_65344 = in0->shape[1];
    q_65346 = in1;
    degree_65347 = in2;
    jump_65348 = in3;
    jump_threshold_65349 = in4;
    q_threshold_65350 = in5;
    if (!(m_65343 == in0->shape[0] && n_65344 == in0->shape[1])) {
        ret = 1;
        if (!ctx->error)
            ctx->error =
                msgprintf("Error: entry point arguments have invalid sizes.\n");
    }
    if (ret == 0) {
        ret = futrts_entry_main(ctx, &mem_out_68296, Y_mem_67095, m_65343,
                                n_65344, q_65346, degree_65347, jump_65348,
                                jump_threshold_65349, q_threshold_65350);
        if (ret == 0) {
            assert((*out0 =
                    (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d))) !=
                NULL);
            (*out0)->mem = mem_out_68296;
            (*out0)->shape[0] = m_65343;
            (*out0)->shape[1] = n_65344;
        }
    }
    lock_unlock(&ctx->lock);
    return ret;
}
  
