// Generated by Futhark 0.22.0
// git: ed22762 (Sat Jan 15 01:09:59 2022 +0100)

// We need to define _GNU_SOURCE before
// _any_ headers files are imported to get
// the usage statistics of a thread (i.e. have RUSAGE_THREAD) on GNU/Linux
// https://manpages.courier-mta.org/htmlman2/getrusage.2.html
#ifndef _GNU_SOURCE // Avoid possible double-definition warning.
#define _GNU_SOURCE
#endif

#ifdef __clang__
#pragma clang diagnostic ignored "-Wunused-function"
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wparentheses"
#pragma clang diagnostic ignored "-Wunused-label"
#elif __GNUC__
#pragma GCC diagnostic ignored "-Wunused-function"
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wparentheses"
#pragma GCC diagnostic ignored "-Wunused-label"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif

// Headers\n")
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdio.h>
#include <float.h>

#ifdef __cplusplus
extern "C" {
#endif

// Initialisation
struct futhark_context_config;
struct futhark_context_config *futhark_context_config_new(void);
void futhark_context_config_free(struct futhark_context_config *cfg);
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int flag);
struct futhark_context;
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg);
void futhark_context_free(struct futhark_context *ctx);
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t param_value);
int futhark_get_tuning_param_count(void);
const char *futhark_get_tuning_param_name(int);
const char *futhark_get_tuning_param_class(int);

// Arrays
struct futhark_f32_2d;
struct futhark_f32_2d *futhark_new_f32_2d(struct futhark_context *ctx, const
                                          float *data, int64_t dim0,
                                          int64_t dim1);
struct futhark_f32_2d *futhark_new_raw_f32_2d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0,
                                              int64_t dim1);
int futhark_free_f32_2d(struct futhark_context *ctx,
                        struct futhark_f32_2d *arr);
int futhark_values_f32_2d(struct futhark_context *ctx,
                          struct futhark_f32_2d *arr, float *data);
unsigned char *futhark_values_raw_f32_2d(struct futhark_context *ctx,
                                         struct futhark_f32_2d *arr);
const int64_t *futhark_shape_f32_2d(struct futhark_context *ctx,
                                    struct futhark_f32_2d *arr);

// Opaque values


// Entry points
int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f32_2d **out0,
                       struct futhark_f32_2d **out1,
                       struct futhark_f32_2d **out2, const
                       struct futhark_f32_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5, const int64_t in6, const int64_t in7, const
                       int64_t in8, const int64_t in9, const int64_t in10, const
                       int64_t in11, const int64_t in12, const int64_t in13,
                       const int64_t in14);

// Miscellaneous
int futhark_context_sync(struct futhark_context *ctx);
char *futhark_context_report(struct futhark_context *ctx);
char *futhark_context_get_error(struct futhark_context *ctx);
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f);
void futhark_context_pause_profiling(struct futhark_context *ctx);
void futhark_context_unpause_profiling(struct futhark_context *ctx);
int futhark_context_clear_caches(struct futhark_context *ctx);
#define FUTHARK_BACKEND_c

#ifdef __cplusplus
}
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>
#include <stdint.h>
// If NDEBUG is set, the assert() macro will do nothing. Since Futhark
// (unfortunately) makes use of assert() for error detection (and even some
// side effects), we want to avoid that.
#undef NDEBUG
#include <assert.h>
#include <stdarg.h>
// Start of util.h.
//
// Various helper functions that are useful in all generated C code.

#include <errno.h>
#include <string.h>

static const char *fut_progname = "(embedded Futhark)";

static void futhark_panic(int eval, const char *fmt, ...) __attribute__((noreturn));
static char* msgprintf(const char *s, ...);
static void* slurp_file(const char *filename, size_t *size);
static int dump_file(const char *file, const void *buf, size_t n);
struct str_builder;
static void str_builder_init(struct str_builder *b);
static void str_builder(struct str_builder *b, const char *s, ...);

static void futhark_panic(int eval, const char *fmt, ...) {
  va_list ap;
  va_start(ap, fmt);
  fprintf(stderr, "%s: ", fut_progname);
  vfprintf(stderr, fmt, ap);
  va_end(ap);
  exit(eval);
}

// For generating arbitrary-sized error messages.  It is the callers
// responsibility to free the buffer at some point.
static char* msgprintf(const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = 1 + (size_t)vsnprintf(NULL, 0, s, vl);
  char *buffer = (char*) malloc(needed);
  va_start(vl, s); // Must re-init.
  vsnprintf(buffer, needed, s, vl);
  return buffer;
}

static inline void check_err(int errval, int sets_errno, const char *fun, int line,
                            const char *msg, ...) {
  if (errval) {
    char errnum[10];

    va_list vl;
    va_start(vl, msg);

    fprintf(stderr, "ERROR: ");
    vfprintf(stderr, msg, vl);
    fprintf(stderr, " in %s() at line %d with error code %s\n",
            fun, line,
            sets_errno ? strerror(errno) : errnum);
    exit(errval);
  }
}

#define CHECK_ERR(err, ...) check_err(err, 0, __func__, __LINE__, __VA_ARGS__)
#define CHECK_ERRNO(err, ...) check_err(err, 1, __func__, __LINE__, __VA_ARGS__)

// Read the rest of an open file into a NUL-terminated string; returns
// NULL on error.
static void* fslurp_file(FILE *f, size_t *size) {
  long start = ftell(f);
  fseek(f, 0, SEEK_END);
  long src_size = ftell(f)-start;
  fseek(f, start, SEEK_SET);
  unsigned char *s = (unsigned char*) malloc((size_t)src_size + 1);
  if (fread(s, 1, (size_t)src_size, f) != (size_t)src_size) {
    free(s);
    s = NULL;
  } else {
    s[src_size] = '\0';
  }

  if (size) {
    *size = (size_t)src_size;
  }

  return s;
}

// Read a file into a NUL-terminated string; returns NULL on error.
static void* slurp_file(const char *filename, size_t *size) {
  FILE *f = fopen(filename, "rb"); // To avoid Windows messing with linebreaks.
  if (f == NULL) return NULL;
  unsigned char *s = fslurp_file(f, size);
  fclose(f);
  return s;
}

// Dump 'n' bytes from 'buf' into the file at the designated location.
// Returns 0 on success.
static int dump_file(const char *file, const void *buf, size_t n) {
  FILE *f = fopen(file, "w");

  if (f == NULL) {
    return 1;
  }

  if (fwrite(buf, sizeof(char), n, f) != n) {
    return 1;
  }

  if (fclose(f) != 0) {
    return 1;
  }

  return 0;
}

struct str_builder {
  char *str;
  size_t capacity; // Size of buffer.
  size_t used; // Bytes used, *not* including final zero.
};

static void str_builder_init(struct str_builder *b) {
  b->capacity = 10;
  b->used = 0;
  b->str = malloc(b->capacity);
  b->str[0] = 0;
}

static void str_builder(struct str_builder *b, const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = (size_t)vsnprintf(NULL, 0, s, vl);

  while (b->capacity < b->used + needed + 1) {
    b->capacity *= 2;
    b->str = realloc(b->str, b->capacity);
  }

  va_start(vl, s); // Must re-init.
  vsnprintf(b->str+b->used, b->capacity-b->used, s, vl);
  b->used += needed;
}

// End of util.h.
// Start of half.h.

// Conversion functions are from http://half.sourceforge.net/, but
// translated to C.
//
// Copyright (c) 2012-2021 Christian Rau
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

#ifndef __OPENCL_VERSION__
#define __constant
#endif

__constant static const uint16_t base_table[512] = {
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0002, 0x0004, 0x0008, 0x0010, 0x0020, 0x0040, 0x0080, 0x0100,
  0x0200, 0x0400, 0x0800, 0x0C00, 0x1000, 0x1400, 0x1800, 0x1C00, 0x2000, 0x2400, 0x2800, 0x2C00, 0x3000, 0x3400, 0x3800, 0x3C00,
  0x4000, 0x4400, 0x4800, 0x4C00, 0x5000, 0x5400, 0x5800, 0x5C00, 0x6000, 0x6400, 0x6800, 0x6C00, 0x7000, 0x7400, 0x7800, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8001, 0x8002, 0x8004, 0x8008, 0x8010, 0x8020, 0x8040, 0x8080, 0x8100,
  0x8200, 0x8400, 0x8800, 0x8C00, 0x9000, 0x9400, 0x9800, 0x9C00, 0xA000, 0xA400, 0xA800, 0xAC00, 0xB000, 0xB400, 0xB800, 0xBC00,
  0xC000, 0xC400, 0xC800, 0xCC00, 0xD000, 0xD400, 0xD800, 0xDC00, 0xE000, 0xE400, 0xE800, 0xEC00, 0xF000, 0xF400, 0xF800, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00 };

__constant static const unsigned char shift_table[512] = {
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13 };

__constant static const uint32_t mantissa_table[2048] = {
  0x00000000, 0x33800000, 0x34000000, 0x34400000, 0x34800000, 0x34A00000, 0x34C00000, 0x34E00000, 0x35000000, 0x35100000, 0x35200000, 0x35300000, 0x35400000, 0x35500000, 0x35600000, 0x35700000,
  0x35800000, 0x35880000, 0x35900000, 0x35980000, 0x35A00000, 0x35A80000, 0x35B00000, 0x35B80000, 0x35C00000, 0x35C80000, 0x35D00000, 0x35D80000, 0x35E00000, 0x35E80000, 0x35F00000, 0x35F80000,
  0x36000000, 0x36040000, 0x36080000, 0x360C0000, 0x36100000, 0x36140000, 0x36180000, 0x361C0000, 0x36200000, 0x36240000, 0x36280000, 0x362C0000, 0x36300000, 0x36340000, 0x36380000, 0x363C0000,
  0x36400000, 0x36440000, 0x36480000, 0x364C0000, 0x36500000, 0x36540000, 0x36580000, 0x365C0000, 0x36600000, 0x36640000, 0x36680000, 0x366C0000, 0x36700000, 0x36740000, 0x36780000, 0x367C0000,
  0x36800000, 0x36820000, 0x36840000, 0x36860000, 0x36880000, 0x368A0000, 0x368C0000, 0x368E0000, 0x36900000, 0x36920000, 0x36940000, 0x36960000, 0x36980000, 0x369A0000, 0x369C0000, 0x369E0000,
  0x36A00000, 0x36A20000, 0x36A40000, 0x36A60000, 0x36A80000, 0x36AA0000, 0x36AC0000, 0x36AE0000, 0x36B00000, 0x36B20000, 0x36B40000, 0x36B60000, 0x36B80000, 0x36BA0000, 0x36BC0000, 0x36BE0000,
  0x36C00000, 0x36C20000, 0x36C40000, 0x36C60000, 0x36C80000, 0x36CA0000, 0x36CC0000, 0x36CE0000, 0x36D00000, 0x36D20000, 0x36D40000, 0x36D60000, 0x36D80000, 0x36DA0000, 0x36DC0000, 0x36DE0000,
  0x36E00000, 0x36E20000, 0x36E40000, 0x36E60000, 0x36E80000, 0x36EA0000, 0x36EC0000, 0x36EE0000, 0x36F00000, 0x36F20000, 0x36F40000, 0x36F60000, 0x36F80000, 0x36FA0000, 0x36FC0000, 0x36FE0000,
  0x37000000, 0x37010000, 0x37020000, 0x37030000, 0x37040000, 0x37050000, 0x37060000, 0x37070000, 0x37080000, 0x37090000, 0x370A0000, 0x370B0000, 0x370C0000, 0x370D0000, 0x370E0000, 0x370F0000,
  0x37100000, 0x37110000, 0x37120000, 0x37130000, 0x37140000, 0x37150000, 0x37160000, 0x37170000, 0x37180000, 0x37190000, 0x371A0000, 0x371B0000, 0x371C0000, 0x371D0000, 0x371E0000, 0x371F0000,
  0x37200000, 0x37210000, 0x37220000, 0x37230000, 0x37240000, 0x37250000, 0x37260000, 0x37270000, 0x37280000, 0x37290000, 0x372A0000, 0x372B0000, 0x372C0000, 0x372D0000, 0x372E0000, 0x372F0000,
  0x37300000, 0x37310000, 0x37320000, 0x37330000, 0x37340000, 0x37350000, 0x37360000, 0x37370000, 0x37380000, 0x37390000, 0x373A0000, 0x373B0000, 0x373C0000, 0x373D0000, 0x373E0000, 0x373F0000,
  0x37400000, 0x37410000, 0x37420000, 0x37430000, 0x37440000, 0x37450000, 0x37460000, 0x37470000, 0x37480000, 0x37490000, 0x374A0000, 0x374B0000, 0x374C0000, 0x374D0000, 0x374E0000, 0x374F0000,
  0x37500000, 0x37510000, 0x37520000, 0x37530000, 0x37540000, 0x37550000, 0x37560000, 0x37570000, 0x37580000, 0x37590000, 0x375A0000, 0x375B0000, 0x375C0000, 0x375D0000, 0x375E0000, 0x375F0000,
  0x37600000, 0x37610000, 0x37620000, 0x37630000, 0x37640000, 0x37650000, 0x37660000, 0x37670000, 0x37680000, 0x37690000, 0x376A0000, 0x376B0000, 0x376C0000, 0x376D0000, 0x376E0000, 0x376F0000,
  0x37700000, 0x37710000, 0x37720000, 0x37730000, 0x37740000, 0x37750000, 0x37760000, 0x37770000, 0x37780000, 0x37790000, 0x377A0000, 0x377B0000, 0x377C0000, 0x377D0000, 0x377E0000, 0x377F0000,
  0x37800000, 0x37808000, 0x37810000, 0x37818000, 0x37820000, 0x37828000, 0x37830000, 0x37838000, 0x37840000, 0x37848000, 0x37850000, 0x37858000, 0x37860000, 0x37868000, 0x37870000, 0x37878000,
  0x37880000, 0x37888000, 0x37890000, 0x37898000, 0x378A0000, 0x378A8000, 0x378B0000, 0x378B8000, 0x378C0000, 0x378C8000, 0x378D0000, 0x378D8000, 0x378E0000, 0x378E8000, 0x378F0000, 0x378F8000,
  0x37900000, 0x37908000, 0x37910000, 0x37918000, 0x37920000, 0x37928000, 0x37930000, 0x37938000, 0x37940000, 0x37948000, 0x37950000, 0x37958000, 0x37960000, 0x37968000, 0x37970000, 0x37978000,
  0x37980000, 0x37988000, 0x37990000, 0x37998000, 0x379A0000, 0x379A8000, 0x379B0000, 0x379B8000, 0x379C0000, 0x379C8000, 0x379D0000, 0x379D8000, 0x379E0000, 0x379E8000, 0x379F0000, 0x379F8000,
  0x37A00000, 0x37A08000, 0x37A10000, 0x37A18000, 0x37A20000, 0x37A28000, 0x37A30000, 0x37A38000, 0x37A40000, 0x37A48000, 0x37A50000, 0x37A58000, 0x37A60000, 0x37A68000, 0x37A70000, 0x37A78000,
  0x37A80000, 0x37A88000, 0x37A90000, 0x37A98000, 0x37AA0000, 0x37AA8000, 0x37AB0000, 0x37AB8000, 0x37AC0000, 0x37AC8000, 0x37AD0000, 0x37AD8000, 0x37AE0000, 0x37AE8000, 0x37AF0000, 0x37AF8000,
  0x37B00000, 0x37B08000, 0x37B10000, 0x37B18000, 0x37B20000, 0x37B28000, 0x37B30000, 0x37B38000, 0x37B40000, 0x37B48000, 0x37B50000, 0x37B58000, 0x37B60000, 0x37B68000, 0x37B70000, 0x37B78000,
  0x37B80000, 0x37B88000, 0x37B90000, 0x37B98000, 0x37BA0000, 0x37BA8000, 0x37BB0000, 0x37BB8000, 0x37BC0000, 0x37BC8000, 0x37BD0000, 0x37BD8000, 0x37BE0000, 0x37BE8000, 0x37BF0000, 0x37BF8000,
  0x37C00000, 0x37C08000, 0x37C10000, 0x37C18000, 0x37C20000, 0x37C28000, 0x37C30000, 0x37C38000, 0x37C40000, 0x37C48000, 0x37C50000, 0x37C58000, 0x37C60000, 0x37C68000, 0x37C70000, 0x37C78000,
  0x37C80000, 0x37C88000, 0x37C90000, 0x37C98000, 0x37CA0000, 0x37CA8000, 0x37CB0000, 0x37CB8000, 0x37CC0000, 0x37CC8000, 0x37CD0000, 0x37CD8000, 0x37CE0000, 0x37CE8000, 0x37CF0000, 0x37CF8000,
  0x37D00000, 0x37D08000, 0x37D10000, 0x37D18000, 0x37D20000, 0x37D28000, 0x37D30000, 0x37D38000, 0x37D40000, 0x37D48000, 0x37D50000, 0x37D58000, 0x37D60000, 0x37D68000, 0x37D70000, 0x37D78000,
  0x37D80000, 0x37D88000, 0x37D90000, 0x37D98000, 0x37DA0000, 0x37DA8000, 0x37DB0000, 0x37DB8000, 0x37DC0000, 0x37DC8000, 0x37DD0000, 0x37DD8000, 0x37DE0000, 0x37DE8000, 0x37DF0000, 0x37DF8000,
  0x37E00000, 0x37E08000, 0x37E10000, 0x37E18000, 0x37E20000, 0x37E28000, 0x37E30000, 0x37E38000, 0x37E40000, 0x37E48000, 0x37E50000, 0x37E58000, 0x37E60000, 0x37E68000, 0x37E70000, 0x37E78000,
  0x37E80000, 0x37E88000, 0x37E90000, 0x37E98000, 0x37EA0000, 0x37EA8000, 0x37EB0000, 0x37EB8000, 0x37EC0000, 0x37EC8000, 0x37ED0000, 0x37ED8000, 0x37EE0000, 0x37EE8000, 0x37EF0000, 0x37EF8000,
  0x37F00000, 0x37F08000, 0x37F10000, 0x37F18000, 0x37F20000, 0x37F28000, 0x37F30000, 0x37F38000, 0x37F40000, 0x37F48000, 0x37F50000, 0x37F58000, 0x37F60000, 0x37F68000, 0x37F70000, 0x37F78000,
  0x37F80000, 0x37F88000, 0x37F90000, 0x37F98000, 0x37FA0000, 0x37FA8000, 0x37FB0000, 0x37FB8000, 0x37FC0000, 0x37FC8000, 0x37FD0000, 0x37FD8000, 0x37FE0000, 0x37FE8000, 0x37FF0000, 0x37FF8000,
  0x38000000, 0x38004000, 0x38008000, 0x3800C000, 0x38010000, 0x38014000, 0x38018000, 0x3801C000, 0x38020000, 0x38024000, 0x38028000, 0x3802C000, 0x38030000, 0x38034000, 0x38038000, 0x3803C000,
  0x38040000, 0x38044000, 0x38048000, 0x3804C000, 0x38050000, 0x38054000, 0x38058000, 0x3805C000, 0x38060000, 0x38064000, 0x38068000, 0x3806C000, 0x38070000, 0x38074000, 0x38078000, 0x3807C000,
  0x38080000, 0x38084000, 0x38088000, 0x3808C000, 0x38090000, 0x38094000, 0x38098000, 0x3809C000, 0x380A0000, 0x380A4000, 0x380A8000, 0x380AC000, 0x380B0000, 0x380B4000, 0x380B8000, 0x380BC000,
  0x380C0000, 0x380C4000, 0x380C8000, 0x380CC000, 0x380D0000, 0x380D4000, 0x380D8000, 0x380DC000, 0x380E0000, 0x380E4000, 0x380E8000, 0x380EC000, 0x380F0000, 0x380F4000, 0x380F8000, 0x380FC000,
  0x38100000, 0x38104000, 0x38108000, 0x3810C000, 0x38110000, 0x38114000, 0x38118000, 0x3811C000, 0x38120000, 0x38124000, 0x38128000, 0x3812C000, 0x38130000, 0x38134000, 0x38138000, 0x3813C000,
  0x38140000, 0x38144000, 0x38148000, 0x3814C000, 0x38150000, 0x38154000, 0x38158000, 0x3815C000, 0x38160000, 0x38164000, 0x38168000, 0x3816C000, 0x38170000, 0x38174000, 0x38178000, 0x3817C000,
  0x38180000, 0x38184000, 0x38188000, 0x3818C000, 0x38190000, 0x38194000, 0x38198000, 0x3819C000, 0x381A0000, 0x381A4000, 0x381A8000, 0x381AC000, 0x381B0000, 0x381B4000, 0x381B8000, 0x381BC000,
  0x381C0000, 0x381C4000, 0x381C8000, 0x381CC000, 0x381D0000, 0x381D4000, 0x381D8000, 0x381DC000, 0x381E0000, 0x381E4000, 0x381E8000, 0x381EC000, 0x381F0000, 0x381F4000, 0x381F8000, 0x381FC000,
  0x38200000, 0x38204000, 0x38208000, 0x3820C000, 0x38210000, 0x38214000, 0x38218000, 0x3821C000, 0x38220000, 0x38224000, 0x38228000, 0x3822C000, 0x38230000, 0x38234000, 0x38238000, 0x3823C000,
  0x38240000, 0x38244000, 0x38248000, 0x3824C000, 0x38250000, 0x38254000, 0x38258000, 0x3825C000, 0x38260000, 0x38264000, 0x38268000, 0x3826C000, 0x38270000, 0x38274000, 0x38278000, 0x3827C000,
  0x38280000, 0x38284000, 0x38288000, 0x3828C000, 0x38290000, 0x38294000, 0x38298000, 0x3829C000, 0x382A0000, 0x382A4000, 0x382A8000, 0x382AC000, 0x382B0000, 0x382B4000, 0x382B8000, 0x382BC000,
  0x382C0000, 0x382C4000, 0x382C8000, 0x382CC000, 0x382D0000, 0x382D4000, 0x382D8000, 0x382DC000, 0x382E0000, 0x382E4000, 0x382E8000, 0x382EC000, 0x382F0000, 0x382F4000, 0x382F8000, 0x382FC000,
  0x38300000, 0x38304000, 0x38308000, 0x3830C000, 0x38310000, 0x38314000, 0x38318000, 0x3831C000, 0x38320000, 0x38324000, 0x38328000, 0x3832C000, 0x38330000, 0x38334000, 0x38338000, 0x3833C000,
  0x38340000, 0x38344000, 0x38348000, 0x3834C000, 0x38350000, 0x38354000, 0x38358000, 0x3835C000, 0x38360000, 0x38364000, 0x38368000, 0x3836C000, 0x38370000, 0x38374000, 0x38378000, 0x3837C000,
  0x38380000, 0x38384000, 0x38388000, 0x3838C000, 0x38390000, 0x38394000, 0x38398000, 0x3839C000, 0x383A0000, 0x383A4000, 0x383A8000, 0x383AC000, 0x383B0000, 0x383B4000, 0x383B8000, 0x383BC000,
  0x383C0000, 0x383C4000, 0x383C8000, 0x383CC000, 0x383D0000, 0x383D4000, 0x383D8000, 0x383DC000, 0x383E0000, 0x383E4000, 0x383E8000, 0x383EC000, 0x383F0000, 0x383F4000, 0x383F8000, 0x383FC000,
  0x38400000, 0x38404000, 0x38408000, 0x3840C000, 0x38410000, 0x38414000, 0x38418000, 0x3841C000, 0x38420000, 0x38424000, 0x38428000, 0x3842C000, 0x38430000, 0x38434000, 0x38438000, 0x3843C000,
  0x38440000, 0x38444000, 0x38448000, 0x3844C000, 0x38450000, 0x38454000, 0x38458000, 0x3845C000, 0x38460000, 0x38464000, 0x38468000, 0x3846C000, 0x38470000, 0x38474000, 0x38478000, 0x3847C000,
  0x38480000, 0x38484000, 0x38488000, 0x3848C000, 0x38490000, 0x38494000, 0x38498000, 0x3849C000, 0x384A0000, 0x384A4000, 0x384A8000, 0x384AC000, 0x384B0000, 0x384B4000, 0x384B8000, 0x384BC000,
  0x384C0000, 0x384C4000, 0x384C8000, 0x384CC000, 0x384D0000, 0x384D4000, 0x384D8000, 0x384DC000, 0x384E0000, 0x384E4000, 0x384E8000, 0x384EC000, 0x384F0000, 0x384F4000, 0x384F8000, 0x384FC000,
  0x38500000, 0x38504000, 0x38508000, 0x3850C000, 0x38510000, 0x38514000, 0x38518000, 0x3851C000, 0x38520000, 0x38524000, 0x38528000, 0x3852C000, 0x38530000, 0x38534000, 0x38538000, 0x3853C000,
  0x38540000, 0x38544000, 0x38548000, 0x3854C000, 0x38550000, 0x38554000, 0x38558000, 0x3855C000, 0x38560000, 0x38564000, 0x38568000, 0x3856C000, 0x38570000, 0x38574000, 0x38578000, 0x3857C000,
  0x38580000, 0x38584000, 0x38588000, 0x3858C000, 0x38590000, 0x38594000, 0x38598000, 0x3859C000, 0x385A0000, 0x385A4000, 0x385A8000, 0x385AC000, 0x385B0000, 0x385B4000, 0x385B8000, 0x385BC000,
  0x385C0000, 0x385C4000, 0x385C8000, 0x385CC000, 0x385D0000, 0x385D4000, 0x385D8000, 0x385DC000, 0x385E0000, 0x385E4000, 0x385E8000, 0x385EC000, 0x385F0000, 0x385F4000, 0x385F8000, 0x385FC000,
  0x38600000, 0x38604000, 0x38608000, 0x3860C000, 0x38610000, 0x38614000, 0x38618000, 0x3861C000, 0x38620000, 0x38624000, 0x38628000, 0x3862C000, 0x38630000, 0x38634000, 0x38638000, 0x3863C000,
  0x38640000, 0x38644000, 0x38648000, 0x3864C000, 0x38650000, 0x38654000, 0x38658000, 0x3865C000, 0x38660000, 0x38664000, 0x38668000, 0x3866C000, 0x38670000, 0x38674000, 0x38678000, 0x3867C000,
  0x38680000, 0x38684000, 0x38688000, 0x3868C000, 0x38690000, 0x38694000, 0x38698000, 0x3869C000, 0x386A0000, 0x386A4000, 0x386A8000, 0x386AC000, 0x386B0000, 0x386B4000, 0x386B8000, 0x386BC000,
  0x386C0000, 0x386C4000, 0x386C8000, 0x386CC000, 0x386D0000, 0x386D4000, 0x386D8000, 0x386DC000, 0x386E0000, 0x386E4000, 0x386E8000, 0x386EC000, 0x386F0000, 0x386F4000, 0x386F8000, 0x386FC000,
  0x38700000, 0x38704000, 0x38708000, 0x3870C000, 0x38710000, 0x38714000, 0x38718000, 0x3871C000, 0x38720000, 0x38724000, 0x38728000, 0x3872C000, 0x38730000, 0x38734000, 0x38738000, 0x3873C000,
  0x38740000, 0x38744000, 0x38748000, 0x3874C000, 0x38750000, 0x38754000, 0x38758000, 0x3875C000, 0x38760000, 0x38764000, 0x38768000, 0x3876C000, 0x38770000, 0x38774000, 0x38778000, 0x3877C000,
  0x38780000, 0x38784000, 0x38788000, 0x3878C000, 0x38790000, 0x38794000, 0x38798000, 0x3879C000, 0x387A0000, 0x387A4000, 0x387A8000, 0x387AC000, 0x387B0000, 0x387B4000, 0x387B8000, 0x387BC000,
  0x387C0000, 0x387C4000, 0x387C8000, 0x387CC000, 0x387D0000, 0x387D4000, 0x387D8000, 0x387DC000, 0x387E0000, 0x387E4000, 0x387E8000, 0x387EC000, 0x387F0000, 0x387F4000, 0x387F8000, 0x387FC000,
  0x38000000, 0x38002000, 0x38004000, 0x38006000, 0x38008000, 0x3800A000, 0x3800C000, 0x3800E000, 0x38010000, 0x38012000, 0x38014000, 0x38016000, 0x38018000, 0x3801A000, 0x3801C000, 0x3801E000,
  0x38020000, 0x38022000, 0x38024000, 0x38026000, 0x38028000, 0x3802A000, 0x3802C000, 0x3802E000, 0x38030000, 0x38032000, 0x38034000, 0x38036000, 0x38038000, 0x3803A000, 0x3803C000, 0x3803E000,
  0x38040000, 0x38042000, 0x38044000, 0x38046000, 0x38048000, 0x3804A000, 0x3804C000, 0x3804E000, 0x38050000, 0x38052000, 0x38054000, 0x38056000, 0x38058000, 0x3805A000, 0x3805C000, 0x3805E000,
  0x38060000, 0x38062000, 0x38064000, 0x38066000, 0x38068000, 0x3806A000, 0x3806C000, 0x3806E000, 0x38070000, 0x38072000, 0x38074000, 0x38076000, 0x38078000, 0x3807A000, 0x3807C000, 0x3807E000,
  0x38080000, 0x38082000, 0x38084000, 0x38086000, 0x38088000, 0x3808A000, 0x3808C000, 0x3808E000, 0x38090000, 0x38092000, 0x38094000, 0x38096000, 0x38098000, 0x3809A000, 0x3809C000, 0x3809E000,
  0x380A0000, 0x380A2000, 0x380A4000, 0x380A6000, 0x380A8000, 0x380AA000, 0x380AC000, 0x380AE000, 0x380B0000, 0x380B2000, 0x380B4000, 0x380B6000, 0x380B8000, 0x380BA000, 0x380BC000, 0x380BE000,
  0x380C0000, 0x380C2000, 0x380C4000, 0x380C6000, 0x380C8000, 0x380CA000, 0x380CC000, 0x380CE000, 0x380D0000, 0x380D2000, 0x380D4000, 0x380D6000, 0x380D8000, 0x380DA000, 0x380DC000, 0x380DE000,
  0x380E0000, 0x380E2000, 0x380E4000, 0x380E6000, 0x380E8000, 0x380EA000, 0x380EC000, 0x380EE000, 0x380F0000, 0x380F2000, 0x380F4000, 0x380F6000, 0x380F8000, 0x380FA000, 0x380FC000, 0x380FE000,
  0x38100000, 0x38102000, 0x38104000, 0x38106000, 0x38108000, 0x3810A000, 0x3810C000, 0x3810E000, 0x38110000, 0x38112000, 0x38114000, 0x38116000, 0x38118000, 0x3811A000, 0x3811C000, 0x3811E000,
  0x38120000, 0x38122000, 0x38124000, 0x38126000, 0x38128000, 0x3812A000, 0x3812C000, 0x3812E000, 0x38130000, 0x38132000, 0x38134000, 0x38136000, 0x38138000, 0x3813A000, 0x3813C000, 0x3813E000,
  0x38140000, 0x38142000, 0x38144000, 0x38146000, 0x38148000, 0x3814A000, 0x3814C000, 0x3814E000, 0x38150000, 0x38152000, 0x38154000, 0x38156000, 0x38158000, 0x3815A000, 0x3815C000, 0x3815E000,
  0x38160000, 0x38162000, 0x38164000, 0x38166000, 0x38168000, 0x3816A000, 0x3816C000, 0x3816E000, 0x38170000, 0x38172000, 0x38174000, 0x38176000, 0x38178000, 0x3817A000, 0x3817C000, 0x3817E000,
  0x38180000, 0x38182000, 0x38184000, 0x38186000, 0x38188000, 0x3818A000, 0x3818C000, 0x3818E000, 0x38190000, 0x38192000, 0x38194000, 0x38196000, 0x38198000, 0x3819A000, 0x3819C000, 0x3819E000,
  0x381A0000, 0x381A2000, 0x381A4000, 0x381A6000, 0x381A8000, 0x381AA000, 0x381AC000, 0x381AE000, 0x381B0000, 0x381B2000, 0x381B4000, 0x381B6000, 0x381B8000, 0x381BA000, 0x381BC000, 0x381BE000,
  0x381C0000, 0x381C2000, 0x381C4000, 0x381C6000, 0x381C8000, 0x381CA000, 0x381CC000, 0x381CE000, 0x381D0000, 0x381D2000, 0x381D4000, 0x381D6000, 0x381D8000, 0x381DA000, 0x381DC000, 0x381DE000,
  0x381E0000, 0x381E2000, 0x381E4000, 0x381E6000, 0x381E8000, 0x381EA000, 0x381EC000, 0x381EE000, 0x381F0000, 0x381F2000, 0x381F4000, 0x381F6000, 0x381F8000, 0x381FA000, 0x381FC000, 0x381FE000,
  0x38200000, 0x38202000, 0x38204000, 0x38206000, 0x38208000, 0x3820A000, 0x3820C000, 0x3820E000, 0x38210000, 0x38212000, 0x38214000, 0x38216000, 0x38218000, 0x3821A000, 0x3821C000, 0x3821E000,
  0x38220000, 0x38222000, 0x38224000, 0x38226000, 0x38228000, 0x3822A000, 0x3822C000, 0x3822E000, 0x38230000, 0x38232000, 0x38234000, 0x38236000, 0x38238000, 0x3823A000, 0x3823C000, 0x3823E000,
  0x38240000, 0x38242000, 0x38244000, 0x38246000, 0x38248000, 0x3824A000, 0x3824C000, 0x3824E000, 0x38250000, 0x38252000, 0x38254000, 0x38256000, 0x38258000, 0x3825A000, 0x3825C000, 0x3825E000,
  0x38260000, 0x38262000, 0x38264000, 0x38266000, 0x38268000, 0x3826A000, 0x3826C000, 0x3826E000, 0x38270000, 0x38272000, 0x38274000, 0x38276000, 0x38278000, 0x3827A000, 0x3827C000, 0x3827E000,
  0x38280000, 0x38282000, 0x38284000, 0x38286000, 0x38288000, 0x3828A000, 0x3828C000, 0x3828E000, 0x38290000, 0x38292000, 0x38294000, 0x38296000, 0x38298000, 0x3829A000, 0x3829C000, 0x3829E000,
  0x382A0000, 0x382A2000, 0x382A4000, 0x382A6000, 0x382A8000, 0x382AA000, 0x382AC000, 0x382AE000, 0x382B0000, 0x382B2000, 0x382B4000, 0x382B6000, 0x382B8000, 0x382BA000, 0x382BC000, 0x382BE000,
  0x382C0000, 0x382C2000, 0x382C4000, 0x382C6000, 0x382C8000, 0x382CA000, 0x382CC000, 0x382CE000, 0x382D0000, 0x382D2000, 0x382D4000, 0x382D6000, 0x382D8000, 0x382DA000, 0x382DC000, 0x382DE000,
  0x382E0000, 0x382E2000, 0x382E4000, 0x382E6000, 0x382E8000, 0x382EA000, 0x382EC000, 0x382EE000, 0x382F0000, 0x382F2000, 0x382F4000, 0x382F6000, 0x382F8000, 0x382FA000, 0x382FC000, 0x382FE000,
  0x38300000, 0x38302000, 0x38304000, 0x38306000, 0x38308000, 0x3830A000, 0x3830C000, 0x3830E000, 0x38310000, 0x38312000, 0x38314000, 0x38316000, 0x38318000, 0x3831A000, 0x3831C000, 0x3831E000,
  0x38320000, 0x38322000, 0x38324000, 0x38326000, 0x38328000, 0x3832A000, 0x3832C000, 0x3832E000, 0x38330000, 0x38332000, 0x38334000, 0x38336000, 0x38338000, 0x3833A000, 0x3833C000, 0x3833E000,
  0x38340000, 0x38342000, 0x38344000, 0x38346000, 0x38348000, 0x3834A000, 0x3834C000, 0x3834E000, 0x38350000, 0x38352000, 0x38354000, 0x38356000, 0x38358000, 0x3835A000, 0x3835C000, 0x3835E000,
  0x38360000, 0x38362000, 0x38364000, 0x38366000, 0x38368000, 0x3836A000, 0x3836C000, 0x3836E000, 0x38370000, 0x38372000, 0x38374000, 0x38376000, 0x38378000, 0x3837A000, 0x3837C000, 0x3837E000,
  0x38380000, 0x38382000, 0x38384000, 0x38386000, 0x38388000, 0x3838A000, 0x3838C000, 0x3838E000, 0x38390000, 0x38392000, 0x38394000, 0x38396000, 0x38398000, 0x3839A000, 0x3839C000, 0x3839E000,
  0x383A0000, 0x383A2000, 0x383A4000, 0x383A6000, 0x383A8000, 0x383AA000, 0x383AC000, 0x383AE000, 0x383B0000, 0x383B2000, 0x383B4000, 0x383B6000, 0x383B8000, 0x383BA000, 0x383BC000, 0x383BE000,
  0x383C0000, 0x383C2000, 0x383C4000, 0x383C6000, 0x383C8000, 0x383CA000, 0x383CC000, 0x383CE000, 0x383D0000, 0x383D2000, 0x383D4000, 0x383D6000, 0x383D8000, 0x383DA000, 0x383DC000, 0x383DE000,
  0x383E0000, 0x383E2000, 0x383E4000, 0x383E6000, 0x383E8000, 0x383EA000, 0x383EC000, 0x383EE000, 0x383F0000, 0x383F2000, 0x383F4000, 0x383F6000, 0x383F8000, 0x383FA000, 0x383FC000, 0x383FE000,
  0x38400000, 0x38402000, 0x38404000, 0x38406000, 0x38408000, 0x3840A000, 0x3840C000, 0x3840E000, 0x38410000, 0x38412000, 0x38414000, 0x38416000, 0x38418000, 0x3841A000, 0x3841C000, 0x3841E000,
  0x38420000, 0x38422000, 0x38424000, 0x38426000, 0x38428000, 0x3842A000, 0x3842C000, 0x3842E000, 0x38430000, 0x38432000, 0x38434000, 0x38436000, 0x38438000, 0x3843A000, 0x3843C000, 0x3843E000,
  0x38440000, 0x38442000, 0x38444000, 0x38446000, 0x38448000, 0x3844A000, 0x3844C000, 0x3844E000, 0x38450000, 0x38452000, 0x38454000, 0x38456000, 0x38458000, 0x3845A000, 0x3845C000, 0x3845E000,
  0x38460000, 0x38462000, 0x38464000, 0x38466000, 0x38468000, 0x3846A000, 0x3846C000, 0x3846E000, 0x38470000, 0x38472000, 0x38474000, 0x38476000, 0x38478000, 0x3847A000, 0x3847C000, 0x3847E000,
  0x38480000, 0x38482000, 0x38484000, 0x38486000, 0x38488000, 0x3848A000, 0x3848C000, 0x3848E000, 0x38490000, 0x38492000, 0x38494000, 0x38496000, 0x38498000, 0x3849A000, 0x3849C000, 0x3849E000,
  0x384A0000, 0x384A2000, 0x384A4000, 0x384A6000, 0x384A8000, 0x384AA000, 0x384AC000, 0x384AE000, 0x384B0000, 0x384B2000, 0x384B4000, 0x384B6000, 0x384B8000, 0x384BA000, 0x384BC000, 0x384BE000,
  0x384C0000, 0x384C2000, 0x384C4000, 0x384C6000, 0x384C8000, 0x384CA000, 0x384CC000, 0x384CE000, 0x384D0000, 0x384D2000, 0x384D4000, 0x384D6000, 0x384D8000, 0x384DA000, 0x384DC000, 0x384DE000,
  0x384E0000, 0x384E2000, 0x384E4000, 0x384E6000, 0x384E8000, 0x384EA000, 0x384EC000, 0x384EE000, 0x384F0000, 0x384F2000, 0x384F4000, 0x384F6000, 0x384F8000, 0x384FA000, 0x384FC000, 0x384FE000,
  0x38500000, 0x38502000, 0x38504000, 0x38506000, 0x38508000, 0x3850A000, 0x3850C000, 0x3850E000, 0x38510000, 0x38512000, 0x38514000, 0x38516000, 0x38518000, 0x3851A000, 0x3851C000, 0x3851E000,
  0x38520000, 0x38522000, 0x38524000, 0x38526000, 0x38528000, 0x3852A000, 0x3852C000, 0x3852E000, 0x38530000, 0x38532000, 0x38534000, 0x38536000, 0x38538000, 0x3853A000, 0x3853C000, 0x3853E000,
  0x38540000, 0x38542000, 0x38544000, 0x38546000, 0x38548000, 0x3854A000, 0x3854C000, 0x3854E000, 0x38550000, 0x38552000, 0x38554000, 0x38556000, 0x38558000, 0x3855A000, 0x3855C000, 0x3855E000,
  0x38560000, 0x38562000, 0x38564000, 0x38566000, 0x38568000, 0x3856A000, 0x3856C000, 0x3856E000, 0x38570000, 0x38572000, 0x38574000, 0x38576000, 0x38578000, 0x3857A000, 0x3857C000, 0x3857E000,
  0x38580000, 0x38582000, 0x38584000, 0x38586000, 0x38588000, 0x3858A000, 0x3858C000, 0x3858E000, 0x38590000, 0x38592000, 0x38594000, 0x38596000, 0x38598000, 0x3859A000, 0x3859C000, 0x3859E000,
  0x385A0000, 0x385A2000, 0x385A4000, 0x385A6000, 0x385A8000, 0x385AA000, 0x385AC000, 0x385AE000, 0x385B0000, 0x385B2000, 0x385B4000, 0x385B6000, 0x385B8000, 0x385BA000, 0x385BC000, 0x385BE000,
  0x385C0000, 0x385C2000, 0x385C4000, 0x385C6000, 0x385C8000, 0x385CA000, 0x385CC000, 0x385CE000, 0x385D0000, 0x385D2000, 0x385D4000, 0x385D6000, 0x385D8000, 0x385DA000, 0x385DC000, 0x385DE000,
  0x385E0000, 0x385E2000, 0x385E4000, 0x385E6000, 0x385E8000, 0x385EA000, 0x385EC000, 0x385EE000, 0x385F0000, 0x385F2000, 0x385F4000, 0x385F6000, 0x385F8000, 0x385FA000, 0x385FC000, 0x385FE000,
  0x38600000, 0x38602000, 0x38604000, 0x38606000, 0x38608000, 0x3860A000, 0x3860C000, 0x3860E000, 0x38610000, 0x38612000, 0x38614000, 0x38616000, 0x38618000, 0x3861A000, 0x3861C000, 0x3861E000,
  0x38620000, 0x38622000, 0x38624000, 0x38626000, 0x38628000, 0x3862A000, 0x3862C000, 0x3862E000, 0x38630000, 0x38632000, 0x38634000, 0x38636000, 0x38638000, 0x3863A000, 0x3863C000, 0x3863E000,
  0x38640000, 0x38642000, 0x38644000, 0x38646000, 0x38648000, 0x3864A000, 0x3864C000, 0x3864E000, 0x38650000, 0x38652000, 0x38654000, 0x38656000, 0x38658000, 0x3865A000, 0x3865C000, 0x3865E000,
  0x38660000, 0x38662000, 0x38664000, 0x38666000, 0x38668000, 0x3866A000, 0x3866C000, 0x3866E000, 0x38670000, 0x38672000, 0x38674000, 0x38676000, 0x38678000, 0x3867A000, 0x3867C000, 0x3867E000,
  0x38680000, 0x38682000, 0x38684000, 0x38686000, 0x38688000, 0x3868A000, 0x3868C000, 0x3868E000, 0x38690000, 0x38692000, 0x38694000, 0x38696000, 0x38698000, 0x3869A000, 0x3869C000, 0x3869E000,
  0x386A0000, 0x386A2000, 0x386A4000, 0x386A6000, 0x386A8000, 0x386AA000, 0x386AC000, 0x386AE000, 0x386B0000, 0x386B2000, 0x386B4000, 0x386B6000, 0x386B8000, 0x386BA000, 0x386BC000, 0x386BE000,
  0x386C0000, 0x386C2000, 0x386C4000, 0x386C6000, 0x386C8000, 0x386CA000, 0x386CC000, 0x386CE000, 0x386D0000, 0x386D2000, 0x386D4000, 0x386D6000, 0x386D8000, 0x386DA000, 0x386DC000, 0x386DE000,
  0x386E0000, 0x386E2000, 0x386E4000, 0x386E6000, 0x386E8000, 0x386EA000, 0x386EC000, 0x386EE000, 0x386F0000, 0x386F2000, 0x386F4000, 0x386F6000, 0x386F8000, 0x386FA000, 0x386FC000, 0x386FE000,
  0x38700000, 0x38702000, 0x38704000, 0x38706000, 0x38708000, 0x3870A000, 0x3870C000, 0x3870E000, 0x38710000, 0x38712000, 0x38714000, 0x38716000, 0x38718000, 0x3871A000, 0x3871C000, 0x3871E000,
  0x38720000, 0x38722000, 0x38724000, 0x38726000, 0x38728000, 0x3872A000, 0x3872C000, 0x3872E000, 0x38730000, 0x38732000, 0x38734000, 0x38736000, 0x38738000, 0x3873A000, 0x3873C000, 0x3873E000,
  0x38740000, 0x38742000, 0x38744000, 0x38746000, 0x38748000, 0x3874A000, 0x3874C000, 0x3874E000, 0x38750000, 0x38752000, 0x38754000, 0x38756000, 0x38758000, 0x3875A000, 0x3875C000, 0x3875E000,
  0x38760000, 0x38762000, 0x38764000, 0x38766000, 0x38768000, 0x3876A000, 0x3876C000, 0x3876E000, 0x38770000, 0x38772000, 0x38774000, 0x38776000, 0x38778000, 0x3877A000, 0x3877C000, 0x3877E000,
  0x38780000, 0x38782000, 0x38784000, 0x38786000, 0x38788000, 0x3878A000, 0x3878C000, 0x3878E000, 0x38790000, 0x38792000, 0x38794000, 0x38796000, 0x38798000, 0x3879A000, 0x3879C000, 0x3879E000,
  0x387A0000, 0x387A2000, 0x387A4000, 0x387A6000, 0x387A8000, 0x387AA000, 0x387AC000, 0x387AE000, 0x387B0000, 0x387B2000, 0x387B4000, 0x387B6000, 0x387B8000, 0x387BA000, 0x387BC000, 0x387BE000,
  0x387C0000, 0x387C2000, 0x387C4000, 0x387C6000, 0x387C8000, 0x387CA000, 0x387CC000, 0x387CE000, 0x387D0000, 0x387D2000, 0x387D4000, 0x387D6000, 0x387D8000, 0x387DA000, 0x387DC000, 0x387DE000,
  0x387E0000, 0x387E2000, 0x387E4000, 0x387E6000, 0x387E8000, 0x387EA000, 0x387EC000, 0x387EE000, 0x387F0000, 0x387F2000, 0x387F4000, 0x387F6000, 0x387F8000, 0x387FA000, 0x387FC000, 0x387FE000 };
__constant static const uint32_t exponent_table[64] = {
  0x00000000, 0x00800000, 0x01000000, 0x01800000, 0x02000000, 0x02800000, 0x03000000, 0x03800000, 0x04000000, 0x04800000, 0x05000000, 0x05800000, 0x06000000, 0x06800000, 0x07000000, 0x07800000,
  0x08000000, 0x08800000, 0x09000000, 0x09800000, 0x0A000000, 0x0A800000, 0x0B000000, 0x0B800000, 0x0C000000, 0x0C800000, 0x0D000000, 0x0D800000, 0x0E000000, 0x0E800000, 0x0F000000, 0x47800000,
  0x80000000, 0x80800000, 0x81000000, 0x81800000, 0x82000000, 0x82800000, 0x83000000, 0x83800000, 0x84000000, 0x84800000, 0x85000000, 0x85800000, 0x86000000, 0x86800000, 0x87000000, 0x87800000,
  0x88000000, 0x88800000, 0x89000000, 0x89800000, 0x8A000000, 0x8A800000, 0x8B000000, 0x8B800000, 0x8C000000, 0x8C800000, 0x8D000000, 0x8D800000, 0x8E000000, 0x8E800000, 0x8F000000, 0xC7800000 };
__constant static const unsigned short offset_table[64] = {
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024 };

static uint16_t float2halfbits(float value) {
  union { float x; uint32_t y; } u;
  u.x = value;
  uint32_t bits = u.y;

  uint16_t hbits = base_table[bits>>23] + (uint16_t)((bits&0x7FFFFF)>>shift_table[bits>>23]);;

  return hbits;
}

static float halfbits2float(uint16_t value) {
  uint32_t bits = mantissa_table[offset_table[value>>10]+(value&0x3FF)] + exponent_table[value>>10];

  union { uint32_t x; float y; } u;
  u.x = bits;
  return u.y;
}

// End of half.h.
// Start of timing.h.

// The function get_wall_time() returns the wall time in microseconds
// (with an unspecified offset).

#ifdef _WIN32

#include <windows.h>

static int64_t get_wall_time(void) {
  LARGE_INTEGER time,freq;
  assert(QueryPerformanceFrequency(&freq));
  assert(QueryPerformanceCounter(&time));
  return ((double)time.QuadPart / freq.QuadPart) * 1000000;
}

#else
// Assuming POSIX

#include <time.h>
#include <sys/time.h>

static int64_t get_wall_time(void) {
  struct timeval time;
  assert(gettimeofday(&time,NULL) == 0);
  return time.tv_sec * 1000000 + time.tv_usec;
}

static int64_t get_wall_time_ns(void) {
  struct timespec time;
  assert(clock_gettime(CLOCK_REALTIME, &time) == 0);
  return time.tv_sec * 1000000000 + time.tv_nsec;
}

#endif

// End of timing.h.

#ifdef _MSC_VER
#define inline __inline
#endif
#include <string.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include <ctype.h>



// Start of lock.h.

// A very simple cross-platform implementation of locks.  Uses
// pthreads on Unix and some Windows thing there.  Futhark's
// host-level code is not multithreaded, but user code may be, so we
// need some mechanism for ensuring atomic access to API functions.
// This is that mechanism.  It is not exposed to user code at all, so
// we do not have to worry about name collisions.

#ifdef _WIN32

typedef HANDLE lock_t;

static void create_lock(lock_t *lock) {
  *lock = CreateMutex(NULL,  // Default security attributes.
                      FALSE, // Initially unlocked.
                      NULL); // Unnamed.
}

static void lock_lock(lock_t *lock) {
  assert(WaitForSingleObject(*lock, INFINITE) == WAIT_OBJECT_0);
}

static void lock_unlock(lock_t *lock) {
  assert(ReleaseMutex(*lock));
}

static void free_lock(lock_t *lock) {
  CloseHandle(*lock);
}

#else
// Assuming POSIX

#include <pthread.h>

typedef pthread_mutex_t lock_t;

static void create_lock(lock_t *lock) {
  int r = pthread_mutex_init(lock, NULL);
  assert(r == 0);
}

static void lock_lock(lock_t *lock) {
  int r = pthread_mutex_lock(lock);
  assert(r == 0);
}

static void lock_unlock(lock_t *lock) {
  int r = pthread_mutex_unlock(lock);
  assert(r == 0);
}

static void free_lock(lock_t *lock) {
  // Nothing to do for pthreads.
  (void)lock;
}

#endif

// End of lock.h.

#define FUTHARK_F64_ENABLED

// Start of scalar.h.

// Implementation of the primitive scalar operations.  Very
// repetitive.  This code is inserted directly into both CUDA and
// OpenCL programs, as well as the CPU code, so it has some #ifdefs to
// work everywhere.  Some operations are defined as macros because
// this allows us to use them as constant expressions in things like
// array sizes and static initialisers.

// Some of the #ifdefs are because OpenCL uses type-generic functions
// for some operations (e.g. sqrt), while C and CUDA sensibly use
// distinct functions for different precisions (e.g. sqrtf() and
// sqrt()).  This is quite annoying.  Due to C's unfortunate casting
// rules, it is also really easy to accidentally implement
// floating-point functions in the wrong precision, so be careful.

// Double-precision definitions are only included if the preprocessor
// macro FUTHARK_F64_ENABLED is set.

static inline uint8_t add8(uint8_t x, uint8_t y) {
  return x + y;
}

static inline uint16_t add16(uint16_t x, uint16_t y) {
  return x + y;
}

static inline uint32_t add32(uint32_t x, uint32_t y) {
  return x + y;
}

static inline uint64_t add64(uint64_t x, uint64_t y) {
  return x + y;
}

static inline uint8_t sub8(uint8_t x, uint8_t y) {
  return x - y;
}

static inline uint16_t sub16(uint16_t x, uint16_t y) {
  return x - y;
}

static inline uint32_t sub32(uint32_t x, uint32_t y) {
  return x - y;
}

static inline uint64_t sub64(uint64_t x, uint64_t y) {
  return x - y;
}

static inline uint8_t mul8(uint8_t x, uint8_t y) {
  return x * y;
}

static inline uint16_t mul16(uint16_t x, uint16_t y) {
  return x * y;
}

static inline uint32_t mul32(uint32_t x, uint32_t y) {
  return x * y;
}

static inline uint64_t mul64(uint64_t x, uint64_t y) {
  return x * y;
}

static inline uint8_t udiv8(uint8_t x, uint8_t y) {
  return x / y;
}

static inline uint16_t udiv16(uint16_t x, uint16_t y) {
  return x / y;
}

static inline uint32_t udiv32(uint32_t x, uint32_t y) {
  return x / y;
}

static inline uint64_t udiv64(uint64_t x, uint64_t y) {
  return x / y;
}

static inline uint8_t udiv_up8(uint8_t x, uint8_t y) {
  return (x + y - 1) / y;
}

static inline uint16_t udiv_up16(uint16_t x, uint16_t y) {
  return (x + y - 1) / y;
}

static inline uint32_t udiv_up32(uint32_t x, uint32_t y) {
  return (x + y - 1) / y;
}

static inline uint64_t udiv_up64(uint64_t x, uint64_t y) {
  return (x + y - 1) / y;
}

static inline uint8_t umod8(uint8_t x, uint8_t y) {
  return x % y;
}

static inline uint16_t umod16(uint16_t x, uint16_t y) {
  return x % y;
}

static inline uint32_t umod32(uint32_t x, uint32_t y) {
  return x % y;
}

static inline uint64_t umod64(uint64_t x, uint64_t y) {
  return x % y;
}

static inline uint8_t udiv_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint16_t udiv_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint32_t udiv_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint64_t udiv_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint8_t udiv_up_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint16_t udiv_up_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint32_t udiv_up_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint64_t udiv_up_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint8_t umod_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint16_t umod_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint32_t umod_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint64_t umod_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t sdiv8(int8_t x, int8_t y) {
  int8_t q = x / y;
  int8_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int16_t sdiv16(int16_t x, int16_t y) {
  int16_t q = x / y;
  int16_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int32_t sdiv32(int32_t x, int32_t y) {
  int32_t q = x / y;
  int32_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int64_t sdiv64(int64_t x, int64_t y) {
  int64_t q = x / y;
  int64_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int8_t sdiv_up8(int8_t x, int8_t y) {
  return sdiv8(x + y - 1, y);
}

static inline int16_t sdiv_up16(int16_t x, int16_t y) {
  return sdiv16(x + y - 1, y);
}

static inline int32_t sdiv_up32(int32_t x, int32_t y) {
  return sdiv32(x + y - 1, y);
}

static inline int64_t sdiv_up64(int64_t x, int64_t y) {
  return sdiv64(x + y - 1, y);
}

static inline int8_t smod8(int8_t x, int8_t y) {
  int8_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int16_t smod16(int16_t x, int16_t y) {
  int16_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int32_t smod32(int32_t x, int32_t y) {
  int32_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int64_t smod64(int64_t x, int64_t y) {
  int64_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int8_t sdiv_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : sdiv8(x, y);
}

static inline int16_t sdiv_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : sdiv16(x, y);
}

static inline int32_t sdiv_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : sdiv32(x, y);
}

static inline int64_t sdiv_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : sdiv64(x, y);
}

static inline int8_t sdiv_up_safe8(int8_t x, int8_t y) {
  return sdiv_safe8(x + y - 1, y);
}

static inline int16_t sdiv_up_safe16(int16_t x, int16_t y) {
  return sdiv_safe16(x + y - 1, y);
}

static inline int32_t sdiv_up_safe32(int32_t x, int32_t y) {
  return sdiv_safe32(x + y - 1, y);
}

static inline int64_t sdiv_up_safe64(int64_t x, int64_t y) {
  return sdiv_safe64(x + y - 1, y);
}

static inline int8_t smod_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : smod8(x, y);
}

static inline int16_t smod_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : smod16(x, y);
}

static inline int32_t smod_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : smod32(x, y);
}

static inline int64_t smod_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : smod64(x, y);
}

static inline int8_t squot8(int8_t x, int8_t y) {
  return x / y;
}

static inline int16_t squot16(int16_t x, int16_t y) {
  return x / y;
}

static inline int32_t squot32(int32_t x, int32_t y) {
  return x / y;
}

static inline int64_t squot64(int64_t x, int64_t y) {
  return x / y;
}

static inline int8_t srem8(int8_t x, int8_t y) {
  return x % y;
}

static inline int16_t srem16(int16_t x, int16_t y) {
  return x % y;
}

static inline int32_t srem32(int32_t x, int32_t y) {
  return x % y;
}

static inline int64_t srem64(int64_t x, int64_t y) {
  return x % y;
}

static inline int8_t squot_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int16_t squot_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int32_t squot_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int64_t squot_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int8_t srem_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int16_t srem_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int32_t srem_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int64_t srem_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t smin8(int8_t x, int8_t y) {
  return x < y ? x : y;
}

static inline int16_t smin16(int16_t x, int16_t y) {
  return x < y ? x : y;
}

static inline int32_t smin32(int32_t x, int32_t y) {
  return x < y ? x : y;
}

static inline int64_t smin64(int64_t x, int64_t y) {
  return x < y ? x : y;
}

static inline uint8_t umin8(uint8_t x, uint8_t y) {
  return x < y ? x : y;
}

static inline uint16_t umin16(uint16_t x, uint16_t y) {
  return x < y ? x : y;
}

static inline uint32_t umin32(uint32_t x, uint32_t y) {
  return x < y ? x : y;
}

static inline uint64_t umin64(uint64_t x, uint64_t y) {
  return x < y ? x : y;
}

static inline int8_t smax8(int8_t x, int8_t y) {
  return x < y ? y : x;
}

static inline int16_t smax16(int16_t x, int16_t y) {
  return x < y ? y : x;
}

static inline int32_t smax32(int32_t x, int32_t y) {
  return x < y ? y : x;
}

static inline int64_t smax64(int64_t x, int64_t y) {
  return x < y ? y : x;
}

static inline uint8_t umax8(uint8_t x, uint8_t y) {
  return x < y ? y : x;
}

static inline uint16_t umax16(uint16_t x, uint16_t y) {
  return x < y ? y : x;
}

static inline uint32_t umax32(uint32_t x, uint32_t y) {
  return x < y ? y : x;
}

static inline uint64_t umax64(uint64_t x, uint64_t y) {
  return x < y ? y : x;
}

static inline uint8_t shl8(uint8_t x, uint8_t y) {
  return (uint8_t)(x << y);
}

static inline uint16_t shl16(uint16_t x, uint16_t y) {
  return (uint16_t)(x << y);
}

static inline uint32_t shl32(uint32_t x, uint32_t y) {
  return x << y;
}

static inline uint64_t shl64(uint64_t x, uint64_t y) {
  return x << y;
}

static inline uint8_t lshr8(uint8_t x, uint8_t y) {
  return x >> y;
}

static inline uint16_t lshr16(uint16_t x, uint16_t y) {
  return x >> y;
}

static inline uint32_t lshr32(uint32_t x, uint32_t y) {
  return x >> y;
}

static inline uint64_t lshr64(uint64_t x, uint64_t y) {
  return x >> y;
}

static inline int8_t ashr8(int8_t x, int8_t y) {
  return x >> y;
}

static inline int16_t ashr16(int16_t x, int16_t y) {
  return x >> y;
}

static inline int32_t ashr32(int32_t x, int32_t y) {
  return x >> y;
}

static inline int64_t ashr64(int64_t x, int64_t y) {
  return x >> y;
}

static inline uint8_t and8(uint8_t x, uint8_t y) {
  return x & y;
}

static inline uint16_t and16(uint16_t x, uint16_t y) {
  return x & y;
}

static inline uint32_t and32(uint32_t x, uint32_t y) {
  return x & y;
}

static inline uint64_t and64(uint64_t x, uint64_t y) {
  return x & y;
}

static inline uint8_t or8(uint8_t x, uint8_t y) {
  return x | y;
}

static inline uint16_t or16(uint16_t x, uint16_t y) {
  return x | y;
}

static inline uint32_t or32(uint32_t x, uint32_t y) {
  return x | y;
}

static inline uint64_t or64(uint64_t x, uint64_t y) {
  return x | y;
}

static inline uint8_t xor8(uint8_t x, uint8_t y) {
  return x ^ y;
}

static inline uint16_t xor16(uint16_t x, uint16_t y) {
  return x ^ y;
}

static inline uint32_t xor32(uint32_t x, uint32_t y) {
  return x ^ y;
}

static inline uint64_t xor64(uint64_t x, uint64_t y) {
  return x ^ y;
}

static inline bool ult8(uint8_t x, uint8_t y) {
  return x < y;
}

static inline bool ult16(uint16_t x, uint16_t y) {
  return x < y;
}

static inline bool ult32(uint32_t x, uint32_t y) {
  return x < y;
}

static inline bool ult64(uint64_t x, uint64_t y) {
  return x < y;
}

static inline bool ule8(uint8_t x, uint8_t y) {
  return x <= y;
}

static inline bool ule16(uint16_t x, uint16_t y) {
  return x <= y;
}

static inline bool ule32(uint32_t x, uint32_t y) {
  return x <= y;
}

static inline bool ule64(uint64_t x, uint64_t y) {
  return x <= y;
}

static inline bool slt8(int8_t x, int8_t y) {
  return x < y;
}

static inline bool slt16(int16_t x, int16_t y) {
  return x < y;
}

static inline bool slt32(int32_t x, int32_t y) {
  return x < y;
}

static inline bool slt64(int64_t x, int64_t y) {
  return x < y;
}

static inline bool sle8(int8_t x, int8_t y) {
  return x <= y;
}

static inline bool sle16(int16_t x, int16_t y) {
  return x <= y;
}

static inline bool sle32(int32_t x, int32_t y) {
  return x <= y;
}

static inline bool sle64(int64_t x, int64_t y) {
  return x <= y;
}

static inline uint8_t pow8(uint8_t x, uint8_t y) {
  uint8_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint16_t pow16(uint16_t x, uint16_t y) {
  uint16_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint32_t pow32(uint32_t x, uint32_t y) {
  uint32_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint64_t pow64(uint64_t x, uint64_t y) {
  uint64_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline bool itob_i8_bool(int8_t x) {
  return x;
}

static inline bool itob_i16_bool(int16_t x) {
  return x;
}

static inline bool itob_i32_bool(int32_t x) {
  return x;
}

static inline bool itob_i64_bool(int64_t x) {
  return x;
}

static inline int8_t btoi_bool_i8(bool x) {
  return x;
}

static inline int16_t btoi_bool_i16(bool x) {
  return x;
}

static inline int32_t btoi_bool_i32(bool x) {
  return x;
}

static inline int64_t btoi_bool_i64(bool x) {
  return x;
}

#define sext_i8_i8(x) ((int8_t) (int8_t) (x))
#define sext_i8_i16(x) ((int16_t) (int8_t) (x))
#define sext_i8_i32(x) ((int32_t) (int8_t) (x))
#define sext_i8_i64(x) ((int64_t) (int8_t) (x))
#define sext_i16_i8(x) ((int8_t) (int16_t) (x))
#define sext_i16_i16(x) ((int16_t) (int16_t) (x))
#define sext_i16_i32(x) ((int32_t) (int16_t) (x))
#define sext_i16_i64(x) ((int64_t) (int16_t) (x))
#define sext_i32_i8(x) ((int8_t) (int32_t) (x))
#define sext_i32_i16(x) ((int16_t) (int32_t) (x))
#define sext_i32_i32(x) ((int32_t) (int32_t) (x))
#define sext_i32_i64(x) ((int64_t) (int32_t) (x))
#define sext_i64_i8(x) ((int8_t) (int64_t) (x))
#define sext_i64_i16(x) ((int16_t) (int64_t) (x))
#define sext_i64_i32(x) ((int32_t) (int64_t) (x))
#define sext_i64_i64(x) ((int64_t) (int64_t) (x))
#define zext_i8_i8(x) ((int8_t) (uint8_t) (x))
#define zext_i8_i16(x) ((int16_t) (uint8_t) (x))
#define zext_i8_i32(x) ((int32_t) (uint8_t) (x))
#define zext_i8_i64(x) ((int64_t) (uint8_t) (x))
#define zext_i16_i8(x) ((int8_t) (uint16_t) (x))
#define zext_i16_i16(x) ((int16_t) (uint16_t) (x))
#define zext_i16_i32(x) ((int32_t) (uint16_t) (x))
#define zext_i16_i64(x) ((int64_t) (uint16_t) (x))
#define zext_i32_i8(x) ((int8_t) (uint32_t) (x))
#define zext_i32_i16(x) ((int16_t) (uint32_t) (x))
#define zext_i32_i32(x) ((int32_t) (uint32_t) (x))
#define zext_i32_i64(x) ((int64_t) (uint32_t) (x))
#define zext_i64_i8(x) ((int8_t) (uint64_t) (x))
#define zext_i64_i16(x) ((int16_t) (uint64_t) (x))
#define zext_i64_i32(x) ((int32_t) (uint64_t) (x))
#define zext_i64_i64(x) ((int64_t) (uint64_t) (x))

static int8_t abs8(int8_t x) {
  return (int8_t)abs(x);
}

static int16_t abs16(int16_t x) {
  return (int16_t)abs(x);
}

static int32_t abs32(int32_t x) {
  return abs(x);
}

static int64_t abs64(int64_t x) {
#if defined(__OPENCL_VERSION__)
  return abs(x);
#else
  return llabs(x);
#endif
}

#if defined(__OPENCL_VERSION__)
static int32_t futrts_popc8(int8_t x) {
  return popcount(x);
}

static int32_t futrts_popc16(int16_t x) {
  return popcount(x);
}

static int32_t futrts_popc32(int32_t x) {
  return popcount(x);
}

static int32_t futrts_popc64(int64_t x) {
  return popcount(x);
}
#elif defined(__CUDA_ARCH__)

static int32_t futrts_popc8(int8_t x) {
  return __popc(zext_i8_i32(x));
}

static int32_t futrts_popc16(int16_t x) {
  return __popc(zext_i16_i32(x));
}

static int32_t futrts_popc32(int32_t x) {
  return __popc(x);
}

static int32_t futrts_popc64(int64_t x) {
  return __popcll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_popc8(uint8_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc16(uint16_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc32(uint32_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc64(uint64_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  return mul_hi(a, b);
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  return mul_hi(a, b);
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mul_hi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul_hi(a, b);
}

#elif defined(__CUDA_ARCH__)

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mulhi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul64hi(a, b);
}

#else // Not OpenCL or CUDA, but plain C.

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  uint64_t aa = a;
  uint64_t bb = b;

  return aa * bb >> 32;
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  __uint128_t aa = a;
  __uint128_t bb = b;

  return aa * bb >> 64;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return mad_hi(a, b, c);
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return mad_hi(a, b, c);
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return mad_hi(a, b, c);
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return mad_hi(a, b, c);
}

#else // Not OpenCL

static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return futrts_mul_hi8(a, b) + c;
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return futrts_mul_hi16(a, b) + c;
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return futrts_mul_hi32(a, b) + c;
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return futrts_mul_hi64(a, b) + c;
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_clzz8(int8_t x) {
  return clz(x);
}

static int32_t futrts_clzz16(int16_t x) {
  return clz(x);
}

static int32_t futrts_clzz32(int32_t x) {
  return clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return clz(x);
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_clzz8(int8_t x) {
  return __clz(zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return __clz(zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return __clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return __clzll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_clzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_clz((uint32_t)zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_clz((uint32_t)zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_clz((uint32_t)x);
}

static int32_t futrts_clzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_clzll((uint64_t)x);
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_ctzz8(int8_t x) {
  int i = 0;
  for (; i < 8 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz16(int16_t x) {
  int i = 0;
  for (; i < 16 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz32(int32_t x) {
  int i = 0;
  for (; i < 32 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz64(int64_t x) {
  int i = 0;
  for (; i < 64 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_ctzz8(int8_t x) {
  int y = __ffs(x);
  return y == 0 ? 8 : y - 1;
}

static int32_t futrts_ctzz16(int16_t x) {
  int y = __ffs(x);
  return y == 0 ? 16 : y - 1;
}

static int32_t futrts_ctzz32(int32_t x) {
  int y = __ffs(x);
  return y == 0 ? 32 : y - 1;
}

static int32_t futrts_ctzz64(int64_t x) {
  int y = __ffsll(x);
  return y == 0 ? 64 : y - 1;
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_ctzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_ctzll((uint64_t)x);
}
#endif

static inline float fdiv32(float x, float y) {
  return x / y;
}

static inline float fadd32(float x, float y) {
  return x + y;
}

static inline float fsub32(float x, float y) {
  return x - y;
}

static inline float fmul32(float x, float y) {
  return x * y;
}

static inline bool cmplt32(float x, float y) {
  return x < y;
}

static inline bool cmple32(float x, float y) {
  return x <= y;
}

static inline float sitofp_i8_f32(int8_t x) {
  return (float) x;
}

static inline float sitofp_i16_f32(int16_t x) {
  return (float) x;
}

static inline float sitofp_i32_f32(int32_t x) {
  return (float) x;
}

static inline float sitofp_i64_f32(int64_t x) {
  return (float) x;
}

static inline float uitofp_i8_f32(uint8_t x) {
  return (float) x;
}

static inline float uitofp_i16_f32(uint16_t x) {
  return (float) x;
}

static inline float uitofp_i32_f32(uint32_t x) {
  return (float) x;
}

static inline float uitofp_i64_f32(uint64_t x) {
  return (float) x;
}

static inline int8_t fptosi_f32_i8(float x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f32_i16(float x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f32_i32(float x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f32_i64(float x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f32_i8(float x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f32_i16(float x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f32_i32(float x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f32_i64(float x) {
  return (uint64_t) x;
}

#ifdef __OPENCL_VERSION__
static inline float fabs32(float x) {
  return fabs(x);
}

static inline float fmax32(float x, float y) {
  return fmax(x, y);
}

static inline float fmin32(float x, float y) {
  return fmin(x, y);
}

static inline float fpow32(float x, float y) {
  return pow(x, y);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float fabs32(float x) {
  return fabsf(x);
}

static inline float fmax32(float x, float y) {
  return fmaxf(x, y);
}

static inline float fmin32(float x, float y) {
  return fminf(x, y);
}

static inline float fpow32(float x, float y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan32(float x) {
  return isnan(x);
}

static inline bool futrts_isinf32(float x) {
  return isinf(x);
}

#ifdef __OPENCL_VERSION__
static inline float futrts_log32(float x) {
  return log(x);
}

static inline float futrts_log2_32(float x) {
  return log2(x);
}

static inline float futrts_log10_32(float x) {
  return log10(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrt(x);
}

static inline float futrts_exp32(float x) {
  return exp(x);
}

static inline float futrts_cos32(float x) {
  return cos(x);
}

static inline float futrts_sin32(float x) {
  return sin(x);
}

static inline float futrts_tan32(float x) {
  return tan(x);
}

static inline float futrts_acos32(float x) {
  return acos(x);
}

static inline float futrts_asin32(float x) {
  return asin(x);
}

static inline float futrts_atan32(float x) {
  return atan(x);
}

static inline float futrts_cosh32(float x) {
  return cosh(x);
}

static inline float futrts_sinh32(float x) {
  return sinh(x);
}

static inline float futrts_tanh32(float x) {
  return tanh(x);
}

static inline float futrts_acosh32(float x) {
  return acosh(x);
}

static inline float futrts_asinh32(float x) {
  return asinh(x);
}

static inline float futrts_atanh32(float x) {
  return atanh(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypot(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgamma(x);
}

static inline float futrts_lgamma32(float x) {
  return lgamma(x);
}

static inline float fmod32(float x, float y) {
  return fmod(x, y);
}

static inline float futrts_round32(float x) {
  return rint(x);
}

static inline float futrts_floor32(float x) {
  return floor(x);
}

static inline float futrts_ceil32(float x) {
  return ceil(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return mix(v0, v1, t);
}

static inline float futrts_mad32(float a, float b, float c) {
  return mad(a, b, c);
}

static inline float futrts_fma32(float a, float b, float c) {
  return fma(a, b, c);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float futrts_log32(float x) {
  return logf(x);
}

static inline float futrts_log2_32(float x) {
  return log2f(x);
}

static inline float futrts_log10_32(float x) {
  return log10f(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrtf(x);
}

static inline float futrts_exp32(float x) {
  return expf(x);
}

static inline float futrts_cos32(float x) {
  return cosf(x);
}

static inline float futrts_sin32(float x) {
  return sinf(x);
}

static inline float futrts_tan32(float x) {
  return tanf(x);
}

static inline float futrts_acos32(float x) {
  return acosf(x);
}

static inline float futrts_asin32(float x) {
  return asinf(x);
}

static inline float futrts_atan32(float x) {
  return atanf(x);
}

static inline float futrts_cosh32(float x) {
  return coshf(x);
}

static inline float futrts_sinh32(float x) {
  return sinhf(x);
}

static inline float futrts_tanh32(float x) {
  return tanhf(x);
}

static inline float futrts_acosh32(float x) {
  return acoshf(x);
}

static inline float futrts_asinh32(float x) {
  return asinhf(x);
}

static inline float futrts_atanh32(float x) {
  return atanhf(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2f(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypotf(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgammaf(x);
}

static inline float futrts_lgamma32(float x) {
  return lgammaf(x);
}

static inline float fmod32(float x, float y) {
  return fmodf(x, y);
}

static inline float futrts_round32(float x) {
  return rintf(x);
}

static inline float futrts_floor32(float x) {
  return floorf(x);
}

static inline float futrts_ceil32(float x) {
  return ceilf(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return v0 + (v1 - v0) * t;
}

static inline float futrts_mad32(float a, float b, float c) {
  return a * b + c;
}

static inline float futrts_fma32(float a, float b, float c) {
  return fmaf(a, b, c);
}
#endif

static inline int32_t futrts_to_bits32(float x) {
  union {
    float f;
    int32_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline float futrts_from_bits32(int32_t x) {
  union {
    int32_t f;
    float t;
  } p;

  p.f = x;
  return p.t;
}

static inline float fsignum32(float x) {
  return futrts_isnan32(x) ? x : (x > 0) - (x < 0);
}

#ifdef FUTHARK_F64_ENABLED

static inline double fdiv64(double x, double y) {
  return x / y;
}

static inline double fadd64(double x, double y) {
  return x + y;
}

static inline double fsub64(double x, double y) {
  return x - y;
}

static inline double fmul64(double x, double y) {
  return x * y;
}

static inline bool cmplt64(double x, double y) {
  return x < y;
}

static inline bool cmple64(double x, double y) {
  return x <= y;
}

static inline double sitofp_i8_f64(int8_t x) {
  return (double) x;
}

static inline double sitofp_i16_f64(int16_t x) {
  return (double) x;
}

static inline double sitofp_i32_f64(int32_t x) {
  return (double) x;
}

static inline double sitofp_i64_f64(int64_t x) {
  return (double) x;
}

static inline double uitofp_i8_f64(uint8_t x) {
  return (double) x;
}

static inline double uitofp_i16_f64(uint16_t x) {
  return (double) x;
}

static inline double uitofp_i32_f64(uint32_t x) {
  return (double) x;
}

static inline double uitofp_i64_f64(uint64_t x) {
  return (double) x;
}

static inline int8_t fptosi_f64_i8(double x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f64_i16(double x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f64_i32(double x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f64_i64(double x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f64_i8(double x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f64_i16(double x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f64_i32(double x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f64_i64(double x) {
  return (uint64_t) x;
}

static inline double fabs64(double x) {
  return fabs(x);
}

static inline double fmax64(double x, double y) {
  return fmax(x, y);
}

static inline double fmin64(double x, double y) {
  return fmin(x, y);
}

static inline double fpow64(double x, double y) {
  return pow(x, y);
}

static inline double futrts_log64(double x) {
  return log(x);
}

static inline double futrts_log2_64(double x) {
  return log2(x);
}

static inline double futrts_log10_64(double x) {
  return log10(x);
}

static inline double futrts_sqrt64(double x) {
  return sqrt(x);
}

static inline double futrts_exp64(double x) {
  return exp(x);
}

static inline double futrts_cos64(double x) {
  return cos(x);
}

static inline double futrts_sin64(double x) {
  return sin(x);
}

static inline double futrts_tan64(double x) {
  return tan(x);
}

static inline double futrts_acos64(double x) {
  return acos(x);
}

static inline double futrts_asin64(double x) {
  return asin(x);
}

static inline double futrts_atan64(double x) {
  return atan(x);
}

static inline double futrts_cosh64(double x) {
  return cosh(x);
}

static inline double futrts_sinh64(double x) {
  return sinh(x);
}

static inline double futrts_tanh64(double x) {
  return tanh(x);
}

static inline double futrts_acosh64(double x) {
  return acosh(x);
}

static inline double futrts_asinh64(double x) {
  return asinh(x);
}

static inline double futrts_atanh64(double x) {
  return atanh(x);
}

static inline double futrts_atan2_64(double x, double y) {
  return atan2(x, y);
}

static inline double futrts_hypot64(double x, double y) {
  return hypot(x, y);
}

static inline double futrts_gamma64(double x) {
  return tgamma(x);
}

static inline double futrts_lgamma64(double x) {
  return lgamma(x);
}

static inline double futrts_fma64(double a, double b, double c) {
  return fma(a, b, c);
}

static inline double futrts_round64(double x) {
  return rint(x);
}

static inline double futrts_ceil64(double x) {
  return ceil(x);
}

static inline double futrts_floor64(double x) {
  return floor(x);
}

static inline bool futrts_isnan64(double x) {
  return isnan(x);
}

static inline bool futrts_isinf64(double x) {
  return isinf(x);
}

static inline int64_t futrts_to_bits64(double x) {
  union {
    double f;
    int64_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline double futrts_from_bits64(int64_t x) {
  union {
    int64_t f;
    double t;
  } p;

  p.f = x;
  return p.t;
}

static inline double fmod64(double x, double y) {
  return fmod(x, y);
}

static inline double fsignum64(double x) {
  return futrts_isnan64(x) ? x : (x > 0) - (x < 0);
}

static inline double futrts_lerp64(double v0, double v1, double t) {
#ifdef __OPENCL_VERSION__
  return mix(v0, v1, t);
#else
  return v0 + (v1 - v0) * t;
#endif
}

static inline double futrts_mad64(double a, double b, double c) {
#ifdef __OPENCL_VERSION__
  return mad(a, b, c);
#else
  return a * b + c;
#endif
}

static inline float fpconv_f32_f32(float x) {
  return (float) x;
}

static inline double fpconv_f32_f64(float x) {
  return (double) x;
}

static inline float fpconv_f64_f32(double x) {
  return (float) x;
}

static inline double fpconv_f64_f64(double x) {
  return (double) x;
}

#endif

// End of scalar.h.
// Start of scalar_f16.h.

// Half-precision is emulated if needed (e.g. in straight C) with the
// native type used if possible.  The emulation works by typedef'ing
// 'float' to 'f16', and then implementing all operations on single
// precision.  To cut down on duplication, we use the same code for
// those Futhark functions that require just operators or casts.  The
// in-memory representation for arrays will still be 16 bits even
// under emulation, so the compiler will have to be careful when
// generating reads or writes.

#if !defined(cl_khr_fp16) && !(defined(__CUDA_ARCH__) && __CUDA_ARCH__ >= 600)
#define EMULATE_F16
#endif

#if !defined(EMULATE_F16) && defined(__OPENCL_VERSION__)
#pragma OPENCL EXTENSION cl_khr_fp16 : enable
#endif

#ifdef EMULATE_F16

// Note that the half-precision storage format is still 16 bits - the
// compiler will have to be real careful!
typedef float f16;

#else

#ifdef __CUDA_ARCH__
#include <cuda_fp16.h>
#endif

typedef half f16;

#endif

// Some of these functions convert to single precision because half
// precision versions are not available.

static inline f16 fadd16(f16 x, f16 y) {
  return x + y;
}

static inline f16 fsub16(f16 x, f16 y) {
  return x - y;
}

static inline f16 fmul16(f16 x, f16 y) {
  return x * y;
}

static inline bool cmplt16(f16 x, f16 y) {
  return x < y;
}

static inline bool cmple16(f16 x, f16 y) {
  return x <= y;
}

static inline f16 sitofp_i8_f16(int8_t x) {
  return (f16) x;
}

static inline f16 sitofp_i16_f16(int16_t x) {
  return (f16) x;
}

static inline f16 sitofp_i32_f16(int32_t x) {
  return (f16) x;
}

static inline f16 sitofp_i64_f16(int64_t x) {
  return (f16) x;
}

static inline f16 uitofp_i8_f16(uint8_t x) {
  return (f16) x;
}

static inline f16 uitofp_i16_f16(uint16_t x) {
  return (f16) x;
}

static inline f16 uitofp_i32_f16(uint32_t x) {
  return (f16) x;
}

static inline f16 uitofp_i64_f16(uint64_t x) {
  return (f16) x;
}

static inline int8_t fptosi_f16_i8(f16 x) {
  return (int8_t) (float) x;
}

static inline int16_t fptosi_f16_i16(f16 x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f16_i32(f16 x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f16_i64(f16 x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f16_i8(f16 x) {
  return (uint8_t) (float) x;
}

static inline uint16_t fptoui_f16_i16(f16 x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f16_i32(f16 x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f16_i64(f16 x) {
  return (uint64_t) x;
}

#ifndef EMULATE_F16

#ifdef __OPENCL_VERSION__
static inline f16 fabs16(f16 x) {
  return fabs(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return pow(x, y);
}

#else // Assuming CUDA.

static inline f16 fabs16(f16 x) {
  return fabsf(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmaxf(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fminf(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan16(f16 x) {
  return isnan((float)x);
}

static inline bool futrts_isinf16(f16 x) {
  return isinf((float)x);
}

#ifdef __OPENCL_VERSION__
static inline f16 futrts_log16(f16 x) {
  return log(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return log2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return log10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return sqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return exp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return cos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return sin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tan(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acos(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asin(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atan(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return cosh(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinh(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanh(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acosh(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinh(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanh(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypot(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgamma(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgamma(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rint(x);
}

static inline f16 futrts_floor16(f16 x) {
  return floor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return ceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return mix(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return mad(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fma(a, b, c);
}

#else // Assume CUDA.

static inline f16 futrts_log16(f16 x) {
  return hlog(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return hlog2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return hlog10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return hsqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return hexp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return hcos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return hsin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tanf(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acosf(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asinf(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atanf(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return coshf(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinhf(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanhf(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acoshf(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinhf(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanhf(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2f(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypotf(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgammaf(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgammaf(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmodf(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rintf(x);
}

static inline f16 futrts_floor16(f16 x) {
  return hfloor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return hceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return v0 + (v1 - v0) * t;
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return a * b + c;
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fmaf(a, b, c);
}

#endif

// The CUDA __half type cannot be put in unions for some reason, so we
// use bespoke conversion functions instead.
#ifdef __CUDA_ARCH__
static inline int16_t futrts_to_bits16(f16 x) {
  return __half_as_ushort(x);
}
static inline f16 futrts_from_bits16(int16_t x) {
  return __ushort_as_half(x);
}
#else
static inline int16_t futrts_to_bits16(f16 x) {
  union {
    f16 f;
    int16_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline f16 futrts_from_bits16(int16_t x) {
  union {
    int16_t f;
    f16 t;
  } p;

  p.f = x;
  return p.t;
}
#endif

#else // No native f16 - emulate.

static inline f16 fabs16(f16 x) {
  return fabs32(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax32(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin32(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return fpow32(x, y);
}

static inline bool futrts_isnan16(f16 x) {
  return futrts_isnan32(x);
}

static inline bool futrts_isinf16(f16 x) {
  return futrts_isinf32(x);
}

static inline f16 futrts_log16(f16 x) {
  return futrts_log32(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return futrts_log2_32(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return futrts_log10_32(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return futrts_sqrt32(x);
}

static inline f16 futrts_exp16(f16 x) {
  return futrts_exp32(x);
}

static inline f16 futrts_cos16(f16 x) {
  return futrts_cos32(x);
}

static inline f16 futrts_sin16(f16 x) {
  return futrts_sin32(x);
}

static inline f16 futrts_tan16(f16 x) {
  return futrts_tan32(x);
}

static inline f16 futrts_acos16(f16 x) {
  return futrts_acos32(x);
}

static inline f16 futrts_asin16(f16 x) {
  return futrts_asin32(x);
}

static inline f16 futrts_atan16(f16 x) {
  return futrts_atan32(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return futrts_cosh32(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return futrts_sinh32(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return futrts_tanh32(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return futrts_acosh32(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return futrts_asinh32(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return futrts_atanh32(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return futrts_atan2_32(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return futrts_hypot32(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return futrts_gamma32(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return futrts_lgamma32(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod32(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return futrts_round32(x);
}

static inline f16 futrts_floor16(f16 x) {
  return futrts_floor32(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return futrts_ceil32(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return futrts_lerp32(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return futrts_mad32(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return futrts_fma32(a, b, c);
}

// Even when we are using an OpenCL that does not support cl_khr_fp16,
// it must still support vload_half for actually creating a
// half-precision number, which can then be efficiently converted to a
// float.  Similarly for vstore_half.
#ifdef __OPENCL_VERSION__

static inline int16_t futrts_to_bits16(f16 x) {
  int16_t y;
  // Violating strict aliasing here.
  vstore_half((float)x, 0, (half*)&y);
  return y;
}

static inline f16 futrts_from_bits16(int16_t x) {
  return (f16)vload_half(0, (half*)&x);
}

#else

static inline int16_t futrts_to_bits16(f16 x) {
  return (int16_t)float2halfbits(x);
}

static inline f16 futrts_from_bits16(int16_t x) {
  return halfbits2float((uint16_t)x);
}

static inline f16 fsignum16(f16 x) {
  return futrts_isnan16(x) ? x : (x > 0) - (x < 0);
}

#endif

#endif

static inline float fpconv_f16_f16(f16 x) {
  return x;
}

static inline float fpconv_f16_f32(f16 x) {
  return x;
}

static inline f16 fpconv_f32_f16(float x) {
  return x;
}

#ifdef FUTHARK_F64_ENABLED

static inline double fpconv_f16_f64(f16 x) {
  return (double) x;
}

static inline f16 fpconv_f64_f16(double x) {
  return (f16) x;
}

#endif


// End of scalar_f16.h.

static int init_constants(struct futhark_context *);
static int free_constants(struct futhark_context *);
struct memblock {
    int *references;
    unsigned char *mem;
    int64_t size;
    const char *desc;
};
struct futhark_context_config {
    int debugging;
    int in_use;
};
struct futhark_context_config *futhark_context_config_new(void)
{
    struct futhark_context_config *cfg =
                                  (struct futhark_context_config *) malloc(sizeof(struct futhark_context_config));
    
    if (cfg == NULL)
        return NULL;
    cfg->in_use = 0;
    cfg->debugging = 0;
    return cfg;
}
void futhark_context_config_free(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    free(cfg);
}
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int detail)
{
    cfg->debugging = detail;
}
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag)
{
    (void) cfg;
    (void) flag;
}
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int detail)
{
    // Does nothing for this backend.
    (void) cfg;
    (void) detail;
}
struct futhark_context {
    struct futhark_context_config *cfg;
    int detail_memory;
    int debugging;
    int profiling;
    int logging;
    lock_t lock;
    char *error;
    FILE *log;
    int profiling_paused;
    int64_t peak_mem_usage_default;
    int64_t cur_mem_usage_default;
    struct {
        int dummy;
    } constants;
};
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    
    struct futhark_context *ctx =
                           (struct futhark_context *) malloc(sizeof(struct futhark_context));
    
    if (ctx == NULL)
        return NULL;
    ctx->cfg = cfg;
    ctx->cfg->in_use = 1;
    ctx->detail_memory = cfg->debugging;
    ctx->debugging = cfg->debugging;
    ctx->profiling = cfg->debugging;
    ctx->logging = cfg->debugging;
    ctx->error = NULL;
    ctx->log = stderr;
    create_lock(&ctx->lock);
    ctx->peak_mem_usage_default = 0;
    ctx->cur_mem_usage_default = 0;
    init_constants(ctx);
    return ctx;
}
void futhark_context_free(struct futhark_context *ctx)
{
    free_constants(ctx);
    free_lock(&ctx->lock);
    ctx->cfg->in_use = 0;
    free(ctx);
}
int futhark_context_sync(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
static const char *tuning_param_names[0];
static const char *tuning_param_vars[0];
static const char *tuning_param_classes[0];
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t param_value)
{
    (void) cfg;
    (void) param_name;
    (void) param_value;
    return 1;
}
static int memblock_unref(struct futhark_context *ctx, struct memblock *block,
                          const char *desc)
{
    if (block->references != NULL) {
        *block->references -= 1;
        if (ctx->detail_memory)
            fprintf(ctx->log,
                    "Unreferencing block %s (allocated as %s) in %s: %d references remaining.\n",
                    desc, block->desc, "default space", *block->references);
        if (*block->references == 0) {
            ctx->cur_mem_usage_default -= block->size;
            free(block->mem);
            free(block->references);
            if (ctx->detail_memory)
                fprintf(ctx->log,
                        "%lld bytes freed (now allocated: %lld bytes)\n",
                        (long long) block->size,
                        (long long) ctx->cur_mem_usage_default);
        }
        block->references = NULL;
    }
    return 0;
}
static int memblock_alloc(struct futhark_context *ctx, struct memblock *block,
                          int64_t size, const char *desc)
{
    if (size < 0)
        futhark_panic(1,
                      "Negative allocation of %lld bytes attempted for %s in %s.\n",
                      (long long) size, desc, "default space",
                      ctx->cur_mem_usage_default);
    
    int ret = memblock_unref(ctx, block, desc);
    
    ctx->cur_mem_usage_default += size;
    if (ctx->detail_memory)
        fprintf(ctx->log,
                "Allocating %lld bytes for %s in %s (then allocated: %lld bytes)",
                (long long) size, desc, "default space",
                (long long) ctx->cur_mem_usage_default);
    if (ctx->cur_mem_usage_default > ctx->peak_mem_usage_default) {
        ctx->peak_mem_usage_default = ctx->cur_mem_usage_default;
        if (ctx->detail_memory)
            fprintf(ctx->log, " (new peak).\n");
    } else if (ctx->detail_memory)
        fprintf(ctx->log, ".\n");
    block->mem = (unsigned char *) malloc((size_t) size);
    block->references = (int *) malloc(sizeof(int));
    *block->references = 1;
    block->size = size;
    block->desc = desc;
    return ret;
}
static int memblock_set(struct futhark_context *ctx, struct memblock *lhs,
                        struct memblock *rhs, const char *lhs_desc)
{
    int ret = memblock_unref(ctx, lhs, lhs_desc);
    
    if (rhs->references != NULL)
        (*rhs->references)++;
    *lhs = *rhs;
    return ret;
}
int futhark_get_tuning_param_count(void)
{
    return sizeof(tuning_param_names) / sizeof(tuning_param_names[0]);
}
const char *futhark_get_tuning_param_name(int i)
{
    return tuning_param_names[i];
}
const char *futhark_get_tuning_param_class(int i)
{
    return tuning_param_classes[i];
}
char *futhark_context_report(struct futhark_context *ctx)
{
    if (futhark_context_sync(ctx) != 0)
        return NULL;
    
    struct str_builder builder;
    
    str_builder_init(&builder);
    if (ctx->detail_memory || ctx->profiling || ctx->logging) {
        { }
    }
    if (ctx->profiling) { }
    return builder.str;
}
char *futhark_context_get_error(struct futhark_context *ctx)
{
    char *error = ctx->error;
    
    ctx->error = NULL;
    return error;
}
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f)
{
    ctx->log = f;
}
void futhark_context_pause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 1;
}
void futhark_context_unpause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 0;
}
int futhark_context_clear_caches(struct futhark_context *ctx)
{
    lock_lock(&ctx->lock);
    ctx->peak_mem_usage_default = 0;
    lock_unlock(&ctx->lock);
    return ctx->error != NULL;
}

static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock *mem_out_p_206655,
                             struct memblock *mem_out_p_206656,
                             struct memblock *mem_out_p_206657,
                             struct memblock Y_mem_201382, int64_t m_196691,
                             int64_t n_196692, int64_t n_p_196694,
                             int64_t q_s_196695, int64_t q_t_196696,
                             int64_t q_l_196697, int64_t d_s_196698,
                             int64_t d_t_196699, int64_t d_l_196700,
                             int64_t jump_s_196701, int64_t jump_t_196702,
                             int64_t jump_l_196703, int64_t n_inner_196704,
                             int64_t n_outer_196705,
                             int64_t jump_threshold_196706,
                             int64_t q_threshold_196707);

static int init_constants(struct futhark_context *ctx)
{
    (void) ctx;
    
    int err = 0;
    
    
  cleanup:
    return err;
}
static int free_constants(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
struct futhark_f32_2d {
    struct memblock mem;
    int64_t shape[2];
};
struct futhark_f32_2d *futhark_new_f32_2d(struct futhark_context *ctx, const
                                          float *data, int64_t dim0,
                                          int64_t dim1)
{
    struct futhark_f32_2d *bad = NULL;
    struct futhark_f32_2d *arr =
                          (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * dim1 * 4, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    if ((size_t) (dim0 * dim1) * 4 > 0)
        memmove(arr->mem.mem + 0, data + 0, (size_t) (dim0 * dim1) * 4);
    lock_unlock(&ctx->lock);
    return arr;
}
struct futhark_f32_2d *futhark_new_raw_f32_2d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0,
                                              int64_t dim1)
{
    struct futhark_f32_2d *bad = NULL;
    struct futhark_f32_2d *arr =
                          (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * dim1 * 4, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    if ((size_t) (dim0 * dim1) * 4 > 0)
        memmove(arr->mem.mem + 0, data + offset, (size_t) (dim0 * dim1) * 4);
    lock_unlock(&ctx->lock);
    return arr;
}
int futhark_free_f32_2d(struct futhark_context *ctx, struct futhark_f32_2d *arr)
{
    lock_lock(&ctx->lock);
    if (memblock_unref(ctx, &arr->mem, "arr->mem") != 0)
        return 1;
    lock_unlock(&ctx->lock);
    free(arr);
    return 0;
}
int futhark_values_f32_2d(struct futhark_context *ctx,
                          struct futhark_f32_2d *arr, float *data)
{
    lock_lock(&ctx->lock);
    if ((size_t) (arr->shape[0] * arr->shape[1]) * 4 > 0)
        memmove(data + 0, arr->mem.mem + 0, (size_t) (arr->shape[0] *
                                                      arr->shape[1]) * 4);
    lock_unlock(&ctx->lock);
    return 0;
}
unsigned char *futhark_values_raw_f32_2d(struct futhark_context *ctx,
                                         struct futhark_f32_2d *arr)
{
    (void) ctx;
    return arr->mem.mem;
}
const int64_t *futhark_shape_f32_2d(struct futhark_context *ctx,
                                    struct futhark_f32_2d *arr)
{
    (void) ctx;
    return arr->shape;
}

static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock *mem_out_p_206655,
                             struct memblock *mem_out_p_206656,
                             struct memblock *mem_out_p_206657,
                             struct memblock Y_mem_201382, int64_t m_196691,
                             int64_t n_196692, int64_t n_p_196694,
                             int64_t q_s_196695, int64_t q_t_196696,
                             int64_t q_l_196697, int64_t d_s_196698,
                             int64_t d_t_196699, int64_t d_l_196700,
                             int64_t jump_s_196701, int64_t jump_t_196702,
                             int64_t jump_l_196703, int64_t n_inner_196704,
                             int64_t n_outer_196705,
                             int64_t jump_threshold_196706,
                             int64_t q_threshold_196707)
{
    (void) ctx;
    
    int err = 0;
    size_t mem_201386_cached_sizze_206658 = 0;
    unsigned char *mem_201386 = NULL;
    size_t mem_201389_cached_sizze_206659 = 0;
    unsigned char *mem_201389 = NULL;
    size_t mem_201409_cached_sizze_206660 = 0;
    unsigned char *mem_201409 = NULL;
    size_t mem_201424_cached_sizze_206661 = 0;
    unsigned char *mem_201424 = NULL;
    size_t mem_201461_cached_sizze_206662 = 0;
    unsigned char *mem_201461 = NULL;
    size_t mem_201553_cached_sizze_206663 = 0;
    unsigned char *mem_201553 = NULL;
    size_t mem_201557_cached_sizze_206664 = 0;
    unsigned char *mem_201557 = NULL;
    size_t mem_201610_cached_sizze_206665 = 0;
    unsigned char *mem_201610 = NULL;
    size_t mem_201625_cached_sizze_206666 = 0;
    unsigned char *mem_201625 = NULL;
    size_t mem_201704_cached_sizze_206667 = 0;
    unsigned char *mem_201704 = NULL;
    size_t mem_201709_cached_sizze_206668 = 0;
    unsigned char *mem_201709 = NULL;
    size_t mem_201770_cached_sizze_206669 = 0;
    unsigned char *mem_201770 = NULL;
    size_t mem_201902_cached_sizze_206670 = 0;
    unsigned char *mem_201902 = NULL;
    size_t mem_201906_cached_sizze_206671 = 0;
    unsigned char *mem_201906 = NULL;
    size_t mem_201929_cached_sizze_206672 = 0;
    unsigned char *mem_201929 = NULL;
    size_t mem_202005_cached_sizze_206673 = 0;
    unsigned char *mem_202005 = NULL;
    size_t mem_202009_cached_sizze_206674 = 0;
    unsigned char *mem_202009 = NULL;
    size_t mem_202032_cached_sizze_206675 = 0;
    unsigned char *mem_202032 = NULL;
    size_t mem_202162_cached_sizze_206676 = 0;
    unsigned char *mem_202162 = NULL;
    size_t mem_202207_cached_sizze_206677 = 0;
    unsigned char *mem_202207 = NULL;
    size_t mem_202212_cached_sizze_206678 = 0;
    unsigned char *mem_202212 = NULL;
    size_t mem_202956_cached_sizze_206679 = 0;
    unsigned char *mem_202956 = NULL;
    size_t mem_203115_cached_sizze_206680 = 0;
    unsigned char *mem_203115 = NULL;
    size_t mem_203118_cached_sizze_206681 = 0;
    unsigned char *mem_203118 = NULL;
    size_t mem_203329_cached_sizze_206682 = 0;
    unsigned char *mem_203329 = NULL;
    size_t mem_203332_cached_sizze_206683 = 0;
    unsigned char *mem_203332 = NULL;
    size_t mem_203359_cached_sizze_206684 = 0;
    unsigned char *mem_203359 = NULL;
    size_t mem_203362_cached_sizze_206685 = 0;
    unsigned char *mem_203362 = NULL;
    size_t mem_203637_cached_sizze_206686 = 0;
    unsigned char *mem_203637 = NULL;
    size_t mem_203680_cached_sizze_206687 = 0;
    unsigned char *mem_203680 = NULL;
    size_t mem_203696_cached_sizze_206688 = 0;
    unsigned char *mem_203696 = NULL;
    size_t mem_203709_cached_sizze_206689 = 0;
    unsigned char *mem_203709 = NULL;
    size_t mem_203732_cached_sizze_206690 = 0;
    unsigned char *mem_203732 = NULL;
    size_t mem_203748_cached_sizze_206691 = 0;
    unsigned char *mem_203748 = NULL;
    size_t mem_203761_cached_sizze_206692 = 0;
    unsigned char *mem_203761 = NULL;
    size_t mem_203784_cached_sizze_206693 = 0;
    unsigned char *mem_203784 = NULL;
    size_t mem_203800_cached_sizze_206694 = 0;
    unsigned char *mem_203800 = NULL;
    size_t mem_203813_cached_sizze_206695 = 0;
    unsigned char *mem_203813 = NULL;
    size_t mem_204121_cached_sizze_206696 = 0;
    unsigned char *mem_204121 = NULL;
    size_t mem_204205_cached_sizze_206697 = 0;
    unsigned char *mem_204205 = NULL;
    size_t mem_204208_cached_sizze_206698 = 0;
    unsigned char *mem_204208 = NULL;
    size_t mem_204323_cached_sizze_206699 = 0;
    unsigned char *mem_204323 = NULL;
    size_t mem_204326_cached_sizze_206700 = 0;
    unsigned char *mem_204326 = NULL;
    size_t mem_204353_cached_sizze_206701 = 0;
    unsigned char *mem_204353 = NULL;
    size_t mem_204356_cached_sizze_206702 = 0;
    unsigned char *mem_204356 = NULL;
    size_t mem_204583_cached_sizze_206703 = 0;
    unsigned char *mem_204583 = NULL;
    size_t mem_204598_cached_sizze_206704 = 0;
    unsigned char *mem_204598 = NULL;
    size_t mem_204601_cached_sizze_206705 = 0;
    unsigned char *mem_204601 = NULL;
    size_t mem_204686_cached_sizze_206706 = 0;
    unsigned char *mem_204686 = NULL;
    size_t mem_204701_cached_sizze_206707 = 0;
    unsigned char *mem_204701 = NULL;
    size_t mem_204704_cached_sizze_206708 = 0;
    unsigned char *mem_204704 = NULL;
    size_t mem_204819_cached_sizze_206709 = 0;
    unsigned char *mem_204819 = NULL;
    size_t mem_204834_cached_sizze_206710 = 0;
    unsigned char *mem_204834 = NULL;
    size_t mem_204837_cached_sizze_206711 = 0;
    unsigned char *mem_204837 = NULL;
    size_t mem_204974_cached_sizze_206712 = 0;
    unsigned char *mem_204974 = NULL;
    size_t mem_204989_cached_sizze_206713 = 0;
    unsigned char *mem_204989 = NULL;
    size_t mem_204992_cached_sizze_206714 = 0;
    unsigned char *mem_204992 = NULL;
    size_t mem_205030_cached_sizze_206715 = 0;
    unsigned char *mem_205030 = NULL;
    size_t mem_205092_cached_sizze_206716 = 0;
    unsigned char *mem_205092 = NULL;
    size_t mem_205107_cached_sizze_206717 = 0;
    unsigned char *mem_205107 = NULL;
    size_t mem_205110_cached_sizze_206718 = 0;
    unsigned char *mem_205110 = NULL;
    size_t mem_205159_cached_sizze_206719 = 0;
    unsigned char *mem_205159 = NULL;
    size_t mem_205162_cached_sizze_206720 = 0;
    unsigned char *mem_205162 = NULL;
    size_t mem_205255_cached_sizze_206721 = 0;
    unsigned char *mem_205255 = NULL;
    size_t mem_205270_cached_sizze_206722 = 0;
    unsigned char *mem_205270 = NULL;
    size_t mem_205273_cached_sizze_206723 = 0;
    unsigned char *mem_205273 = NULL;
    size_t mem_205322_cached_sizze_206724 = 0;
    unsigned char *mem_205322 = NULL;
    size_t mem_205325_cached_sizze_206725 = 0;
    unsigned char *mem_205325 = NULL;
    size_t mem_205352_cached_sizze_206726 = 0;
    unsigned char *mem_205352 = NULL;
    size_t mem_205355_cached_sizze_206727 = 0;
    unsigned char *mem_205355 = NULL;
    size_t mem_205537_cached_sizze_206728 = 0;
    unsigned char *mem_205537 = NULL;
    size_t mem_205541_cached_sizze_206729 = 0;
    unsigned char *mem_205541 = NULL;
    size_t mem_205625_cached_sizze_206730 = 0;
    unsigned char *mem_205625 = NULL;
    size_t mem_205646_cached_sizze_206731 = 0;
    unsigned char *mem_205646 = NULL;
    size_t mem_205649_cached_sizze_206732 = 0;
    unsigned char *mem_205649 = NULL;
    size_t mem_205652_cached_sizze_206733 = 0;
    unsigned char *mem_205652 = NULL;
    size_t mem_205655_cached_sizze_206734 = 0;
    unsigned char *mem_205655 = NULL;
    size_t mem_205658_cached_sizze_206735 = 0;
    unsigned char *mem_205658 = NULL;
    size_t mem_205721_cached_sizze_206736 = 0;
    unsigned char *mem_205721 = NULL;
    size_t mem_205752_cached_sizze_206737 = 0;
    unsigned char *mem_205752 = NULL;
    size_t mem_205755_cached_sizze_206738 = 0;
    unsigned char *mem_205755 = NULL;
    size_t mem_205758_cached_sizze_206739 = 0;
    unsigned char *mem_205758 = NULL;
    size_t mem_205874_cached_sizze_206740 = 0;
    unsigned char *mem_205874 = NULL;
    struct memblock mem_out_206307;
    
    mem_out_206307.references = NULL;
    
    struct memblock mem_out_206308;
    
    mem_out_206308.references = NULL;
    
    struct memblock mem_out_206309;
    
    mem_out_206309.references = NULL;
    
    bool assert_cond_196708 = sle64((int64_t) 4, n_p_196694);
    bool assert_c_196709;
    
    if (!assert_cond_196708) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (n_p >= 4)",
                               "-> #0  stl.fut:69:13-33\n   #1  stl.fut:401:3-415:29\n   #2  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t x_196710 = smod64(q_t_196696, (int64_t) 2);
    bool assert_cond_196711 = x_196710 == (int64_t) 1;
    bool assert_c_196712;
    
    if (!assert_cond_196711) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x % 2 == 1)",
                               "-> #0  utils.fut:20:3-23\n   #1  /prelude/functional.fut:39:62-64\n   #2  stl.fut:71:13-25\n   #3  stl.fut:401:3-415:29\n   #4  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_196713 = slt64((int64_t) 0, q_t_196696);
    bool assert_c_196714;
    
    if (!assert_cond_196713) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  /prelude/functional.fut:39:59-65\n   #2  stl.fut:71:13-25\n   #3  stl.fut:401:3-415:29\n   #4  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t x_196715 = smod64(q_l_196697, (int64_t) 2);
    bool assert_cond_196716 = x_196715 == (int64_t) 1;
    bool assert_c_196717;
    
    if (!assert_cond_196716) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x % 2 == 1)",
                               "-> #0  utils.fut:20:3-23\n   #1  /prelude/functional.fut:39:62-64\n   #2  stl.fut:72:13-25\n   #3  stl.fut:401:3-415:29\n   #4  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_196718 = slt64((int64_t) 0, q_l_196697);
    bool assert_c_196719;
    
    if (!assert_cond_196718) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  /prelude/functional.fut:39:59-65\n   #2  stl.fut:72:13-25\n   #3  stl.fut:401:3-415:29\n   #4  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_196728 = slt64((int64_t) 0, jump_t_196702);
    bool assert_c_196729;
    
    if (!assert_cond_196728) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:77:16-31\n   #2  stl.fut:401:3-415:29\n   #3  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_196730 = slt64((int64_t) 0, jump_l_196703);
    bool assert_c_196731;
    
    if (!assert_cond_196730) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:78:16-31\n   #2  stl.fut:401:3-415:29\n   #3  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_196732 = slt64((int64_t) 0, n_inner_196704);
    bool assert_c_196733;
    
    if (!assert_cond_196732) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:80:17-33\n   #2  stl.fut:401:3-415:29\n   #3  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_196734 = slt64((int64_t) 0, n_outer_196705);
    bool assert_c_196735;
    
    if (!assert_cond_196734) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:81:17-33\n   #2  stl.fut:401:3-415:29\n   #3  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    float i64_res_196736 = sitofp_i64_f32(n_196692);
    float i64_res_196737 = sitofp_i64_f32(n_p_196694);
    float ceil_arg_196738 = i64_res_196736 / i64_res_196737;
    float ceil_res_196739;
    
    ceil_res_196739 = futrts_ceil32(ceil_arg_196738);
    
    int64_t defunc_0_f_res_196740 = fptosi_f32_i64(ceil_res_196739);
    int64_t pad_css_len_196741 = add64((int64_t) 2, defunc_0_f_res_196740);
    int64_t y_196742 = mul64((int64_t) 2, n_p_196694);
    int64_t C_len_196743 = add64(n_196692, y_196742);
    bool cond_196744 = jump_s_196701 == (int64_t) 1;
    int64_t s_n_m_196745;
    
    if (cond_196744) {
        s_n_m_196745 = pad_css_len_196741;
    } else {
        bool zzero_196746 = jump_s_196701 == (int64_t) 0;
        bool nonzzero_196747 = !zzero_196746;
        bool nonzzero_cert_196748;
        
        if (!nonzzero_196747) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:88:52-71\n   #1  stl.fut:401:3-415:29\n   #2  stl.fut:385:1-415:29\n");
            if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t x_196749 = sdiv64(defunc_0_f_res_196740, jump_s_196701);
        int64_t s_n_m_f_res_196750 = add64((int64_t) 3, x_196749);
        
        s_n_m_196745 = s_n_m_f_res_196750;
    }
    
    bool cond_196751 = jump_l_196703 == (int64_t) 1;
    int64_t l_n_m_196752;
    
    if (cond_196751) {
        l_n_m_196752 = n_196692;
    } else {
        bool zzero_196753 = jump_l_196703 == (int64_t) 0;
        bool nonzzero_196754 = !zzero_196753;
        bool nonzzero_cert_196755;
        
        if (!nonzzero_196754) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:94:42-51\n   #1  stl.fut:401:3-415:29\n   #2  stl.fut:385:1-415:29\n");
            if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t x_196756 = sdiv64(n_196692, jump_l_196703);
        int64_t l_n_m_f_res_196757 = add64((int64_t) 1, x_196756);
        
        l_n_m_196752 = l_n_m_f_res_196757;
    }
    
    bool cond_196758 = jump_t_196702 == (int64_t) 1;
    int64_t t_n_m_196759;
    
    if (cond_196758) {
        t_n_m_196759 = n_196692;
    } else {
        bool zzero_196760 = jump_t_196702 == (int64_t) 0;
        bool nonzzero_196761 = !zzero_196760;
        bool nonzzero_cert_196762;
        
        if (!nonzzero_196761) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:98:42-51\n   #1  stl.fut:401:3-415:29\n   #2  stl.fut:385:1-415:29\n");
            if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t x_196763 = sdiv64(n_196692, jump_t_196702);
        int64_t t_n_m_f_res_196764 = add64((int64_t) 1, x_196763);
        
        t_n_m_196759 = t_n_m_f_res_196764;
    }
    
    float x_196765 = i64_res_196736 / 2.0F;
    float floor_arg_196766 = 1.0F + x_196765;
    float floor_res_196767;
    
    floor_res_196767 = futrts_floor32(floor_arg_196766);
    
    int64_t defunc_0_f_res_196768 = fptosi_f32_i64(floor_res_196767);
    int64_t x_196769 = sub64(n_196692, defunc_0_f_res_196768);
    int64_t mid2_196770 = add64((int64_t) 1, x_196769);
    bool cond_196771 = defunc_0_f_res_196768 == mid2_196770;
    int64_t stl_res_t_res_196772 = sub64(defunc_0_f_res_196768, (int64_t) 1);
    int64_t stl_res_196773;
    int64_t stl_res_196774;
    
    if (cond_196771) {
        stl_res_196773 = stl_res_t_res_196772;
        stl_res_196774 = defunc_0_f_res_196768;
    } else {
        int64_t min_res_196775 = smin64(defunc_0_f_res_196768, mid2_196770);
        int64_t stl_res_f_res_196776 = sub64(min_res_196775, (int64_t) 1);
        int64_t max_res_196777 = smax64(defunc_0_f_res_196768, mid2_196770);
        
        stl_res_196773 = stl_res_f_res_196776;
        stl_res_196774 = max_res_196777;
    }
    
    int64_t i_196779 = sub64(n_196692, (int64_t) 1);
    bool x_196780 = sle64((int64_t) 0, i_196779);
    bool y_196781 = slt64(i_196779, n_196692);
    bool bounds_check_196782 = x_196780 && y_196781;
    bool index_certs_196783;
    
    if (!bounds_check_196782) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) i_196779,
                               "] out of bounds for array of shape [",
                               (long long) n_196692, "].",
                               "-> #0  /prelude/array.fut:26:29-34\n   #1  utils.fut:45:13-20\n   #2  stl.fut:112:31-49\n   #3  stl.fut:401:3-415:29\n   #4  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_x_201383 = m_196691 * n_196692;
    int64_t binop_y_201384 = (int64_t) 8 * binop_x_201383;
    int64_t bytes_201385 = smax64((int64_t) 0, binop_y_201384);
    
    if (mem_201386_cached_sizze_206658 < (size_t) bytes_201385) {
        mem_201386 = realloc(mem_201386, bytes_201385);
        mem_201386_cached_sizze_206658 = bytes_201385;
    }
    
    int64_t binop_y_201387 = (int64_t) 8 * m_196691;
    int64_t bytes_201388 = smax64((int64_t) 0, binop_y_201387);
    
    if (mem_201389_cached_sizze_206659 < (size_t) bytes_201388) {
        mem_201389 = realloc(mem_201389, bytes_201388);
        mem_201389_cached_sizze_206659 = bytes_201388;
    }
    
    int64_t binop_y_201407 = (int64_t) 8 * n_196692;
    int64_t bytes_201408 = smax64((int64_t) 0, binop_y_201407);
    
    if (mem_201409_cached_sizze_206660 < (size_t) bytes_201408) {
        mem_201409 = realloc(mem_201409, bytes_201408);
        mem_201409_cached_sizze_206660 = bytes_201408;
    }
    if (mem_201424_cached_sizze_206661 < (size_t) bytes_201408) {
        mem_201424 = realloc(mem_201424, bytes_201408);
        mem_201424_cached_sizze_206661 = bytes_201408;
    }
    for (int64_t i_206310 = 0; i_206310 < n_196692; i_206310++) {
        ((int64_t *) mem_201424)[i_206310] = (int64_t) -1;
    }
    for (int64_t i_199975 = 0; i_199975 < m_196691; i_199975++) {
        int64_t discard_199964;
        int64_t scanacc_199960 = (int64_t) 0;
        
        for (int64_t i_199962 = 0; i_199962 < n_196692; i_199962++) {
            float x_196791;
            
            x_196791 = ((float *) Y_mem_201382.mem)[i_199975 * n_196692 +
                                                    i_199962];
            
            bool isnan_res_196792;
            
            isnan_res_196792 = futrts_isnan32(x_196791);
            
            bool defunc_0_p_res_196793 = !isnan_res_196792;
            int64_t defunc_0_f_res_196794 =
                    btoi_bool_i64(defunc_0_p_res_196793);
            int64_t defunc_1_op_res_196790 = add64(defunc_0_f_res_196794,
                                                   scanacc_199960);
            
            ((int64_t *) mem_201409)[i_199962] = defunc_1_op_res_196790;
            
            int64_t scanacc_tmp_206313 = defunc_1_op_res_196790;
            
            scanacc_199960 = scanacc_tmp_206313;
        }
        discard_199964 = scanacc_199960;
        if (n_196692 * (int64_t) 8 > 0)
            memmove(mem_201386 + i_199975 * n_196692 * (int64_t) 8, mem_201424 +
                    (int64_t) 0, n_196692 * (int64_t) 8);
        for (int64_t write_iter_199965 = 0; write_iter_199965 < n_196692;
             write_iter_199965++) {
            float write_iv_199967;
            
            write_iv_199967 = ((float *) Y_mem_201382.mem)[i_199975 * n_196692 +
                                                           write_iter_199965];
            
            int64_t write_iv_199968;
            
            write_iv_199968 = ((int64_t *) mem_201409)[write_iter_199965];
            
            bool isnan_res_196801;
            
            isnan_res_196801 = futrts_isnan32(write_iv_199967);
            
            bool defunc_0_p_res_196802 = !isnan_res_196801;
            int64_t defunc_1_f_res_196803;
            
            if (defunc_0_p_res_196802) {
                int64_t defunc_1_f_res_t_res_196804 = sub64(write_iv_199968,
                                                            (int64_t) 1);
                
                defunc_1_f_res_196803 = defunc_1_f_res_t_res_196804;
            } else {
                defunc_1_f_res_196803 = (int64_t) -1;
            }
            if ((sle64((int64_t) 0, i_199975) && slt64(i_199975, m_196691)) &&
                (sle64((int64_t) 0, defunc_1_f_res_196803) &&
                 slt64(defunc_1_f_res_196803, n_196692))) {
                ((int64_t *) mem_201386)[i_199975 * n_196692 +
                                         defunc_1_f_res_196803] =
                    write_iter_199965;
            }
        }
        if ((int64_t) 8 > 0)
            memmove(mem_201389 + i_199975 * (int64_t) 8, mem_201409 +
                    ((int64_t) 0 + (int64_t) 1 * i_196779) * (int64_t) 8,
                    (int64_t) 8);
    }
    
    bool bounds_invalid_upwards_196807 = slt64(n_p_196694, (int64_t) 0);
    bool valid_196808 = !bounds_invalid_upwards_196807;
    bool range_valid_c_196809;
    
    if (!valid_196808) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) n_p_196694, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:117:12-126:20\n   #4  stl.fut:116:5-127:11\n   #5  stl.fut:401:3-415:29\n   #6  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_196811 = slt64(defunc_0_f_res_196740,
                                               (int64_t) 0);
    bool valid_196812 = !bounds_invalid_upwards_196811;
    bool range_valid_c_196813;
    
    if (!valid_196812) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) defunc_0_f_res_196740,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:119:20-125:36\n   #4  /prelude/soacs.fut:59:3-10\n   #5  /prelude/array.fut:195:3-17\n   #6  utils.fut:6:3-16\n   #7  stl.fut:117:12-126:20\n   #8  stl.fut:116:5-127:11\n   #9  stl.fut:401:3-415:29\n   #10 stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_x_201457 = m_196691 * n_p_196694;
    int64_t binop_x_201458 = defunc_0_f_res_196740 * binop_x_201457;
    int64_t binop_y_201459 = (int64_t) 4 * binop_x_201458;
    int64_t bytes_201460 = smax64((int64_t) 0, binop_y_201459);
    
    if (mem_201461_cached_sizze_206662 < (size_t) bytes_201460) {
        mem_201461 = realloc(mem_201461, bytes_201460);
        mem_201461_cached_sizze_206662 = bytes_201460;
    }
    
    int64_t ctx_val_201474 = n_p_196694 * defunc_0_f_res_196740;
    
    for (int64_t i_199988 = 0; i_199988 < m_196691; i_199988++) {
        for (int64_t i_199984 = 0; i_199984 < n_p_196694; i_199984++) {
            for (int64_t i_199980 = 0; i_199980 < defunc_0_f_res_196740;
                 i_199980++) {
                int64_t y_196821 = mul64(n_p_196694, i_199980);
                int64_t new_i_196822 = add64(y_196821, i_199984);
                bool cond_196823 = slt64(i_196779, new_i_196822);
                float defunc_0_f_res_196824;
                
                if (cond_196823) {
                    defunc_0_f_res_196824 = NAN;
                } else {
                    bool x_196825 = sle64((int64_t) 0, new_i_196822);
                    bool y_196826 = slt64(new_i_196822, n_196692);
                    bool bounds_check_196827 = x_196825 && y_196826;
                    bool index_certs_196828;
                    
                    if (!bounds_check_196827) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) new_i_196822,
                                      "] out of bounds for array of shape [",
                                      (long long) n_196692, "].",
                                      "-> #0  stl.fut:124:33-40\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:119:20-125:36\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:117:12-126:20\n   #9  stl.fut:116:5-127:11\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                        if (memblock_unref(ctx, &mem_out_206309,
                                           "mem_out_206309") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_206308,
                                           "mem_out_206308") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_206307,
                                           "mem_out_206307") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    float defunc_0_f_res_f_res_196829;
                    
                    defunc_0_f_res_f_res_196829 =
                        ((float *) Y_mem_201382.mem)[i_199988 * n_196692 +
                                                     new_i_196822];
                    defunc_0_f_res_196824 = defunc_0_f_res_f_res_196829;
                }
                ((float *) mem_201461)[i_199988 * ctx_val_201474 + i_199984 *
                                       defunc_0_f_res_196740 + i_199980] =
                    defunc_0_f_res_196824;
            }
        }
    }
    
    int64_t i_196831 = sub64(defunc_0_f_res_196740, (int64_t) 1);
    bool x_196832 = sle64((int64_t) 0, i_196831);
    bool y_196833 = slt64(i_196831, defunc_0_f_res_196740);
    bool bounds_check_196834 = x_196832 && y_196833;
    bool index_certs_196835;
    
    if (!bounds_check_196834) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) i_196831,
                               "] out of bounds for array of shape [",
                               (long long) defunc_0_f_res_196740, "].",
                               "-> #0  /prelude/array.fut:26:29-34\n   #1  utils.fut:45:13-20\n   #2  stl.fut:133:51-67\n   #3  stl.fut:132:12-135:21\n   #4  stl.fut:131:5-136:16\n   #5  stl.fut:401:3-415:29\n   #6  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_y_201551 = (int64_t) 8 * binop_x_201458;
    int64_t bytes_201552 = smax64((int64_t) 0, binop_y_201551);
    
    if (mem_201553_cached_sizze_206663 < (size_t) bytes_201552) {
        mem_201553 = realloc(mem_201553, bytes_201552);
        mem_201553_cached_sizze_206663 = bytes_201552;
    }
    
    int64_t binop_y_201555 = (int64_t) 8 * binop_x_201457;
    int64_t bytes_201556 = smax64((int64_t) 0, binop_y_201555);
    
    if (mem_201557_cached_sizze_206664 < (size_t) bytes_201556) {
        mem_201557 = realloc(mem_201557, bytes_201556);
        mem_201557_cached_sizze_206664 = bytes_201556;
    }
    
    int64_t binop_y_201608 = (int64_t) 8 * defunc_0_f_res_196740;
    int64_t bytes_201609 = smax64((int64_t) 0, binop_y_201608);
    
    if (mem_201610_cached_sizze_206665 < (size_t) bytes_201609) {
        mem_201610 = realloc(mem_201610, bytes_201609);
        mem_201610_cached_sizze_206665 = bytes_201609;
    }
    if (mem_201625_cached_sizze_206666 < (size_t) bytes_201609) {
        mem_201625 = realloc(mem_201625, bytes_201609);
        mem_201625_cached_sizze_206666 = bytes_201609;
    }
    for (int64_t i_206319 = 0; i_206319 < defunc_0_f_res_196740; i_206319++) {
        ((int64_t *) mem_201625)[i_206319] = (int64_t) -1;
    }
    for (int64_t i_200013 = 0; i_200013 < m_196691; i_200013++) {
        for (int64_t i_200006 = 0; i_200006 < n_p_196694; i_200006++) {
            int64_t discard_199995;
            int64_t scanacc_199991 = (int64_t) 0;
            
            for (int64_t i_199993 = 0; i_199993 < defunc_0_f_res_196740;
                 i_199993++) {
                float x_196846;
                
                x_196846 = ((float *) mem_201461)[i_200013 * ctx_val_201474 +
                                                  i_200006 *
                                                  defunc_0_f_res_196740 +
                                                  i_199993];
                
                bool isnan_res_196847;
                
                isnan_res_196847 = futrts_isnan32(x_196846);
                
                bool defunc_0_p_res_196848 = !isnan_res_196847;
                int64_t defunc_0_f_res_196849 =
                        btoi_bool_i64(defunc_0_p_res_196848);
                int64_t defunc_1_op_res_196845 = add64(defunc_0_f_res_196849,
                                                       scanacc_199991);
                
                ((int64_t *) mem_201610)[i_199993] = defunc_1_op_res_196845;
                
                int64_t scanacc_tmp_206324 = defunc_1_op_res_196845;
                
                scanacc_199991 = scanacc_tmp_206324;
            }
            discard_199995 = scanacc_199991;
            if (defunc_0_f_res_196740 * (int64_t) 8 > 0)
                memmove(mem_201553 + (i_200013 * ctx_val_201474 + i_200006 *
                                      defunc_0_f_res_196740) * (int64_t) 8,
                        mem_201625 + (int64_t) 0, defunc_0_f_res_196740 *
                        (int64_t) 8);
            for (int64_t write_iter_199996 = 0; write_iter_199996 <
                 defunc_0_f_res_196740; write_iter_199996++) {
                float write_iv_199998;
                
                write_iv_199998 = ((float *) mem_201461)[i_200013 *
                                                         ctx_val_201474 +
                                                         i_200006 *
                                                         defunc_0_f_res_196740 +
                                                         write_iter_199996];
                
                int64_t write_iv_199999;
                
                write_iv_199999 = ((int64_t *) mem_201610)[write_iter_199996];
                
                bool isnan_res_196856;
                
                isnan_res_196856 = futrts_isnan32(write_iv_199998);
                
                bool defunc_0_p_res_196857 = !isnan_res_196856;
                int64_t defunc_1_f_res_196858;
                
                if (defunc_0_p_res_196857) {
                    int64_t defunc_1_f_res_t_res_196859 = sub64(write_iv_199999,
                                                                (int64_t) 1);
                    
                    defunc_1_f_res_196858 = defunc_1_f_res_t_res_196859;
                } else {
                    defunc_1_f_res_196858 = (int64_t) -1;
                }
                if (((sle64((int64_t) 0, i_200013) && slt64(i_200013,
                                                            m_196691)) &&
                     (sle64((int64_t) 0, i_200006) && slt64(i_200006,
                                                            n_p_196694))) &&
                    (sle64((int64_t) 0, defunc_1_f_res_196858) &&
                     slt64(defunc_1_f_res_196858, defunc_0_f_res_196740))) {
                    ((int64_t *) mem_201553)[i_200013 * ctx_val_201474 +
                                             i_200006 * defunc_0_f_res_196740 +
                                             defunc_1_f_res_196858] =
                        write_iter_199996;
                }
            }
            if ((int64_t) 8 > 0)
                memmove(mem_201557 + (i_200013 * n_p_196694 + i_200006) *
                        (int64_t) 8, mem_201610 + ((int64_t) 0 + (int64_t) 1 *
                                                   i_196831) * (int64_t) 8,
                        (int64_t) 8);
        }
    }
    
    int64_t min_res_196862 = smin64(q_s_196695, defunc_0_f_res_196740);
    bool bounds_invalid_upwards_196863 = slt64(s_n_m_196745, (int64_t) 0);
    bool valid_196864 = !bounds_invalid_upwards_196863;
    bool range_valid_c_196865;
    
    if (!valid_196864) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) s_n_m_196745, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:442:3-469:10\n   #4  loess.fut:516:15-50\n   #5  stl.fut:142:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:141:12-143:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:140:5-144:36\n   #12 stl.fut:401:3-415:29\n   #13 stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool loop_cond_196867 = slt64((int64_t) 1, min_res_196862);
    float i64_res_196868 = sitofp_i64_f32(q_s_196695);
    int64_t binop_x_201701 = s_n_m_196745 * binop_x_201457;
    int64_t binop_y_201702 = (int64_t) 8 * binop_x_201701;
    int64_t bytes_201703 = smax64((int64_t) 0, binop_y_201702);
    
    if (mem_201704_cached_sizze_206667 < (size_t) bytes_201703) {
        mem_201704 = realloc(mem_201704, bytes_201703);
        mem_201704_cached_sizze_206667 = bytes_201703;
    }
    
    int64_t binop_y_201707 = (int64_t) 4 * binop_x_201701;
    int64_t bytes_201708 = smax64((int64_t) 0, binop_y_201707);
    
    if (mem_201709_cached_sizze_206668 < (size_t) bytes_201708) {
        mem_201709 = realloc(mem_201709, bytes_201708);
        mem_201709_cached_sizze_206668 = bytes_201708;
    }
    
    int64_t ctx_val_201733 = n_p_196694 * s_n_m_196745;
    int64_t binop_y_201768 = (int64_t) 8 * defunc_0_f_res_196740;
    int64_t bytes_201769 = smax64((int64_t) 0, binop_y_201768);
    
    if (mem_201770_cached_sizze_206669 < (size_t) bytes_201769) {
        mem_201770 = realloc(mem_201770, bytes_201769);
        mem_201770_cached_sizze_206669 = bytes_201769;
    }
    for (int64_t i_200038 = 0; i_200038 < m_196691; i_200038++) {
        for (int64_t i_200031 = 0; i_200031 < n_p_196694; i_200031++) {
            int64_t x_196876;
            
            x_196876 = ((int64_t *) mem_201557)[i_200038 * n_p_196694 +
                                                i_200031];
            for (int64_t i_200018 = 0; i_200018 < defunc_0_f_res_196740;
                 i_200018++) {
                int64_t x_196878;
                
                x_196878 = ((int64_t *) mem_201553)[i_200038 * ctx_val_201474 +
                                                    i_200031 *
                                                    defunc_0_f_res_196740 +
                                                    i_200018];
                
                int64_t defunc_0_f_res_196879 = add64((int64_t) 1, x_196878);
                
                ((int64_t *) mem_201770)[i_200018] = defunc_0_f_res_196879;
            }
            
            int64_t min_arg_196880 = sub64(x_196876, (int64_t) 1);
            int64_t min_arg_196881 = sub64(x_196876, min_res_196862);
            int64_t min_res_196882 = smin64(q_s_196695, x_196876);
            float i64_res_196883 = sitofp_i64_f32(x_196876);
            float x_196884 = i64_res_196868 - i64_res_196883;
            float max_arg_196885 = x_196884 / 2.0F;
            float max_res_196886 = fmax32(0.0F, max_arg_196885);
            
            for (int64_t i_200024 = 0; i_200024 < s_n_m_196745; i_200024++) {
                bool cond_196890 = i_200024 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_196891;
                
                if (cond_196890) {
                    defunc_0_m_fun_res_196891 = (int64_t) 0;
                } else {
                    int64_t y_196892 = sub64(s_n_m_196745, (int64_t) 1);
                    bool cond_196893 = i_200024 == y_196892;
                    int64_t defunc_0_m_fun_res_f_res_196894;
                    
                    if (cond_196893) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_196895 =
                                sub64(pad_css_len_196741, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_196894 =
                            defunc_0_m_fun_res_f_res_t_res_196895;
                    } else {
                        int64_t x_196896 = sub64(i_200024, (int64_t) 1);
                        int64_t x_196897 = mul64(jump_s_196701, x_196896);
                        int64_t min_arg_196898 = add64((int64_t) 1, x_196897);
                        int64_t min_res_196899 = smin64(defunc_0_f_res_196740,
                                                        min_arg_196898);
                        
                        defunc_0_m_fun_res_f_res_196894 = min_res_196899;
                    }
                    defunc_0_m_fun_res_196891 = defunc_0_m_fun_res_f_res_196894;
                }
                
                bool init_idx_196900;
                int64_t init_idx_196901;
                int64_t init_idx_196902;
                bool loop_while_196903;
                int64_t low_196904;
                int64_t high_196905;
                
                loop_while_196903 = x_196832;
                low_196904 = (int64_t) 0;
                high_196905 = i_196831;
                while (loop_while_196903) {
                    int64_t x_196906 = add64(low_196904, high_196905);
                    int64_t mid_196907 = sdiv64(x_196906, (int64_t) 2);
                    bool x_196908 = sle64((int64_t) 0, mid_196907);
                    bool y_196909 = slt64(mid_196907, defunc_0_f_res_196740);
                    bool bounds_check_196910 = x_196908 && y_196909;
                    bool index_certs_196911;
                    
                    if (!bounds_check_196910) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) mid_196907,
                                      "] out of bounds for array of shape [",
                                      (long long) defunc_0_f_res_196740, "].",
                                      "-> #0  loess.fut:449:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:516:15-50\n   #6  stl.fut:142:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:141:12-143:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:140:5-144:36\n   #13 stl.fut:401:3-415:29\n   #14 stl.fut:385:1-415:29\n");
                        if (memblock_unref(ctx, &mem_out_206309,
                                           "mem_out_206309") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_206308,
                                           "mem_out_206308") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_206307,
                                           "mem_out_206307") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t mid_id_196912;
                    
                    mid_id_196912 = ((int64_t *) mem_201770)[mid_196907];
                    
                    bool cond_196913 = slt64(mid_id_196912, (int64_t) 0);
                    int64_t mid_idx_196914;
                    
                    if (cond_196913) {
                        mid_idx_196914 = (int64_t) 9223372036854775807;
                    } else {
                        mid_idx_196914 = mid_id_196912;
                    }
                    
                    bool cond_196915 = sle64(defunc_0_m_fun_res_196891,
                                             mid_idx_196914);
                    int64_t loopres_196916;
                    int64_t loopres_196917;
                    
                    if (cond_196915) {
                        int64_t loopres_t_res_196918 = sub64(mid_196907,
                                                             (int64_t) 1);
                        
                        loopres_196916 = low_196904;
                        loopres_196917 = loopres_t_res_196918;
                    } else {
                        int64_t loopres_f_res_196919 = add64((int64_t) 1,
                                                             mid_196907);
                        
                        loopres_196916 = loopres_f_res_196919;
                        loopres_196917 = high_196905;
                    }
                    
                    bool loop_cond_196920 = sle64(loopres_196916,
                                                  loopres_196917);
                    bool loop_while_tmp_206334 = loop_cond_196920;
                    int64_t low_tmp_206335 = loopres_196916;
                    int64_t high_tmp_206336 = loopres_196917;
                    
                    loop_while_196903 = loop_while_tmp_206334;
                    low_196904 = low_tmp_206335;
                    high_196905 = high_tmp_206336;
                }
                init_idx_196900 = loop_while_196903;
                init_idx_196901 = low_196904;
                init_idx_196902 = high_196905;
                
                bool idx_196921;
                int64_t idx_196922;
                int64_t idx_196923;
                int64_t idx_196924;
                bool loop_while_196925;
                int64_t l_idx_196926;
                int64_t r_idx_196927;
                int64_t span_196928;
                
                loop_while_196925 = loop_cond_196867;
                l_idx_196926 = init_idx_196901;
                r_idx_196927 = init_idx_196901;
                span_196928 = (int64_t) 1;
                while (loop_while_196925) {
                    int64_t max_arg_196929 = sub64(l_idx_196926, (int64_t) 1);
                    int64_t max_res_196930 = smax64((int64_t) 0,
                                                    max_arg_196929);
                    int64_t min_arg_196931 = add64((int64_t) 1, r_idx_196927);
                    int64_t min_res_196932 = smin64(min_arg_196880,
                                                    min_arg_196931);
                    bool x_196933 = sle64((int64_t) 0, max_res_196930);
                    bool y_196934 = slt64(max_res_196930,
                                          defunc_0_f_res_196740);
                    bool bounds_check_196935 = x_196933 && y_196934;
                    bool index_certs_196936;
                    
                    if (!bounds_check_196935) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) max_res_196930,
                                      "] out of bounds for array of shape [",
                                      (long long) defunc_0_f_res_196740, "].",
                                      "-> #0  loess.fut:459:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:516:15-50\n   #6  stl.fut:142:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:141:12-143:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:140:5-144:36\n   #13 stl.fut:401:3-415:29\n   #14 stl.fut:385:1-415:29\n");
                        if (memblock_unref(ctx, &mem_out_206309,
                                           "mem_out_206309") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_206308,
                                           "mem_out_206308") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_206307,
                                           "mem_out_206307") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_196937;
                    
                    x_196937 = ((int64_t *) mem_201770)[max_res_196930];
                    
                    int64_t abs_arg_196938 = sub64(x_196937,
                                                   defunc_0_m_fun_res_196891);
                    int64_t abs_res_196939 = abs64(abs_arg_196938);
                    bool x_196940 = sle64((int64_t) 0, min_res_196932);
                    bool y_196941 = slt64(min_res_196932,
                                          defunc_0_f_res_196740);
                    bool bounds_check_196942 = x_196940 && y_196941;
                    bool index_certs_196943;
                    
                    if (!bounds_check_196942) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) min_res_196932,
                                      "] out of bounds for array of shape [",
                                      (long long) defunc_0_f_res_196740, "].",
                                      "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:516:15-50\n   #6  stl.fut:142:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:141:12-143:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:140:5-144:36\n   #13 stl.fut:401:3-415:29\n   #14 stl.fut:385:1-415:29\n");
                        if (memblock_unref(ctx, &mem_out_206309,
                                           "mem_out_206309") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_206308,
                                           "mem_out_206308") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_206307,
                                           "mem_out_206307") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_196944;
                    
                    x_196944 = ((int64_t *) mem_201770)[min_res_196932];
                    
                    int64_t abs_arg_196945 = sub64(x_196944,
                                                   defunc_0_m_fun_res_196891);
                    int64_t abs_res_196946 = abs64(abs_arg_196945);
                    bool cond_196947 = max_res_196930 == l_idx_196926;
                    int64_t loopres_196948;
                    int64_t loopres_196949;
                    int64_t loopres_196950;
                    
                    if (cond_196947) {
                        loopres_196948 = l_idx_196926;
                        loopres_196949 = r_idx_196927;
                        loopres_196950 = min_res_196862;
                    } else {
                        bool cond_196951 = slt64(abs_res_196939,
                                                 abs_res_196946);
                        bool cond_f_res_196952 = min_res_196932 == r_idx_196927;
                        bool x_196953 = !cond_196951;
                        bool y_196954 = cond_f_res_196952 && x_196953;
                        bool cond_196955 = cond_196951 || y_196954;
                        int64_t loopres_f_res_196956;
                        
                        if (cond_196955) {
                            loopres_f_res_196956 = max_res_196930;
                        } else {
                            loopres_f_res_196956 = l_idx_196926;
                        }
                        
                        int64_t loopres_f_res_196957;
                        
                        if (cond_196955) {
                            loopres_f_res_196957 = r_idx_196927;
                        } else {
                            loopres_f_res_196957 = min_res_196932;
                        }
                        
                        int64_t loopres_f_res_196958;
                        
                        if (cond_196955) {
                            int64_t loopres_f_res_t_res_196959 =
                                    add64((int64_t) 1, span_196928);
                            
                            loopres_f_res_196958 = loopres_f_res_t_res_196959;
                        } else {
                            int64_t loopres_f_res_f_res_196960 =
                                    add64((int64_t) 1, span_196928);
                            
                            loopres_f_res_196958 = loopres_f_res_f_res_196960;
                        }
                        loopres_196948 = loopres_f_res_196956;
                        loopres_196949 = loopres_f_res_196957;
                        loopres_196950 = loopres_f_res_196958;
                    }
                    
                    bool loop_cond_196961 = slt64(loopres_196950,
                                                  min_res_196862);
                    bool loop_while_tmp_206337 = loop_cond_196961;
                    int64_t l_idx_tmp_206338 = loopres_196948;
                    int64_t r_idx_tmp_206339 = loopres_196949;
                    int64_t span_tmp_206340 = loopres_196950;
                    
                    loop_while_196925 = loop_while_tmp_206337;
                    l_idx_196926 = l_idx_tmp_206338;
                    r_idx_196927 = r_idx_tmp_206339;
                    span_196928 = span_tmp_206340;
                }
                idx_196921 = loop_while_196925;
                idx_196922 = l_idx_196926;
                idx_196923 = r_idx_196927;
                idx_196924 = span_196928;
                
                int64_t min_res_196962 = smin64(min_arg_196881, idx_196922);
                int64_t max_res_196963 = smax64((int64_t) 0, min_res_196962);
                int64_t defunc_0_m_fun_res_196964;
                
                if (cond_196890) {
                    defunc_0_m_fun_res_196964 = (int64_t) 0;
                } else {
                    int64_t y_196965 = sub64(s_n_m_196745, (int64_t) 1);
                    bool cond_196966 = i_200024 == y_196965;
                    int64_t defunc_0_m_fun_res_f_res_196967;
                    
                    if (cond_196966) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_196968 =
                                sub64(pad_css_len_196741, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_196967 =
                            defunc_0_m_fun_res_f_res_t_res_196968;
                    } else {
                        int64_t x_196969 = sub64(i_200024, (int64_t) 1);
                        int64_t x_196970 = mul64(jump_s_196701, x_196969);
                        int64_t min_arg_196971 = add64((int64_t) 1, x_196970);
                        int64_t min_res_196972 = smin64(defunc_0_f_res_196740,
                                                        min_arg_196971);
                        
                        defunc_0_m_fun_res_f_res_196967 = min_res_196972;
                    }
                    defunc_0_m_fun_res_196964 = defunc_0_m_fun_res_f_res_196967;
                }
                
                int64_t x_196973 = add64(min_res_196882, max_res_196963);
                int64_t r_196974 = sub64(x_196973, (int64_t) 1);
                bool x_196975 = sle64((int64_t) 0, r_196974);
                bool y_196976 = slt64(r_196974, defunc_0_f_res_196740);
                bool bounds_check_196977 = x_196975 && y_196976;
                bool index_certs_196978;
                
                if (!bounds_check_196977) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) r_196974,
                                  "] out of bounds for array of shape [",
                                  (long long) defunc_0_f_res_196740, "].",
                                  "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:517:16-54\n   #5  stl.fut:142:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:141:12-143:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:140:5-144:36\n   #12 stl.fut:401:3-415:29\n   #13 stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_196979;
                
                x_196979 = ((int64_t *) mem_201770)[r_196974];
                
                int64_t abs_arg_196980 = sub64(x_196979,
                                               defunc_0_m_fun_res_196964);
                int64_t abs_res_196981 = abs64(abs_arg_196980);
                bool x_196982 = sle64((int64_t) 0, max_res_196963);
                bool y_196983 = slt64(max_res_196963, defunc_0_f_res_196740);
                bool bounds_check_196984 = x_196982 && y_196983;
                bool index_certs_196985;
                
                if (!bounds_check_196984) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_196963,
                                  "] out of bounds for array of shape [",
                                  (long long) defunc_0_f_res_196740, "].",
                                  "-> #0  loess.fut:483:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:517:16-54\n   #5  stl.fut:142:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:141:12-143:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:140:5-144:36\n   #12 stl.fut:401:3-415:29\n   #13 stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_196986;
                
                x_196986 = ((int64_t *) mem_201770)[max_res_196963];
                
                int64_t abs_arg_196987 = sub64(x_196986,
                                               defunc_0_m_fun_res_196964);
                int64_t abs_res_196988 = abs64(abs_arg_196987);
                int64_t max_res_196989 = smax64(abs_res_196981, abs_res_196988);
                float defunc_0_f_res_196990 = sitofp_i64_f32(max_res_196989);
                float defunc_1_f_res_196991 = max_res_196886 +
                      defunc_0_f_res_196990;
                
                ((float *) mem_201709)[i_200038 * ctx_val_201733 + i_200031 *
                                       s_n_m_196745 + i_200024] =
                    defunc_1_f_res_196991;
                ((int64_t *) mem_201704)[i_200038 * ctx_val_201733 + i_200031 *
                                         s_n_m_196745 + i_200024] =
                    max_res_196963;
            }
        }
    }
    
    int64_t min_res_196994 = smin64(n_196692, q_l_196697);
    bool bounds_invalid_upwards_196995 = slt64(l_n_m_196752, (int64_t) 0);
    bool valid_196996 = !bounds_invalid_upwards_196995;
    bool range_valid_c_196997;
    
    if (!valid_196996) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) l_n_m_196752, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:442:3-469:10\n   #4  loess.fut:502:15-61\n   #5  stl.fut:150:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:148:5-151:26\n   #9  stl.fut:401:3-415:29\n   #10 stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool loop_cond_196999 = slt64((int64_t) 1, min_res_196994);
    float i64_res_197000 = sitofp_i64_f32(q_l_196697);
    int64_t binop_x_201899 = m_196691 * l_n_m_196752;
    int64_t binop_y_201900 = (int64_t) 8 * binop_x_201899;
    int64_t bytes_201901 = smax64((int64_t) 0, binop_y_201900);
    
    if (mem_201902_cached_sizze_206670 < (size_t) bytes_201901) {
        mem_201902 = realloc(mem_201902, bytes_201901);
        mem_201902_cached_sizze_206670 = bytes_201901;
    }
    
    int64_t binop_y_201904 = (int64_t) 4 * binop_x_201899;
    int64_t bytes_201905 = smax64((int64_t) 0, binop_y_201904);
    
    if (mem_201906_cached_sizze_206671 < (size_t) bytes_201905) {
        mem_201906 = realloc(mem_201906, bytes_201905);
        mem_201906_cached_sizze_206671 = bytes_201905;
    }
    
    int64_t binop_y_201927 = (int64_t) 8 * n_196692;
    int64_t bytes_201928 = smax64((int64_t) 0, binop_y_201927);
    
    if (mem_201929_cached_sizze_206672 < (size_t) bytes_201928) {
        mem_201929 = realloc(mem_201929, bytes_201928);
        mem_201929_cached_sizze_206672 = bytes_201928;
    }
    for (int64_t i_200056 = 0; i_200056 < m_196691; i_200056++) {
        int64_t x_197004;
        
        x_197004 = ((int64_t *) mem_201389)[i_200056];
        for (int64_t i_200043 = 0; i_200043 < n_196692; i_200043++) {
            int64_t x_197006;
            
            x_197006 = ((int64_t *) mem_201386)[i_200056 * n_196692 + i_200043];
            
            int64_t defunc_0_f_res_197007 = add64((int64_t) 1, x_197006);
            
            ((int64_t *) mem_201929)[i_200043] = defunc_0_f_res_197007;
        }
        
        int64_t min_arg_197008 = sub64(x_197004, (int64_t) 1);
        int64_t min_arg_197009 = sub64(x_197004, min_res_196994);
        int64_t min_res_197010 = smin64(q_l_196697, x_197004);
        float i64_res_197011 = sitofp_i64_f32(x_197004);
        float x_197012 = i64_res_197000 - i64_res_197011;
        float max_arg_197013 = x_197012 / 2.0F;
        float max_res_197014 = fmax32(0.0F, max_arg_197013);
        
        for (int64_t i_200049 = 0; i_200049 < l_n_m_196752; i_200049++) {
            int64_t min_arg_197018 = mul64(jump_l_196703, i_200049);
            int64_t min_res_197019 = smin64(i_196779, min_arg_197018);
            int64_t defunc_0_g_res_197020 = add64((int64_t) 1, min_res_197019);
            bool init_idx_197021;
            int64_t init_idx_197022;
            int64_t init_idx_197023;
            bool loop_while_197024;
            int64_t low_197025;
            int64_t high_197026;
            
            loop_while_197024 = x_196780;
            low_197025 = (int64_t) 0;
            high_197026 = i_196779;
            while (loop_while_197024) {
                int64_t x_197027 = add64(low_197025, high_197026);
                int64_t mid_197028 = sdiv64(x_197027, (int64_t) 2);
                bool x_197029 = sle64((int64_t) 0, mid_197028);
                bool y_197030 = slt64(mid_197028, n_196692);
                bool bounds_check_197031 = x_197029 && y_197030;
                bool index_certs_197032;
                
                if (!bounds_check_197031) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) mid_197028,
                                  "] out of bounds for array of shape [",
                                  (long long) n_196692, "].",
                                  "-> #0  loess.fut:449:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  stl.fut:150:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:148:5-151:26\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t mid_id_197033;
                
                mid_id_197033 = ((int64_t *) mem_201929)[mid_197028];
                
                bool cond_197034 = slt64(mid_id_197033, (int64_t) 0);
                int64_t mid_idx_197035;
                
                if (cond_197034) {
                    mid_idx_197035 = (int64_t) 9223372036854775807;
                } else {
                    mid_idx_197035 = mid_id_197033;
                }
                
                bool cond_197036 = sle64(defunc_0_g_res_197020, mid_idx_197035);
                int64_t loopres_197037;
                int64_t loopres_197038;
                
                if (cond_197036) {
                    int64_t loopres_t_res_197039 = sub64(mid_197028,
                                                         (int64_t) 1);
                    
                    loopres_197037 = low_197025;
                    loopres_197038 = loopres_t_res_197039;
                } else {
                    int64_t loopres_f_res_197040 = add64((int64_t) 1,
                                                         mid_197028);
                    
                    loopres_197037 = loopres_f_res_197040;
                    loopres_197038 = high_197026;
                }
                
                bool loop_cond_197041 = sle64(loopres_197037, loopres_197038);
                bool loop_while_tmp_206346 = loop_cond_197041;
                int64_t low_tmp_206347 = loopres_197037;
                int64_t high_tmp_206348 = loopres_197038;
                
                loop_while_197024 = loop_while_tmp_206346;
                low_197025 = low_tmp_206347;
                high_197026 = high_tmp_206348;
            }
            init_idx_197021 = loop_while_197024;
            init_idx_197022 = low_197025;
            init_idx_197023 = high_197026;
            
            bool idx_197042;
            int64_t idx_197043;
            int64_t idx_197044;
            int64_t idx_197045;
            bool loop_while_197046;
            int64_t l_idx_197047;
            int64_t r_idx_197048;
            int64_t span_197049;
            
            loop_while_197046 = loop_cond_196999;
            l_idx_197047 = init_idx_197022;
            r_idx_197048 = init_idx_197022;
            span_197049 = (int64_t) 1;
            while (loop_while_197046) {
                int64_t max_arg_197050 = sub64(l_idx_197047, (int64_t) 1);
                int64_t max_res_197051 = smax64((int64_t) 0, max_arg_197050);
                int64_t min_arg_197052 = add64((int64_t) 1, r_idx_197048);
                int64_t min_res_197053 = smin64(min_arg_197008, min_arg_197052);
                bool x_197054 = sle64((int64_t) 0, max_res_197051);
                bool y_197055 = slt64(max_res_197051, n_196692);
                bool bounds_check_197056 = x_197054 && y_197055;
                bool index_certs_197057;
                
                if (!bounds_check_197056) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_197051,
                                  "] out of bounds for array of shape [",
                                  (long long) n_196692, "].",
                                  "-> #0  loess.fut:459:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  stl.fut:150:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:148:5-151:26\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_197058;
                
                x_197058 = ((int64_t *) mem_201929)[max_res_197051];
                
                int64_t abs_arg_197059 = sub64(x_197058, defunc_0_g_res_197020);
                int64_t abs_res_197060 = abs64(abs_arg_197059);
                bool x_197061 = sle64((int64_t) 0, min_res_197053);
                bool y_197062 = slt64(min_res_197053, n_196692);
                bool bounds_check_197063 = x_197061 && y_197062;
                bool index_certs_197064;
                
                if (!bounds_check_197063) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) min_res_197053,
                                  "] out of bounds for array of shape [",
                                  (long long) n_196692, "].",
                                  "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  stl.fut:150:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:148:5-151:26\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_197065;
                
                x_197065 = ((int64_t *) mem_201929)[min_res_197053];
                
                int64_t abs_arg_197066 = sub64(x_197065, defunc_0_g_res_197020);
                int64_t abs_res_197067 = abs64(abs_arg_197066);
                bool cond_197068 = max_res_197051 == l_idx_197047;
                int64_t loopres_197069;
                int64_t loopres_197070;
                int64_t loopres_197071;
                
                if (cond_197068) {
                    loopres_197069 = l_idx_197047;
                    loopres_197070 = r_idx_197048;
                    loopres_197071 = min_res_196994;
                } else {
                    bool cond_197072 = slt64(abs_res_197060, abs_res_197067);
                    bool cond_f_res_197073 = min_res_197053 == r_idx_197048;
                    bool x_197074 = !cond_197072;
                    bool y_197075 = cond_f_res_197073 && x_197074;
                    bool cond_197076 = cond_197072 || y_197075;
                    int64_t loopres_f_res_197077;
                    
                    if (cond_197076) {
                        loopres_f_res_197077 = max_res_197051;
                    } else {
                        loopres_f_res_197077 = l_idx_197047;
                    }
                    
                    int64_t loopres_f_res_197078;
                    
                    if (cond_197076) {
                        loopres_f_res_197078 = r_idx_197048;
                    } else {
                        loopres_f_res_197078 = min_res_197053;
                    }
                    
                    int64_t loopres_f_res_197079;
                    
                    if (cond_197076) {
                        int64_t loopres_f_res_t_res_197080 = add64((int64_t) 1,
                                                                   span_197049);
                        
                        loopres_f_res_197079 = loopres_f_res_t_res_197080;
                    } else {
                        int64_t loopres_f_res_f_res_197081 = add64((int64_t) 1,
                                                                   span_197049);
                        
                        loopres_f_res_197079 = loopres_f_res_f_res_197081;
                    }
                    loopres_197069 = loopres_f_res_197077;
                    loopres_197070 = loopres_f_res_197078;
                    loopres_197071 = loopres_f_res_197079;
                }
                
                bool loop_cond_197082 = slt64(loopres_197071, min_res_196994);
                bool loop_while_tmp_206349 = loop_cond_197082;
                int64_t l_idx_tmp_206350 = loopres_197069;
                int64_t r_idx_tmp_206351 = loopres_197070;
                int64_t span_tmp_206352 = loopres_197071;
                
                loop_while_197046 = loop_while_tmp_206349;
                l_idx_197047 = l_idx_tmp_206350;
                r_idx_197048 = r_idx_tmp_206351;
                span_197049 = span_tmp_206352;
            }
            idx_197042 = loop_while_197046;
            idx_197043 = l_idx_197047;
            idx_197044 = r_idx_197048;
            idx_197045 = span_197049;
            
            int64_t min_res_197083 = smin64(min_arg_197009, idx_197043);
            int64_t max_res_197084 = smax64((int64_t) 0, min_res_197083);
            int64_t x_197085 = add64(min_res_197010, max_res_197084);
            int64_t r_197086 = sub64(x_197085, (int64_t) 1);
            bool x_197087 = sle64((int64_t) 0, r_197086);
            bool y_197088 = slt64(r_197086, n_196692);
            bool bounds_check_197089 = x_197087 && y_197088;
            bool index_certs_197090;
            
            if (!bounds_check_197089) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) r_197086,
                              "] out of bounds for array of shape [",
                              (long long) n_196692, "].",
                              "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  stl.fut:150:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:148:5-151:26\n   #9  stl.fut:401:3-415:29\n   #10 stl.fut:385:1-415:29\n");
                if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t x_197091;
            
            x_197091 = ((int64_t *) mem_201386)[i_200056 * n_196692 + r_197086];
            
            int64_t abs_arg_197092 = sub64(x_197091, min_res_197019);
            int64_t abs_res_197093 = abs64(abs_arg_197092);
            bool x_197094 = sle64((int64_t) 0, max_res_197084);
            bool y_197095 = slt64(max_res_197084, n_196692);
            bool bounds_check_197096 = x_197094 && y_197095;
            bool index_certs_197097;
            
            if (!bounds_check_197096) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) max_res_197084,
                              "] out of bounds for array of shape [",
                              (long long) n_196692, "].",
                              "-> #0  loess.fut:483:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  stl.fut:150:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:148:5-151:26\n   #9  stl.fut:401:3-415:29\n   #10 stl.fut:385:1-415:29\n");
                if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t x_197098;
            
            x_197098 = ((int64_t *) mem_201386)[i_200056 * n_196692 +
                                                max_res_197084];
            
            int64_t abs_arg_197099 = sub64(x_197098, min_res_197019);
            int64_t abs_res_197100 = abs64(abs_arg_197099);
            int64_t max_res_197101 = smax64(abs_res_197093, abs_res_197100);
            float defunc_0_f_res_197102 = sitofp_i64_f32(max_res_197101);
            float defunc_1_f_res_197103 = max_res_197014 +
                  defunc_0_f_res_197102;
            
            ((float *) mem_201906)[i_200056 * l_n_m_196752 + i_200049] =
                defunc_1_f_res_197103;
            ((int64_t *) mem_201902)[i_200056 * l_n_m_196752 + i_200049] =
                max_res_197084;
        }
    }
    
    int64_t min_res_197106 = smin64(n_196692, q_t_196696);
    bool bounds_invalid_upwards_197107 = slt64(t_n_m_196759, (int64_t) 0);
    bool valid_197108 = !bounds_invalid_upwards_197107;
    bool range_valid_c_197109;
    
    if (!valid_197108) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) t_n_m_196759, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:442:3-469:10\n   #4  loess.fut:502:15-61\n   #5  stl.fut:157:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:155:5-158:26\n   #9  stl.fut:401:3-415:29\n   #10 stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool loop_cond_197111 = slt64((int64_t) 1, min_res_197106);
    float i64_res_197112 = sitofp_i64_f32(q_t_196696);
    int64_t binop_x_202002 = m_196691 * t_n_m_196759;
    int64_t binop_y_202003 = (int64_t) 8 * binop_x_202002;
    int64_t bytes_202004 = smax64((int64_t) 0, binop_y_202003);
    
    if (mem_202005_cached_sizze_206673 < (size_t) bytes_202004) {
        mem_202005 = realloc(mem_202005, bytes_202004);
        mem_202005_cached_sizze_206673 = bytes_202004;
    }
    
    int64_t binop_y_202007 = (int64_t) 4 * binop_x_202002;
    int64_t bytes_202008 = smax64((int64_t) 0, binop_y_202007);
    
    if (mem_202009_cached_sizze_206674 < (size_t) bytes_202008) {
        mem_202009 = realloc(mem_202009, bytes_202008);
        mem_202009_cached_sizze_206674 = bytes_202008;
    }
    
    int64_t binop_y_202030 = (int64_t) 8 * n_196692;
    int64_t bytes_202031 = smax64((int64_t) 0, binop_y_202030);
    
    if (mem_202032_cached_sizze_206675 < (size_t) bytes_202031) {
        mem_202032 = realloc(mem_202032, bytes_202031);
        mem_202032_cached_sizze_206675 = bytes_202031;
    }
    for (int64_t i_200074 = 0; i_200074 < m_196691; i_200074++) {
        int64_t x_197116;
        
        x_197116 = ((int64_t *) mem_201389)[i_200074];
        for (int64_t i_200061 = 0; i_200061 < n_196692; i_200061++) {
            int64_t x_197118;
            
            x_197118 = ((int64_t *) mem_201386)[i_200074 * n_196692 + i_200061];
            
            int64_t defunc_0_f_res_197119 = add64((int64_t) 1, x_197118);
            
            ((int64_t *) mem_202032)[i_200061] = defunc_0_f_res_197119;
        }
        
        int64_t min_arg_197120 = sub64(x_197116, (int64_t) 1);
        int64_t min_arg_197121 = sub64(x_197116, min_res_197106);
        int64_t min_res_197122 = smin64(q_t_196696, x_197116);
        float i64_res_197123 = sitofp_i64_f32(x_197116);
        float x_197124 = i64_res_197112 - i64_res_197123;
        float max_arg_197125 = x_197124 / 2.0F;
        float max_res_197126 = fmax32(0.0F, max_arg_197125);
        
        for (int64_t i_200067 = 0; i_200067 < t_n_m_196759; i_200067++) {
            int64_t min_arg_197130 = mul64(jump_t_196702, i_200067);
            int64_t min_res_197131 = smin64(i_196779, min_arg_197130);
            int64_t defunc_0_g_res_197132 = add64((int64_t) 1, min_res_197131);
            bool init_idx_197133;
            int64_t init_idx_197134;
            int64_t init_idx_197135;
            bool loop_while_197136;
            int64_t low_197137;
            int64_t high_197138;
            
            loop_while_197136 = x_196780;
            low_197137 = (int64_t) 0;
            high_197138 = i_196779;
            while (loop_while_197136) {
                int64_t x_197139 = add64(low_197137, high_197138);
                int64_t mid_197140 = sdiv64(x_197139, (int64_t) 2);
                bool x_197141 = sle64((int64_t) 0, mid_197140);
                bool y_197142 = slt64(mid_197140, n_196692);
                bool bounds_check_197143 = x_197141 && y_197142;
                bool index_certs_197144;
                
                if (!bounds_check_197143) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) mid_197140,
                                  "] out of bounds for array of shape [",
                                  (long long) n_196692, "].",
                                  "-> #0  loess.fut:449:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  stl.fut:157:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:155:5-158:26\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t mid_id_197145;
                
                mid_id_197145 = ((int64_t *) mem_202032)[mid_197140];
                
                bool cond_197146 = slt64(mid_id_197145, (int64_t) 0);
                int64_t mid_idx_197147;
                
                if (cond_197146) {
                    mid_idx_197147 = (int64_t) 9223372036854775807;
                } else {
                    mid_idx_197147 = mid_id_197145;
                }
                
                bool cond_197148 = sle64(defunc_0_g_res_197132, mid_idx_197147);
                int64_t loopres_197149;
                int64_t loopres_197150;
                
                if (cond_197148) {
                    int64_t loopres_t_res_197151 = sub64(mid_197140,
                                                         (int64_t) 1);
                    
                    loopres_197149 = low_197137;
                    loopres_197150 = loopres_t_res_197151;
                } else {
                    int64_t loopres_f_res_197152 = add64((int64_t) 1,
                                                         mid_197140);
                    
                    loopres_197149 = loopres_f_res_197152;
                    loopres_197150 = high_197138;
                }
                
                bool loop_cond_197153 = sle64(loopres_197149, loopres_197150);
                bool loop_while_tmp_206358 = loop_cond_197153;
                int64_t low_tmp_206359 = loopres_197149;
                int64_t high_tmp_206360 = loopres_197150;
                
                loop_while_197136 = loop_while_tmp_206358;
                low_197137 = low_tmp_206359;
                high_197138 = high_tmp_206360;
            }
            init_idx_197133 = loop_while_197136;
            init_idx_197134 = low_197137;
            init_idx_197135 = high_197138;
            
            bool idx_197154;
            int64_t idx_197155;
            int64_t idx_197156;
            int64_t idx_197157;
            bool loop_while_197158;
            int64_t l_idx_197159;
            int64_t r_idx_197160;
            int64_t span_197161;
            
            loop_while_197158 = loop_cond_197111;
            l_idx_197159 = init_idx_197134;
            r_idx_197160 = init_idx_197134;
            span_197161 = (int64_t) 1;
            while (loop_while_197158) {
                int64_t max_arg_197162 = sub64(l_idx_197159, (int64_t) 1);
                int64_t max_res_197163 = smax64((int64_t) 0, max_arg_197162);
                int64_t min_arg_197164 = add64((int64_t) 1, r_idx_197160);
                int64_t min_res_197165 = smin64(min_arg_197120, min_arg_197164);
                bool x_197166 = sle64((int64_t) 0, max_res_197163);
                bool y_197167 = slt64(max_res_197163, n_196692);
                bool bounds_check_197168 = x_197166 && y_197167;
                bool index_certs_197169;
                
                if (!bounds_check_197168) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_197163,
                                  "] out of bounds for array of shape [",
                                  (long long) n_196692, "].",
                                  "-> #0  loess.fut:459:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  stl.fut:157:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:155:5-158:26\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_197170;
                
                x_197170 = ((int64_t *) mem_202032)[max_res_197163];
                
                int64_t abs_arg_197171 = sub64(x_197170, defunc_0_g_res_197132);
                int64_t abs_res_197172 = abs64(abs_arg_197171);
                bool x_197173 = sle64((int64_t) 0, min_res_197165);
                bool y_197174 = slt64(min_res_197165, n_196692);
                bool bounds_check_197175 = x_197173 && y_197174;
                bool index_certs_197176;
                
                if (!bounds_check_197175) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) min_res_197165,
                                  "] out of bounds for array of shape [",
                                  (long long) n_196692, "].",
                                  "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:442:3-469:10\n   #5  loess.fut:502:15-61\n   #6  stl.fut:157:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:155:5-158:26\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_197177;
                
                x_197177 = ((int64_t *) mem_202032)[min_res_197165];
                
                int64_t abs_arg_197178 = sub64(x_197177, defunc_0_g_res_197132);
                int64_t abs_res_197179 = abs64(abs_arg_197178);
                bool cond_197180 = max_res_197163 == l_idx_197159;
                int64_t loopres_197181;
                int64_t loopres_197182;
                int64_t loopres_197183;
                
                if (cond_197180) {
                    loopres_197181 = l_idx_197159;
                    loopres_197182 = r_idx_197160;
                    loopres_197183 = min_res_197106;
                } else {
                    bool cond_197184 = slt64(abs_res_197172, abs_res_197179);
                    bool cond_f_res_197185 = min_res_197165 == r_idx_197160;
                    bool x_197186 = !cond_197184;
                    bool y_197187 = cond_f_res_197185 && x_197186;
                    bool cond_197188 = cond_197184 || y_197187;
                    int64_t loopres_f_res_197189;
                    
                    if (cond_197188) {
                        loopres_f_res_197189 = max_res_197163;
                    } else {
                        loopres_f_res_197189 = l_idx_197159;
                    }
                    
                    int64_t loopres_f_res_197190;
                    
                    if (cond_197188) {
                        loopres_f_res_197190 = r_idx_197160;
                    } else {
                        loopres_f_res_197190 = min_res_197165;
                    }
                    
                    int64_t loopres_f_res_197191;
                    
                    if (cond_197188) {
                        int64_t loopres_f_res_t_res_197192 = add64((int64_t) 1,
                                                                   span_197161);
                        
                        loopres_f_res_197191 = loopres_f_res_t_res_197192;
                    } else {
                        int64_t loopres_f_res_f_res_197193 = add64((int64_t) 1,
                                                                   span_197161);
                        
                        loopres_f_res_197191 = loopres_f_res_f_res_197193;
                    }
                    loopres_197181 = loopres_f_res_197189;
                    loopres_197182 = loopres_f_res_197190;
                    loopres_197183 = loopres_f_res_197191;
                }
                
                bool loop_cond_197194 = slt64(loopres_197183, min_res_197106);
                bool loop_while_tmp_206361 = loop_cond_197194;
                int64_t l_idx_tmp_206362 = loopres_197181;
                int64_t r_idx_tmp_206363 = loopres_197182;
                int64_t span_tmp_206364 = loopres_197183;
                
                loop_while_197158 = loop_while_tmp_206361;
                l_idx_197159 = l_idx_tmp_206362;
                r_idx_197160 = r_idx_tmp_206363;
                span_197161 = span_tmp_206364;
            }
            idx_197154 = loop_while_197158;
            idx_197155 = l_idx_197159;
            idx_197156 = r_idx_197160;
            idx_197157 = span_197161;
            
            int64_t min_res_197195 = smin64(min_arg_197121, idx_197155);
            int64_t max_res_197196 = smax64((int64_t) 0, min_res_197195);
            int64_t x_197197 = add64(min_res_197122, max_res_197196);
            int64_t r_197198 = sub64(x_197197, (int64_t) 1);
            bool x_197199 = sle64((int64_t) 0, r_197198);
            bool y_197200 = slt64(r_197198, n_196692);
            bool bounds_check_197201 = x_197199 && y_197200;
            bool index_certs_197202;
            
            if (!bounds_check_197201) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) r_197198,
                              "] out of bounds for array of shape [",
                              (long long) n_196692, "].",
                              "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  stl.fut:157:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:155:5-158:26\n   #9  stl.fut:401:3-415:29\n   #10 stl.fut:385:1-415:29\n");
                if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t x_197203;
            
            x_197203 = ((int64_t *) mem_201386)[i_200074 * n_196692 + r_197198];
            
            int64_t abs_arg_197204 = sub64(x_197203, min_res_197131);
            int64_t abs_res_197205 = abs64(abs_arg_197204);
            bool x_197206 = sle64((int64_t) 0, max_res_197196);
            bool y_197207 = slt64(max_res_197196, n_196692);
            bool bounds_check_197208 = x_197206 && y_197207;
            bool index_certs_197209;
            
            if (!bounds_check_197208) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) max_res_197196,
                              "] out of bounds for array of shape [",
                              (long long) n_196692, "].",
                              "-> #0  loess.fut:483:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:479:3-487:25\n   #4  loess.fut:503:16-51\n   #5  stl.fut:157:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:155:5-158:26\n   #9  stl.fut:401:3-415:29\n   #10 stl.fut:385:1-415:29\n");
                if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t x_197210;
            
            x_197210 = ((int64_t *) mem_201386)[i_200074 * n_196692 +
                                                max_res_197196];
            
            int64_t abs_arg_197211 = sub64(x_197210, min_res_197131);
            int64_t abs_res_197212 = abs64(abs_arg_197211);
            int64_t max_res_197213 = smax64(abs_res_197205, abs_res_197212);
            float defunc_0_f_res_197214 = sitofp_i64_f32(max_res_197213);
            float defunc_1_f_res_197215 = max_res_197126 +
                  defunc_0_f_res_197214;
            
            ((float *) mem_202009)[i_200074 * t_n_m_196759 + i_200067] =
                defunc_1_f_res_197215;
            ((int64_t *) mem_202005)[i_200074 * t_n_m_196759 + i_200067] =
                max_res_197196;
        }
    }
    
    int64_t binop_y_202106 = (int64_t) 4 * binop_x_201383;
    int64_t bytes_202107 = smax64((int64_t) 0, binop_y_202106);
    struct memblock mem_202108;
    
    mem_202108.references = NULL;
    if (memblock_alloc(ctx, &mem_202108, bytes_202107, "mem_202108")) {
        err = 1;
        goto cleanup;
    }
    for (int64_t i_206365 = 0; i_206365 < m_196691; i_206365++) {
        for (int64_t i_206366 = 0; i_206366 < n_196692; i_206366++) {
            ((float *) mem_202108.mem)[i_206365 * n_196692 + i_206366] = 0.0F;
        }
    }
    
    struct memblock mem_202112;
    
    mem_202112.references = NULL;
    if (memblock_alloc(ctx, &mem_202112, bytes_202107, "mem_202112")) {
        err = 1;
        goto cleanup;
    }
    for (int64_t i_206367 = 0; i_206367 < m_196691; i_206367++) {
        for (int64_t i_206368 = 0; i_206368 < n_196692; i_206368++) {
            ((float *) mem_202112.mem)[i_206367 * n_196692 + i_206368] = 1.0F;
        }
    }
    
    bool cond_197220 = slt64((int64_t) 1, jump_l_196703);
    bool cond_197221 = slt64((int64_t) 1, jump_t_196702);
    int64_t y_197222 = sub64(n_outer_196705, (int64_t) 1);
    int64_t css_results_l_197223;
    
    if (cond_196744) {
        css_results_l_197223 = s_n_m_196745;
    } else {
        css_results_l_197223 = pad_css_len_196741;
    }
    
    bool zzero_197224 = n_p_196694 == (int64_t) 0;
    bool nonzzero_197225 = !zzero_197224;
    bool loop_not_taken_197226 = !assert_cond_196732;
    bool protect_assert_disj_197227 = nonzzero_197225 || loop_not_taken_197226;
    bool loop_not_taken_197228 = !assert_cond_196734;
    bool protect_assert_disj_197229 = protect_assert_disj_197227 ||
         loop_not_taken_197228;
    bool nonzzero_cert_197230;
    
    if (!protect_assert_disj_197229) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "division by zero",
                               "-> #0  stl.fut:226:51-57\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:226:28-74\n   #5  stl.fut:225:21-227:39\n   #6  stl.fut:401:3-415:29\n   #7  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t j_197231 = add64(n_196692, n_p_196694);
    bool empty_slice_197232 = n_196692 == (int64_t) 0;
    int64_t i_p_m_t_s_197233 = add64(n_p_196694, i_196779);
    bool zzero_leq_i_p_m_t_s_197234 = sle64((int64_t) 0, i_p_m_t_s_197233);
    bool i_p_m_t_s_leq_w_197235 = slt64(i_p_m_t_s_197233, C_len_196743);
    bool zzero_lte_i_197236 = sle64((int64_t) 0, n_p_196694);
    bool i_lte_j_197237 = sle64(n_p_196694, j_197231);
    bool y_197238 = i_p_m_t_s_leq_w_197235 && zzero_lte_i_197236;
    bool y_197239 = zzero_leq_i_p_m_t_s_197234 && y_197238;
    bool y_197240 = i_lte_j_197237 && y_197239;
    bool forwards_ok_197241 = zzero_lte_i_197236 && y_197240;
    bool ok_or_empty_197242 = empty_slice_197232 || forwards_ok_197241;
    bool protect_assert_disj_197243 = loop_not_taken_197226 ||
         ok_or_empty_197242;
    bool protect_assert_disj_197244 = loop_not_taken_197228 ||
         protect_assert_disj_197243;
    bool index_certs_197245;
    
    if (!protect_assert_disj_197244) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) n_p_196694, ":",
                               (long long) j_197231,
                               "] out of bounds for array of shape [",
                               (long long) C_len_196743, "].",
                               "-> #0  stl.fut:262:35-50\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  stl.fut:260:13-265:26\n   #4  stl.fut:401:3-415:29\n   #5  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t j_m_i_197246 = sub64(stl_res_196774, stl_res_196773);
    int64_t lifted_single_ma_l_arg_197247 = add64((int64_t) 1, j_197231);
    int64_t m_197248 = sub64(n_p_196694, (int64_t) 1);
    bool zzero_leq_i_p_m_t_s_197249 = sle64((int64_t) 0, m_197248);
    bool i_p_m_t_s_leq_w_197250 = slt64(m_197248, C_len_196743);
    bool y_197251 = zzero_leq_i_p_m_t_s_197249 && i_p_m_t_s_leq_w_197250;
    bool y_197252 = zzero_lte_i_197236 && y_197251;
    bool ok_or_empty_197253 = zzero_197224 || y_197252;
    bool protect_assert_disj_197254 = loop_not_taken_197226 ||
         ok_or_empty_197253;
    bool protect_assert_disj_197255 = loop_not_taken_197228 ||
         protect_assert_disj_197254;
    bool index_certs_197256;
    
    if (!protect_assert_disj_197255) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) n_p_196694,
                               "] out of bounds for array of shape [",
                               (long long) C_len_196743, "].",
                               "-> #0  stl.fut:24:37-43\n   #1  stl.fut:24:20-48\n   #2  stl.fut:38:3-36\n   #3  stl.fut:231:23-47\n   #4  stl.fut:401:3-415:29\n   #5  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t dyn_lifted_single_ma_l_arg_197257 = add64((int64_t) 2, n_196692);
    bool i_p_m_t_s_leq_w_197258 = slt64(m_197248,
                                        lifted_single_ma_l_arg_197247);
    bool y_197259 = zzero_leq_i_p_m_t_s_197249 && i_p_m_t_s_leq_w_197258;
    bool y_197260 = zzero_lte_i_197236 && y_197259;
    bool ok_or_empty_197261 = zzero_197224 || y_197260;
    bool protect_assert_disj_197262 = loop_not_taken_197226 ||
         ok_or_empty_197261;
    bool protect_assert_disj_197263 = loop_not_taken_197228 ||
         protect_assert_disj_197262;
    bool index_certs_197264;
    
    if (!protect_assert_disj_197263) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) n_p_196694,
                               "] out of bounds for array of shape [",
                               (long long) lifted_single_ma_l_arg_197247, "].",
                               "-> #0  stl.fut:24:37-43\n   #1  stl.fut:24:20-48\n   #2  /prelude/functional.fut:9:42-44\n   #3  stl.fut:38:3-64\n   #4  stl.fut:231:23-47\n   #5  stl.fut:401:3-415:29\n   #6  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool i_p_m_t_s_leq_w_197265 = slt64((int64_t) 2,
                                        dyn_lifted_single_ma_l_arg_197257);
    bool protect_assert_disj_197266 = loop_not_taken_197226 ||
         i_p_m_t_s_leq_w_197265;
    bool protect_assert_disj_197267 = loop_not_taken_197228 ||
         protect_assert_disj_197266;
    bool index_certs_197268;
    
    if (!protect_assert_disj_197267) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) (int64_t) 3,
                               "] out of bounds for array of shape [",
                               (long long) dyn_lifted_single_ma_l_arg_197257,
                               "].",
                               "-> #0  stl.fut:24:37-43\n   #1  stl.fut:24:20-48\n   #2  /prelude/functional.fut:9:42-44\n   #3  stl.fut:38:3-84\n   #4  stl.fut:231:23-47\n   #5  stl.fut:401:3-415:29\n   #6  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool cond_197269 = slt64(jump_l_196703, jump_threshold_196706);
    bool cond_f_res_197270 = slt64(q_threshold_196707, q_l_196697);
    bool x_197271 = !cond_197269;
    bool y_197272 = cond_f_res_197270 && x_197271;
    bool cond_197273 = cond_197269 || y_197272;
    bool cond_197274 = slt64(jump_t_196702, jump_threshold_196706);
    bool cond_f_res_197275 = slt64(q_threshold_196707, q_t_196696);
    bool x_197276 = !cond_197274;
    bool y_197277 = cond_f_res_197275 && x_197276;
    bool cond_197278 = cond_197274 || y_197277;
    bool cond_197279 = slt64(jump_s_196701, jump_threshold_196706);
    bool cond_f_res_197280 = slt64(q_threshold_196707, q_s_196695);
    bool x_197281 = !cond_197279;
    bool y_197282 = cond_f_res_197280 && x_197281;
    bool cond_197283 = cond_197279 || y_197282;
    bool bounds_invalid_upwards_197284 = slt64(C_len_196743, (int64_t) 0);
    bool valid_197285 = !bounds_invalid_upwards_197284;
    bool protect_assert_disj_197286 = loop_not_taken_197226 || valid_197285;
    bool protect_assert_disj_197287 = loop_not_taken_197228 ||
         protect_assert_disj_197286;
    bool range_valid_c_197288;
    
    if (!protect_assert_disj_197287) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) C_len_196743, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:226:28-74\n   #4  stl.fut:225:21-227:39\n   #5  stl.fut:401:3-415:29\n   #6  stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_197290 = slt64(lifted_single_ma_l_arg_197247,
                                               (int64_t) 0);
    bool valid_197291 = !bounds_invalid_upwards_197290;
    bool protect_assert_disj_197292 = loop_not_taken_197226 || valid_197291;
    bool protect_assert_disj_197293 = loop_not_taken_197228 ||
         protect_assert_disj_197292;
    bool range_valid_c_197294;
    
    if (!protect_assert_disj_197293) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) lifted_single_ma_l_arg_197247,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:27:13-33:19\n   #4  /prelude/soacs.fut:67:19-23\n   #5  /prelude/soacs.fut:67:3-37\n   #6  stl.fut:26:5-34:23\n   #7  stl.fut:38:3-36\n   #8  stl.fut:231:23-47\n   #9  stl.fut:401:3-415:29\n   #10 stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_197296 =
         slt64(dyn_lifted_single_ma_l_arg_197257, (int64_t) 0);
    bool valid_197297 = !bounds_invalid_upwards_197296;
    bool protect_assert_disj_197298 = loop_not_taken_197226 || valid_197297;
    bool protect_assert_disj_197299 = loop_not_taken_197228 ||
         protect_assert_disj_197298;
    bool range_valid_c_197300;
    
    if (!protect_assert_disj_197299) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) dyn_lifted_single_ma_l_arg_197257,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:27:13-33:19\n   #4  /prelude/soacs.fut:67:19-23\n   #5  /prelude/soacs.fut:67:3-37\n   #6  stl.fut:26:5-34:23\n   #7  /prelude/functional.fut:9:42-44\n   #8  stl.fut:38:3-64\n   #9  stl.fut:231:23-47\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
        if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    if (mem_202162_cached_sizze_206676 < (size_t) bytes_202107) {
        mem_202162 = realloc(mem_202162, bytes_202107);
        mem_202162_cached_sizze_206676 = bytes_202107;
    }
    if (mem_202207_cached_sizze_206677 < (size_t) bytes_201460) {
        mem_202207 = realloc(mem_202207, bytes_201460);
        mem_202207_cached_sizze_206677 = bytes_201460;
    }
    if (mem_202212_cached_sizze_206678 < (size_t) bytes_201460) {
        mem_202212 = realloc(mem_202212, bytes_201460);
        mem_202212_cached_sizze_206678 = bytes_201460;
    }
    
    int64_t binop_x_203535 = pad_css_len_196741 * binop_x_201457;
    int64_t binop_y_203536 = (int64_t) 4 * binop_x_203535;
    int64_t bytes_203537 = smax64((int64_t) 0, binop_y_203536);
    int64_t binop_x_203634 = m_196691 * C_len_196743;
    int64_t binop_y_203635 = (int64_t) 4 * binop_x_203634;
    int64_t bytes_203636 = smax64((int64_t) 0, binop_y_203635);
    
    if (mem_203637_cached_sizze_206686 < (size_t) bytes_203636) {
        mem_203637 = realloc(mem_203637, bytes_203636);
        mem_203637_cached_sizze_206686 = bytes_203636;
    }
    
    int64_t binop_y_203678 = (int64_t) 4 * m_196691;
    int64_t bytes_203679 = smax64((int64_t) 0, binop_y_203678);
    
    if (mem_203680_cached_sizze_206687 < (size_t) bytes_203679) {
        mem_203680 = realloc(mem_203680, bytes_203679);
        mem_203680_cached_sizze_206687 = bytes_203679;
    }
    
    int64_t binop_x_203693 = m_196691 * lifted_single_ma_l_arg_197247;
    int64_t binop_y_203694 = (int64_t) 4 * binop_x_203693;
    int64_t bytes_203695 = smax64((int64_t) 0, binop_y_203694);
    
    if (mem_203696_cached_sizze_206688 < (size_t) bytes_203695) {
        mem_203696 = realloc(mem_203696, bytes_203695);
        mem_203696_cached_sizze_206688 = bytes_203695;
    }
    
    int64_t binop_y_203707 = (int64_t) 4 * lifted_single_ma_l_arg_197247;
    int64_t bytes_203708 = smax64((int64_t) 0, binop_y_203707);
    
    if (mem_203709_cached_sizze_206689 < (size_t) bytes_203708) {
        mem_203709 = realloc(mem_203709, bytes_203708);
        mem_203709_cached_sizze_206689 = bytes_203708;
    }
    if (mem_203732_cached_sizze_206690 < (size_t) bytes_203679) {
        mem_203732 = realloc(mem_203732, bytes_203679);
        mem_203732_cached_sizze_206690 = bytes_203679;
    }
    
    int64_t binop_x_203745 = m_196691 * dyn_lifted_single_ma_l_arg_197257;
    int64_t binop_y_203746 = (int64_t) 4 * binop_x_203745;
    int64_t bytes_203747 = smax64((int64_t) 0, binop_y_203746);
    
    if (mem_203748_cached_sizze_206691 < (size_t) bytes_203747) {
        mem_203748 = realloc(mem_203748, bytes_203747);
        mem_203748_cached_sizze_206691 = bytes_203747;
    }
    
    int64_t binop_y_203759 = (int64_t) 4 * dyn_lifted_single_ma_l_arg_197257;
    int64_t bytes_203760 = smax64((int64_t) 0, binop_y_203759);
    
    if (mem_203761_cached_sizze_206692 < (size_t) bytes_203760) {
        mem_203761 = realloc(mem_203761, bytes_203760);
        mem_203761_cached_sizze_206692 = bytes_203760;
    }
    if (mem_203784_cached_sizze_206693 < (size_t) bytes_203679) {
        mem_203784 = realloc(mem_203784, bytes_203679);
        mem_203784_cached_sizze_206693 = bytes_203679;
    }
    if (mem_203800_cached_sizze_206694 < (size_t) bytes_202107) {
        mem_203800 = realloc(mem_203800, bytes_202107);
        mem_203800_cached_sizze_206694 = bytes_202107;
    }
    
    int64_t binop_y_203811 = (int64_t) 4 * n_196692;
    int64_t bytes_203812 = smax64((int64_t) 0, binop_y_203811);
    
    if (mem_203813_cached_sizze_206695 < (size_t) bytes_203812) {
        mem_203813 = realloc(mem_203813, bytes_203812);
        mem_203813_cached_sizze_206695 = bytes_203812;
    }
    
    int32_t iters_199778;
    
    if (empty_slice_197232) {
        iters_199778 = 0;
    } else {
        iters_199778 = 16;
    }
    
    int64_t binop_y_205644 = (int64_t) 8 * n_196692;
    int64_t bytes_205645 = smax64((int64_t) 0, binop_y_205644);
    int64_t binop_y_205656 = (int64_t) 4 * n_196692;
    int64_t bytes_205657 = smax64((int64_t) 0, binop_y_205656);
    int64_t ext_204515;
    
    if (cond_197220) {
        ext_204515 = n_196692;
    } else {
        ext_204515 = l_n_m_196752;
    }
    
    int64_t ext_204514;
    
    if (cond_197220) {
        ext_204514 = n_196692;
    } else {
        ext_204514 = l_n_m_196752;
    }
    
    int64_t ext_205514;
    
    if (cond_197221) {
        ext_205514 = n_196692;
    } else {
        ext_205514 = t_n_m_196759;
    }
    
    int64_t ext_205513;
    
    if (cond_197221) {
        ext_205513 = n_196692;
    } else {
        ext_205513 = t_n_m_196759;
    }
    
    int64_t ext_203631;
    
    if (cond_196744) {
        ext_203631 = s_n_m_196745;
    } else {
        ext_203631 = pad_css_len_196741;
    }
    
    int64_t ext_203629;
    
    if (cond_196744) {
        ext_203629 = s_n_m_196745;
    } else {
        ext_203629 = pad_css_len_196741;
    }
    
    int64_t ext_205862;
    int64_t ext_205860;
    int64_t ext_205856;
    int64_t ext_205855;
    int64_t ext_205854;
    int64_t ext_205853;
    int64_t ext_205852;
    int64_t ext_205851;
    int64_t ext_205850;
    struct memblock ext_mem_205849;
    
    ext_mem_205849.references = NULL;
    
    struct memblock ext_mem_205848;
    
    ext_mem_205848.references = NULL;
    
    struct memblock ext_mem_205847;
    
    ext_mem_205847.references = NULL;
    
    struct memblock mem_param_202120;
    
    mem_param_202120.references = NULL;
    
    int64_t ctx_param_ext_202122;
    int64_t ctx_param_ext_202124;
    struct memblock mem_param_202128;
    
    mem_param_202128.references = NULL;
    
    int64_t ctx_param_ext_202129;
    int64_t ctx_param_ext_202130;
    int64_t ctx_param_ext_202131;
    int64_t ctx_param_ext_202132;
    int64_t ctx_param_ext_202133;
    int64_t ctx_param_ext_202134;
    int64_t ctx_param_ext_202135;
    struct memblock mem_param_202136;
    
    mem_param_202136.references = NULL;
    ctx_param_ext_202122 = n_196692;
    ctx_param_ext_202124 = n_196692;
    ctx_param_ext_202129 = m_196691;
    ctx_param_ext_202130 = n_196692;
    ctx_param_ext_202131 = (int64_t) 0;
    ctx_param_ext_202132 = n_196692;
    ctx_param_ext_202133 = m_196691;
    ctx_param_ext_202134 = (int64_t) 1;
    ctx_param_ext_202135 = n_196692;
    if (memblock_set(ctx, &mem_param_202120, &mem_202108, "mem_202108") != 0)
        return 1;
    if (memblock_set(ctx, &mem_param_202128, &mem_202108, "mem_202108") != 0)
        return 1;
    if (memblock_set(ctx, &mem_param_202136, &mem_202112, "mem_202112") != 0)
        return 1;
    for (int64_t i_outer_197305 = 0; i_outer_197305 < n_outer_196705;
         i_outer_197305++) {
        int64_t ext_205525;
        int64_t ext_205523;
        struct memblock ext_mem_205519;
        
        ext_mem_205519.references = NULL;
        
        struct memblock ext_mem_205518;
        
        ext_mem_205518.references = NULL;
        
        struct memblock mem_param_202150;
        
        mem_param_202150.references = NULL;
        
        int64_t ctx_param_ext_202152;
        int64_t ctx_param_ext_202154;
        struct memblock mem_param_202158;
        
        mem_param_202158.references = NULL;
        ctx_param_ext_202152 = ctx_param_ext_202122;
        ctx_param_ext_202154 = ctx_param_ext_202124;
        if (memblock_set(ctx, &mem_param_202150, &mem_param_202120,
                         "mem_param_202120") != 0)
            return 1;
        if (memblock_set(ctx, &mem_param_202158, &mem_param_202128,
                         "mem_param_202128") != 0)
            return 1;
        for (int64_t _i_inner_197311 = 0; _i_inner_197311 < n_inner_196704;
             _i_inner_197311++) {
            for (int64_t i_200083 = 0; i_200083 < m_196691; i_200083++) {
                for (int64_t i_200079 = 0; i_200079 < n_196692; i_200079++) {
                    float x_197318;
                    
                    x_197318 = ((float *) Y_mem_201382.mem)[i_200083 *
                                                            n_196692 +
                                                            i_200079];
                    
                    float x_197319;
                    
                    x_197319 = ((float *) mem_param_202158.mem)[i_200083 *
                                                                ctx_param_ext_202154 +
                                                                i_200079];
                    
                    float defunc_1_f_res_197320 = x_197318 - x_197319;
                    
                    ((float *) mem_202162)[i_200083 * n_196692 + i_200079] =
                        defunc_1_f_res_197320;
                }
            }
            for (int64_t i_200103 = 0; i_200103 < m_196691; i_200103++) {
                for (int64_t i_200096 = 0; i_200096 < n_p_196694; i_200096++) {
                    for (int64_t i_200089 = 0; i_200089 < defunc_0_f_res_196740;
                         i_200089++) {
                        int64_t x_197333;
                        
                        x_197333 = ((int64_t *) mem_201553)[i_200103 *
                                                            ctx_val_201474 +
                                                            i_200096 *
                                                            defunc_0_f_res_196740 +
                                                            i_200089];
                        
                        int64_t x_197334 = mul64(n_p_196694, x_197333);
                        int64_t idx_197335 = add64(x_197334, i_200096);
                        bool cond_197336 = slt64(i_196779, idx_197335);
                        bool cond_f_res_197337 = slt64(x_197333, (int64_t) 0);
                        bool x_197338 = !cond_197336;
                        bool y_197339 = cond_f_res_197337 && x_197338;
                        bool cond_197340 = cond_197336 || y_197339;
                        float defunc_0_f_res_197341;
                        float defunc_0_f_res_197342;
                        
                        if (cond_197340) {
                            defunc_0_f_res_197341 = 0.0F;
                            defunc_0_f_res_197342 = 0.0F;
                        } else {
                            bool x_197343 = sle64((int64_t) 0, idx_197335);
                            bool y_197344 = slt64(idx_197335, n_196692);
                            bool bounds_check_197345 = x_197343 && y_197344;
                            bool index_certs_197346;
                            
                            if (!bounds_check_197345) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [", (long long) idx_197335,
                                              "] out of bounds for array of shape [",
                                              (long long) n_196692, "].",
                                              "-> #0  stl.fut:193:42-57\n   #1  stl.fut:188:28-194:44\n   #2  /prelude/soacs.fut:67:19-23\n   #3  /prelude/soacs.fut:67:3-37\n   #4  stl.fut:186:21-195:50\n   #5  /prelude/soacs.fut:75:22-28\n   #6  /prelude/soacs.fut:75:3-45\n   #7  stl.fut:184:13-196:57\n   #8  stl.fut:401:3-415:29\n   #9  stl.fut:385:1-415:29\n");
                                if (memblock_unref(ctx, &mem_param_202158,
                                                   "mem_param_202158") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_202150,
                                                   "mem_param_202150") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_205518,
                                                   "ext_mem_205518") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_205519,
                                                   "ext_mem_205519") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_202136,
                                                   "mem_param_202136") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_202128,
                                                   "mem_param_202128") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_202120,
                                                   "mem_param_202120") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_205847,
                                                   "ext_mem_205847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_205848,
                                                   "ext_mem_205848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_205849,
                                                   "ext_mem_205849") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_202112,
                                                   "mem_202112") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_202108,
                                                   "mem_202108") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_206309,
                                                   "mem_out_206309") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_206308,
                                                   "mem_out_206308") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_206307,
                                                   "mem_out_206307") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            float defunc_0_f_res_f_res_197347;
                            
                            defunc_0_f_res_f_res_197347 =
                                ((float *) mem_202162)[i_200103 * n_196692 +
                                                       idx_197335];
                            
                            float defunc_0_f_res_f_res_197348;
                            
                            defunc_0_f_res_f_res_197348 =
                                ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                 (i_200103 *
                                                                  ctx_param_ext_202132 +
                                                                  idx_197335 *
                                                                  ctx_param_ext_202134)];
                            defunc_0_f_res_197341 = defunc_0_f_res_f_res_197347;
                            defunc_0_f_res_197342 = defunc_0_f_res_f_res_197348;
                        }
                        ((float *) mem_202207)[i_200103 * ctx_val_201474 +
                                               i_200096 *
                                               defunc_0_f_res_196740 +
                                               i_200089] =
                            defunc_0_f_res_197341;
                        ((float *) mem_202212)[i_200103 * ctx_val_201474 +
                                               i_200096 *
                                               defunc_0_f_res_196740 +
                                               i_200089] =
                            defunc_0_f_res_197342;
                    }
                }
            }
            
            struct memblock ext_mem_203523;
            
            ext_mem_203523.references = NULL;
            
            struct memblock ext_mem_203512;
            
            ext_mem_203512.references = NULL;
            if (cond_197283) {
                bool match_lit_197353 = (int64_t) 0 == d_s_196698;
                struct memblock ext_mem_202886;
                
                ext_mem_202886.references = NULL;
                
                struct memblock ext_mem_202875;
                
                ext_mem_202875.references = NULL;
                if (match_lit_197353) {
                    struct memblock mem_202391;
                    
                    mem_202391.references = NULL;
                    if (memblock_alloc(ctx, &mem_202391, bytes_201708,
                                       "mem_202391")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_206398 = 0; i_206398 < m_196691;
                         i_206398++) {
                        for (int64_t i_206399 = 0; i_206399 < n_p_196694;
                             i_206399++) {
                            for (int64_t i_206400 = 0; i_206400 < s_n_m_196745;
                                 i_206400++) {
                                ((float *) mem_202391.mem)[i_206398 *
                                                           (s_n_m_196745 *
                                                            n_p_196694) +
                                                           i_206399 *
                                                           s_n_m_196745 +
                                                           i_206400] = 0.0F;
                            }
                        }
                    }
                    
                    struct memblock mem_202396;
                    
                    mem_202396.references = NULL;
                    if (memblock_alloc(ctx, &mem_202396, bytes_201708,
                                       "mem_202396")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_200120 = 0; i_200120 < m_196691;
                         i_200120++) {
                        for (int64_t i_200116 = 0; i_200116 < n_p_196694;
                             i_200116++) {
                            int64_t x_197369;
                            
                            x_197369 = ((int64_t *) mem_201557)[i_200120 *
                                                                n_p_196694 +
                                                                i_200116];
                            for (int64_t i_200112 = 0; i_200112 < s_n_m_196745;
                                 i_200112++) {
                                int64_t x_197374;
                                
                                x_197374 = ((int64_t *) mem_201704)[i_200120 *
                                                                    ctx_val_201733 +
                                                                    i_200116 *
                                                                    s_n_m_196745 +
                                                                    i_200112];
                                
                                float x_197375;
                                
                                x_197375 = ((float *) mem_201709)[i_200120 *
                                                                  ctx_val_201733 +
                                                                  i_200116 *
                                                                  s_n_m_196745 +
                                                                  i_200112];
                                
                                bool cond_197376 = i_200112 == (int64_t) 0;
                                int64_t defunc_0_m_fun_res_197377;
                                
                                if (cond_197376) {
                                    defunc_0_m_fun_res_197377 = (int64_t) 0;
                                } else {
                                    int64_t y_197378 = sub64(s_n_m_196745,
                                                             (int64_t) 1);
                                    bool cond_197379 = i_200112 == y_197378;
                                    int64_t defunc_0_m_fun_res_f_res_197380;
                                    
                                    if (cond_197379) {
                                        int64_t
                                        defunc_0_m_fun_res_f_res_t_res_197381 =
                                        sub64(pad_css_len_196741, (int64_t) 1);
                                        
                                        defunc_0_m_fun_res_f_res_197380 =
                                            defunc_0_m_fun_res_f_res_t_res_197381;
                                    } else {
                                        int64_t x_197382 = sub64(i_200112,
                                                                 (int64_t) 1);
                                        int64_t x_197383 = mul64(jump_s_196701,
                                                                 x_197382);
                                        int64_t min_arg_197384 =
                                                add64((int64_t) 1, x_197383);
                                        int64_t min_res_197385 =
                                                smin64(defunc_0_f_res_196740,
                                                       min_arg_197384);
                                        
                                        defunc_0_m_fun_res_f_res_197380 =
                                            min_res_197385;
                                    }
                                    defunc_0_m_fun_res_197377 =
                                        defunc_0_m_fun_res_f_res_197380;
                                }
                                
                                float defunc_2_reduce_res_197386;
                                float redout_200106 = 0.0F;
                                
                                for (int64_t i_200107 = 0; i_200107 <
                                     q_s_196695; i_200107++) {
                                    bool cond_197391 = sle64(x_197369,
                                                             i_200107);
                                    int64_t defunc_0_f_res_197392;
                                    
                                    if (cond_197391) {
                                        defunc_0_f_res_197392 = (int64_t) 0;
                                    } else {
                                        int64_t i_197393 = add64(x_197374,
                                                                 i_200107);
                                        int64_t defunc_0_add_arg_197394;
                                        
                                        defunc_0_add_arg_197394 =
                                            ((int64_t *) mem_201553)[i_200120 *
                                                                     ctx_val_201474 +
                                                                     i_200116 *
                                                                     defunc_0_f_res_196740 +
                                                                     i_197393];
                                        
                                        int64_t defunc_1_add_res_197395 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_197394);
                                        
                                        defunc_0_f_res_197392 =
                                            defunc_1_add_res_197395;
                                    }
                                    
                                    float defunc_0_f_res_197396;
                                    
                                    if (cond_197391) {
                                        defunc_0_f_res_197396 = 0.0F;
                                    } else {
                                        int64_t i_197397 = add64(x_197374,
                                                                 i_200107);
                                        float defunc_0_add_arg_197398;
                                        
                                        defunc_0_add_arg_197398 =
                                            ((float *) mem_202212)[i_200120 *
                                                                   ctx_val_201474 +
                                                                   i_200116 *
                                                                   defunc_0_f_res_196740 +
                                                                   i_197397];
                                        defunc_0_f_res_197396 =
                                            defunc_0_add_arg_197398;
                                    }
                                    
                                    int64_t binop_p_197399 =
                                            sub64(defunc_0_f_res_197392,
                                                  defunc_0_m_fun_res_197377);
                                    float defunc_0_f_res_197400 =
                                          sitofp_i64_f32(binop_p_197399);
                                    float abs_res_197401 =
                                          (float) fabs(defunc_0_f_res_197400);
                                    float tmp1_197402 = abs_res_197401 /
                                          x_197375;
                                    float x_197403 = tmp1_197402 * tmp1_197402;
                                    float y_197404 = tmp1_197402 * x_197403;
                                    float tmp2_197405 = 1.0F - y_197404;
                                    float x_197406 = tmp2_197405 * tmp2_197405;
                                    float tmp3_197407 = tmp2_197405 * x_197406;
                                    float w_j_197408 = defunc_0_f_res_197396 *
                                          tmp3_197407;
                                    float defunc_1_op_res_197389 = w_j_197408 +
                                          redout_200106;
                                    float redout_tmp_206404 =
                                          defunc_1_op_res_197389;
                                    
                                    redout_200106 = redout_tmp_206404;
                                }
                                defunc_2_reduce_res_197386 = redout_200106;
                                
                                float a0_197409 = 1.0F /
                                      defunc_2_reduce_res_197386;
                                int64_t defunc_0_m_fun_res_197410;
                                
                                if (cond_197376) {
                                    defunc_0_m_fun_res_197410 = (int64_t) 0;
                                } else {
                                    int64_t y_197411 = sub64(s_n_m_196745,
                                                             (int64_t) 1);
                                    bool cond_197412 = i_200112 == y_197411;
                                    int64_t defunc_0_m_fun_res_f_res_197413;
                                    
                                    if (cond_197412) {
                                        int64_t
                                        defunc_0_m_fun_res_f_res_t_res_197414 =
                                        sub64(pad_css_len_196741, (int64_t) 1);
                                        
                                        defunc_0_m_fun_res_f_res_197413 =
                                            defunc_0_m_fun_res_f_res_t_res_197414;
                                    } else {
                                        int64_t x_197415 = sub64(i_200112,
                                                                 (int64_t) 1);
                                        int64_t x_197416 = mul64(jump_s_196701,
                                                                 x_197415);
                                        int64_t min_arg_197417 =
                                                add64((int64_t) 1, x_197416);
                                        int64_t min_res_197418 =
                                                smin64(defunc_0_f_res_196740,
                                                       min_arg_197417);
                                        
                                        defunc_0_m_fun_res_f_res_197413 =
                                            min_res_197418;
                                    }
                                    defunc_0_m_fun_res_197410 =
                                        defunc_0_m_fun_res_f_res_197413;
                                }
                                
                                float defunc_2_reduce_res_197419;
                                float redout_200108 = 0.0F;
                                
                                for (int64_t i_200109 = 0; i_200109 <
                                     q_s_196695; i_200109++) {
                                    bool cond_197424 = sle64(x_197369,
                                                             i_200109);
                                    int64_t defunc_0_f_res_197425;
                                    
                                    if (cond_197424) {
                                        defunc_0_f_res_197425 = (int64_t) 0;
                                    } else {
                                        int64_t i_197426 = add64(x_197374,
                                                                 i_200109);
                                        int64_t defunc_0_add_arg_197427;
                                        
                                        defunc_0_add_arg_197427 =
                                            ((int64_t *) mem_201553)[i_200120 *
                                                                     ctx_val_201474 +
                                                                     i_200116 *
                                                                     defunc_0_f_res_196740 +
                                                                     i_197426];
                                        
                                        int64_t defunc_1_add_res_197428 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_197427);
                                        
                                        defunc_0_f_res_197425 =
                                            defunc_1_add_res_197428;
                                    }
                                    
                                    float defunc_0_f_res_197429;
                                    
                                    if (cond_197424) {
                                        defunc_0_f_res_197429 = 0.0F;
                                    } else {
                                        int64_t i_197430 = add64(x_197374,
                                                                 i_200109);
                                        float defunc_0_add_arg_197431;
                                        
                                        defunc_0_add_arg_197431 =
                                            ((float *) mem_202212)[i_200120 *
                                                                   ctx_val_201474 +
                                                                   i_200116 *
                                                                   defunc_0_f_res_196740 +
                                                                   i_197430];
                                        defunc_0_f_res_197429 =
                                            defunc_0_add_arg_197431;
                                    }
                                    
                                    int64_t binop_p_197432 =
                                            sub64(defunc_0_f_res_197425,
                                                  defunc_0_m_fun_res_197410);
                                    float defunc_0_f_res_197433 =
                                          sitofp_i64_f32(binop_p_197432);
                                    float abs_res_197434 =
                                          (float) fabs(defunc_0_f_res_197433);
                                    float tmp1_197435 = abs_res_197434 /
                                          x_197375;
                                    float x_197436 = tmp1_197435 * tmp1_197435;
                                    float y_197437 = tmp1_197435 * x_197436;
                                    float tmp2_197438 = 1.0F - y_197437;
                                    float x_197439 = tmp2_197438 * tmp2_197438;
                                    float tmp3_197440 = tmp2_197438 * x_197439;
                                    float tmp4_197441 = defunc_0_f_res_197429 *
                                          tmp3_197440;
                                    float defunc_0_f_res_197442;
                                    
                                    if (cond_197424) {
                                        defunc_0_f_res_197442 = 0.0F;
                                    } else {
                                        int64_t i_197443 = add64(x_197374,
                                                                 i_200109);
                                        float defunc_0_add_arg_197444;
                                        
                                        defunc_0_add_arg_197444 =
                                            ((float *) mem_202207)[i_200120 *
                                                                   ctx_val_201474 +
                                                                   i_200116 *
                                                                   defunc_0_f_res_196740 +
                                                                   i_197443];
                                        defunc_0_f_res_197442 =
                                            defunc_0_add_arg_197444;
                                    }
                                    
                                    float x_197445 = a0_197409 * tmp4_197441;
                                    float defunc_9_fit_fun_res_197446 =
                                          defunc_0_f_res_197442 * x_197445;
                                    float defunc_1_op_res_197422 =
                                          defunc_9_fit_fun_res_197446 +
                                          redout_200108;
                                    float redout_tmp_206405 =
                                          defunc_1_op_res_197422;
                                    
                                    redout_200108 = redout_tmp_206405;
                                }
                                defunc_2_reduce_res_197419 = redout_200108;
                                ((float *) mem_202396.mem)[i_200120 *
                                                           ctx_val_201733 +
                                                           i_200116 *
                                                           s_n_m_196745 +
                                                           i_200112] =
                                    defunc_2_reduce_res_197419;
                            }
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_202886, &mem_202396,
                                     "mem_202396") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_202875, &mem_202391,
                                     "mem_202391") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202396, "mem_202396") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202391, "mem_202391") != 0)
                        return 1;
                } else {
                    bool match_lit_197449 = (int64_t) 1 == d_s_196698;
                    struct memblock ext_mem_202863;
                    
                    ext_mem_202863.references = NULL;
                    
                    struct memblock ext_mem_202852;
                    
                    ext_mem_202852.references = NULL;
                    if (match_lit_197449) {
                        struct memblock mem_202488;
                        
                        mem_202488.references = NULL;
                        if (memblock_alloc(ctx, &mem_202488, bytes_201708,
                                           "mem_202488")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_202493;
                        
                        mem_202493.references = NULL;
                        if (memblock_alloc(ctx, &mem_202493, bytes_201708,
                                           "mem_202493")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_200147 = 0; i_200147 < m_196691;
                             i_200147++) {
                            for (int64_t i_200140 = 0; i_200140 < n_p_196694;
                                 i_200140++) {
                                int64_t x_197466;
                                
                                x_197466 = ((int64_t *) mem_201557)[i_200147 *
                                                                    n_p_196694 +
                                                                    i_200140];
                                for (int64_t i_200133 = 0; i_200133 <
                                     s_n_m_196745; i_200133++) {
                                    int64_t x_197472;
                                    
                                    x_197472 =
                                        ((int64_t *) mem_201704)[i_200147 *
                                                                 ctx_val_201733 +
                                                                 i_200140 *
                                                                 s_n_m_196745 +
                                                                 i_200133];
                                    
                                    float x_197473;
                                    
                                    x_197473 = ((float *) mem_201709)[i_200147 *
                                                                      ctx_val_201733 +
                                                                      i_200140 *
                                                                      s_n_m_196745 +
                                                                      i_200133];
                                    
                                    bool cond_197474 = i_200133 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_197475;
                                    
                                    if (cond_197474) {
                                        defunc_0_m_fun_res_197475 = (int64_t) 0;
                                    } else {
                                        int64_t y_197476 = sub64(s_n_m_196745,
                                                                 (int64_t) 1);
                                        bool cond_197477 = i_200133 == y_197476;
                                        int64_t defunc_0_m_fun_res_f_res_197478;
                                        
                                        if (cond_197477) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_197479
                                            = sub64(pad_css_len_196741,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_197478 =
                                                defunc_0_m_fun_res_f_res_t_res_197479;
                                        } else {
                                            int64_t x_197480 = sub64(i_200133,
                                                                     (int64_t) 1);
                                            int64_t x_197481 =
                                                    mul64(jump_s_196701,
                                                          x_197480);
                                            int64_t min_arg_197482 =
                                                    add64((int64_t) 1,
                                                          x_197481);
                                            int64_t min_res_197483 =
                                                    smin64(defunc_0_f_res_196740,
                                                           min_arg_197482);
                                            
                                            defunc_0_m_fun_res_f_res_197478 =
                                                min_res_197483;
                                        }
                                        defunc_0_m_fun_res_197475 =
                                            defunc_0_m_fun_res_f_res_197478;
                                    }
                                    
                                    float defunc_2_reduce_res_197484;
                                    float defunc_2_reduce_res_197485;
                                    float defunc_2_reduce_res_197486;
                                    float redout_200122;
                                    float redout_200123;
                                    float redout_200124;
                                    
                                    redout_200122 = 0.0F;
                                    redout_200123 = 0.0F;
                                    redout_200124 = 0.0F;
                                    for (int64_t i_200125 = 0; i_200125 <
                                         q_s_196695; i_200125++) {
                                        bool cond_197497 = sle64(x_197466,
                                                                 i_200125);
                                        int64_t defunc_0_f_res_197498;
                                        
                                        if (cond_197497) {
                                            defunc_0_f_res_197498 = (int64_t) 0;
                                        } else {
                                            int64_t i_197499 = add64(x_197472,
                                                                     i_200125);
                                            int64_t defunc_0_add_arg_197500;
                                            
                                            defunc_0_add_arg_197500 =
                                                ((int64_t *) mem_201553)[i_200147 *
                                                                         ctx_val_201474 +
                                                                         i_200140 *
                                                                         defunc_0_f_res_196740 +
                                                                         i_197499];
                                            
                                            int64_t defunc_1_add_res_197501 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_197500);
                                            
                                            defunc_0_f_res_197498 =
                                                defunc_1_add_res_197501;
                                        }
                                        
                                        float defunc_0_f_res_197502;
                                        
                                        if (cond_197497) {
                                            defunc_0_f_res_197502 = 0.0F;
                                        } else {
                                            int64_t i_197503 = add64(x_197472,
                                                                     i_200125);
                                            float defunc_0_add_arg_197504;
                                            
                                            defunc_0_add_arg_197504 =
                                                ((float *) mem_202212)[i_200147 *
                                                                       ctx_val_201474 +
                                                                       i_200140 *
                                                                       defunc_0_f_res_196740 +
                                                                       i_197503];
                                            defunc_0_f_res_197502 =
                                                defunc_0_add_arg_197504;
                                        }
                                        
                                        int64_t binop_p_197505 =
                                                sub64(defunc_0_f_res_197498,
                                                      defunc_0_m_fun_res_197475);
                                        float defunc_0_f_res_197506 =
                                              sitofp_i64_f32(binop_p_197505);
                                        float abs_res_197507 =
                                              (float) fabs(defunc_0_f_res_197506);
                                        float tmp1_197508 = abs_res_197507 /
                                              x_197473;
                                        float x_197509 = tmp1_197508 *
                                              tmp1_197508;
                                        float y_197510 = tmp1_197508 * x_197509;
                                        float tmp2_197511 = 1.0F - y_197510;
                                        float x_197512 = tmp2_197511 *
                                              tmp2_197511;
                                        float tmp3_197513 = tmp2_197511 *
                                              x_197512;
                                        float w_j_197514 =
                                              defunc_0_f_res_197502 *
                                              tmp3_197513;
                                        float xw_j_197515 =
                                              defunc_0_f_res_197506 *
                                              w_j_197514;
                                        float x2w_j_197516 =
                                              defunc_0_f_res_197506 *
                                              xw_j_197515;
                                        float defunc_1_op_res_197489 =
                                              w_j_197514 + redout_200122;
                                        float defunc_1_op_res_197492 =
                                              xw_j_197515 + redout_200123;
                                        float defunc_1_op_res_197495 =
                                              x2w_j_197516 + redout_200124;
                                        float redout_tmp_206412 =
                                              defunc_1_op_res_197489;
                                        float redout_tmp_206413 =
                                              defunc_1_op_res_197492;
                                        float redout_tmp_206414 =
                                              defunc_1_op_res_197495;
                                        
                                        redout_200122 = redout_tmp_206412;
                                        redout_200123 = redout_tmp_206413;
                                        redout_200124 = redout_tmp_206414;
                                    }
                                    defunc_2_reduce_res_197484 = redout_200122;
                                    defunc_2_reduce_res_197485 = redout_200123;
                                    defunc_2_reduce_res_197486 = redout_200124;
                                    
                                    float x_197517 =
                                          defunc_2_reduce_res_197484 *
                                          defunc_2_reduce_res_197486;
                                    float y_197518 =
                                          defunc_2_reduce_res_197485 *
                                          defunc_2_reduce_res_197485;
                                    float y_197519 = x_197517 - y_197518;
                                    float det1_197520 = 1.0F / y_197519;
                                    float a11_197521 =
                                          defunc_2_reduce_res_197486 *
                                          det1_197520;
                                    float x_197522 = 0.0F -
                                          defunc_2_reduce_res_197485;
                                    float b11_197523 = det1_197520 * x_197522;
                                    float c11_197524 =
                                          defunc_2_reduce_res_197484 *
                                          det1_197520;
                                    int64_t defunc_0_m_fun_res_197525;
                                    
                                    if (cond_197474) {
                                        defunc_0_m_fun_res_197525 = (int64_t) 0;
                                    } else {
                                        int64_t y_197526 = sub64(s_n_m_196745,
                                                                 (int64_t) 1);
                                        bool cond_197527 = i_200133 == y_197526;
                                        int64_t defunc_0_m_fun_res_f_res_197528;
                                        
                                        if (cond_197527) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_197529
                                            = sub64(pad_css_len_196741,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_197528 =
                                                defunc_0_m_fun_res_f_res_t_res_197529;
                                        } else {
                                            int64_t x_197530 = sub64(i_200133,
                                                                     (int64_t) 1);
                                            int64_t x_197531 =
                                                    mul64(jump_s_196701,
                                                          x_197530);
                                            int64_t min_arg_197532 =
                                                    add64((int64_t) 1,
                                                          x_197531);
                                            int64_t min_res_197533 =
                                                    smin64(defunc_0_f_res_196740,
                                                           min_arg_197532);
                                            
                                            defunc_0_m_fun_res_f_res_197528 =
                                                min_res_197533;
                                        }
                                        defunc_0_m_fun_res_197525 =
                                            defunc_0_m_fun_res_f_res_197528;
                                    }
                                    
                                    float defunc_2_reduce_res_197534;
                                    float defunc_2_reduce_res_197535;
                                    float redout_200126;
                                    float redout_200127;
                                    
                                    redout_200126 = 0.0F;
                                    redout_200127 = 0.0F;
                                    for (int64_t i_200128 = 0; i_200128 <
                                         q_s_196695; i_200128++) {
                                        bool cond_197543 = sle64(x_197466,
                                                                 i_200128);
                                        int64_t defunc_0_f_res_197544;
                                        
                                        if (cond_197543) {
                                            defunc_0_f_res_197544 = (int64_t) 0;
                                        } else {
                                            int64_t i_197545 = add64(x_197472,
                                                                     i_200128);
                                            int64_t defunc_0_add_arg_197546;
                                            
                                            defunc_0_add_arg_197546 =
                                                ((int64_t *) mem_201553)[i_200147 *
                                                                         ctx_val_201474 +
                                                                         i_200140 *
                                                                         defunc_0_f_res_196740 +
                                                                         i_197545];
                                            
                                            int64_t defunc_1_add_res_197547 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_197546);
                                            
                                            defunc_0_f_res_197544 =
                                                defunc_1_add_res_197547;
                                        }
                                        
                                        float defunc_0_f_res_197548;
                                        
                                        if (cond_197543) {
                                            defunc_0_f_res_197548 = 0.0F;
                                        } else {
                                            int64_t i_197549 = add64(x_197472,
                                                                     i_200128);
                                            float defunc_0_add_arg_197550;
                                            
                                            defunc_0_add_arg_197550 =
                                                ((float *) mem_202212)[i_200147 *
                                                                       ctx_val_201474 +
                                                                       i_200140 *
                                                                       defunc_0_f_res_196740 +
                                                                       i_197549];
                                            defunc_0_f_res_197548 =
                                                defunc_0_add_arg_197550;
                                        }
                                        
                                        int64_t binop_p_197551 =
                                                sub64(defunc_0_f_res_197544,
                                                      defunc_0_m_fun_res_197525);
                                        float defunc_0_f_res_197552 =
                                              sitofp_i64_f32(binop_p_197551);
                                        float abs_res_197553 =
                                              (float) fabs(defunc_0_f_res_197552);
                                        float tmp1_197554 = abs_res_197553 /
                                              x_197473;
                                        float x_197555 = tmp1_197554 *
                                              tmp1_197554;
                                        float y_197556 = tmp1_197554 * x_197555;
                                        float tmp2_197557 = 1.0F - y_197556;
                                        float x_197558 = tmp2_197557 *
                                              tmp2_197557;
                                        float tmp3_197559 = tmp2_197557 *
                                              x_197558;
                                        float tmp4_197560 =
                                              defunc_0_f_res_197548 *
                                              tmp3_197559;
                                        float defunc_1_f_res_197561 =
                                              defunc_0_f_res_197552 *
                                              tmp4_197560;
                                        float defunc_0_f_res_197562;
                                        
                                        if (cond_197543) {
                                            defunc_0_f_res_197562 = 0.0F;
                                        } else {
                                            int64_t i_197563 = add64(x_197472,
                                                                     i_200128);
                                            float defunc_0_add_arg_197564;
                                            
                                            defunc_0_add_arg_197564 =
                                                ((float *) mem_202207)[i_200147 *
                                                                       ctx_val_201474 +
                                                                       i_200140 *
                                                                       defunc_0_f_res_196740 +
                                                                       i_197563];
                                            defunc_0_f_res_197562 =
                                                defunc_0_add_arg_197564;
                                        }
                                        
                                        float x_197565 = a11_197521 *
                                              tmp4_197560;
                                        float y_197566 = b11_197523 *
                                              defunc_1_f_res_197561;
                                        float x_197567 = x_197565 + y_197566;
                                        float defunc_9_fit_fun_res_197568 =
                                              defunc_0_f_res_197562 * x_197567;
                                        float x_197569 = b11_197523 *
                                              tmp4_197560;
                                        float y_197570 = c11_197524 *
                                              defunc_1_f_res_197561;
                                        float x_197571 = x_197569 + y_197570;
                                        float defunc_9_slope_fun_res_197572 =
                                              defunc_0_f_res_197562 * x_197571;
                                        float defunc_1_op_res_197538 =
                                              defunc_9_fit_fun_res_197568 +
                                              redout_200126;
                                        float defunc_1_op_res_197541 =
                                              defunc_9_slope_fun_res_197572 +
                                              redout_200127;
                                        float redout_tmp_206415 =
                                              defunc_1_op_res_197538;
                                        float redout_tmp_206416 =
                                              defunc_1_op_res_197541;
                                        
                                        redout_200126 = redout_tmp_206415;
                                        redout_200127 = redout_tmp_206416;
                                    }
                                    defunc_2_reduce_res_197534 = redout_200126;
                                    defunc_2_reduce_res_197535 = redout_200127;
                                    ((float *) mem_202488.mem)[i_200147 *
                                                               ctx_val_201733 +
                                                               i_200140 *
                                                               s_n_m_196745 +
                                                               i_200133] =
                                        defunc_2_reduce_res_197534;
                                    ((float *) mem_202493.mem)[i_200147 *
                                                               ctx_val_201733 +
                                                               i_200140 *
                                                               s_n_m_196745 +
                                                               i_200133] =
                                        defunc_2_reduce_res_197535;
                                }
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_202863, &mem_202488,
                                         "mem_202488") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_202852, &mem_202493,
                                         "mem_202493") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_202493, "mem_202493") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_202488, "mem_202488") != 0)
                            return 1;
                    } else {
                        struct memblock mem_202672;
                        
                        mem_202672.references = NULL;
                        if (memblock_alloc(ctx, &mem_202672, bytes_201708,
                                           "mem_202672")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_202677;
                        
                        mem_202677.references = NULL;
                        if (memblock_alloc(ctx, &mem_202677, bytes_201708,
                                           "mem_202677")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_200177 = 0; i_200177 < m_196691;
                             i_200177++) {
                            for (int64_t i_200170 = 0; i_200170 < n_p_196694;
                                 i_200170++) {
                                int64_t x_197589;
                                
                                x_197589 = ((int64_t *) mem_201557)[i_200177 *
                                                                    n_p_196694 +
                                                                    i_200170];
                                for (int64_t i_200163 = 0; i_200163 <
                                     s_n_m_196745; i_200163++) {
                                    int64_t x_197595;
                                    
                                    x_197595 =
                                        ((int64_t *) mem_201704)[i_200177 *
                                                                 ctx_val_201733 +
                                                                 i_200170 *
                                                                 s_n_m_196745 +
                                                                 i_200163];
                                    
                                    float x_197596;
                                    
                                    x_197596 = ((float *) mem_201709)[i_200177 *
                                                                      ctx_val_201733 +
                                                                      i_200170 *
                                                                      s_n_m_196745 +
                                                                      i_200163];
                                    
                                    bool cond_197597 = i_200163 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_197598;
                                    
                                    if (cond_197597) {
                                        defunc_0_m_fun_res_197598 = (int64_t) 0;
                                    } else {
                                        int64_t y_197599 = sub64(s_n_m_196745,
                                                                 (int64_t) 1);
                                        bool cond_197600 = i_200163 == y_197599;
                                        int64_t defunc_0_m_fun_res_f_res_197601;
                                        
                                        if (cond_197600) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_197602
                                            = sub64(pad_css_len_196741,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_197601 =
                                                defunc_0_m_fun_res_f_res_t_res_197602;
                                        } else {
                                            int64_t x_197603 = sub64(i_200163,
                                                                     (int64_t) 1);
                                            int64_t x_197604 =
                                                    mul64(jump_s_196701,
                                                          x_197603);
                                            int64_t min_arg_197605 =
                                                    add64((int64_t) 1,
                                                          x_197604);
                                            int64_t min_res_197606 =
                                                    smin64(defunc_0_f_res_196740,
                                                           min_arg_197605);
                                            
                                            defunc_0_m_fun_res_f_res_197601 =
                                                min_res_197606;
                                        }
                                        defunc_0_m_fun_res_197598 =
                                            defunc_0_m_fun_res_f_res_197601;
                                    }
                                    
                                    float defunc_2_reduce_res_197607;
                                    float defunc_2_reduce_res_197608;
                                    float defunc_2_reduce_res_197609;
                                    float defunc_2_reduce_res_197610;
                                    float defunc_2_reduce_res_197611;
                                    float redout_200150;
                                    float redout_200151;
                                    float redout_200152;
                                    float redout_200153;
                                    float redout_200154;
                                    
                                    redout_200150 = 0.0F;
                                    redout_200151 = 0.0F;
                                    redout_200152 = 0.0F;
                                    redout_200153 = 0.0F;
                                    redout_200154 = 0.0F;
                                    for (int64_t i_200155 = 0; i_200155 <
                                         q_s_196695; i_200155++) {
                                        bool cond_197628 = sle64(x_197589,
                                                                 i_200155);
                                        int64_t defunc_0_f_res_197629;
                                        
                                        if (cond_197628) {
                                            defunc_0_f_res_197629 = (int64_t) 0;
                                        } else {
                                            int64_t i_197630 = add64(x_197595,
                                                                     i_200155);
                                            int64_t defunc_0_add_arg_197631;
                                            
                                            defunc_0_add_arg_197631 =
                                                ((int64_t *) mem_201553)[i_200177 *
                                                                         ctx_val_201474 +
                                                                         i_200170 *
                                                                         defunc_0_f_res_196740 +
                                                                         i_197630];
                                            
                                            int64_t defunc_1_add_res_197632 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_197631);
                                            
                                            defunc_0_f_res_197629 =
                                                defunc_1_add_res_197632;
                                        }
                                        
                                        float defunc_0_f_res_197633;
                                        
                                        if (cond_197628) {
                                            defunc_0_f_res_197633 = 0.0F;
                                        } else {
                                            int64_t i_197634 = add64(x_197595,
                                                                     i_200155);
                                            float defunc_0_add_arg_197635;
                                            
                                            defunc_0_add_arg_197635 =
                                                ((float *) mem_202212)[i_200177 *
                                                                       ctx_val_201474 +
                                                                       i_200170 *
                                                                       defunc_0_f_res_196740 +
                                                                       i_197634];
                                            defunc_0_f_res_197633 =
                                                defunc_0_add_arg_197635;
                                        }
                                        
                                        int64_t binop_p_197636 =
                                                sub64(defunc_0_f_res_197629,
                                                      defunc_0_m_fun_res_197598);
                                        float defunc_0_f_res_197637 =
                                              sitofp_i64_f32(binop_p_197636);
                                        float abs_res_197638 =
                                              (float) fabs(defunc_0_f_res_197637);
                                        float tmp1_197639 = abs_res_197638 /
                                              x_197596;
                                        float x_197640 = tmp1_197639 *
                                              tmp1_197639;
                                        float y_197641 = tmp1_197639 * x_197640;
                                        float tmp2_197642 = 1.0F - y_197641;
                                        float x_197643 = tmp2_197642 *
                                              tmp2_197642;
                                        float tmp3_197644 = tmp2_197642 *
                                              x_197643;
                                        float w_j_197645 =
                                              defunc_0_f_res_197633 *
                                              tmp3_197644;
                                        float xw_j_197646 =
                                              defunc_0_f_res_197637 *
                                              w_j_197645;
                                        float x2w_j_197647 =
                                              defunc_0_f_res_197637 *
                                              xw_j_197646;
                                        float x3w_j_197648 =
                                              defunc_0_f_res_197637 *
                                              x2w_j_197647;
                                        float x4w_j_197649 =
                                              defunc_0_f_res_197637 *
                                              x3w_j_197648;
                                        float defunc_1_op_res_197614 =
                                              w_j_197645 + redout_200150;
                                        float defunc_1_op_res_197617 =
                                              xw_j_197646 + redout_200151;
                                        float defunc_1_op_res_197620 =
                                              x2w_j_197647 + redout_200152;
                                        float defunc_1_op_res_197623 =
                                              x3w_j_197648 + redout_200153;
                                        float defunc_1_op_res_197626 =
                                              x4w_j_197649 + redout_200154;
                                        float redout_tmp_206423 =
                                              defunc_1_op_res_197614;
                                        float redout_tmp_206424 =
                                              defunc_1_op_res_197617;
                                        float redout_tmp_206425 =
                                              defunc_1_op_res_197620;
                                        float redout_tmp_206426 =
                                              defunc_1_op_res_197623;
                                        float redout_tmp_206427 =
                                              defunc_1_op_res_197626;
                                        
                                        redout_200150 = redout_tmp_206423;
                                        redout_200151 = redout_tmp_206424;
                                        redout_200152 = redout_tmp_206425;
                                        redout_200153 = redout_tmp_206426;
                                        redout_200154 = redout_tmp_206427;
                                    }
                                    defunc_2_reduce_res_197607 = redout_200150;
                                    defunc_2_reduce_res_197608 = redout_200151;
                                    defunc_2_reduce_res_197609 = redout_200152;
                                    defunc_2_reduce_res_197610 = redout_200153;
                                    defunc_2_reduce_res_197611 = redout_200154;
                                    
                                    float x_197650 =
                                          defunc_2_reduce_res_197609 *
                                          defunc_2_reduce_res_197611;
                                    float y_197651 =
                                          defunc_2_reduce_res_197610 *
                                          defunc_2_reduce_res_197610;
                                    float a12_197652 = x_197650 - y_197651;
                                    float x_197653 =
                                          defunc_2_reduce_res_197609 *
                                          defunc_2_reduce_res_197610;
                                    float y_197654 =
                                          defunc_2_reduce_res_197608 *
                                          defunc_2_reduce_res_197611;
                                    float b12_197655 = x_197653 - y_197654;
                                    float x_197656 =
                                          defunc_2_reduce_res_197608 *
                                          defunc_2_reduce_res_197610;
                                    float y_197657 =
                                          defunc_2_reduce_res_197609 *
                                          defunc_2_reduce_res_197609;
                                    float c12_197658 = x_197656 - y_197657;
                                    float x_197659 =
                                          defunc_2_reduce_res_197607 *
                                          defunc_2_reduce_res_197611;
                                    float b2_197660 = x_197659 - y_197657;
                                    float x_197661 =
                                          defunc_2_reduce_res_197608 *
                                          defunc_2_reduce_res_197609;
                                    float y_197662 =
                                          defunc_2_reduce_res_197607 *
                                          defunc_2_reduce_res_197610;
                                    float c2_197663 = x_197661 - y_197662;
                                    float x_197664 =
                                          defunc_2_reduce_res_197607 *
                                          a12_197652;
                                    float y_197665 =
                                          defunc_2_reduce_res_197608 *
                                          b12_197655;
                                    float x_197666 = x_197664 + y_197665;
                                    float y_197667 =
                                          defunc_2_reduce_res_197609 *
                                          c12_197658;
                                    float y_197668 = x_197666 + y_197667;
                                    float det_197669 = 1.0F / y_197668;
                                    float a12_197670 = a12_197652 * det_197669;
                                    float b12_197671 = b12_197655 * det_197669;
                                    float c12_197672 = c12_197658 * det_197669;
                                    float b2_197673 = b2_197660 * det_197669;
                                    float c2_197674 = c2_197663 * det_197669;
                                    int64_t defunc_0_m_fun_res_197675;
                                    
                                    if (cond_197597) {
                                        defunc_0_m_fun_res_197675 = (int64_t) 0;
                                    } else {
                                        int64_t y_197676 = sub64(s_n_m_196745,
                                                                 (int64_t) 1);
                                        bool cond_197677 = i_200163 == y_197676;
                                        int64_t defunc_0_m_fun_res_f_res_197678;
                                        
                                        if (cond_197677) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_197679
                                            = sub64(pad_css_len_196741,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_197678 =
                                                defunc_0_m_fun_res_f_res_t_res_197679;
                                        } else {
                                            int64_t x_197680 = sub64(i_200163,
                                                                     (int64_t) 1);
                                            int64_t x_197681 =
                                                    mul64(jump_s_196701,
                                                          x_197680);
                                            int64_t min_arg_197682 =
                                                    add64((int64_t) 1,
                                                          x_197681);
                                            int64_t min_res_197683 =
                                                    smin64(defunc_0_f_res_196740,
                                                           min_arg_197682);
                                            
                                            defunc_0_m_fun_res_f_res_197678 =
                                                min_res_197683;
                                        }
                                        defunc_0_m_fun_res_197675 =
                                            defunc_0_m_fun_res_f_res_197678;
                                    }
                                    
                                    float defunc_2_reduce_res_197684;
                                    float defunc_2_reduce_res_197685;
                                    float redout_200156;
                                    float redout_200157;
                                    
                                    redout_200156 = 0.0F;
                                    redout_200157 = 0.0F;
                                    for (int64_t i_200158 = 0; i_200158 <
                                         q_s_196695; i_200158++) {
                                        bool cond_197693 = sle64(x_197589,
                                                                 i_200158);
                                        int64_t defunc_0_f_res_197694;
                                        
                                        if (cond_197693) {
                                            defunc_0_f_res_197694 = (int64_t) 0;
                                        } else {
                                            int64_t i_197695 = add64(x_197595,
                                                                     i_200158);
                                            int64_t defunc_0_add_arg_197696;
                                            
                                            defunc_0_add_arg_197696 =
                                                ((int64_t *) mem_201553)[i_200177 *
                                                                         ctx_val_201474 +
                                                                         i_200170 *
                                                                         defunc_0_f_res_196740 +
                                                                         i_197695];
                                            
                                            int64_t defunc_1_add_res_197697 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_197696);
                                            
                                            defunc_0_f_res_197694 =
                                                defunc_1_add_res_197697;
                                        }
                                        
                                        float defunc_0_f_res_197698;
                                        
                                        if (cond_197693) {
                                            defunc_0_f_res_197698 = 0.0F;
                                        } else {
                                            int64_t i_197699 = add64(x_197595,
                                                                     i_200158);
                                            float defunc_0_add_arg_197700;
                                            
                                            defunc_0_add_arg_197700 =
                                                ((float *) mem_202212)[i_200177 *
                                                                       ctx_val_201474 +
                                                                       i_200170 *
                                                                       defunc_0_f_res_196740 +
                                                                       i_197699];
                                            defunc_0_f_res_197698 =
                                                defunc_0_add_arg_197700;
                                        }
                                        
                                        int64_t binop_p_197701 =
                                                sub64(defunc_0_f_res_197694,
                                                      defunc_0_m_fun_res_197675);
                                        float defunc_0_f_res_197702 =
                                              sitofp_i64_f32(binop_p_197701);
                                        float abs_res_197703 =
                                              (float) fabs(defunc_0_f_res_197702);
                                        float tmp1_197704 = abs_res_197703 /
                                              x_197596;
                                        float x_197705 = tmp1_197704 *
                                              tmp1_197704;
                                        float y_197706 = tmp1_197704 * x_197705;
                                        float tmp2_197707 = 1.0F - y_197706;
                                        float x_197708 = tmp2_197707 *
                                              tmp2_197707;
                                        float tmp3_197709 = tmp2_197707 *
                                              x_197708;
                                        float tmp4_197710 =
                                              defunc_0_f_res_197698 *
                                              tmp3_197709;
                                        float defunc_1_f_res_197711 =
                                              defunc_0_f_res_197702 *
                                              tmp4_197710;
                                        float defunc_1_f_res_197712 =
                                              defunc_0_f_res_197702 *
                                              defunc_1_f_res_197711;
                                        float defunc_0_f_res_197713;
                                        
                                        if (cond_197693) {
                                            defunc_0_f_res_197713 = 0.0F;
                                        } else {
                                            int64_t i_197714 = add64(x_197595,
                                                                     i_200158);
                                            float defunc_0_add_arg_197715;
                                            
                                            defunc_0_add_arg_197715 =
                                                ((float *) mem_202207)[i_200177 *
                                                                       ctx_val_201474 +
                                                                       i_200170 *
                                                                       defunc_0_f_res_196740 +
                                                                       i_197714];
                                            defunc_0_f_res_197713 =
                                                defunc_0_add_arg_197715;
                                        }
                                        
                                        float x_197716 = a12_197670 *
                                              tmp4_197710;
                                        float y_197717 = b12_197671 *
                                              defunc_1_f_res_197711;
                                        float x_197718 = x_197716 + y_197717;
                                        float y_197719 = c12_197672 *
                                              defunc_1_f_res_197712;
                                        float x_197720 = x_197718 + y_197719;
                                        float defunc_9_fit_fun_res_197721 =
                                              defunc_0_f_res_197713 * x_197720;
                                        float x_197722 = b12_197671 *
                                              tmp4_197710;
                                        float y_197723 = b2_197673 *
                                              defunc_1_f_res_197711;
                                        float x_197724 = x_197722 + y_197723;
                                        float y_197725 = c2_197674 *
                                              defunc_1_f_res_197712;
                                        float x_197726 = x_197724 + y_197725;
                                        float defunc_9_slope_fun_res_197727 =
                                              defunc_0_f_res_197713 * x_197726;
                                        float defunc_1_op_res_197688 =
                                              defunc_9_fit_fun_res_197721 +
                                              redout_200156;
                                        float defunc_1_op_res_197691 =
                                              defunc_9_slope_fun_res_197727 +
                                              redout_200157;
                                        float redout_tmp_206428 =
                                              defunc_1_op_res_197688;
                                        float redout_tmp_206429 =
                                              defunc_1_op_res_197691;
                                        
                                        redout_200156 = redout_tmp_206428;
                                        redout_200157 = redout_tmp_206429;
                                    }
                                    defunc_2_reduce_res_197684 = redout_200156;
                                    defunc_2_reduce_res_197685 = redout_200157;
                                    ((float *) mem_202672.mem)[i_200177 *
                                                               ctx_val_201733 +
                                                               i_200170 *
                                                               s_n_m_196745 +
                                                               i_200163] =
                                        defunc_2_reduce_res_197684;
                                    ((float *) mem_202677.mem)[i_200177 *
                                                               ctx_val_201733 +
                                                               i_200170 *
                                                               s_n_m_196745 +
                                                               i_200163] =
                                        defunc_2_reduce_res_197685;
                                }
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_202863, &mem_202672,
                                         "mem_202672") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_202852, &mem_202677,
                                         "mem_202677") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_202677, "mem_202677") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_202672, "mem_202672") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_202886, &ext_mem_202863,
                                     "ext_mem_202863") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_202875, &ext_mem_202852,
                                     "ext_mem_202852") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_202852,
                                       "ext_mem_202852") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_202863,
                                       "ext_mem_202863") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_203523, &ext_mem_202886,
                                 "ext_mem_202886") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_203512, &ext_mem_202875,
                                 "ext_mem_202875") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_202875, "ext_mem_202875") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_202886, "ext_mem_202886") != 0)
                    return 1;
            } else {
                bool match_lit_197730 = (int64_t) 0 == d_s_196698;
                int64_t binop_y_202954 = (int64_t) 4 * q_s_196695;
                int64_t bytes_202955 = smax64((int64_t) 0, binop_y_202954);
                struct memblock ext_mem_203501;
                
                ext_mem_203501.references = NULL;
                
                struct memblock ext_mem_203490;
                
                ext_mem_203490.references = NULL;
                if (match_lit_197730) {
                    struct memblock mem_202901;
                    
                    mem_202901.references = NULL;
                    if (memblock_alloc(ctx, &mem_202901, bytes_201708,
                                       "mem_202901")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_206430 = 0; i_206430 < m_196691;
                         i_206430++) {
                        for (int64_t i_206431 = 0; i_206431 < n_p_196694;
                             i_206431++) {
                            for (int64_t i_206432 = 0; i_206432 < s_n_m_196745;
                                 i_206432++) {
                                ((float *) mem_202901.mem)[i_206430 *
                                                           (s_n_m_196745 *
                                                            n_p_196694) +
                                                           i_206431 *
                                                           s_n_m_196745 +
                                                           i_206432] = 0.0F;
                            }
                        }
                    }
                    
                    struct memblock mem_202906;
                    
                    mem_202906.references = NULL;
                    if (memblock_alloc(ctx, &mem_202906, bytes_201708,
                                       "mem_202906")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (mem_202956_cached_sizze_206679 <
                        (size_t) bytes_202955) {
                        mem_202956 = realloc(mem_202956, bytes_202955);
                        mem_202956_cached_sizze_206679 = bytes_202955;
                    }
                    for (int64_t i_200197 = 0; i_200197 < m_196691;
                         i_200197++) {
                        for (int64_t i_200193 = 0; i_200193 < n_p_196694;
                             i_200193++) {
                            int64_t x_197746;
                            
                            x_197746 = ((int64_t *) mem_201557)[i_200197 *
                                                                n_p_196694 +
                                                                i_200193];
                            for (int64_t i_200189 = 0; i_200189 < s_n_m_196745;
                                 i_200189++) {
                                int64_t x_197751;
                                
                                x_197751 = ((int64_t *) mem_201704)[i_200197 *
                                                                    ctx_val_201733 +
                                                                    i_200193 *
                                                                    s_n_m_196745 +
                                                                    i_200189];
                                
                                float x_197752;
                                
                                x_197752 = ((float *) mem_201709)[i_200197 *
                                                                  ctx_val_201733 +
                                                                  i_200193 *
                                                                  s_n_m_196745 +
                                                                  i_200189];
                                
                                bool cond_197753 = i_200189 == (int64_t) 0;
                                int64_t defunc_0_m_fun_res_197754;
                                
                                if (cond_197753) {
                                    defunc_0_m_fun_res_197754 = (int64_t) 0;
                                } else {
                                    int64_t y_197755 = sub64(s_n_m_196745,
                                                             (int64_t) 1);
                                    bool cond_197756 = i_200189 == y_197755;
                                    int64_t defunc_0_m_fun_res_f_res_197757;
                                    
                                    if (cond_197756) {
                                        int64_t
                                        defunc_0_m_fun_res_f_res_t_res_197758 =
                                        sub64(pad_css_len_196741, (int64_t) 1);
                                        
                                        defunc_0_m_fun_res_f_res_197757 =
                                            defunc_0_m_fun_res_f_res_t_res_197758;
                                    } else {
                                        int64_t x_197759 = sub64(i_200189,
                                                                 (int64_t) 1);
                                        int64_t x_197760 = mul64(jump_s_196701,
                                                                 x_197759);
                                        int64_t min_arg_197761 =
                                                add64((int64_t) 1, x_197760);
                                        int64_t min_res_197762 =
                                                smin64(defunc_0_f_res_196740,
                                                       min_arg_197761);
                                        
                                        defunc_0_m_fun_res_f_res_197757 =
                                            min_res_197762;
                                    }
                                    defunc_0_m_fun_res_197754 =
                                        defunc_0_m_fun_res_f_res_197757;
                                }
                                
                                float defunc_2_reduce_res_197763;
                                float redout_200181 = 0.0F;
                                
                                for (int64_t i_200183 = 0; i_200183 <
                                     q_s_196695; i_200183++) {
                                    bool cond_197769 = sle64(x_197746,
                                                             i_200183);
                                    int64_t defunc_0_f_res_197770;
                                    
                                    if (cond_197769) {
                                        defunc_0_f_res_197770 = (int64_t) 0;
                                    } else {
                                        int64_t i_197771 = add64(x_197751,
                                                                 i_200183);
                                        int64_t defunc_0_add_arg_197772;
                                        
                                        defunc_0_add_arg_197772 =
                                            ((int64_t *) mem_201553)[i_200197 *
                                                                     ctx_val_201474 +
                                                                     i_200193 *
                                                                     defunc_0_f_res_196740 +
                                                                     i_197771];
                                        
                                        int64_t defunc_1_add_res_197773 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_197772);
                                        
                                        defunc_0_f_res_197770 =
                                            defunc_1_add_res_197773;
                                    }
                                    
                                    float defunc_0_f_res_197774;
                                    
                                    if (cond_197769) {
                                        defunc_0_f_res_197774 = 0.0F;
                                    } else {
                                        int64_t i_197775 = add64(x_197751,
                                                                 i_200183);
                                        float defunc_0_add_arg_197776;
                                        
                                        defunc_0_add_arg_197776 =
                                            ((float *) mem_202212)[i_200197 *
                                                                   ctx_val_201474 +
                                                                   i_200193 *
                                                                   defunc_0_f_res_196740 +
                                                                   i_197775];
                                        defunc_0_f_res_197774 =
                                            defunc_0_add_arg_197776;
                                    }
                                    
                                    int64_t binop_p_197777 =
                                            sub64(defunc_0_f_res_197770,
                                                  defunc_0_m_fun_res_197754);
                                    float defunc_0_f_res_197778 =
                                          sitofp_i64_f32(binop_p_197777);
                                    float abs_res_197779 =
                                          (float) fabs(defunc_0_f_res_197778);
                                    float tmp1_197780 = abs_res_197779 /
                                          x_197752;
                                    float x_197781 = tmp1_197780 * tmp1_197780;
                                    float y_197782 = tmp1_197780 * x_197781;
                                    float tmp2_197783 = 1.0F - y_197782;
                                    float x_197784 = tmp2_197783 * tmp2_197783;
                                    float tmp3_197785 = tmp2_197783 * x_197784;
                                    float tmp4_197786 = defunc_0_f_res_197774 *
                                          tmp3_197785;
                                    float defunc_1_op_res_197767 = tmp4_197786 +
                                          redout_200181;
                                    
                                    ((float *) mem_202956)[i_200183] =
                                        tmp4_197786;
                                    
                                    float redout_tmp_206436 =
                                          defunc_1_op_res_197767;
                                    
                                    redout_200181 = redout_tmp_206436;
                                }
                                defunc_2_reduce_res_197763 = redout_200181;
                                
                                float a0_197787 = 1.0F /
                                      defunc_2_reduce_res_197763;
                                float defunc_2_reduce_res_197788;
                                float redout_200185 = 0.0F;
                                
                                for (int64_t i_200186 = 0; i_200186 <
                                     q_s_196695; i_200186++) {
                                    float x_197793;
                                    
                                    x_197793 = ((float *) mem_202956)[i_200186];
                                    
                                    bool cond_197794 = sle64(x_197746,
                                                             i_200186);
                                    float defunc_0_f_res_197795;
                                    
                                    if (cond_197794) {
                                        defunc_0_f_res_197795 = 0.0F;
                                    } else {
                                        int64_t i_197796 = add64(x_197751,
                                                                 i_200186);
                                        float defunc_0_add_arg_197797;
                                        
                                        defunc_0_add_arg_197797 =
                                            ((float *) mem_202207)[i_200197 *
                                                                   ctx_val_201474 +
                                                                   i_200193 *
                                                                   defunc_0_f_res_196740 +
                                                                   i_197796];
                                        defunc_0_f_res_197795 =
                                            defunc_0_add_arg_197797;
                                    }
                                    
                                    float x_197798 = a0_197787 * x_197793;
                                    float defunc_9_fit_fun_res_197799 =
                                          defunc_0_f_res_197795 * x_197798;
                                    float defunc_1_op_res_197791 =
                                          defunc_9_fit_fun_res_197799 +
                                          redout_200185;
                                    float redout_tmp_206438 =
                                          defunc_1_op_res_197791;
                                    
                                    redout_200185 = redout_tmp_206438;
                                }
                                defunc_2_reduce_res_197788 = redout_200185;
                                ((float *) mem_202906.mem)[i_200197 *
                                                           ctx_val_201733 +
                                                           i_200193 *
                                                           s_n_m_196745 +
                                                           i_200189] =
                                    defunc_2_reduce_res_197788;
                            }
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_203501, &mem_202906,
                                     "mem_202906") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_203490, &mem_202901,
                                     "mem_202901") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202906, "mem_202906") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202901, "mem_202901") != 0)
                        return 1;
                } else {
                    bool match_lit_197802 = (int64_t) 1 == d_s_196698;
                    int64_t binop_y_203113 = (int64_t) 4 * q_s_196695;
                    int64_t bytes_203114 = smax64((int64_t) 0, binop_y_203113);
                    int64_t binop_y_203327 = (int64_t) 4 * q_s_196695;
                    int64_t bytes_203328 = smax64((int64_t) 0, binop_y_203327);
                    struct memblock ext_mem_203478;
                    
                    ext_mem_203478.references = NULL;
                    
                    struct memblock ext_mem_203467;
                    
                    ext_mem_203467.references = NULL;
                    if (match_lit_197802) {
                        struct memblock mem_203013;
                        
                        mem_203013.references = NULL;
                        if (memblock_alloc(ctx, &mem_203013, bytes_201708,
                                           "mem_203013")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_203018;
                        
                        mem_203018.references = NULL;
                        if (memblock_alloc(ctx, &mem_203018, bytes_201708,
                                           "mem_203018")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_203115_cached_sizze_206680 <
                            (size_t) bytes_203114) {
                            mem_203115 = realloc(mem_203115, bytes_203114);
                            mem_203115_cached_sizze_206680 = bytes_203114;
                        }
                        if (mem_203118_cached_sizze_206681 <
                            (size_t) bytes_203114) {
                            mem_203118 = realloc(mem_203118, bytes_203114);
                            mem_203118_cached_sizze_206681 = bytes_203114;
                        }
                        for (int64_t i_200230 = 0; i_200230 < m_196691;
                             i_200230++) {
                            for (int64_t i_200223 = 0; i_200223 < n_p_196694;
                                 i_200223++) {
                                int64_t x_197819;
                                
                                x_197819 = ((int64_t *) mem_201557)[i_200230 *
                                                                    n_p_196694 +
                                                                    i_200223];
                                for (int64_t i_200216 = 0; i_200216 <
                                     s_n_m_196745; i_200216++) {
                                    int64_t x_197825;
                                    
                                    x_197825 =
                                        ((int64_t *) mem_201704)[i_200230 *
                                                                 ctx_val_201733 +
                                                                 i_200223 *
                                                                 s_n_m_196745 +
                                                                 i_200216];
                                    
                                    float x_197826;
                                    
                                    x_197826 = ((float *) mem_201709)[i_200230 *
                                                                      ctx_val_201733 +
                                                                      i_200223 *
                                                                      s_n_m_196745 +
                                                                      i_200216];
                                    
                                    bool cond_197827 = i_200216 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_197828;
                                    
                                    if (cond_197827) {
                                        defunc_0_m_fun_res_197828 = (int64_t) 0;
                                    } else {
                                        int64_t y_197829 = sub64(s_n_m_196745,
                                                                 (int64_t) 1);
                                        bool cond_197830 = i_200216 == y_197829;
                                        int64_t defunc_0_m_fun_res_f_res_197831;
                                        
                                        if (cond_197830) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_197832
                                            = sub64(pad_css_len_196741,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_197831 =
                                                defunc_0_m_fun_res_f_res_t_res_197832;
                                        } else {
                                            int64_t x_197833 = sub64(i_200216,
                                                                     (int64_t) 1);
                                            int64_t x_197834 =
                                                    mul64(jump_s_196701,
                                                          x_197833);
                                            int64_t min_arg_197835 =
                                                    add64((int64_t) 1,
                                                          x_197834);
                                            int64_t min_res_197836 =
                                                    smin64(defunc_0_f_res_196740,
                                                           min_arg_197835);
                                            
                                            defunc_0_m_fun_res_f_res_197831 =
                                                min_res_197836;
                                        }
                                        defunc_0_m_fun_res_197828 =
                                            defunc_0_m_fun_res_f_res_197831;
                                    }
                                    
                                    float defunc_2_reduce_res_197860;
                                    float defunc_2_reduce_res_197861;
                                    float defunc_2_reduce_res_197862;
                                    float redout_200201;
                                    float redout_200202;
                                    float redout_200203;
                                    
                                    redout_200201 = 0.0F;
                                    redout_200202 = 0.0F;
                                    redout_200203 = 0.0F;
                                    for (int64_t i_200206 = 0; i_200206 <
                                         q_s_196695; i_200206++) {
                                        bool cond_197875 = sle64(x_197819,
                                                                 i_200206);
                                        int64_t defunc_0_f_res_197876;
                                        
                                        if (cond_197875) {
                                            defunc_0_f_res_197876 = (int64_t) 0;
                                        } else {
                                            int64_t i_197877 = add64(x_197825,
                                                                     i_200206);
                                            int64_t defunc_0_add_arg_197878;
                                            
                                            defunc_0_add_arg_197878 =
                                                ((int64_t *) mem_201553)[i_200230 *
                                                                         ctx_val_201474 +
                                                                         i_200223 *
                                                                         defunc_0_f_res_196740 +
                                                                         i_197877];
                                            
                                            int64_t defunc_1_add_res_197879 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_197878);
                                            
                                            defunc_0_f_res_197876 =
                                                defunc_1_add_res_197879;
                                        }
                                        
                                        float defunc_0_f_res_197880;
                                        
                                        if (cond_197875) {
                                            defunc_0_f_res_197880 = 0.0F;
                                        } else {
                                            int64_t i_197881 = add64(x_197825,
                                                                     i_200206);
                                            float defunc_0_add_arg_197882;
                                            
                                            defunc_0_add_arg_197882 =
                                                ((float *) mem_202212)[i_200230 *
                                                                       ctx_val_201474 +
                                                                       i_200223 *
                                                                       defunc_0_f_res_196740 +
                                                                       i_197881];
                                            defunc_0_f_res_197880 =
                                                defunc_0_add_arg_197882;
                                        }
                                        
                                        int64_t binop_p_197883 =
                                                sub64(defunc_0_f_res_197876,
                                                      defunc_0_m_fun_res_197828);
                                        float defunc_0_f_res_197884 =
                                              sitofp_i64_f32(binop_p_197883);
                                        float abs_res_197885 =
                                              (float) fabs(defunc_0_f_res_197884);
                                        float tmp1_197886 = abs_res_197885 /
                                              x_197826;
                                        float x_197887 = tmp1_197886 *
                                              tmp1_197886;
                                        float y_197888 = tmp1_197886 * x_197887;
                                        float tmp2_197889 = 1.0F - y_197888;
                                        float x_197890 = tmp2_197889 *
                                              tmp2_197889;
                                        float tmp3_197891 = tmp2_197889 *
                                              x_197890;
                                        float tmp4_197892 =
                                              defunc_0_f_res_197880 *
                                              tmp3_197891;
                                        float defunc_1_f_res_197893 =
                                              defunc_0_f_res_197884 *
                                              tmp4_197892;
                                        float defunc_1_f_res_197894 =
                                              defunc_0_f_res_197884 *
                                              defunc_1_f_res_197893;
                                        float defunc_1_op_res_197867 =
                                              tmp4_197892 + redout_200201;
                                        float defunc_1_op_res_197870 =
                                              defunc_1_f_res_197893 +
                                              redout_200202;
                                        float defunc_1_op_res_197873 =
                                              defunc_1_f_res_197894 +
                                              redout_200203;
                                        
                                        ((float *) mem_203115)[i_200206] =
                                            defunc_1_f_res_197893;
                                        ((float *) mem_203118)[i_200206] =
                                            tmp4_197892;
                                        
                                        float redout_tmp_206445 =
                                              defunc_1_op_res_197867;
                                        float redout_tmp_206446 =
                                              defunc_1_op_res_197870;
                                        float redout_tmp_206447 =
                                              defunc_1_op_res_197873;
                                        
                                        redout_200201 = redout_tmp_206445;
                                        redout_200202 = redout_tmp_206446;
                                        redout_200203 = redout_tmp_206447;
                                    }
                                    defunc_2_reduce_res_197860 = redout_200201;
                                    defunc_2_reduce_res_197861 = redout_200202;
                                    defunc_2_reduce_res_197862 = redout_200203;
                                    
                                    float x_197900 =
                                          defunc_2_reduce_res_197860 *
                                          defunc_2_reduce_res_197862;
                                    float y_197901 =
                                          defunc_2_reduce_res_197861 *
                                          defunc_2_reduce_res_197861;
                                    float y_197902 = x_197900 - y_197901;
                                    float det1_197903 = 1.0F / y_197902;
                                    float a11_197904 =
                                          defunc_2_reduce_res_197862 *
                                          det1_197903;
                                    float x_197905 = 0.0F -
                                          defunc_2_reduce_res_197861;
                                    float b11_197906 = det1_197903 * x_197905;
                                    float c11_197907 =
                                          defunc_2_reduce_res_197860 *
                                          det1_197903;
                                    float defunc_2_reduce_res_197908;
                                    float defunc_2_reduce_res_197909;
                                    float redout_200209;
                                    float redout_200210;
                                    
                                    redout_200209 = 0.0F;
                                    redout_200210 = 0.0F;
                                    for (int64_t i_200211 = 0; i_200211 <
                                         q_s_196695; i_200211++) {
                                        float x_197917;
                                        
                                        x_197917 =
                                            ((float *) mem_203118)[i_200211];
                                        
                                        float x_197918;
                                        
                                        x_197918 =
                                            ((float *) mem_203115)[i_200211];
                                        
                                        bool cond_197919 = sle64(x_197819,
                                                                 i_200211);
                                        float defunc_0_f_res_197920;
                                        
                                        if (cond_197919) {
                                            defunc_0_f_res_197920 = 0.0F;
                                        } else {
                                            int64_t i_197921 = add64(x_197825,
                                                                     i_200211);
                                            float defunc_0_add_arg_197922;
                                            
                                            defunc_0_add_arg_197922 =
                                                ((float *) mem_202207)[i_200230 *
                                                                       ctx_val_201474 +
                                                                       i_200223 *
                                                                       defunc_0_f_res_196740 +
                                                                       i_197921];
                                            defunc_0_f_res_197920 =
                                                defunc_0_add_arg_197922;
                                        }
                                        
                                        float x_197923 = a11_197904 * x_197917;
                                        float y_197924 = b11_197906 * x_197918;
                                        float x_197925 = x_197923 + y_197924;
                                        float defunc_9_fit_fun_res_197926 =
                                              defunc_0_f_res_197920 * x_197925;
                                        float x_197927 = b11_197906 * x_197917;
                                        float y_197928 = c11_197907 * x_197918;
                                        float x_197929 = x_197927 + y_197928;
                                        float defunc_9_slope_fun_res_197930 =
                                              defunc_0_f_res_197920 * x_197929;
                                        float defunc_1_op_res_197912 =
                                              defunc_9_fit_fun_res_197926 +
                                              redout_200209;
                                        float defunc_1_op_res_197915 =
                                              defunc_9_slope_fun_res_197930 +
                                              redout_200210;
                                        float redout_tmp_206450 =
                                              defunc_1_op_res_197912;
                                        float redout_tmp_206451 =
                                              defunc_1_op_res_197915;
                                        
                                        redout_200209 = redout_tmp_206450;
                                        redout_200210 = redout_tmp_206451;
                                    }
                                    defunc_2_reduce_res_197908 = redout_200209;
                                    defunc_2_reduce_res_197909 = redout_200210;
                                    ((float *) mem_203013.mem)[i_200230 *
                                                               ctx_val_201733 +
                                                               i_200223 *
                                                               s_n_m_196745 +
                                                               i_200216] =
                                        defunc_2_reduce_res_197908;
                                    ((float *) mem_203018.mem)[i_200230 *
                                                               ctx_val_201733 +
                                                               i_200223 *
                                                               s_n_m_196745 +
                                                               i_200216] =
                                        defunc_2_reduce_res_197909;
                                }
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_203478, &mem_203013,
                                         "mem_203013") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_203467, &mem_203018,
                                         "mem_203018") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_203018, "mem_203018") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_203013, "mem_203013") != 0)
                            return 1;
                    } else {
                        struct memblock mem_203227;
                        
                        mem_203227.references = NULL;
                        if (memblock_alloc(ctx, &mem_203227, bytes_201708,
                                           "mem_203227")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_203232;
                        
                        mem_203232.references = NULL;
                        if (memblock_alloc(ctx, &mem_203232, bytes_201708,
                                           "mem_203232")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_203329_cached_sizze_206682 <
                            (size_t) bytes_203328) {
                            mem_203329 = realloc(mem_203329, bytes_203328);
                            mem_203329_cached_sizze_206682 = bytes_203328;
                        }
                        if (mem_203332_cached_sizze_206683 <
                            (size_t) bytes_203328) {
                            mem_203332 = realloc(mem_203332, bytes_203328);
                            mem_203332_cached_sizze_206683 = bytes_203328;
                        }
                        if (mem_203359_cached_sizze_206684 <
                            (size_t) bytes_203328) {
                            mem_203359 = realloc(mem_203359, bytes_203328);
                            mem_203359_cached_sizze_206684 = bytes_203328;
                        }
                        if (mem_203362_cached_sizze_206685 <
                            (size_t) bytes_203328) {
                            mem_203362 = realloc(mem_203362, bytes_203328);
                            mem_203362_cached_sizze_206685 = bytes_203328;
                        }
                        for (int64_t i_200273 = 0; i_200273 < m_196691;
                             i_200273++) {
                            for (int64_t i_200266 = 0; i_200266 < n_p_196694;
                                 i_200266++) {
                                int64_t x_197947;
                                
                                x_197947 = ((int64_t *) mem_201557)[i_200273 *
                                                                    n_p_196694 +
                                                                    i_200266];
                                for (int64_t i_200259 = 0; i_200259 <
                                     s_n_m_196745; i_200259++) {
                                    int64_t x_197953;
                                    
                                    x_197953 =
                                        ((int64_t *) mem_201704)[i_200273 *
                                                                 ctx_val_201733 +
                                                                 i_200266 *
                                                                 s_n_m_196745 +
                                                                 i_200259];
                                    
                                    float x_197954;
                                    
                                    x_197954 = ((float *) mem_201709)[i_200273 *
                                                                      ctx_val_201733 +
                                                                      i_200266 *
                                                                      s_n_m_196745 +
                                                                      i_200259];
                                    
                                    bool cond_197955 = i_200259 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_197956;
                                    
                                    if (cond_197955) {
                                        defunc_0_m_fun_res_197956 = (int64_t) 0;
                                    } else {
                                        int64_t y_197957 = sub64(s_n_m_196745,
                                                                 (int64_t) 1);
                                        bool cond_197958 = i_200259 == y_197957;
                                        int64_t defunc_0_m_fun_res_f_res_197959;
                                        
                                        if (cond_197958) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_197960
                                            = sub64(pad_css_len_196741,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_197959 =
                                                defunc_0_m_fun_res_f_res_t_res_197960;
                                        } else {
                                            int64_t x_197961 = sub64(i_200259,
                                                                     (int64_t) 1);
                                            int64_t x_197962 =
                                                    mul64(jump_s_196701,
                                                          x_197961);
                                            int64_t min_arg_197963 =
                                                    add64((int64_t) 1,
                                                          x_197962);
                                            int64_t min_res_197964 =
                                                    smin64(defunc_0_f_res_196740,
                                                           min_arg_197963);
                                            
                                            defunc_0_m_fun_res_f_res_197959 =
                                                min_res_197964;
                                        }
                                        defunc_0_m_fun_res_197956 =
                                            defunc_0_m_fun_res_f_res_197959;
                                    }
                                    for (int64_t i_200237 = 0; i_200237 <
                                         q_s_196695; i_200237++) {
                                        bool cond_197968 = sle64(x_197947,
                                                                 i_200237);
                                        int64_t defunc_0_f_res_197969;
                                        
                                        if (cond_197968) {
                                            defunc_0_f_res_197969 = (int64_t) 0;
                                        } else {
                                            int64_t i_197970 = add64(x_197953,
                                                                     i_200237);
                                            int64_t defunc_0_add_arg_197971;
                                            
                                            defunc_0_add_arg_197971 =
                                                ((int64_t *) mem_201553)[i_200273 *
                                                                         ctx_val_201474 +
                                                                         i_200266 *
                                                                         defunc_0_f_res_196740 +
                                                                         i_197970];
                                            
                                            int64_t defunc_1_add_res_197972 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_197971);
                                            
                                            defunc_0_f_res_197969 =
                                                defunc_1_add_res_197972;
                                        }
                                        
                                        float defunc_0_f_res_197973;
                                        
                                        if (cond_197968) {
                                            defunc_0_f_res_197973 = 0.0F;
                                        } else {
                                            int64_t i_197974 = add64(x_197953,
                                                                     i_200237);
                                            float defunc_0_add_arg_197975;
                                            
                                            defunc_0_add_arg_197975 =
                                                ((float *) mem_202212)[i_200273 *
                                                                       ctx_val_201474 +
                                                                       i_200266 *
                                                                       defunc_0_f_res_196740 +
                                                                       i_197974];
                                            defunc_0_f_res_197973 =
                                                defunc_0_add_arg_197975;
                                        }
                                        
                                        int64_t binop_p_197976 =
                                                sub64(defunc_0_f_res_197969,
                                                      defunc_0_m_fun_res_197956);
                                        float defunc_0_f_res_197977 =
                                              sitofp_i64_f32(binop_p_197976);
                                        float abs_res_197978 =
                                              (float) fabs(defunc_0_f_res_197977);
                                        float tmp1_197979 = abs_res_197978 /
                                              x_197954;
                                        float x_197980 = tmp1_197979 *
                                              tmp1_197979;
                                        float y_197981 = tmp1_197979 * x_197980;
                                        float tmp2_197982 = 1.0F - y_197981;
                                        float x_197983 = tmp2_197982 *
                                              tmp2_197982;
                                        float tmp3_197984 = tmp2_197982 *
                                              x_197983;
                                        float tmp4_197985 =
                                              defunc_0_f_res_197973 *
                                              tmp3_197984;
                                        
                                        ((float *) mem_203329)[i_200237] =
                                            defunc_0_f_res_197977;
                                        ((float *) mem_203332)[i_200237] =
                                            tmp4_197985;
                                    }
                                    
                                    float defunc_2_reduce_res_197992;
                                    float defunc_2_reduce_res_197993;
                                    float defunc_2_reduce_res_197994;
                                    float defunc_2_reduce_res_197995;
                                    float defunc_2_reduce_res_197996;
                                    float redout_200242;
                                    float redout_200243;
                                    float redout_200244;
                                    float redout_200245;
                                    float redout_200246;
                                    
                                    redout_200242 = 0.0F;
                                    redout_200243 = 0.0F;
                                    redout_200244 = 0.0F;
                                    redout_200245 = 0.0F;
                                    redout_200246 = 0.0F;
                                    for (int64_t i_200249 = 0; i_200249 <
                                         q_s_196695; i_200249++) {
                                        float x_198014;
                                        
                                        x_198014 =
                                            ((float *) mem_203329)[i_200249];
                                        
                                        float x_198015;
                                        
                                        x_198015 =
                                            ((float *) mem_203332)[i_200249];
                                        
                                        float defunc_1_f_res_198016 = x_198014 *
                                              x_198015;
                                        float defunc_1_f_res_198017 = x_198014 *
                                              defunc_1_f_res_198016;
                                        float defunc_1_f_res_198018 = x_198014 *
                                              defunc_1_f_res_198017;
                                        float defunc_1_f_res_198019 = x_198014 *
                                              defunc_1_f_res_198018;
                                        float defunc_1_op_res_198001 =
                                              x_198015 + redout_200242;
                                        float defunc_1_op_res_198004 =
                                              defunc_1_f_res_198016 +
                                              redout_200243;
                                        float defunc_1_op_res_198007 =
                                              defunc_1_f_res_198017 +
                                              redout_200244;
                                        float defunc_1_op_res_198010 =
                                              defunc_1_f_res_198018 +
                                              redout_200245;
                                        float defunc_1_op_res_198013 =
                                              defunc_1_f_res_198019 +
                                              redout_200246;
                                        
                                        ((float *) mem_203359)[i_200249] =
                                            defunc_1_f_res_198017;
                                        ((float *) mem_203362)[i_200249] =
                                            defunc_1_f_res_198016;
                                        
                                        float redout_tmp_206460 =
                                              defunc_1_op_res_198001;
                                        float redout_tmp_206461 =
                                              defunc_1_op_res_198004;
                                        float redout_tmp_206462 =
                                              defunc_1_op_res_198007;
                                        float redout_tmp_206463 =
                                              defunc_1_op_res_198010;
                                        float redout_tmp_206464 =
                                              defunc_1_op_res_198013;
                                        
                                        redout_200242 = redout_tmp_206460;
                                        redout_200243 = redout_tmp_206461;
                                        redout_200244 = redout_tmp_206462;
                                        redout_200245 = redout_tmp_206463;
                                        redout_200246 = redout_tmp_206464;
                                    }
                                    defunc_2_reduce_res_197992 = redout_200242;
                                    defunc_2_reduce_res_197993 = redout_200243;
                                    defunc_2_reduce_res_197994 = redout_200244;
                                    defunc_2_reduce_res_197995 = redout_200245;
                                    defunc_2_reduce_res_197996 = redout_200246;
                                    
                                    float x_198027 =
                                          defunc_2_reduce_res_197994 *
                                          defunc_2_reduce_res_197996;
                                    float y_198028 =
                                          defunc_2_reduce_res_197995 *
                                          defunc_2_reduce_res_197995;
                                    float a12_198029 = x_198027 - y_198028;
                                    float x_198030 =
                                          defunc_2_reduce_res_197994 *
                                          defunc_2_reduce_res_197995;
                                    float y_198031 =
                                          defunc_2_reduce_res_197993 *
                                          defunc_2_reduce_res_197996;
                                    float b12_198032 = x_198030 - y_198031;
                                    float x_198033 =
                                          defunc_2_reduce_res_197993 *
                                          defunc_2_reduce_res_197995;
                                    float y_198034 =
                                          defunc_2_reduce_res_197994 *
                                          defunc_2_reduce_res_197994;
                                    float c12_198035 = x_198033 - y_198034;
                                    float x_198036 =
                                          defunc_2_reduce_res_197992 *
                                          defunc_2_reduce_res_197996;
                                    float b2_198037 = x_198036 - y_198034;
                                    float x_198038 =
                                          defunc_2_reduce_res_197993 *
                                          defunc_2_reduce_res_197994;
                                    float y_198039 =
                                          defunc_2_reduce_res_197992 *
                                          defunc_2_reduce_res_197995;
                                    float c2_198040 = x_198038 - y_198039;
                                    float x_198041 =
                                          defunc_2_reduce_res_197992 *
                                          a12_198029;
                                    float y_198042 =
                                          defunc_2_reduce_res_197993 *
                                          b12_198032;
                                    float x_198043 = x_198041 + y_198042;
                                    float y_198044 =
                                          defunc_2_reduce_res_197994 *
                                          c12_198035;
                                    float y_198045 = x_198043 + y_198044;
                                    float det_198046 = 1.0F / y_198045;
                                    float a12_198047 = a12_198029 * det_198046;
                                    float b12_198048 = b12_198032 * det_198046;
                                    float c12_198049 = c12_198035 * det_198046;
                                    float b2_198050 = b2_198037 * det_198046;
                                    float c2_198051 = c2_198040 * det_198046;
                                    float defunc_2_reduce_res_198052;
                                    float defunc_2_reduce_res_198053;
                                    float redout_200252;
                                    float redout_200253;
                                    
                                    redout_200252 = 0.0F;
                                    redout_200253 = 0.0F;
                                    for (int64_t i_200254 = 0; i_200254 <
                                         q_s_196695; i_200254++) {
                                        float x_198061;
                                        
                                        x_198061 =
                                            ((float *) mem_203332)[i_200254];
                                        
                                        float x_198062;
                                        
                                        x_198062 =
                                            ((float *) mem_203362)[i_200254];
                                        
                                        float x_198063;
                                        
                                        x_198063 =
                                            ((float *) mem_203359)[i_200254];
                                        
                                        bool cond_198064 = sle64(x_197947,
                                                                 i_200254);
                                        float defunc_0_f_res_198065;
                                        
                                        if (cond_198064) {
                                            defunc_0_f_res_198065 = 0.0F;
                                        } else {
                                            int64_t i_198066 = add64(x_197953,
                                                                     i_200254);
                                            float defunc_0_add_arg_198067;
                                            
                                            defunc_0_add_arg_198067 =
                                                ((float *) mem_202207)[i_200273 *
                                                                       ctx_val_201474 +
                                                                       i_200266 *
                                                                       defunc_0_f_res_196740 +
                                                                       i_198066];
                                            defunc_0_f_res_198065 =
                                                defunc_0_add_arg_198067;
                                        }
                                        
                                        float x_198068 = a12_198047 * x_198061;
                                        float y_198069 = b12_198048 * x_198062;
                                        float x_198070 = x_198068 + y_198069;
                                        float y_198071 = c12_198049 * x_198063;
                                        float x_198072 = x_198070 + y_198071;
                                        float defunc_9_fit_fun_res_198073 =
                                              defunc_0_f_res_198065 * x_198072;
                                        float x_198074 = b12_198048 * x_198061;
                                        float y_198075 = b2_198050 * x_198062;
                                        float x_198076 = x_198074 + y_198075;
                                        float y_198077 = c2_198051 * x_198063;
                                        float x_198078 = x_198076 + y_198077;
                                        float defunc_9_slope_fun_res_198079 =
                                              defunc_0_f_res_198065 * x_198078;
                                        float defunc_1_op_res_198056 =
                                              defunc_9_fit_fun_res_198073 +
                                              redout_200252;
                                        float defunc_1_op_res_198059 =
                                              defunc_9_slope_fun_res_198079 +
                                              redout_200253;
                                        float redout_tmp_206467 =
                                              defunc_1_op_res_198056;
                                        float redout_tmp_206468 =
                                              defunc_1_op_res_198059;
                                        
                                        redout_200252 = redout_tmp_206467;
                                        redout_200253 = redout_tmp_206468;
                                    }
                                    defunc_2_reduce_res_198052 = redout_200252;
                                    defunc_2_reduce_res_198053 = redout_200253;
                                    ((float *) mem_203227.mem)[i_200273 *
                                                               ctx_val_201733 +
                                                               i_200266 *
                                                               s_n_m_196745 +
                                                               i_200259] =
                                        defunc_2_reduce_res_198052;
                                    ((float *) mem_203232.mem)[i_200273 *
                                                               ctx_val_201733 +
                                                               i_200266 *
                                                               s_n_m_196745 +
                                                               i_200259] =
                                        defunc_2_reduce_res_198053;
                                }
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_203478, &mem_203227,
                                         "mem_203227") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_203467, &mem_203232,
                                         "mem_203232") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_203232, "mem_203232") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_203227, "mem_203227") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_203501, &ext_mem_203478,
                                     "ext_mem_203478") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_203490, &ext_mem_203467,
                                     "ext_mem_203467") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203467,
                                       "ext_mem_203467") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203478,
                                       "ext_mem_203478") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_203523, &ext_mem_203501,
                                 "ext_mem_203501") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_203512, &ext_mem_203490,
                                 "ext_mem_203490") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_203490, "ext_mem_203490") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_203501, "ext_mem_203501") != 0)
                    return 1;
            }
            
            int64_t ext_203630;
            struct memblock ext_mem_203626;
            
            ext_mem_203626.references = NULL;
            if (cond_196744) {
                ext_203630 = ctx_val_201733;
                if (memblock_set(ctx, &ext_mem_203626, &ext_mem_203523,
                                 "ext_mem_203523") != 0)
                    return 1;
            } else {
                bool bounds_invalid_upwards_198084 = slt64(pad_css_len_196741,
                                                           (int64_t) 0);
                bool valid_198085 = !bounds_invalid_upwards_198084;
                bool range_valid_c_198086;
                
                if (!valid_198085) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Range ", (long long) (int64_t) 0, "..",
                                  (long long) (int64_t) 1, "..<",
                                  (long long) pad_css_len_196741,
                                  " is invalid.",
                                  "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:556:3-565:9\n   #4  stl.fut:220:31-96\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:219:23-221:48\n   #8  /prelude/soacs.fut:67:19-23\n   #9  /prelude/soacs.fut:67:3-37\n   #10 stl.fut:218:15-222:44\n   #11 stl.fut:401:3-415:29\n   #12 stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &ext_mem_203626,
                                       "ext_mem_203626") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203512,
                                       "ext_mem_203512") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203523,
                                       "ext_mem_203523") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202158,
                                       "mem_param_202158") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202150,
                                       "mem_param_202150") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205518,
                                       "ext_mem_205518") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205519,
                                       "ext_mem_205519") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202136,
                                       "mem_param_202136") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202128,
                                       "mem_param_202128") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202120,
                                       "mem_param_202120") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205847,
                                       "ext_mem_205847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205848,
                                       "ext_mem_205848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205849,
                                       "ext_mem_205849") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock mem_203538;
                
                mem_203538.references = NULL;
                if (memblock_alloc(ctx, &mem_203538, bytes_203537,
                                   "mem_203538")) {
                    err = 1;
                    goto cleanup;
                }
                
                int64_t ctx_val_203551 = n_p_196694 * pad_css_len_196741;
                
                for (int64_t i_200286 = 0; i_200286 < m_196691; i_200286++) {
                    for (int64_t i_200282 = 0; i_200282 < n_p_196694;
                         i_200282++) {
                        for (int64_t i_200278 = 0; i_200278 <
                             pad_css_len_196741; i_200278++) {
                            bool cond_198096 = i_200278 == (int64_t) 0;
                            float defunc_0_f_res_198097;
                            
                            if (cond_198096) {
                                bool y_198098 = slt64((int64_t) 0,
                                                      s_n_m_196745);
                                bool index_certs_198099;
                                
                                if (!y_198098) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) (int64_t) 0,
                                                  "] out of bounds for array of shape [",
                                                  (long long) s_n_m_196745,
                                                  "].",
                                                  "-> #0  /prelude/array.fut:21:29-32\n   #1  loess.fut:558:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:556:3-565:9\n   #6  stl.fut:220:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:219:23-221:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:218:15-222:44\n   #13 stl.fut:401:3-415:29\n   #14 stl.fut:385:1-415:29\n");
                                    if (memblock_unref(ctx, &mem_203538,
                                                       "mem_203538") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203626,
                                                       "ext_mem_203626") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203512,
                                                       "ext_mem_203512") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203523,
                                                       "ext_mem_203523") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202158,
                                                       "mem_param_202158") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202150,
                                                       "mem_param_202150") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205518,
                                                       "ext_mem_205518") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205519,
                                                       "ext_mem_205519") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202136,
                                                       "mem_param_202136") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202128,
                                                       "mem_param_202128") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202120,
                                                       "mem_param_202120") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205847,
                                                       "ext_mem_205847") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205848,
                                                       "ext_mem_205848") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205849,
                                                       "ext_mem_205849") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_202112,
                                                       "mem_202112") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_202108,
                                                       "mem_202108") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206309,
                                                       "mem_out_206309") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206308,
                                                       "mem_out_206308") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206307,
                                                       "mem_out_206307") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                float head_res_198100;
                                
                                head_res_198100 =
                                    ((float *) ext_mem_203523.mem)[i_200286 *
                                                                   ctx_val_201733 +
                                                                   i_200282 *
                                                                   s_n_m_196745];
                                defunc_0_f_res_198097 = head_res_198100;
                            } else {
                                int64_t y_198101 = sub64(pad_css_len_196741,
                                                         (int64_t) 1);
                                bool cond_198102 = i_200278 == y_198101;
                                float defunc_0_f_res_f_res_198103;
                                
                                if (cond_198102) {
                                    int64_t i_198104 = sub64(s_n_m_196745,
                                                             (int64_t) 1);
                                    bool x_198105 = sle64((int64_t) 0,
                                                          i_198104);
                                    bool y_198106 = slt64(i_198104,
                                                          s_n_m_196745);
                                    bool bounds_check_198107 = x_198105 &&
                                         y_198106;
                                    bool index_certs_198108;
                                    
                                    if (!bounds_check_198107) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) i_198104,
                                                      "] out of bounds for array of shape [",
                                                      (long long) s_n_m_196745,
                                                      "].",
                                                      "-> #0  /prelude/array.fut:26:29-34\n   #1  loess.fut:560:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:556:3-565:9\n   #6  stl.fut:220:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:219:23-221:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:218:15-222:44\n   #13 stl.fut:401:3-415:29\n   #14 stl.fut:385:1-415:29\n");
                                        if (memblock_unref(ctx, &mem_203538,
                                                           "mem_203538") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203626,
                                                           "ext_mem_203626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203512,
                                                           "ext_mem_203512") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203523,
                                                           "ext_mem_203523") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202158,
                                                           "mem_param_202158") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202150,
                                                           "mem_param_202150") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205518,
                                                           "ext_mem_205518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205519,
                                                           "ext_mem_205519") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202136,
                                                           "mem_param_202136") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202128,
                                                           "mem_param_202128") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202120,
                                                           "mem_param_202120") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205847,
                                                           "ext_mem_205847") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205848,
                                                           "ext_mem_205848") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205849,
                                                           "ext_mem_205849") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202112,
                                                           "mem_202112") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202108,
                                                           "mem_202108") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206309,
                                                           "mem_out_206309") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206308,
                                                           "mem_out_206308") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206307,
                                                           "mem_out_206307") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    float last_res_198109;
                                    
                                    last_res_198109 =
                                        ((float *) ext_mem_203523.mem)[i_200286 *
                                                                       ctx_val_201733 +
                                                                       i_200282 *
                                                                       s_n_m_196745 +
                                                                       i_198104];
                                    defunc_0_f_res_f_res_198103 =
                                        last_res_198109;
                                } else {
                                    int64_t x_198110 = sub64(i_200278,
                                                             (int64_t) 1);
                                    bool zzero_198111 = jump_s_196701 ==
                                         (int64_t) 0;
                                    bool nonzzero_198112 = !zzero_198111;
                                    bool nonzzero_cert_198113;
                                    
                                    if (!nonzzero_198112) {
                                        ctx->error =
                                            msgprintf("Error: %s\n\nBacktrace:\n%s",
                                                      "division by zero",
                                                      "-> #0  loess.fut:562:22-35\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:556:3-565:9\n   #5  stl.fut:220:31-96\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:219:23-221:48\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:218:15-222:44\n   #12 stl.fut:401:3-415:29\n   #13 stl.fut:385:1-415:29\n");
                                        if (memblock_unref(ctx, &mem_203538,
                                                           "mem_203538") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203626,
                                                           "ext_mem_203626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203512,
                                                           "ext_mem_203512") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203523,
                                                           "ext_mem_203523") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202158,
                                                           "mem_param_202158") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202150,
                                                           "mem_param_202150") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205518,
                                                           "ext_mem_205518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205519,
                                                           "ext_mem_205519") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202136,
                                                           "mem_param_202136") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202128,
                                                           "mem_param_202128") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202120,
                                                           "mem_param_202120") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205847,
                                                           "ext_mem_205847") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205848,
                                                           "ext_mem_205848") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205849,
                                                           "ext_mem_205849") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202112,
                                                           "mem_202112") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202108,
                                                           "mem_202108") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206309,
                                                           "mem_out_206309") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206308,
                                                           "mem_out_206308") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206307,
                                                           "mem_out_206307") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    int64_t x_198114 = sdiv64(x_198110,
                                                              jump_s_196701);
                                    int64_t m_v_198115 = add64((int64_t) 1,
                                                               x_198114);
                                    int64_t j_198116;
                                    
                                    if (cond_198096) {
                                        j_198116 = (int64_t) 0;
                                    } else {
                                        int64_t y_198117 = sub64(s_n_m_196745,
                                                                 (int64_t) 1);
                                        bool cond_198118 = m_v_198115 ==
                                             y_198117;
                                        int64_t j_f_res_198119;
                                        
                                        if (cond_198118) {
                                            j_f_res_198119 = x_198114;
                                        } else {
                                            j_f_res_198119 = m_v_198115;
                                        }
                                        j_198116 = j_f_res_198119;
                                    }
                                    
                                    bool cond_198120 = j_198116 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_198121;
                                    
                                    if (cond_198120) {
                                        defunc_0_m_fun_res_198121 = (int64_t) 0;
                                    } else {
                                        int64_t y_198122 = sub64(s_n_m_196745,
                                                                 (int64_t) 1);
                                        bool cond_198123 = j_198116 == y_198122;
                                        int64_t defunc_0_m_fun_res_f_res_198124;
                                        
                                        if (cond_198123) {
                                            defunc_0_m_fun_res_f_res_198124 =
                                                y_198101;
                                        } else {
                                            int64_t x_198125 = sub64(j_198116,
                                                                     (int64_t) 1);
                                            int64_t x_198126 =
                                                    mul64(jump_s_196701,
                                                          x_198125);
                                            int64_t min_arg_198127 =
                                                    add64((int64_t) 1,
                                                          x_198126);
                                            int64_t min_res_198128 =
                                                    smin64(defunc_0_f_res_196740,
                                                           min_arg_198127);
                                            
                                            defunc_0_m_fun_res_f_res_198124 =
                                                min_res_198128;
                                        }
                                        defunc_0_m_fun_res_198121 =
                                            defunc_0_m_fun_res_f_res_198124;
                                    }
                                    
                                    int64_t defunc_0_m_fun_arg_198129 =
                                            add64((int64_t) 1, j_198116);
                                    bool cond_198130 =
                                         defunc_0_m_fun_arg_198129 ==
                                         (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_198131;
                                    
                                    if (cond_198130) {
                                        defunc_0_m_fun_res_198131 = (int64_t) 0;
                                    } else {
                                        int64_t y_198132 = sub64(s_n_m_196745,
                                                                 (int64_t) 1);
                                        bool cond_198133 =
                                             defunc_0_m_fun_arg_198129 ==
                                             y_198132;
                                        int64_t defunc_0_m_fun_res_f_res_198134;
                                        
                                        if (cond_198133) {
                                            defunc_0_m_fun_res_f_res_198134 =
                                                y_198101;
                                        } else {
                                            int64_t x_198135 =
                                                    mul64(jump_s_196701,
                                                          j_198116);
                                            int64_t min_arg_198136 =
                                                    add64((int64_t) 1,
                                                          x_198135);
                                            int64_t min_res_198137 =
                                                    smin64(defunc_0_f_res_196740,
                                                           min_arg_198136);
                                            
                                            defunc_0_m_fun_res_f_res_198134 =
                                                min_res_198137;
                                        }
                                        defunc_0_m_fun_res_198131 =
                                            defunc_0_m_fun_res_f_res_198134;
                                    }
                                    
                                    int64_t i64_arg_198138 =
                                            sub64(defunc_0_m_fun_res_198131,
                                                  defunc_0_m_fun_res_198121);
                                    float i64_res_198139 =
                                          sitofp_i64_f32(i64_arg_198138);
                                    int64_t i64_arg_198140 = sub64(i_200278,
                                                                   defunc_0_m_fun_res_198121);
                                    float i64_res_198141 =
                                          sitofp_i64_f32(i64_arg_198140);
                                    float u_198142 = i64_res_198141 /
                                          i64_res_198139;
                                    float u2_198143 = u_198142 * u_198142;
                                    float u3_198144 = u_198142 * u2_198143;
                                    float x_198145 = 2.0F * u3_198144;
                                    float y_198146 = 3.0F * u2_198143;
                                    float x_198147 = x_198145 - y_198146;
                                    float x_198148 = 1.0F + x_198147;
                                    bool x_198149 = sle64((int64_t) 0,
                                                          j_198116);
                                    bool y_198150 = slt64(j_198116,
                                                          s_n_m_196745);
                                    bool bounds_check_198151 = x_198149 &&
                                         y_198150;
                                    bool index_certs_198152;
                                    
                                    if (!bounds_check_198151) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) j_198116,
                                                      "] out of bounds for array of shape [",
                                                      (long long) s_n_m_196745,
                                                      "].",
                                                      "-> #0  loess.fut:535:27-33\n   #1  loess.fut:564:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:556:3-565:9\n   #6  stl.fut:220:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:219:23-221:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:218:15-222:44\n   #13 stl.fut:401:3-415:29\n   #14 stl.fut:385:1-415:29\n");
                                        if (memblock_unref(ctx, &mem_203538,
                                                           "mem_203538") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203626,
                                                           "ext_mem_203626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203512,
                                                           "ext_mem_203512") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203523,
                                                           "ext_mem_203523") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202158,
                                                           "mem_param_202158") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202150,
                                                           "mem_param_202150") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205518,
                                                           "ext_mem_205518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205519,
                                                           "ext_mem_205519") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202136,
                                                           "mem_param_202136") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202128,
                                                           "mem_param_202128") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202120,
                                                           "mem_param_202120") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205847,
                                                           "ext_mem_205847") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205848,
                                                           "ext_mem_205848") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205849,
                                                           "ext_mem_205849") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202112,
                                                           "mem_202112") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202108,
                                                           "mem_202108") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206309,
                                                           "mem_out_206309") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206308,
                                                           "mem_out_206308") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206307,
                                                           "mem_out_206307") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    float y_198153;
                                    
                                    y_198153 =
                                        ((float *) ext_mem_203523.mem)[i_200286 *
                                                                       ctx_val_201733 +
                                                                       i_200282 *
                                                                       s_n_m_196745 +
                                                                       j_198116];
                                    
                                    float x_198154 = x_198148 * y_198153;
                                    float x_198155 = y_198146 - x_198145;
                                    bool x_198156 = sle64((int64_t) 0,
                                                          defunc_0_m_fun_arg_198129);
                                    bool y_198157 =
                                         slt64(defunc_0_m_fun_arg_198129,
                                               s_n_m_196745);
                                    bool bounds_check_198158 = x_198156 &&
                                         y_198157;
                                    bool index_certs_198159;
                                    
                                    if (!bounds_check_198158) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) defunc_0_m_fun_arg_198129,
                                                      "] out of bounds for array of shape [",
                                                      (long long) s_n_m_196745,
                                                      "].",
                                                      "-> #0  loess.fut:536:27-37\n   #1  loess.fut:564:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:556:3-565:9\n   #6  stl.fut:220:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:219:23-221:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:218:15-222:44\n   #13 stl.fut:401:3-415:29\n   #14 stl.fut:385:1-415:29\n");
                                        if (memblock_unref(ctx, &mem_203538,
                                                           "mem_203538") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203626,
                                                           "ext_mem_203626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203512,
                                                           "ext_mem_203512") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203523,
                                                           "ext_mem_203523") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202158,
                                                           "mem_param_202158") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202150,
                                                           "mem_param_202150") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205518,
                                                           "ext_mem_205518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205519,
                                                           "ext_mem_205519") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202136,
                                                           "mem_param_202136") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202128,
                                                           "mem_param_202128") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202120,
                                                           "mem_param_202120") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205847,
                                                           "ext_mem_205847") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205848,
                                                           "ext_mem_205848") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205849,
                                                           "ext_mem_205849") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202112,
                                                           "mem_202112") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202108,
                                                           "mem_202108") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206309,
                                                           "mem_out_206309") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206308,
                                                           "mem_out_206308") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206307,
                                                           "mem_out_206307") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    float y_198160;
                                    
                                    y_198160 =
                                        ((float *) ext_mem_203523.mem)[i_200286 *
                                                                       ctx_val_201733 +
                                                                       i_200282 *
                                                                       s_n_m_196745 +
                                                                       defunc_0_m_fun_arg_198129];
                                    
                                    float y_198161 = x_198155 * y_198160;
                                    float x_198162 = x_198154 + y_198161;
                                    float y_198163 = 2.0F * u2_198143;
                                    float x_198164 = u3_198144 - y_198163;
                                    float x_198165 = u_198142 + x_198164;
                                    float y_198166;
                                    
                                    y_198166 =
                                        ((float *) ext_mem_203512.mem)[i_200286 *
                                                                       ctx_val_201733 +
                                                                       i_200282 *
                                                                       s_n_m_196745 +
                                                                       j_198116];
                                    
                                    float x_198167 = x_198165 * y_198166;
                                    float y_198168 = i64_res_198139 * x_198167;
                                    float x_198169 = x_198162 + y_198168;
                                    float x_198170 = u3_198144 - u2_198143;
                                    float y_198171;
                                    
                                    y_198171 =
                                        ((float *) ext_mem_203512.mem)[i_200286 *
                                                                       ctx_val_201733 +
                                                                       i_200282 *
                                                                       s_n_m_196745 +
                                                                       defunc_0_m_fun_arg_198129];
                                    
                                    float x_198172 = x_198170 * y_198171;
                                    float y_198173 = i64_res_198139 * x_198172;
                                    float defunc_4_interpolate_proc_res_198174 =
                                          x_198169 + y_198173;
                                    
                                    defunc_0_f_res_f_res_198103 =
                                        defunc_4_interpolate_proc_res_198174;
                                }
                                defunc_0_f_res_198097 =
                                    defunc_0_f_res_f_res_198103;
                            }
                            ((float *) mem_203538.mem)[i_200286 *
                                                       ctx_val_203551 +
                                                       i_200282 *
                                                       pad_css_len_196741 +
                                                       i_200278] =
                                defunc_0_f_res_198097;
                        }
                    }
                }
                ext_203630 = ctx_val_203551;
                if (memblock_set(ctx, &ext_mem_203626, &mem_203538,
                                 "mem_203538") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_203538, "mem_203538") != 0)
                    return 1;
            }
            if (memblock_unref(ctx, &ext_mem_203512, "ext_mem_203512") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_203523, "ext_mem_203523") != 0)
                return 1;
            for (int64_t i_200294 = 0; i_200294 < m_196691; i_200294++) {
                for (int64_t i_200290 = 0; i_200290 < C_len_196743;
                     i_200290++) {
                    int64_t i_198181 = smod64(i_200290, n_p_196694);
                    bool x_198182 = sle64((int64_t) 0, i_198181);
                    bool y_198183 = slt64(i_198181, n_p_196694);
                    bool bounds_check_198184 = x_198182 && y_198183;
                    int64_t i_198185 = sdiv64(i_200290, n_p_196694);
                    bool x_198186 = sle64((int64_t) 0, i_198185);
                    bool y_198187 = slt64(i_198185, css_results_l_197223);
                    bool bounds_check_198188 = x_198186 && y_198187;
                    bool index_ok_198189 = bounds_check_198184 &&
                         bounds_check_198188;
                    bool index_certs_198190;
                    
                    if (!index_ok_198189) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) i_198181, ", ",
                                      (long long) i_198185,
                                      "] out of bounds for array of shape [",
                                      (long long) n_p_196694, "][",
                                      (long long) css_results_l_197223, "].",
                                      "-> #0  stl.fut:226:39-67\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:226:28-74\n   #5  stl.fut:225:21-227:39\n   #6  stl.fut:401:3-415:29\n   #7  stl.fut:385:1-415:29\n");
                        if (memblock_unref(ctx, &ext_mem_203626,
                                           "ext_mem_203626") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_203512,
                                           "ext_mem_203512") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_203523,
                                           "ext_mem_203523") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_202158,
                                           "mem_param_202158") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_202150,
                                           "mem_param_202150") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_205518,
                                           "ext_mem_205518") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_205519,
                                           "ext_mem_205519") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_202136,
                                           "mem_param_202136") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_202128,
                                           "mem_param_202128") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_202120,
                                           "mem_param_202120") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_205847,
                                           "ext_mem_205847") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_205848,
                                           "ext_mem_205848") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_205849,
                                           "ext_mem_205849") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_206309,
                                           "mem_out_206309") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_206308,
                                           "mem_out_206308") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_206307,
                                           "mem_out_206307") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    if ((int64_t) 4 > 0)
                        memmove(mem_203637 + (i_200294 * C_len_196743 +
                                              i_200290) * (int64_t) 4,
                                ext_mem_203626.mem + ((int64_t) 0 + i_200294 *
                                                      ext_203630 + i_198181 *
                                                      ext_203629 + (int64_t) 1 *
                                                      i_198185) * (int64_t) 4,
                                (int64_t) 4);
                }
            }
            if (memblock_unref(ctx, &ext_mem_203626, "ext_mem_203626") != 0)
                return 1;
            for (int64_t i_200300 = 0; i_200300 < m_196691; i_200300++) {
                float defunc_2_reduce_res_198196;
                float redout_200296 = 0.0F;
                
                for (int64_t i_200297 = 0; i_200297 < n_p_196694; i_200297++) {
                    float x_198200;
                    
                    x_198200 = ((float *) mem_203637)[i_200300 * C_len_196743 +
                                                      i_200297];
                    
                    float defunc_1_op_res_198199 = x_198200 + redout_200296;
                    float redout_tmp_206475 = defunc_1_op_res_198199;
                    
                    redout_200296 = redout_tmp_206475;
                }
                defunc_2_reduce_res_198196 = redout_200296;
                ((float *) mem_203680)[i_200300] = defunc_2_reduce_res_198196;
            }
            for (int64_t i_200310 = 0; i_200310 < m_196691; i_200310++) {
                float x_198204;
                
                x_198204 = ((float *) mem_203680)[i_200310];
                
                float discard_200307;
                float scanacc_200303 = 0.0F;
                
                for (int64_t i_200305 = 0; i_200305 <
                     lifted_single_ma_l_arg_197247; i_200305++) {
                    bool cond_198210 = i_200305 == (int64_t) 0;
                    float defunc_0_f_res_198211;
                    
                    if (cond_198210) {
                        float defunc_0_f_res_t_res_198212 = x_198204 /
                              i64_res_196737;
                        
                        defunc_0_f_res_198211 = defunc_0_f_res_t_res_198212;
                    } else {
                        int64_t x_198213 = add64(n_p_196694, i_200305);
                        int64_t i_198214 = sub64(x_198213, (int64_t) 1);
                        bool x_198215 = sle64((int64_t) 0, i_198214);
                        bool y_198216 = slt64(i_198214, C_len_196743);
                        bool bounds_check_198217 = x_198215 && y_198216;
                        bool index_certs_198218;
                        
                        if (!bounds_check_198217) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_198214,
                                          "] out of bounds for array of shape [",
                                          (long long) C_len_196743, "].",
                                          "-> #0  stl.fut:32:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  stl.fut:38:3-36\n   #9  stl.fut:231:23-47\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                            if (memblock_unref(ctx, &ext_mem_203626,
                                               "ext_mem_203626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203512,
                                               "ext_mem_203512") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203523,
                                               "ext_mem_203523") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202158,
                                               "mem_param_202158") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202150,
                                               "mem_param_202150") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205518,
                                               "ext_mem_205518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205519,
                                               "ext_mem_205519") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202136,
                                               "mem_param_202136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202128,
                                               "mem_param_202128") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202120,
                                               "mem_param_202120") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205847,
                                               "ext_mem_205847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205848,
                                               "ext_mem_205848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205849,
                                               "ext_mem_205849") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202112,
                                               "mem_202112") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202108,
                                               "mem_202108") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206309,
                                               "mem_out_206309") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206308,
                                               "mem_out_206308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206307,
                                               "mem_out_206307") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        float x_198219;
                        
                        x_198219 = ((float *) mem_203637)[i_200310 *
                                                          C_len_196743 +
                                                          i_198214];
                        
                        int64_t i_198220 = sub64(i_200305, (int64_t) 1);
                        bool x_198221 = sle64((int64_t) 0, i_198220);
                        bool y_198222 = slt64(i_198220, C_len_196743);
                        bool bounds_check_198223 = x_198221 && y_198222;
                        bool index_certs_198224;
                        
                        if (!bounds_check_198223) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_198220,
                                          "] out of bounds for array of shape [",
                                          (long long) C_len_196743, "].",
                                          "-> #0  stl.fut:32:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  stl.fut:38:3-36\n   #9  stl.fut:231:23-47\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                            if (memblock_unref(ctx, &ext_mem_203626,
                                               "ext_mem_203626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203512,
                                               "ext_mem_203512") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203523,
                                               "ext_mem_203523") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202158,
                                               "mem_param_202158") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202150,
                                               "mem_param_202150") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205518,
                                               "ext_mem_205518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205519,
                                               "ext_mem_205519") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202136,
                                               "mem_param_202136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202128,
                                               "mem_param_202128") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202120,
                                               "mem_param_202120") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205847,
                                               "ext_mem_205847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205848,
                                               "ext_mem_205848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205849,
                                               "ext_mem_205849") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202112,
                                               "mem_202112") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202108,
                                               "mem_202108") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206309,
                                               "mem_out_206309") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206308,
                                               "mem_out_206308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206307,
                                               "mem_out_206307") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        float y_198225;
                        
                        y_198225 = ((float *) mem_203637)[i_200310 *
                                                          C_len_196743 +
                                                          i_198220];
                        
                        float x_198226 = x_198219 - y_198225;
                        float defunc_0_f_res_f_res_198227 = x_198226 /
                              i64_res_196737;
                        
                        defunc_0_f_res_198211 = defunc_0_f_res_f_res_198227;
                    }
                    
                    float defunc_1_op_res_198208 = defunc_0_f_res_198211 +
                          scanacc_200303;
                    
                    ((float *) mem_203709)[i_200305] = defunc_1_op_res_198208;
                    
                    float scanacc_tmp_206477 = defunc_1_op_res_198208;
                    
                    scanacc_200303 = scanacc_tmp_206477;
                }
                discard_200307 = scanacc_200303;
                if (lifted_single_ma_l_arg_197247 * (int64_t) 4 > 0)
                    memmove(mem_203696 + i_200310 *
                            lifted_single_ma_l_arg_197247 * (int64_t) 4,
                            mem_203709 + (int64_t) 0,
                            lifted_single_ma_l_arg_197247 * (int64_t) 4);
            }
            for (int64_t i_200316 = 0; i_200316 < m_196691; i_200316++) {
                float defunc_2_reduce_res_198232;
                float redout_200312 = 0.0F;
                
                for (int64_t i_200313 = 0; i_200313 < n_p_196694; i_200313++) {
                    float x_198236;
                    
                    x_198236 = ((float *) mem_203696)[i_200316 *
                                                      lifted_single_ma_l_arg_197247 +
                                                      i_200313];
                    
                    float defunc_1_op_res_198235 = x_198236 + redout_200312;
                    float redout_tmp_206480 = defunc_1_op_res_198235;
                    
                    redout_200312 = redout_tmp_206480;
                }
                defunc_2_reduce_res_198232 = redout_200312;
                ((float *) mem_203732)[i_200316] = defunc_2_reduce_res_198232;
            }
            for (int64_t i_200326 = 0; i_200326 < m_196691; i_200326++) {
                float x_198240;
                
                x_198240 = ((float *) mem_203732)[i_200326];
                
                float discard_200323;
                float scanacc_200319 = 0.0F;
                
                for (int64_t i_200321 = 0; i_200321 <
                     dyn_lifted_single_ma_l_arg_197257; i_200321++) {
                    bool cond_198246 = i_200321 == (int64_t) 0;
                    float defunc_0_f_res_198247;
                    
                    if (cond_198246) {
                        float defunc_0_f_res_t_res_198248 = x_198240 /
                              i64_res_196737;
                        
                        defunc_0_f_res_198247 = defunc_0_f_res_t_res_198248;
                    } else {
                        int64_t x_198249 = add64(n_p_196694, i_200321);
                        int64_t i_198250 = sub64(x_198249, (int64_t) 1);
                        bool x_198251 = sle64((int64_t) 0, i_198250);
                        bool y_198252 = slt64(i_198250,
                                              lifted_single_ma_l_arg_197247);
                        bool bounds_check_198253 = x_198251 && y_198252;
                        bool index_certs_198254;
                        
                        if (!bounds_check_198253) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_198250,
                                          "] out of bounds for array of shape [",
                                          (long long) lifted_single_ma_l_arg_197247,
                                          "].",
                                          "-> #0  stl.fut:32:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:38:3-64\n   #10 stl.fut:231:23-47\n   #11 stl.fut:401:3-415:29\n   #12 stl.fut:385:1-415:29\n");
                            if (memblock_unref(ctx, &ext_mem_203626,
                                               "ext_mem_203626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203512,
                                               "ext_mem_203512") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203523,
                                               "ext_mem_203523") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202158,
                                               "mem_param_202158") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202150,
                                               "mem_param_202150") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205518,
                                               "ext_mem_205518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205519,
                                               "ext_mem_205519") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202136,
                                               "mem_param_202136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202128,
                                               "mem_param_202128") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202120,
                                               "mem_param_202120") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205847,
                                               "ext_mem_205847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205848,
                                               "ext_mem_205848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205849,
                                               "ext_mem_205849") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202112,
                                               "mem_202112") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202108,
                                               "mem_202108") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206309,
                                               "mem_out_206309") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206308,
                                               "mem_out_206308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206307,
                                               "mem_out_206307") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        float x_198255;
                        
                        x_198255 = ((float *) mem_203696)[i_200326 *
                                                          lifted_single_ma_l_arg_197247 +
                                                          i_198250];
                        
                        int64_t i_198256 = sub64(i_200321, (int64_t) 1);
                        bool x_198257 = sle64((int64_t) 0, i_198256);
                        bool y_198258 = slt64(i_198256,
                                              lifted_single_ma_l_arg_197247);
                        bool bounds_check_198259 = x_198257 && y_198258;
                        bool index_certs_198260;
                        
                        if (!bounds_check_198259) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_198256,
                                          "] out of bounds for array of shape [",
                                          (long long) lifted_single_ma_l_arg_197247,
                                          "].",
                                          "-> #0  stl.fut:32:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:38:3-64\n   #10 stl.fut:231:23-47\n   #11 stl.fut:401:3-415:29\n   #12 stl.fut:385:1-415:29\n");
                            if (memblock_unref(ctx, &ext_mem_203626,
                                               "ext_mem_203626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203512,
                                               "ext_mem_203512") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203523,
                                               "ext_mem_203523") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202158,
                                               "mem_param_202158") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202150,
                                               "mem_param_202150") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205518,
                                               "ext_mem_205518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205519,
                                               "ext_mem_205519") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202136,
                                               "mem_param_202136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202128,
                                               "mem_param_202128") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202120,
                                               "mem_param_202120") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205847,
                                               "ext_mem_205847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205848,
                                               "ext_mem_205848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205849,
                                               "ext_mem_205849") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202112,
                                               "mem_202112") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202108,
                                               "mem_202108") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206309,
                                               "mem_out_206309") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206308,
                                               "mem_out_206308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206307,
                                               "mem_out_206307") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        float y_198261;
                        
                        y_198261 = ((float *) mem_203696)[i_200326 *
                                                          lifted_single_ma_l_arg_197247 +
                                                          i_198256];
                        
                        float x_198262 = x_198255 - y_198261;
                        float defunc_0_f_res_f_res_198263 = x_198262 /
                              i64_res_196737;
                        
                        defunc_0_f_res_198247 = defunc_0_f_res_f_res_198263;
                    }
                    
                    float defunc_1_op_res_198244 = defunc_0_f_res_198247 +
                          scanacc_200319;
                    
                    ((float *) mem_203761)[i_200321] = defunc_1_op_res_198244;
                    
                    float scanacc_tmp_206482 = defunc_1_op_res_198244;
                    
                    scanacc_200319 = scanacc_tmp_206482;
                }
                discard_200323 = scanacc_200319;
                if (dyn_lifted_single_ma_l_arg_197257 * (int64_t) 4 > 0)
                    memmove(mem_203748 + i_200326 *
                            dyn_lifted_single_ma_l_arg_197257 * (int64_t) 4,
                            mem_203761 + (int64_t) 0,
                            dyn_lifted_single_ma_l_arg_197257 * (int64_t) 4);
            }
            for (int64_t i_200332 = 0; i_200332 < m_196691; i_200332++) {
                float defunc_2_reduce_res_198268;
                float redout_200328 = 0.0F;
                
                for (int32_t i_200863 = 0; i_200863 < 3; i_200863++) {
                    int64_t i_200329 = sext_i32_i64(i_200863);
                    float x_198272;
                    
                    x_198272 = ((float *) mem_203748)[i_200332 *
                                                      dyn_lifted_single_ma_l_arg_197257 +
                                                      i_200329];
                    
                    float defunc_1_op_res_198271 = x_198272 + redout_200328;
                    float redout_tmp_206485 = defunc_1_op_res_198271;
                    
                    redout_200328 = redout_tmp_206485;
                }
                defunc_2_reduce_res_198268 = redout_200328;
                ((float *) mem_203784)[i_200332] = defunc_2_reduce_res_198268;
            }
            for (int64_t i_200342 = 0; i_200342 < m_196691; i_200342++) {
                float x_198276;
                
                x_198276 = ((float *) mem_203784)[i_200342];
                
                float discard_200339;
                float scanacc_200335 = 0.0F;
                
                for (int64_t i_200337 = 0; i_200337 < n_196692; i_200337++) {
                    bool cond_198282 = i_200337 == (int64_t) 0;
                    float defunc_0_f_res_198283;
                    
                    if (cond_198282) {
                        float defunc_0_f_res_t_res_198284 = x_198276 / 3.0F;
                        
                        defunc_0_f_res_198283 = defunc_0_f_res_t_res_198284;
                    } else {
                        int64_t x_198285 = add64((int64_t) 3, i_200337);
                        int64_t i_198286 = sub64(x_198285, (int64_t) 1);
                        bool x_198287 = sle64((int64_t) 0, i_198286);
                        bool y_198288 = slt64(i_198286,
                                              dyn_lifted_single_ma_l_arg_197257);
                        bool bounds_check_198289 = x_198287 && y_198288;
                        bool index_certs_198290;
                        
                        if (!bounds_check_198289) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_198286,
                                          "] out of bounds for array of shape [",
                                          (long long) dyn_lifted_single_ma_l_arg_197257,
                                          "].",
                                          "-> #0  stl.fut:32:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:38:3-84\n   #10 stl.fut:231:23-47\n   #11 stl.fut:401:3-415:29\n   #12 stl.fut:385:1-415:29\n");
                            if (memblock_unref(ctx, &ext_mem_203626,
                                               "ext_mem_203626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203512,
                                               "ext_mem_203512") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203523,
                                               "ext_mem_203523") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202158,
                                               "mem_param_202158") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202150,
                                               "mem_param_202150") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205518,
                                               "ext_mem_205518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205519,
                                               "ext_mem_205519") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202136,
                                               "mem_param_202136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202128,
                                               "mem_param_202128") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202120,
                                               "mem_param_202120") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205847,
                                               "ext_mem_205847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205848,
                                               "ext_mem_205848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205849,
                                               "ext_mem_205849") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202112,
                                               "mem_202112") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202108,
                                               "mem_202108") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206309,
                                               "mem_out_206309") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206308,
                                               "mem_out_206308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206307,
                                               "mem_out_206307") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        float x_198291;
                        
                        x_198291 = ((float *) mem_203748)[i_200342 *
                                                          dyn_lifted_single_ma_l_arg_197257 +
                                                          i_198286];
                        
                        int64_t i_198292 = sub64(i_200337, (int64_t) 1);
                        bool x_198293 = sle64((int64_t) 0, i_198292);
                        bool y_198294 = slt64(i_198292,
                                              dyn_lifted_single_ma_l_arg_197257);
                        bool bounds_check_198295 = x_198293 && y_198294;
                        bool index_certs_198296;
                        
                        if (!bounds_check_198295) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_198292,
                                          "] out of bounds for array of shape [",
                                          (long long) dyn_lifted_single_ma_l_arg_197257,
                                          "].",
                                          "-> #0  stl.fut:32:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:38:3-84\n   #10 stl.fut:231:23-47\n   #11 stl.fut:401:3-415:29\n   #12 stl.fut:385:1-415:29\n");
                            if (memblock_unref(ctx, &ext_mem_203626,
                                               "ext_mem_203626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203512,
                                               "ext_mem_203512") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203523,
                                               "ext_mem_203523") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202158,
                                               "mem_param_202158") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202150,
                                               "mem_param_202150") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205518,
                                               "ext_mem_205518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205519,
                                               "ext_mem_205519") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202136,
                                               "mem_param_202136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202128,
                                               "mem_param_202128") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202120,
                                               "mem_param_202120") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205847,
                                               "ext_mem_205847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205848,
                                               "ext_mem_205848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205849,
                                               "ext_mem_205849") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202112,
                                               "mem_202112") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202108,
                                               "mem_202108") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206309,
                                               "mem_out_206309") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206308,
                                               "mem_out_206308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206307,
                                               "mem_out_206307") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        float y_198297;
                        
                        y_198297 = ((float *) mem_203748)[i_200342 *
                                                          dyn_lifted_single_ma_l_arg_197257 +
                                                          i_198292];
                        
                        float x_198298 = x_198291 - y_198297;
                        float defunc_0_f_res_f_res_198299 = x_198298 / 3.0F;
                        
                        defunc_0_f_res_198283 = defunc_0_f_res_f_res_198299;
                    }
                    
                    float defunc_1_op_res_198280 = defunc_0_f_res_198283 +
                          scanacc_200335;
                    
                    ((float *) mem_203813)[i_200337] = defunc_1_op_res_198280;
                    
                    float scanacc_tmp_206487 = defunc_1_op_res_198280;
                    
                    scanacc_200335 = scanacc_tmp_206487;
                }
                discard_200339 = scanacc_200335;
                if (n_196692 * (int64_t) 4 > 0)
                    memmove(mem_203800 + i_200342 * n_196692 * (int64_t) 4,
                            mem_203813 + (int64_t) 0, n_196692 * (int64_t) 4);
            }
            
            struct memblock ext_mem_204459;
            
            ext_mem_204459.references = NULL;
            
            struct memblock ext_mem_204451;
            
            ext_mem_204451.references = NULL;
            if (cond_197273) {
                bool match_lit_198303 = (int64_t) 0 == d_l_196700;
                struct memblock ext_mem_204082;
                
                ext_mem_204082.references = NULL;
                
                struct memblock ext_mem_204074;
                
                ext_mem_204074.references = NULL;
                if (match_lit_198303) {
                    struct memblock mem_203837;
                    
                    mem_203837.references = NULL;
                    if (memblock_alloc(ctx, &mem_203837, bytes_201905,
                                       "mem_203837")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_206489 = 0; i_206489 < m_196691;
                         i_206489++) {
                        for (int64_t i_206490 = 0; i_206490 < l_n_m_196752;
                             i_206490++) {
                            ((float *) mem_203837.mem)[i_206489 * l_n_m_196752 +
                                                       i_206490] = 0.0F;
                        }
                    }
                    
                    struct memblock mem_203841;
                    
                    mem_203841.references = NULL;
                    if (memblock_alloc(ctx, &mem_203841, bytes_201905,
                                       "mem_203841")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_200354 = 0; i_200354 < m_196691;
                         i_200354++) {
                        for (int64_t i_200350 = 0; i_200350 < l_n_m_196752;
                             i_200350++) {
                            int64_t x_198315;
                            
                            x_198315 = ((int64_t *) mem_201902)[i_200354 *
                                                                l_n_m_196752 +
                                                                i_200350];
                            
                            float x_198316;
                            
                            x_198316 = ((float *) mem_201906)[i_200354 *
                                                              l_n_m_196752 +
                                                              i_200350];
                            
                            int64_t min_arg_198317 = mul64(jump_t_196702,
                                                           i_200350);
                            int64_t min_res_198318 = smin64(i_196779,
                                                            min_arg_198317);
                            int64_t defunc_0_g_res_198319 = add64((int64_t) 1,
                                                                  min_res_198318);
                            float defunc_2_reduce_res_198320;
                            float redout_200344 = 0.0F;
                            
                            for (int64_t i_200345 = 0; i_200345 < q_l_196697;
                                 i_200345++) {
                                bool cond_198325 = sle64(n_196692, i_200345);
                                int64_t defunc_0_f_res_198326;
                                
                                if (cond_198325) {
                                    defunc_0_f_res_198326 = (int64_t) 0;
                                } else {
                                    int64_t i_198327 = add64(x_198315,
                                                             i_200345);
                                    int64_t defunc_1_add_res_198328 =
                                            add64((int64_t) 1, i_198327);
                                    
                                    defunc_0_f_res_198326 =
                                        defunc_1_add_res_198328;
                                }
                                
                                float defunc_0_f_res_198329;
                                
                                if (cond_198325) {
                                    defunc_0_f_res_198329 = 0.0F;
                                } else {
                                    int64_t i_198330 = add64(x_198315,
                                                             i_200345);
                                    float defunc_0_add_arg_198331;
                                    
                                    defunc_0_add_arg_198331 =
                                        ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                         (i_200354 *
                                                                          ctx_param_ext_202132 +
                                                                          i_198330 *
                                                                          ctx_param_ext_202134)];
                                    defunc_0_f_res_198329 =
                                        defunc_0_add_arg_198331;
                                }
                                
                                int64_t binop_p_198332 =
                                        sub64(defunc_0_f_res_198326,
                                              defunc_0_g_res_198319);
                                float defunc_0_f_res_198333 =
                                      sitofp_i64_f32(binop_p_198332);
                                float abs_res_198334 =
                                      (float) fabs(defunc_0_f_res_198333);
                                float tmp1_198335 = abs_res_198334 / x_198316;
                                float x_198336 = tmp1_198335 * tmp1_198335;
                                float y_198337 = tmp1_198335 * x_198336;
                                float tmp2_198338 = 1.0F - y_198337;
                                float x_198339 = tmp2_198338 * tmp2_198338;
                                float tmp3_198340 = tmp2_198338 * x_198339;
                                float w_j_198341 = defunc_0_f_res_198329 *
                                      tmp3_198340;
                                float defunc_1_op_res_198323 = w_j_198341 +
                                      redout_200344;
                                float redout_tmp_206493 =
                                      defunc_1_op_res_198323;
                                
                                redout_200344 = redout_tmp_206493;
                            }
                            defunc_2_reduce_res_198320 = redout_200344;
                            
                            float a0_198342 = 1.0F / defunc_2_reduce_res_198320;
                            float defunc_2_reduce_res_198343;
                            float redout_200346 = 0.0F;
                            
                            for (int64_t i_200347 = 0; i_200347 < q_l_196697;
                                 i_200347++) {
                                bool cond_198348 = sle64(n_196692, i_200347);
                                int64_t defunc_0_f_res_198349;
                                
                                if (cond_198348) {
                                    defunc_0_f_res_198349 = (int64_t) 0;
                                } else {
                                    int64_t i_198350 = add64(x_198315,
                                                             i_200347);
                                    int64_t defunc_1_add_res_198351 =
                                            add64((int64_t) 1, i_198350);
                                    
                                    defunc_0_f_res_198349 =
                                        defunc_1_add_res_198351;
                                }
                                
                                float defunc_0_f_res_198352;
                                
                                if (cond_198348) {
                                    defunc_0_f_res_198352 = 0.0F;
                                } else {
                                    int64_t i_198353 = add64(x_198315,
                                                             i_200347);
                                    float defunc_0_add_arg_198354;
                                    
                                    defunc_0_add_arg_198354 =
                                        ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                         (i_200354 *
                                                                          ctx_param_ext_202132 +
                                                                          i_198353 *
                                                                          ctx_param_ext_202134)];
                                    defunc_0_f_res_198352 =
                                        defunc_0_add_arg_198354;
                                }
                                
                                int64_t binop_p_198355 =
                                        sub64(defunc_0_f_res_198349,
                                              defunc_0_g_res_198319);
                                float defunc_0_f_res_198356 =
                                      sitofp_i64_f32(binop_p_198355);
                                float abs_res_198357 =
                                      (float) fabs(defunc_0_f_res_198356);
                                float tmp1_198358 = abs_res_198357 / x_198316;
                                float x_198359 = tmp1_198358 * tmp1_198358;
                                float y_198360 = tmp1_198358 * x_198359;
                                float tmp2_198361 = 1.0F - y_198360;
                                float x_198362 = tmp2_198361 * tmp2_198361;
                                float tmp3_198363 = tmp2_198361 * x_198362;
                                float tmp4_198364 = defunc_0_f_res_198352 *
                                      tmp3_198363;
                                float defunc_0_f_res_198365;
                                
                                if (cond_198348) {
                                    defunc_0_f_res_198365 = 0.0F;
                                } else {
                                    int64_t i_198366 = add64(x_198315,
                                                             i_200347);
                                    float defunc_0_add_arg_198367;
                                    
                                    defunc_0_add_arg_198367 =
                                        ((float *) mem_203800)[i_200354 *
                                                               n_196692 +
                                                               i_198366];
                                    defunc_0_f_res_198365 =
                                        defunc_0_add_arg_198367;
                                }
                                
                                float x_198368 = a0_198342 * tmp4_198364;
                                float defunc_9_fit_fun_res_198369 =
                                      defunc_0_f_res_198365 * x_198368;
                                float defunc_1_op_res_198346 =
                                      defunc_9_fit_fun_res_198369 +
                                      redout_200346;
                                float redout_tmp_206494 =
                                      defunc_1_op_res_198346;
                                
                                redout_200346 = redout_tmp_206494;
                            }
                            defunc_2_reduce_res_198343 = redout_200346;
                            ((float *) mem_203841.mem)[i_200354 * l_n_m_196752 +
                                                       i_200350] =
                                defunc_2_reduce_res_198343;
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_204082, &mem_203841,
                                     "mem_203841") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_204074, &mem_203837,
                                     "mem_203837") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_203841, "mem_203841") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_203837, "mem_203837") != 0)
                        return 1;
                } else {
                    bool match_lit_198372 = (int64_t) 1 == d_l_196700;
                    struct memblock ext_mem_204066;
                    
                    ext_mem_204066.references = NULL;
                    
                    struct memblock ext_mem_204058;
                    
                    ext_mem_204058.references = NULL;
                    if (match_lit_198372) {
                        struct memblock mem_203885;
                        
                        mem_203885.references = NULL;
                        if (memblock_alloc(ctx, &mem_203885, bytes_201905,
                                           "mem_203885")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_203889;
                        
                        mem_203889.references = NULL;
                        if (memblock_alloc(ctx, &mem_203889, bytes_201905,
                                           "mem_203889")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_200374 = 0; i_200374 < m_196691;
                             i_200374++) {
                            for (int64_t i_200367 = 0; i_200367 < l_n_m_196752;
                                 i_200367++) {
                                int64_t x_198385;
                                
                                x_198385 = ((int64_t *) mem_201902)[i_200374 *
                                                                    l_n_m_196752 +
                                                                    i_200367];
                                
                                float x_198386;
                                
                                x_198386 = ((float *) mem_201906)[i_200374 *
                                                                  l_n_m_196752 +
                                                                  i_200367];
                                
                                int64_t min_arg_198387 = mul64(jump_t_196702,
                                                               i_200367);
                                int64_t min_res_198388 = smin64(i_196779,
                                                                min_arg_198387);
                                int64_t defunc_0_g_res_198389 =
                                        add64((int64_t) 1, min_res_198388);
                                float defunc_2_reduce_res_198390;
                                float defunc_2_reduce_res_198391;
                                float defunc_2_reduce_res_198392;
                                float redout_200356;
                                float redout_200357;
                                float redout_200358;
                                
                                redout_200356 = 0.0F;
                                redout_200357 = 0.0F;
                                redout_200358 = 0.0F;
                                for (int64_t i_200359 = 0; i_200359 <
                                     q_l_196697; i_200359++) {
                                    bool cond_198403 = sle64(n_196692,
                                                             i_200359);
                                    int64_t defunc_0_f_res_198404;
                                    
                                    if (cond_198403) {
                                        defunc_0_f_res_198404 = (int64_t) 0;
                                    } else {
                                        int64_t i_198405 = add64(x_198385,
                                                                 i_200359);
                                        int64_t defunc_1_add_res_198406 =
                                                add64((int64_t) 1, i_198405);
                                        
                                        defunc_0_f_res_198404 =
                                            defunc_1_add_res_198406;
                                    }
                                    
                                    float defunc_0_f_res_198407;
                                    
                                    if (cond_198403) {
                                        defunc_0_f_res_198407 = 0.0F;
                                    } else {
                                        int64_t i_198408 = add64(x_198385,
                                                                 i_200359);
                                        float defunc_0_add_arg_198409;
                                        
                                        defunc_0_add_arg_198409 =
                                            ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                             (i_200374 *
                                                                              ctx_param_ext_202132 +
                                                                              i_198408 *
                                                                              ctx_param_ext_202134)];
                                        defunc_0_f_res_198407 =
                                            defunc_0_add_arg_198409;
                                    }
                                    
                                    int64_t binop_p_198410 =
                                            sub64(defunc_0_f_res_198404,
                                                  defunc_0_g_res_198389);
                                    float defunc_0_f_res_198411 =
                                          sitofp_i64_f32(binop_p_198410);
                                    float abs_res_198412 =
                                          (float) fabs(defunc_0_f_res_198411);
                                    float tmp1_198413 = abs_res_198412 /
                                          x_198386;
                                    float x_198414 = tmp1_198413 * tmp1_198413;
                                    float y_198415 = tmp1_198413 * x_198414;
                                    float tmp2_198416 = 1.0F - y_198415;
                                    float x_198417 = tmp2_198416 * tmp2_198416;
                                    float tmp3_198418 = tmp2_198416 * x_198417;
                                    float w_j_198419 = defunc_0_f_res_198407 *
                                          tmp3_198418;
                                    float xw_j_198420 = defunc_0_f_res_198411 *
                                          w_j_198419;
                                    float x2w_j_198421 = defunc_0_f_res_198411 *
                                          xw_j_198420;
                                    float defunc_1_op_res_198395 = w_j_198419 +
                                          redout_200356;
                                    float defunc_1_op_res_198398 = xw_j_198420 +
                                          redout_200357;
                                    float defunc_1_op_res_198401 =
                                          x2w_j_198421 + redout_200358;
                                    float redout_tmp_206499 =
                                          defunc_1_op_res_198395;
                                    float redout_tmp_206500 =
                                          defunc_1_op_res_198398;
                                    float redout_tmp_206501 =
                                          defunc_1_op_res_198401;
                                    
                                    redout_200356 = redout_tmp_206499;
                                    redout_200357 = redout_tmp_206500;
                                    redout_200358 = redout_tmp_206501;
                                }
                                defunc_2_reduce_res_198390 = redout_200356;
                                defunc_2_reduce_res_198391 = redout_200357;
                                defunc_2_reduce_res_198392 = redout_200358;
                                
                                float x_198422 = defunc_2_reduce_res_198390 *
                                      defunc_2_reduce_res_198392;
                                float y_198423 = defunc_2_reduce_res_198391 *
                                      defunc_2_reduce_res_198391;
                                float y_198424 = x_198422 - y_198423;
                                float det1_198425 = 1.0F / y_198424;
                                float a11_198426 = defunc_2_reduce_res_198392 *
                                      det1_198425;
                                float x_198427 = 0.0F -
                                      defunc_2_reduce_res_198391;
                                float b11_198428 = det1_198425 * x_198427;
                                float c11_198429 = defunc_2_reduce_res_198390 *
                                      det1_198425;
                                float defunc_2_reduce_res_198430;
                                float defunc_2_reduce_res_198431;
                                float redout_200360;
                                float redout_200361;
                                
                                redout_200360 = 0.0F;
                                redout_200361 = 0.0F;
                                for (int64_t i_200362 = 0; i_200362 <
                                     q_l_196697; i_200362++) {
                                    bool cond_198439 = sle64(n_196692,
                                                             i_200362);
                                    int64_t defunc_0_f_res_198440;
                                    
                                    if (cond_198439) {
                                        defunc_0_f_res_198440 = (int64_t) 0;
                                    } else {
                                        int64_t i_198441 = add64(x_198385,
                                                                 i_200362);
                                        int64_t defunc_1_add_res_198442 =
                                                add64((int64_t) 1, i_198441);
                                        
                                        defunc_0_f_res_198440 =
                                            defunc_1_add_res_198442;
                                    }
                                    
                                    float defunc_0_f_res_198443;
                                    
                                    if (cond_198439) {
                                        defunc_0_f_res_198443 = 0.0F;
                                    } else {
                                        int64_t i_198444 = add64(x_198385,
                                                                 i_200362);
                                        float defunc_0_add_arg_198445;
                                        
                                        defunc_0_add_arg_198445 =
                                            ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                             (i_200374 *
                                                                              ctx_param_ext_202132 +
                                                                              i_198444 *
                                                                              ctx_param_ext_202134)];
                                        defunc_0_f_res_198443 =
                                            defunc_0_add_arg_198445;
                                    }
                                    
                                    int64_t binop_p_198446 =
                                            sub64(defunc_0_f_res_198440,
                                                  defunc_0_g_res_198389);
                                    float defunc_0_f_res_198447 =
                                          sitofp_i64_f32(binop_p_198446);
                                    float abs_res_198448 =
                                          (float) fabs(defunc_0_f_res_198447);
                                    float tmp1_198449 = abs_res_198448 /
                                          x_198386;
                                    float x_198450 = tmp1_198449 * tmp1_198449;
                                    float y_198451 = tmp1_198449 * x_198450;
                                    float tmp2_198452 = 1.0F - y_198451;
                                    float x_198453 = tmp2_198452 * tmp2_198452;
                                    float tmp3_198454 = tmp2_198452 * x_198453;
                                    float tmp4_198455 = defunc_0_f_res_198443 *
                                          tmp3_198454;
                                    float defunc_1_f_res_198456 =
                                          defunc_0_f_res_198447 * tmp4_198455;
                                    float defunc_0_f_res_198457;
                                    
                                    if (cond_198439) {
                                        defunc_0_f_res_198457 = 0.0F;
                                    } else {
                                        int64_t i_198458 = add64(x_198385,
                                                                 i_200362);
                                        float defunc_0_add_arg_198459;
                                        
                                        defunc_0_add_arg_198459 =
                                            ((float *) mem_203800)[i_200374 *
                                                                   n_196692 +
                                                                   i_198458];
                                        defunc_0_f_res_198457 =
                                            defunc_0_add_arg_198459;
                                    }
                                    
                                    float x_198460 = a11_198426 * tmp4_198455;
                                    float y_198461 = b11_198428 *
                                          defunc_1_f_res_198456;
                                    float x_198462 = x_198460 + y_198461;
                                    float defunc_9_fit_fun_res_198463 =
                                          defunc_0_f_res_198457 * x_198462;
                                    float x_198464 = b11_198428 * tmp4_198455;
                                    float y_198465 = c11_198429 *
                                          defunc_1_f_res_198456;
                                    float x_198466 = x_198464 + y_198465;
                                    float defunc_9_slope_fun_res_198467 =
                                          defunc_0_f_res_198457 * x_198466;
                                    float defunc_1_op_res_198434 =
                                          defunc_9_fit_fun_res_198463 +
                                          redout_200360;
                                    float defunc_1_op_res_198437 =
                                          defunc_9_slope_fun_res_198467 +
                                          redout_200361;
                                    float redout_tmp_206502 =
                                          defunc_1_op_res_198434;
                                    float redout_tmp_206503 =
                                          defunc_1_op_res_198437;
                                    
                                    redout_200360 = redout_tmp_206502;
                                    redout_200361 = redout_tmp_206503;
                                }
                                defunc_2_reduce_res_198430 = redout_200360;
                                defunc_2_reduce_res_198431 = redout_200361;
                                ((float *) mem_203885.mem)[i_200374 *
                                                           l_n_m_196752 +
                                                           i_200367] =
                                    defunc_2_reduce_res_198430;
                                ((float *) mem_203889.mem)[i_200374 *
                                                           l_n_m_196752 +
                                                           i_200367] =
                                    defunc_2_reduce_res_198431;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_204066, &mem_203885,
                                         "mem_203885") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_204058, &mem_203889,
                                         "mem_203889") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_203889, "mem_203889") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_203885, "mem_203885") != 0)
                            return 1;
                    } else {
                        struct memblock mem_203973;
                        
                        mem_203973.references = NULL;
                        if (memblock_alloc(ctx, &mem_203973, bytes_201905,
                                           "mem_203973")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_203977;
                        
                        mem_203977.references = NULL;
                        if (memblock_alloc(ctx, &mem_203977, bytes_201905,
                                           "mem_203977")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_200397 = 0; i_200397 < m_196691;
                             i_200397++) {
                            for (int64_t i_200390 = 0; i_200390 < l_n_m_196752;
                                 i_200390++) {
                                int64_t x_198480;
                                
                                x_198480 = ((int64_t *) mem_201902)[i_200397 *
                                                                    l_n_m_196752 +
                                                                    i_200390];
                                
                                float x_198481;
                                
                                x_198481 = ((float *) mem_201906)[i_200397 *
                                                                  l_n_m_196752 +
                                                                  i_200390];
                                
                                int64_t min_arg_198482 = mul64(jump_t_196702,
                                                               i_200390);
                                int64_t min_res_198483 = smin64(i_196779,
                                                                min_arg_198482);
                                int64_t defunc_0_g_res_198484 =
                                        add64((int64_t) 1, min_res_198483);
                                float defunc_2_reduce_res_198485;
                                float defunc_2_reduce_res_198486;
                                float defunc_2_reduce_res_198487;
                                float defunc_2_reduce_res_198488;
                                float defunc_2_reduce_res_198489;
                                float redout_200377;
                                float redout_200378;
                                float redout_200379;
                                float redout_200380;
                                float redout_200381;
                                
                                redout_200377 = 0.0F;
                                redout_200378 = 0.0F;
                                redout_200379 = 0.0F;
                                redout_200380 = 0.0F;
                                redout_200381 = 0.0F;
                                for (int64_t i_200382 = 0; i_200382 <
                                     q_l_196697; i_200382++) {
                                    bool cond_198506 = sle64(n_196692,
                                                             i_200382);
                                    int64_t defunc_0_f_res_198507;
                                    
                                    if (cond_198506) {
                                        defunc_0_f_res_198507 = (int64_t) 0;
                                    } else {
                                        int64_t i_198508 = add64(x_198480,
                                                                 i_200382);
                                        int64_t defunc_1_add_res_198509 =
                                                add64((int64_t) 1, i_198508);
                                        
                                        defunc_0_f_res_198507 =
                                            defunc_1_add_res_198509;
                                    }
                                    
                                    float defunc_0_f_res_198510;
                                    
                                    if (cond_198506) {
                                        defunc_0_f_res_198510 = 0.0F;
                                    } else {
                                        int64_t i_198511 = add64(x_198480,
                                                                 i_200382);
                                        float defunc_0_add_arg_198512;
                                        
                                        defunc_0_add_arg_198512 =
                                            ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                             (i_200397 *
                                                                              ctx_param_ext_202132 +
                                                                              i_198511 *
                                                                              ctx_param_ext_202134)];
                                        defunc_0_f_res_198510 =
                                            defunc_0_add_arg_198512;
                                    }
                                    
                                    int64_t binop_p_198513 =
                                            sub64(defunc_0_f_res_198507,
                                                  defunc_0_g_res_198484);
                                    float defunc_0_f_res_198514 =
                                          sitofp_i64_f32(binop_p_198513);
                                    float abs_res_198515 =
                                          (float) fabs(defunc_0_f_res_198514);
                                    float tmp1_198516 = abs_res_198515 /
                                          x_198481;
                                    float x_198517 = tmp1_198516 * tmp1_198516;
                                    float y_198518 = tmp1_198516 * x_198517;
                                    float tmp2_198519 = 1.0F - y_198518;
                                    float x_198520 = tmp2_198519 * tmp2_198519;
                                    float tmp3_198521 = tmp2_198519 * x_198520;
                                    float w_j_198522 = defunc_0_f_res_198510 *
                                          tmp3_198521;
                                    float xw_j_198523 = defunc_0_f_res_198514 *
                                          w_j_198522;
                                    float x2w_j_198524 = defunc_0_f_res_198514 *
                                          xw_j_198523;
                                    float x3w_j_198525 = defunc_0_f_res_198514 *
                                          x2w_j_198524;
                                    float x4w_j_198526 = defunc_0_f_res_198514 *
                                          x3w_j_198525;
                                    float defunc_1_op_res_198492 = w_j_198522 +
                                          redout_200377;
                                    float defunc_1_op_res_198495 = xw_j_198523 +
                                          redout_200378;
                                    float defunc_1_op_res_198498 =
                                          x2w_j_198524 + redout_200379;
                                    float defunc_1_op_res_198501 =
                                          x3w_j_198525 + redout_200380;
                                    float defunc_1_op_res_198504 =
                                          x4w_j_198526 + redout_200381;
                                    float redout_tmp_206508 =
                                          defunc_1_op_res_198492;
                                    float redout_tmp_206509 =
                                          defunc_1_op_res_198495;
                                    float redout_tmp_206510 =
                                          defunc_1_op_res_198498;
                                    float redout_tmp_206511 =
                                          defunc_1_op_res_198501;
                                    float redout_tmp_206512 =
                                          defunc_1_op_res_198504;
                                    
                                    redout_200377 = redout_tmp_206508;
                                    redout_200378 = redout_tmp_206509;
                                    redout_200379 = redout_tmp_206510;
                                    redout_200380 = redout_tmp_206511;
                                    redout_200381 = redout_tmp_206512;
                                }
                                defunc_2_reduce_res_198485 = redout_200377;
                                defunc_2_reduce_res_198486 = redout_200378;
                                defunc_2_reduce_res_198487 = redout_200379;
                                defunc_2_reduce_res_198488 = redout_200380;
                                defunc_2_reduce_res_198489 = redout_200381;
                                
                                float x_198527 = defunc_2_reduce_res_198487 *
                                      defunc_2_reduce_res_198489;
                                float y_198528 = defunc_2_reduce_res_198488 *
                                      defunc_2_reduce_res_198488;
                                float a12_198529 = x_198527 - y_198528;
                                float x_198530 = defunc_2_reduce_res_198487 *
                                      defunc_2_reduce_res_198488;
                                float y_198531 = defunc_2_reduce_res_198486 *
                                      defunc_2_reduce_res_198489;
                                float b12_198532 = x_198530 - y_198531;
                                float x_198533 = defunc_2_reduce_res_198486 *
                                      defunc_2_reduce_res_198488;
                                float y_198534 = defunc_2_reduce_res_198487 *
                                      defunc_2_reduce_res_198487;
                                float c12_198535 = x_198533 - y_198534;
                                float x_198536 = defunc_2_reduce_res_198485 *
                                      defunc_2_reduce_res_198489;
                                float b2_198537 = x_198536 - y_198534;
                                float x_198538 = defunc_2_reduce_res_198486 *
                                      defunc_2_reduce_res_198487;
                                float y_198539 = defunc_2_reduce_res_198485 *
                                      defunc_2_reduce_res_198488;
                                float c2_198540 = x_198538 - y_198539;
                                float x_198541 = defunc_2_reduce_res_198485 *
                                      a12_198529;
                                float y_198542 = defunc_2_reduce_res_198486 *
                                      b12_198532;
                                float x_198543 = x_198541 + y_198542;
                                float y_198544 = defunc_2_reduce_res_198487 *
                                      c12_198535;
                                float y_198545 = x_198543 + y_198544;
                                float det_198546 = 1.0F / y_198545;
                                float a12_198547 = a12_198529 * det_198546;
                                float b12_198548 = b12_198532 * det_198546;
                                float c12_198549 = c12_198535 * det_198546;
                                float b2_198550 = b2_198537 * det_198546;
                                float c2_198551 = c2_198540 * det_198546;
                                float defunc_2_reduce_res_198552;
                                float defunc_2_reduce_res_198553;
                                float redout_200383;
                                float redout_200384;
                                
                                redout_200383 = 0.0F;
                                redout_200384 = 0.0F;
                                for (int64_t i_200385 = 0; i_200385 <
                                     q_l_196697; i_200385++) {
                                    bool cond_198561 = sle64(n_196692,
                                                             i_200385);
                                    int64_t defunc_0_f_res_198562;
                                    
                                    if (cond_198561) {
                                        defunc_0_f_res_198562 = (int64_t) 0;
                                    } else {
                                        int64_t i_198563 = add64(x_198480,
                                                                 i_200385);
                                        int64_t defunc_1_add_res_198564 =
                                                add64((int64_t) 1, i_198563);
                                        
                                        defunc_0_f_res_198562 =
                                            defunc_1_add_res_198564;
                                    }
                                    
                                    float defunc_0_f_res_198565;
                                    
                                    if (cond_198561) {
                                        defunc_0_f_res_198565 = 0.0F;
                                    } else {
                                        int64_t i_198566 = add64(x_198480,
                                                                 i_200385);
                                        float defunc_0_add_arg_198567;
                                        
                                        defunc_0_add_arg_198567 =
                                            ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                             (i_200397 *
                                                                              ctx_param_ext_202132 +
                                                                              i_198566 *
                                                                              ctx_param_ext_202134)];
                                        defunc_0_f_res_198565 =
                                            defunc_0_add_arg_198567;
                                    }
                                    
                                    int64_t binop_p_198568 =
                                            sub64(defunc_0_f_res_198562,
                                                  defunc_0_g_res_198484);
                                    float defunc_0_f_res_198569 =
                                          sitofp_i64_f32(binop_p_198568);
                                    float abs_res_198570 =
                                          (float) fabs(defunc_0_f_res_198569);
                                    float tmp1_198571 = abs_res_198570 /
                                          x_198481;
                                    float x_198572 = tmp1_198571 * tmp1_198571;
                                    float y_198573 = tmp1_198571 * x_198572;
                                    float tmp2_198574 = 1.0F - y_198573;
                                    float x_198575 = tmp2_198574 * tmp2_198574;
                                    float tmp3_198576 = tmp2_198574 * x_198575;
                                    float tmp4_198577 = defunc_0_f_res_198565 *
                                          tmp3_198576;
                                    float defunc_1_f_res_198578 =
                                          defunc_0_f_res_198569 * tmp4_198577;
                                    float defunc_1_f_res_198579 =
                                          defunc_0_f_res_198569 *
                                          defunc_1_f_res_198578;
                                    float defunc_0_f_res_198580;
                                    
                                    if (cond_198561) {
                                        defunc_0_f_res_198580 = 0.0F;
                                    } else {
                                        int64_t i_198581 = add64(x_198480,
                                                                 i_200385);
                                        float defunc_0_add_arg_198582;
                                        
                                        defunc_0_add_arg_198582 =
                                            ((float *) mem_203800)[i_200397 *
                                                                   n_196692 +
                                                                   i_198581];
                                        defunc_0_f_res_198580 =
                                            defunc_0_add_arg_198582;
                                    }
                                    
                                    float x_198583 = a12_198547 * tmp4_198577;
                                    float y_198584 = b12_198548 *
                                          defunc_1_f_res_198578;
                                    float x_198585 = x_198583 + y_198584;
                                    float y_198586 = c12_198549 *
                                          defunc_1_f_res_198579;
                                    float x_198587 = x_198585 + y_198586;
                                    float defunc_9_fit_fun_res_198588 =
                                          defunc_0_f_res_198580 * x_198587;
                                    float x_198589 = b12_198548 * tmp4_198577;
                                    float y_198590 = b2_198550 *
                                          defunc_1_f_res_198578;
                                    float x_198591 = x_198589 + y_198590;
                                    float y_198592 = c2_198551 *
                                          defunc_1_f_res_198579;
                                    float x_198593 = x_198591 + y_198592;
                                    float defunc_9_slope_fun_res_198594 =
                                          defunc_0_f_res_198580 * x_198593;
                                    float defunc_1_op_res_198556 =
                                          defunc_9_fit_fun_res_198588 +
                                          redout_200383;
                                    float defunc_1_op_res_198559 =
                                          defunc_9_slope_fun_res_198594 +
                                          redout_200384;
                                    float redout_tmp_206513 =
                                          defunc_1_op_res_198556;
                                    float redout_tmp_206514 =
                                          defunc_1_op_res_198559;
                                    
                                    redout_200383 = redout_tmp_206513;
                                    redout_200384 = redout_tmp_206514;
                                }
                                defunc_2_reduce_res_198552 = redout_200383;
                                defunc_2_reduce_res_198553 = redout_200384;
                                ((float *) mem_203973.mem)[i_200397 *
                                                           l_n_m_196752 +
                                                           i_200390] =
                                    defunc_2_reduce_res_198552;
                                ((float *) mem_203977.mem)[i_200397 *
                                                           l_n_m_196752 +
                                                           i_200390] =
                                    defunc_2_reduce_res_198553;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_204066, &mem_203973,
                                         "mem_203973") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_204058, &mem_203977,
                                         "mem_203977") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_203977, "mem_203977") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_203973, "mem_203973") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_204082, &ext_mem_204066,
                                     "ext_mem_204066") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_204074, &ext_mem_204058,
                                     "ext_mem_204058") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204058,
                                       "ext_mem_204058") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204066,
                                       "ext_mem_204066") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_204459, &ext_mem_204082,
                                 "ext_mem_204082") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_204451, &ext_mem_204074,
                                 "ext_mem_204074") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_204074, "ext_mem_204074") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_204082, "ext_mem_204082") != 0)
                    return 1;
            } else {
                bool match_lit_198597 = (int64_t) 0 == d_l_196700;
                int64_t binop_y_204119 = (int64_t) 4 * q_l_196697;
                int64_t bytes_204120 = smax64((int64_t) 0, binop_y_204119);
                struct memblock ext_mem_204443;
                
                ext_mem_204443.references = NULL;
                
                struct memblock ext_mem_204435;
                
                ext_mem_204435.references = NULL;
                if (match_lit_198597) {
                    struct memblock mem_204093;
                    
                    mem_204093.references = NULL;
                    if (memblock_alloc(ctx, &mem_204093, bytes_201905,
                                       "mem_204093")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_206515 = 0; i_206515 < m_196691;
                         i_206515++) {
                        for (int64_t i_206516 = 0; i_206516 < l_n_m_196752;
                             i_206516++) {
                            ((float *) mem_204093.mem)[i_206515 * l_n_m_196752 +
                                                       i_206516] = 0.0F;
                        }
                    }
                    
                    struct memblock mem_204097;
                    
                    mem_204097.references = NULL;
                    if (memblock_alloc(ctx, &mem_204097, bytes_201905,
                                       "mem_204097")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (mem_204121_cached_sizze_206696 <
                        (size_t) bytes_204120) {
                        mem_204121 = realloc(mem_204121, bytes_204120);
                        mem_204121_cached_sizze_206696 = bytes_204120;
                    }
                    for (int64_t i_200413 = 0; i_200413 < m_196691;
                         i_200413++) {
                        for (int64_t i_200409 = 0; i_200409 < l_n_m_196752;
                             i_200409++) {
                            int64_t x_198609;
                            
                            x_198609 = ((int64_t *) mem_201902)[i_200413 *
                                                                l_n_m_196752 +
                                                                i_200409];
                            
                            float x_198610;
                            
                            x_198610 = ((float *) mem_201906)[i_200413 *
                                                              l_n_m_196752 +
                                                              i_200409];
                            
                            int64_t min_arg_198611 = mul64(jump_t_196702,
                                                           i_200409);
                            int64_t min_res_198612 = smin64(i_196779,
                                                            min_arg_198611);
                            int64_t defunc_0_g_res_198613 = add64((int64_t) 1,
                                                                  min_res_198612);
                            float defunc_2_reduce_res_198614;
                            float redout_200401 = 0.0F;
                            
                            for (int64_t i_200403 = 0; i_200403 < q_l_196697;
                                 i_200403++) {
                                bool cond_198620 = sle64(n_196692, i_200403);
                                int64_t defunc_0_f_res_198621;
                                
                                if (cond_198620) {
                                    defunc_0_f_res_198621 = (int64_t) 0;
                                } else {
                                    int64_t i_198622 = add64(x_198609,
                                                             i_200403);
                                    int64_t defunc_1_add_res_198623 =
                                            add64((int64_t) 1, i_198622);
                                    
                                    defunc_0_f_res_198621 =
                                        defunc_1_add_res_198623;
                                }
                                
                                float defunc_0_f_res_198624;
                                
                                if (cond_198620) {
                                    defunc_0_f_res_198624 = 0.0F;
                                } else {
                                    int64_t i_198625 = add64(x_198609,
                                                             i_200403);
                                    float defunc_0_add_arg_198626;
                                    
                                    defunc_0_add_arg_198626 =
                                        ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                         (i_200413 *
                                                                          ctx_param_ext_202132 +
                                                                          i_198625 *
                                                                          ctx_param_ext_202134)];
                                    defunc_0_f_res_198624 =
                                        defunc_0_add_arg_198626;
                                }
                                
                                int64_t binop_p_198627 =
                                        sub64(defunc_0_f_res_198621,
                                              defunc_0_g_res_198613);
                                float defunc_0_f_res_198628 =
                                      sitofp_i64_f32(binop_p_198627);
                                float abs_res_198629 =
                                      (float) fabs(defunc_0_f_res_198628);
                                float tmp1_198630 = abs_res_198629 / x_198610;
                                float x_198631 = tmp1_198630 * tmp1_198630;
                                float y_198632 = tmp1_198630 * x_198631;
                                float tmp2_198633 = 1.0F - y_198632;
                                float x_198634 = tmp2_198633 * tmp2_198633;
                                float tmp3_198635 = tmp2_198633 * x_198634;
                                float tmp4_198636 = defunc_0_f_res_198624 *
                                      tmp3_198635;
                                float defunc_1_op_res_198618 = tmp4_198636 +
                                      redout_200401;
                                
                                ((float *) mem_204121)[i_200403] = tmp4_198636;
                                
                                float redout_tmp_206519 =
                                      defunc_1_op_res_198618;
                                
                                redout_200401 = redout_tmp_206519;
                            }
                            defunc_2_reduce_res_198614 = redout_200401;
                            
                            float a0_198637 = 1.0F / defunc_2_reduce_res_198614;
                            float defunc_2_reduce_res_198638;
                            float redout_200405 = 0.0F;
                            
                            for (int64_t i_200406 = 0; i_200406 < q_l_196697;
                                 i_200406++) {
                                float x_198643;
                                
                                x_198643 = ((float *) mem_204121)[i_200406];
                                
                                bool cond_198644 = sle64(n_196692, i_200406);
                                float defunc_0_f_res_198645;
                                
                                if (cond_198644) {
                                    defunc_0_f_res_198645 = 0.0F;
                                } else {
                                    int64_t i_198646 = add64(x_198609,
                                                             i_200406);
                                    float defunc_0_add_arg_198647;
                                    
                                    defunc_0_add_arg_198647 =
                                        ((float *) mem_203800)[i_200413 *
                                                               n_196692 +
                                                               i_198646];
                                    defunc_0_f_res_198645 =
                                        defunc_0_add_arg_198647;
                                }
                                
                                float x_198648 = a0_198637 * x_198643;
                                float defunc_9_fit_fun_res_198649 =
                                      defunc_0_f_res_198645 * x_198648;
                                float defunc_1_op_res_198641 =
                                      defunc_9_fit_fun_res_198649 +
                                      redout_200405;
                                float redout_tmp_206521 =
                                      defunc_1_op_res_198641;
                                
                                redout_200405 = redout_tmp_206521;
                            }
                            defunc_2_reduce_res_198638 = redout_200405;
                            ((float *) mem_204097.mem)[i_200413 * l_n_m_196752 +
                                                       i_200409] =
                                defunc_2_reduce_res_198638;
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_204443, &mem_204097,
                                     "mem_204097") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_204435, &mem_204093,
                                     "mem_204093") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_204097, "mem_204097") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_204093, "mem_204093") != 0)
                        return 1;
                } else {
                    bool match_lit_198652 = (int64_t) 1 == d_l_196700;
                    int64_t binop_y_204203 = (int64_t) 4 * q_l_196697;
                    int64_t bytes_204204 = smax64((int64_t) 0, binop_y_204203);
                    int64_t binop_y_204321 = (int64_t) 4 * q_l_196697;
                    int64_t bytes_204322 = smax64((int64_t) 0, binop_y_204321);
                    struct memblock ext_mem_204427;
                    
                    ext_mem_204427.references = NULL;
                    
                    struct memblock ext_mem_204419;
                    
                    ext_mem_204419.references = NULL;
                    if (match_lit_198652) {
                        struct memblock mem_204156;
                        
                        mem_204156.references = NULL;
                        if (memblock_alloc(ctx, &mem_204156, bytes_201905,
                                           "mem_204156")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_204160;
                        
                        mem_204160.references = NULL;
                        if (memblock_alloc(ctx, &mem_204160, bytes_201905,
                                           "mem_204160")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_204205_cached_sizze_206697 <
                            (size_t) bytes_204204) {
                            mem_204205 = realloc(mem_204205, bytes_204204);
                            mem_204205_cached_sizze_206697 = bytes_204204;
                        }
                        if (mem_204208_cached_sizze_206698 <
                            (size_t) bytes_204204) {
                            mem_204208 = realloc(mem_204208, bytes_204204);
                            mem_204208_cached_sizze_206698 = bytes_204204;
                        }
                        for (int64_t i_200439 = 0; i_200439 < m_196691;
                             i_200439++) {
                            for (int64_t i_200432 = 0; i_200432 < l_n_m_196752;
                                 i_200432++) {
                                int64_t x_198665;
                                
                                x_198665 = ((int64_t *) mem_201902)[i_200439 *
                                                                    l_n_m_196752 +
                                                                    i_200432];
                                
                                float x_198666;
                                
                                x_198666 = ((float *) mem_201906)[i_200439 *
                                                                  l_n_m_196752 +
                                                                  i_200432];
                                
                                int64_t min_arg_198667 = mul64(jump_t_196702,
                                                               i_200432);
                                int64_t min_res_198668 = smin64(i_196779,
                                                                min_arg_198667);
                                int64_t defunc_0_g_res_198669 =
                                        add64((int64_t) 1, min_res_198668);
                                float defunc_2_reduce_res_198692;
                                float defunc_2_reduce_res_198693;
                                float defunc_2_reduce_res_198694;
                                float redout_200417;
                                float redout_200418;
                                float redout_200419;
                                
                                redout_200417 = 0.0F;
                                redout_200418 = 0.0F;
                                redout_200419 = 0.0F;
                                for (int64_t i_200422 = 0; i_200422 <
                                     q_l_196697; i_200422++) {
                                    bool cond_198707 = sle64(n_196692,
                                                             i_200422);
                                    int64_t defunc_0_f_res_198708;
                                    
                                    if (cond_198707) {
                                        defunc_0_f_res_198708 = (int64_t) 0;
                                    } else {
                                        int64_t i_198709 = add64(x_198665,
                                                                 i_200422);
                                        int64_t defunc_1_add_res_198710 =
                                                add64((int64_t) 1, i_198709);
                                        
                                        defunc_0_f_res_198708 =
                                            defunc_1_add_res_198710;
                                    }
                                    
                                    float defunc_0_f_res_198711;
                                    
                                    if (cond_198707) {
                                        defunc_0_f_res_198711 = 0.0F;
                                    } else {
                                        int64_t i_198712 = add64(x_198665,
                                                                 i_200422);
                                        float defunc_0_add_arg_198713;
                                        
                                        defunc_0_add_arg_198713 =
                                            ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                             (i_200439 *
                                                                              ctx_param_ext_202132 +
                                                                              i_198712 *
                                                                              ctx_param_ext_202134)];
                                        defunc_0_f_res_198711 =
                                            defunc_0_add_arg_198713;
                                    }
                                    
                                    int64_t binop_p_198714 =
                                            sub64(defunc_0_f_res_198708,
                                                  defunc_0_g_res_198669);
                                    float defunc_0_f_res_198715 =
                                          sitofp_i64_f32(binop_p_198714);
                                    float abs_res_198716 =
                                          (float) fabs(defunc_0_f_res_198715);
                                    float tmp1_198717 = abs_res_198716 /
                                          x_198666;
                                    float x_198718 = tmp1_198717 * tmp1_198717;
                                    float y_198719 = tmp1_198717 * x_198718;
                                    float tmp2_198720 = 1.0F - y_198719;
                                    float x_198721 = tmp2_198720 * tmp2_198720;
                                    float tmp3_198722 = tmp2_198720 * x_198721;
                                    float tmp4_198723 = defunc_0_f_res_198711 *
                                          tmp3_198722;
                                    float defunc_1_f_res_198724 =
                                          defunc_0_f_res_198715 * tmp4_198723;
                                    float defunc_1_f_res_198725 =
                                          defunc_0_f_res_198715 *
                                          defunc_1_f_res_198724;
                                    float defunc_1_op_res_198699 = tmp4_198723 +
                                          redout_200417;
                                    float defunc_1_op_res_198702 =
                                          defunc_1_f_res_198724 + redout_200418;
                                    float defunc_1_op_res_198705 =
                                          defunc_1_f_res_198725 + redout_200419;
                                    
                                    ((float *) mem_204205)[i_200422] =
                                        defunc_1_f_res_198724;
                                    ((float *) mem_204208)[i_200422] =
                                        tmp4_198723;
                                    
                                    float redout_tmp_206526 =
                                          defunc_1_op_res_198699;
                                    float redout_tmp_206527 =
                                          defunc_1_op_res_198702;
                                    float redout_tmp_206528 =
                                          defunc_1_op_res_198705;
                                    
                                    redout_200417 = redout_tmp_206526;
                                    redout_200418 = redout_tmp_206527;
                                    redout_200419 = redout_tmp_206528;
                                }
                                defunc_2_reduce_res_198692 = redout_200417;
                                defunc_2_reduce_res_198693 = redout_200418;
                                defunc_2_reduce_res_198694 = redout_200419;
                                
                                float x_198731 = defunc_2_reduce_res_198692 *
                                      defunc_2_reduce_res_198694;
                                float y_198732 = defunc_2_reduce_res_198693 *
                                      defunc_2_reduce_res_198693;
                                float y_198733 = x_198731 - y_198732;
                                float det1_198734 = 1.0F / y_198733;
                                float a11_198735 = defunc_2_reduce_res_198694 *
                                      det1_198734;
                                float x_198736 = 0.0F -
                                      defunc_2_reduce_res_198693;
                                float b11_198737 = det1_198734 * x_198736;
                                float c11_198738 = defunc_2_reduce_res_198692 *
                                      det1_198734;
                                float defunc_2_reduce_res_198739;
                                float defunc_2_reduce_res_198740;
                                float redout_200425;
                                float redout_200426;
                                
                                redout_200425 = 0.0F;
                                redout_200426 = 0.0F;
                                for (int64_t i_200427 = 0; i_200427 <
                                     q_l_196697; i_200427++) {
                                    float x_198748;
                                    
                                    x_198748 = ((float *) mem_204208)[i_200427];
                                    
                                    float x_198749;
                                    
                                    x_198749 = ((float *) mem_204205)[i_200427];
                                    
                                    bool cond_198750 = sle64(n_196692,
                                                             i_200427);
                                    float defunc_0_f_res_198751;
                                    
                                    if (cond_198750) {
                                        defunc_0_f_res_198751 = 0.0F;
                                    } else {
                                        int64_t i_198752 = add64(x_198665,
                                                                 i_200427);
                                        float defunc_0_add_arg_198753;
                                        
                                        defunc_0_add_arg_198753 =
                                            ((float *) mem_203800)[i_200439 *
                                                                   n_196692 +
                                                                   i_198752];
                                        defunc_0_f_res_198751 =
                                            defunc_0_add_arg_198753;
                                    }
                                    
                                    float x_198754 = a11_198735 * x_198748;
                                    float y_198755 = b11_198737 * x_198749;
                                    float x_198756 = x_198754 + y_198755;
                                    float defunc_9_fit_fun_res_198757 =
                                          defunc_0_f_res_198751 * x_198756;
                                    float x_198758 = b11_198737 * x_198748;
                                    float y_198759 = c11_198738 * x_198749;
                                    float x_198760 = x_198758 + y_198759;
                                    float defunc_9_slope_fun_res_198761 =
                                          defunc_0_f_res_198751 * x_198760;
                                    float defunc_1_op_res_198743 =
                                          defunc_9_fit_fun_res_198757 +
                                          redout_200425;
                                    float defunc_1_op_res_198746 =
                                          defunc_9_slope_fun_res_198761 +
                                          redout_200426;
                                    float redout_tmp_206531 =
                                          defunc_1_op_res_198743;
                                    float redout_tmp_206532 =
                                          defunc_1_op_res_198746;
                                    
                                    redout_200425 = redout_tmp_206531;
                                    redout_200426 = redout_tmp_206532;
                                }
                                defunc_2_reduce_res_198739 = redout_200425;
                                defunc_2_reduce_res_198740 = redout_200426;
                                ((float *) mem_204156.mem)[i_200439 *
                                                           l_n_m_196752 +
                                                           i_200432] =
                                    defunc_2_reduce_res_198739;
                                ((float *) mem_204160.mem)[i_200439 *
                                                           l_n_m_196752 +
                                                           i_200432] =
                                    defunc_2_reduce_res_198740;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_204427, &mem_204156,
                                         "mem_204156") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_204419, &mem_204160,
                                         "mem_204160") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_204160, "mem_204160") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_204156, "mem_204156") != 0)
                            return 1;
                    } else {
                        struct memblock mem_204274;
                        
                        mem_204274.references = NULL;
                        if (memblock_alloc(ctx, &mem_204274, bytes_201905,
                                           "mem_204274")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_204278;
                        
                        mem_204278.references = NULL;
                        if (memblock_alloc(ctx, &mem_204278, bytes_201905,
                                           "mem_204278")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_204323_cached_sizze_206699 <
                            (size_t) bytes_204322) {
                            mem_204323 = realloc(mem_204323, bytes_204322);
                            mem_204323_cached_sizze_206699 = bytes_204322;
                        }
                        if (mem_204326_cached_sizze_206700 <
                            (size_t) bytes_204322) {
                            mem_204326 = realloc(mem_204326, bytes_204322);
                            mem_204326_cached_sizze_206700 = bytes_204322;
                        }
                        if (mem_204353_cached_sizze_206701 <
                            (size_t) bytes_204322) {
                            mem_204353 = realloc(mem_204353, bytes_204322);
                            mem_204353_cached_sizze_206701 = bytes_204322;
                        }
                        if (mem_204356_cached_sizze_206702 <
                            (size_t) bytes_204322) {
                            mem_204356 = realloc(mem_204356, bytes_204322);
                            mem_204356_cached_sizze_206702 = bytes_204322;
                        }
                        for (int64_t i_200475 = 0; i_200475 < m_196691;
                             i_200475++) {
                            for (int64_t i_200468 = 0; i_200468 < l_n_m_196752;
                                 i_200468++) {
                                int64_t x_198774;
                                
                                x_198774 = ((int64_t *) mem_201902)[i_200475 *
                                                                    l_n_m_196752 +
                                                                    i_200468];
                                
                                float x_198775;
                                
                                x_198775 = ((float *) mem_201906)[i_200475 *
                                                                  l_n_m_196752 +
                                                                  i_200468];
                                
                                int64_t min_arg_198776 = mul64(jump_t_196702,
                                                               i_200468);
                                int64_t min_res_198777 = smin64(i_196779,
                                                                min_arg_198776);
                                int64_t defunc_0_g_res_198778 =
                                        add64((int64_t) 1, min_res_198777);
                                
                                for (int64_t i_200446 = 0; i_200446 <
                                     q_l_196697; i_200446++) {
                                    bool cond_198782 = sle64(n_196692,
                                                             i_200446);
                                    int64_t defunc_0_f_res_198783;
                                    
                                    if (cond_198782) {
                                        defunc_0_f_res_198783 = (int64_t) 0;
                                    } else {
                                        int64_t i_198784 = add64(x_198774,
                                                                 i_200446);
                                        int64_t defunc_1_add_res_198785 =
                                                add64((int64_t) 1, i_198784);
                                        
                                        defunc_0_f_res_198783 =
                                            defunc_1_add_res_198785;
                                    }
                                    
                                    float defunc_0_f_res_198786;
                                    
                                    if (cond_198782) {
                                        defunc_0_f_res_198786 = 0.0F;
                                    } else {
                                        int64_t i_198787 = add64(x_198774,
                                                                 i_200446);
                                        float defunc_0_add_arg_198788;
                                        
                                        defunc_0_add_arg_198788 =
                                            ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                             (i_200475 *
                                                                              ctx_param_ext_202132 +
                                                                              i_198787 *
                                                                              ctx_param_ext_202134)];
                                        defunc_0_f_res_198786 =
                                            defunc_0_add_arg_198788;
                                    }
                                    
                                    int64_t binop_p_198789 =
                                            sub64(defunc_0_f_res_198783,
                                                  defunc_0_g_res_198778);
                                    float defunc_0_f_res_198790 =
                                          sitofp_i64_f32(binop_p_198789);
                                    float abs_res_198791 =
                                          (float) fabs(defunc_0_f_res_198790);
                                    float tmp1_198792 = abs_res_198791 /
                                          x_198775;
                                    float x_198793 = tmp1_198792 * tmp1_198792;
                                    float y_198794 = tmp1_198792 * x_198793;
                                    float tmp2_198795 = 1.0F - y_198794;
                                    float x_198796 = tmp2_198795 * tmp2_198795;
                                    float tmp3_198797 = tmp2_198795 * x_198796;
                                    float tmp4_198798 = defunc_0_f_res_198786 *
                                          tmp3_198797;
                                    
                                    ((float *) mem_204323)[i_200446] =
                                        defunc_0_f_res_198790;
                                    ((float *) mem_204326)[i_200446] =
                                        tmp4_198798;
                                }
                                
                                float defunc_2_reduce_res_198805;
                                float defunc_2_reduce_res_198806;
                                float defunc_2_reduce_res_198807;
                                float defunc_2_reduce_res_198808;
                                float defunc_2_reduce_res_198809;
                                float redout_200451;
                                float redout_200452;
                                float redout_200453;
                                float redout_200454;
                                float redout_200455;
                                
                                redout_200451 = 0.0F;
                                redout_200452 = 0.0F;
                                redout_200453 = 0.0F;
                                redout_200454 = 0.0F;
                                redout_200455 = 0.0F;
                                for (int64_t i_200458 = 0; i_200458 <
                                     q_l_196697; i_200458++) {
                                    float x_198827;
                                    
                                    x_198827 = ((float *) mem_204323)[i_200458];
                                    
                                    float x_198828;
                                    
                                    x_198828 = ((float *) mem_204326)[i_200458];
                                    
                                    float defunc_1_f_res_198829 = x_198827 *
                                          x_198828;
                                    float defunc_1_f_res_198830 = x_198827 *
                                          defunc_1_f_res_198829;
                                    float defunc_1_f_res_198831 = x_198827 *
                                          defunc_1_f_res_198830;
                                    float defunc_1_f_res_198832 = x_198827 *
                                          defunc_1_f_res_198831;
                                    float defunc_1_op_res_198814 = x_198828 +
                                          redout_200451;
                                    float defunc_1_op_res_198817 =
                                          defunc_1_f_res_198829 + redout_200452;
                                    float defunc_1_op_res_198820 =
                                          defunc_1_f_res_198830 + redout_200453;
                                    float defunc_1_op_res_198823 =
                                          defunc_1_f_res_198831 + redout_200454;
                                    float defunc_1_op_res_198826 =
                                          defunc_1_f_res_198832 + redout_200455;
                                    
                                    ((float *) mem_204353)[i_200458] =
                                        defunc_1_f_res_198830;
                                    ((float *) mem_204356)[i_200458] =
                                        defunc_1_f_res_198829;
                                    
                                    float redout_tmp_206539 =
                                          defunc_1_op_res_198814;
                                    float redout_tmp_206540 =
                                          defunc_1_op_res_198817;
                                    float redout_tmp_206541 =
                                          defunc_1_op_res_198820;
                                    float redout_tmp_206542 =
                                          defunc_1_op_res_198823;
                                    float redout_tmp_206543 =
                                          defunc_1_op_res_198826;
                                    
                                    redout_200451 = redout_tmp_206539;
                                    redout_200452 = redout_tmp_206540;
                                    redout_200453 = redout_tmp_206541;
                                    redout_200454 = redout_tmp_206542;
                                    redout_200455 = redout_tmp_206543;
                                }
                                defunc_2_reduce_res_198805 = redout_200451;
                                defunc_2_reduce_res_198806 = redout_200452;
                                defunc_2_reduce_res_198807 = redout_200453;
                                defunc_2_reduce_res_198808 = redout_200454;
                                defunc_2_reduce_res_198809 = redout_200455;
                                
                                float x_198840 = defunc_2_reduce_res_198807 *
                                      defunc_2_reduce_res_198809;
                                float y_198841 = defunc_2_reduce_res_198808 *
                                      defunc_2_reduce_res_198808;
                                float a12_198842 = x_198840 - y_198841;
                                float x_198843 = defunc_2_reduce_res_198807 *
                                      defunc_2_reduce_res_198808;
                                float y_198844 = defunc_2_reduce_res_198806 *
                                      defunc_2_reduce_res_198809;
                                float b12_198845 = x_198843 - y_198844;
                                float x_198846 = defunc_2_reduce_res_198806 *
                                      defunc_2_reduce_res_198808;
                                float y_198847 = defunc_2_reduce_res_198807 *
                                      defunc_2_reduce_res_198807;
                                float c12_198848 = x_198846 - y_198847;
                                float x_198849 = defunc_2_reduce_res_198805 *
                                      defunc_2_reduce_res_198809;
                                float b2_198850 = x_198849 - y_198847;
                                float x_198851 = defunc_2_reduce_res_198806 *
                                      defunc_2_reduce_res_198807;
                                float y_198852 = defunc_2_reduce_res_198805 *
                                      defunc_2_reduce_res_198808;
                                float c2_198853 = x_198851 - y_198852;
                                float x_198854 = defunc_2_reduce_res_198805 *
                                      a12_198842;
                                float y_198855 = defunc_2_reduce_res_198806 *
                                      b12_198845;
                                float x_198856 = x_198854 + y_198855;
                                float y_198857 = defunc_2_reduce_res_198807 *
                                      c12_198848;
                                float y_198858 = x_198856 + y_198857;
                                float det_198859 = 1.0F / y_198858;
                                float a12_198860 = a12_198842 * det_198859;
                                float b12_198861 = b12_198845 * det_198859;
                                float c12_198862 = c12_198848 * det_198859;
                                float b2_198863 = b2_198850 * det_198859;
                                float c2_198864 = c2_198853 * det_198859;
                                float defunc_2_reduce_res_198865;
                                float defunc_2_reduce_res_198866;
                                float redout_200461;
                                float redout_200462;
                                
                                redout_200461 = 0.0F;
                                redout_200462 = 0.0F;
                                for (int64_t i_200463 = 0; i_200463 <
                                     q_l_196697; i_200463++) {
                                    float x_198874;
                                    
                                    x_198874 = ((float *) mem_204326)[i_200463];
                                    
                                    float x_198875;
                                    
                                    x_198875 = ((float *) mem_204356)[i_200463];
                                    
                                    float x_198876;
                                    
                                    x_198876 = ((float *) mem_204353)[i_200463];
                                    
                                    bool cond_198877 = sle64(n_196692,
                                                             i_200463);
                                    float defunc_0_f_res_198878;
                                    
                                    if (cond_198877) {
                                        defunc_0_f_res_198878 = 0.0F;
                                    } else {
                                        int64_t i_198879 = add64(x_198774,
                                                                 i_200463);
                                        float defunc_0_add_arg_198880;
                                        
                                        defunc_0_add_arg_198880 =
                                            ((float *) mem_203800)[i_200475 *
                                                                   n_196692 +
                                                                   i_198879];
                                        defunc_0_f_res_198878 =
                                            defunc_0_add_arg_198880;
                                    }
                                    
                                    float x_198881 = a12_198860 * x_198874;
                                    float y_198882 = b12_198861 * x_198875;
                                    float x_198883 = x_198881 + y_198882;
                                    float y_198884 = c12_198862 * x_198876;
                                    float x_198885 = x_198883 + y_198884;
                                    float defunc_9_fit_fun_res_198886 =
                                          defunc_0_f_res_198878 * x_198885;
                                    float x_198887 = b12_198861 * x_198874;
                                    float y_198888 = b2_198863 * x_198875;
                                    float x_198889 = x_198887 + y_198888;
                                    float y_198890 = c2_198864 * x_198876;
                                    float x_198891 = x_198889 + y_198890;
                                    float defunc_9_slope_fun_res_198892 =
                                          defunc_0_f_res_198878 * x_198891;
                                    float defunc_1_op_res_198869 =
                                          defunc_9_fit_fun_res_198886 +
                                          redout_200461;
                                    float defunc_1_op_res_198872 =
                                          defunc_9_slope_fun_res_198892 +
                                          redout_200462;
                                    float redout_tmp_206546 =
                                          defunc_1_op_res_198869;
                                    float redout_tmp_206547 =
                                          defunc_1_op_res_198872;
                                    
                                    redout_200461 = redout_tmp_206546;
                                    redout_200462 = redout_tmp_206547;
                                }
                                defunc_2_reduce_res_198865 = redout_200461;
                                defunc_2_reduce_res_198866 = redout_200462;
                                ((float *) mem_204274.mem)[i_200475 *
                                                           l_n_m_196752 +
                                                           i_200468] =
                                    defunc_2_reduce_res_198865;
                                ((float *) mem_204278.mem)[i_200475 *
                                                           l_n_m_196752 +
                                                           i_200468] =
                                    defunc_2_reduce_res_198866;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_204427, &mem_204274,
                                         "mem_204274") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_204419, &mem_204278,
                                         "mem_204278") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_204278, "mem_204278") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_204274, "mem_204274") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_204443, &ext_mem_204427,
                                     "ext_mem_204427") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_204435, &ext_mem_204419,
                                     "ext_mem_204419") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204419,
                                       "ext_mem_204419") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204427,
                                       "ext_mem_204427") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_204459, &ext_mem_204443,
                                 "ext_mem_204443") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_204451, &ext_mem_204435,
                                 "ext_mem_204435") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_204435, "ext_mem_204435") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_204443, "ext_mem_204443") != 0)
                    return 1;
            }
            
            struct memblock ext_mem_204511;
            
            ext_mem_204511.references = NULL;
            if (cond_197220) {
                bool zzero_198896 = jump_l_196703 == (int64_t) 0;
                bool nonzzero_198897 = !zzero_198896;
                bool nonzzero_cert_198898;
                
                if (!nonzzero_198897) {
                    ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                           "division by zero",
                                           "-> #0  loess.fut:546:20-27\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:545:3-549:9\n   #5  stl.fut:252:23-75\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:250:15-253:43\n   #9  stl.fut:401:3-415:29\n   #10 stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &ext_mem_204511,
                                       "ext_mem_204511") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204451,
                                       "ext_mem_204451") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204459,
                                       "ext_mem_204459") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203626,
                                       "ext_mem_203626") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203512,
                                       "ext_mem_203512") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203523,
                                       "ext_mem_203523") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202158,
                                       "mem_param_202158") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202150,
                                       "mem_param_202150") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205518,
                                       "ext_mem_205518") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205519,
                                       "ext_mem_205519") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202136,
                                       "mem_param_202136") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202128,
                                       "mem_param_202128") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202120,
                                       "mem_param_202120") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205847,
                                       "ext_mem_205847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205848,
                                       "ext_mem_205848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205849,
                                       "ext_mem_205849") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t y_198899 = sub64(l_n_m_196752, (int64_t) 1);
                struct memblock mem_204470;
                
                mem_204470.references = NULL;
                if (memblock_alloc(ctx, &mem_204470, bytes_202107,
                                   "mem_204470")) {
                    err = 1;
                    goto cleanup;
                }
                for (int64_t i_200484 = 0; i_200484 < m_196691; i_200484++) {
                    for (int64_t i_200480 = 0; i_200480 < n_196692;
                         i_200480++) {
                        int64_t m_v_198905 = sdiv64(i_200480, jump_l_196703);
                        bool cond_198906 = m_v_198905 == y_198899;
                        int64_t j_198907;
                        
                        if (cond_198906) {
                            int64_t j_t_res_198908 = sub64(m_v_198905,
                                                           (int64_t) 1);
                            
                            j_198907 = j_t_res_198908;
                        } else {
                            j_198907 = m_v_198905;
                        }
                        
                        int64_t min_arg_198909 = mul64(jump_l_196703, j_198907);
                        int64_t min_res_198910 = smin64(i_196779,
                                                        min_arg_198909);
                        int64_t defunc_0_m_fun_arg_198911 = add64((int64_t) 1,
                                                                  j_198907);
                        int64_t min_arg_198912 = mul64(jump_l_196703,
                                                       defunc_0_m_fun_arg_198911);
                        int64_t min_res_198913 = smin64(i_196779,
                                                        min_arg_198912);
                        int64_t i64_arg_198914 = sub64(min_res_198913,
                                                       min_res_198910);
                        float i64_res_198915 = sitofp_i64_f32(i64_arg_198914);
                        int64_t i64_arg_198916 = sub64(i_200480,
                                                       min_res_198910);
                        float i64_res_198917 = sitofp_i64_f32(i64_arg_198916);
                        float u_198918 = i64_res_198917 / i64_res_198915;
                        float u2_198919 = u_198918 * u_198918;
                        float u3_198920 = u_198918 * u2_198919;
                        float x_198921 = 2.0F * u3_198920;
                        float y_198922 = 3.0F * u2_198919;
                        float x_198923 = x_198921 - y_198922;
                        float x_198924 = 1.0F + x_198923;
                        bool x_198925 = sle64((int64_t) 0, j_198907);
                        bool y_198926 = slt64(j_198907, l_n_m_196752);
                        bool bounds_check_198927 = x_198925 && y_198926;
                        bool index_certs_198928;
                        
                        if (!bounds_check_198927) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) j_198907,
                                          "] out of bounds for array of shape [",
                                          (long long) l_n_m_196752, "].",
                                          "-> #0  loess.fut:535:27-33\n   #1  loess.fut:548:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:545:3-549:9\n   #6  stl.fut:252:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:250:15-253:43\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                            if (memblock_unref(ctx, &mem_204470,
                                               "mem_204470") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_204511,
                                               "ext_mem_204511") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_204451,
                                               "ext_mem_204451") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_204459,
                                               "ext_mem_204459") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203626,
                                               "ext_mem_203626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203512,
                                               "ext_mem_203512") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203523,
                                               "ext_mem_203523") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202158,
                                               "mem_param_202158") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202150,
                                               "mem_param_202150") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205518,
                                               "ext_mem_205518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205519,
                                               "ext_mem_205519") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202136,
                                               "mem_param_202136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202128,
                                               "mem_param_202128") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202120,
                                               "mem_param_202120") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205847,
                                               "ext_mem_205847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205848,
                                               "ext_mem_205848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205849,
                                               "ext_mem_205849") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202112,
                                               "mem_202112") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202108,
                                               "mem_202108") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206309,
                                               "mem_out_206309") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206308,
                                               "mem_out_206308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206307,
                                               "mem_out_206307") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        float y_198929;
                        
                        y_198929 = ((float *) ext_mem_204459.mem)[i_200484 *
                                                                  l_n_m_196752 +
                                                                  j_198907];
                        
                        float x_198930 = x_198924 * y_198929;
                        float x_198931 = y_198922 - x_198921;
                        bool x_198932 = sle64((int64_t) 0,
                                              defunc_0_m_fun_arg_198911);
                        bool y_198933 = slt64(defunc_0_m_fun_arg_198911,
                                              l_n_m_196752);
                        bool bounds_check_198934 = x_198932 && y_198933;
                        bool index_certs_198935;
                        
                        if (!bounds_check_198934) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [",
                                          (long long) defunc_0_m_fun_arg_198911,
                                          "] out of bounds for array of shape [",
                                          (long long) l_n_m_196752, "].",
                                          "-> #0  loess.fut:536:27-37\n   #1  loess.fut:548:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:545:3-549:9\n   #6  stl.fut:252:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:250:15-253:43\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                            if (memblock_unref(ctx, &mem_204470,
                                               "mem_204470") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_204511,
                                               "ext_mem_204511") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_204451,
                                               "ext_mem_204451") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_204459,
                                               "ext_mem_204459") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203626,
                                               "ext_mem_203626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203512,
                                               "ext_mem_203512") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203523,
                                               "ext_mem_203523") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202158,
                                               "mem_param_202158") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202150,
                                               "mem_param_202150") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205518,
                                               "ext_mem_205518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205519,
                                               "ext_mem_205519") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202136,
                                               "mem_param_202136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202128,
                                               "mem_param_202128") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202120,
                                               "mem_param_202120") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205847,
                                               "ext_mem_205847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205848,
                                               "ext_mem_205848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205849,
                                               "ext_mem_205849") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202112,
                                               "mem_202112") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202108,
                                               "mem_202108") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206309,
                                               "mem_out_206309") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206308,
                                               "mem_out_206308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206307,
                                               "mem_out_206307") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        float y_198936;
                        
                        y_198936 = ((float *) ext_mem_204459.mem)[i_200484 *
                                                                  l_n_m_196752 +
                                                                  defunc_0_m_fun_arg_198911];
                        
                        float y_198937 = x_198931 * y_198936;
                        float x_198938 = x_198930 + y_198937;
                        float y_198939 = 2.0F * u2_198919;
                        float x_198940 = u3_198920 - y_198939;
                        float x_198941 = u_198918 + x_198940;
                        float y_198942;
                        
                        y_198942 = ((float *) ext_mem_204451.mem)[i_200484 *
                                                                  l_n_m_196752 +
                                                                  j_198907];
                        
                        float x_198943 = x_198941 * y_198942;
                        float y_198944 = i64_res_198915 * x_198943;
                        float x_198945 = x_198938 + y_198944;
                        float x_198946 = u3_198920 - u2_198919;
                        float y_198947;
                        
                        y_198947 = ((float *) ext_mem_204451.mem)[i_200484 *
                                                                  l_n_m_196752 +
                                                                  defunc_0_m_fun_arg_198911];
                        
                        float x_198948 = x_198946 * y_198947;
                        float y_198949 = i64_res_198915 * x_198948;
                        float defunc_4_interpolate_proc_res_198950 = x_198945 +
                              y_198949;
                        
                        ((float *) mem_204470.mem)[i_200484 * n_196692 +
                                                   i_200480] =
                            defunc_4_interpolate_proc_res_198950;
                    }
                }
                if (memblock_set(ctx, &ext_mem_204511, &mem_204470,
                                 "mem_204470") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_204470, "mem_204470") != 0)
                    return 1;
            } else {
                bool dim_match_198951 = n_196692 == l_n_m_196752;
                bool empty_or_match_cert_198952;
                
                if (!dim_match_198951) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Value of (core language) shape (",
                                  (long long) m_196691, ", ",
                                  (long long) l_n_m_196752,
                                  ") cannot match shape of type `[",
                                  (long long) m_196691, "][",
                                  (long long) n_196692, "]t`.",
                                  "-> #0  stl.fut:255:15-36\n   #1  stl.fut:401:3-415:29\n   #2  stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &ext_mem_204511,
                                       "ext_mem_204511") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204451,
                                       "ext_mem_204451") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204459,
                                       "ext_mem_204459") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203626,
                                       "ext_mem_203626") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203512,
                                       "ext_mem_203512") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203523,
                                       "ext_mem_203523") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202158,
                                       "mem_param_202158") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202150,
                                       "mem_param_202150") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205518,
                                       "ext_mem_205518") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205519,
                                       "ext_mem_205519") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202136,
                                       "mem_param_202136") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202128,
                                       "mem_param_202128") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202120,
                                       "mem_param_202120") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205847,
                                       "ext_mem_205847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205848,
                                       "ext_mem_205848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205849,
                                       "ext_mem_205849") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                if (memblock_set(ctx, &ext_mem_204511, &ext_mem_204459,
                                 "ext_mem_204459") != 0)
                    return 1;
            }
            if (memblock_unref(ctx, &ext_mem_204451, "ext_mem_204451") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_204459, "ext_mem_204459") != 0)
                return 1;
            
            struct memblock mem_204522;
            
            mem_204522.references = NULL;
            if (memblock_alloc(ctx, &mem_204522, bytes_202107, "mem_204522")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_200492 = 0; i_200492 < m_196691; i_200492++) {
                for (int64_t i_200488 = 0; i_200488 < n_196692; i_200488++) {
                    int64_t slice_200822 = n_p_196694 + i_200488;
                    float x_198959;
                    
                    x_198959 = ((float *) mem_203637)[i_200492 * C_len_196743 +
                                                      slice_200822];
                    
                    float x_198960;
                    
                    x_198960 = ((float *) ext_mem_204511.mem)[i_200492 *
                                                              ext_204514 +
                                                              i_200488];
                    
                    float defunc_1_f_res_198961 = x_198959 - x_198960;
                    
                    ((float *) mem_204522.mem)[i_200492 * n_196692 + i_200488] =
                        defunc_1_f_res_198961;
                }
            }
            if (memblock_unref(ctx, &ext_mem_204511, "ext_mem_204511") != 0)
                return 1;
            
            struct memblock ext_mem_205458;
            
            ext_mem_205458.references = NULL;
            
            struct memblock ext_mem_205450;
            
            ext_mem_205450.references = NULL;
            if (cond_197278) {
                bool match_lit_198964 = (int64_t) 0 == d_t_196699;
                int64_t binop_y_204581 = (int64_t) 4 * n_196692;
                int64_t bytes_204582 = smax64((int64_t) 0, binop_y_204581);
                struct memblock ext_mem_204946;
                
                ext_mem_204946.references = NULL;
                
                struct memblock ext_mem_204938;
                
                ext_mem_204938.references = NULL;
                if (match_lit_198964) {
                    struct memblock mem_204566;
                    
                    mem_204566.references = NULL;
                    if (memblock_alloc(ctx, &mem_204566, bytes_202008,
                                       "mem_204566")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_206552 = 0; i_206552 < m_196691;
                         i_206552++) {
                        for (int64_t i_206553 = 0; i_206553 < t_n_m_196759;
                             i_206553++) {
                            ((float *) mem_204566.mem)[i_206552 * t_n_m_196759 +
                                                       i_206553] = 0.0F;
                        }
                    }
                    
                    struct memblock mem_204570;
                    
                    mem_204570.references = NULL;
                    if (memblock_alloc(ctx, &mem_204570, bytes_202008,
                                       "mem_204570")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (mem_204583_cached_sizze_206703 <
                        (size_t) bytes_204582) {
                        mem_204583 = realloc(mem_204583, bytes_204582);
                        mem_204583_cached_sizze_206703 = bytes_204582;
                    }
                    if (mem_204598_cached_sizze_206704 <
                        (size_t) bytes_204582) {
                        mem_204598 = realloc(mem_204598, bytes_204582);
                        mem_204598_cached_sizze_206704 = bytes_204582;
                    }
                    if (mem_204601_cached_sizze_206705 <
                        (size_t) bytes_204582) {
                        mem_204601 = realloc(mem_204601, bytes_204582);
                        mem_204601_cached_sizze_206705 = bytes_204582;
                    }
                    for (int64_t i_200515 = 0; i_200515 < m_196691;
                         i_200515++) {
                        int64_t x_198974;
                        
                        x_198974 = ((int64_t *) mem_201389)[i_200515];
                        for (int64_t i_200496 = 0; i_200496 < n_196692;
                             i_200496++) {
                            float x_198978;
                            
                            x_198978 = ((float *) Y_mem_201382.mem)[i_200515 *
                                                                    n_196692 +
                                                                    i_200496];
                            
                            float x_198979;
                            
                            x_198979 = ((float *) mem_204522.mem)[i_200515 *
                                                                  n_196692 +
                                                                  i_200496];
                            
                            float defunc_1_f_res_198980 = x_198978 - x_198979;
                            
                            ((float *) mem_204583)[i_200496] =
                                defunc_1_f_res_198980;
                        }
                        for (int64_t i_200502 = 0; i_200502 < n_196692;
                             i_200502++) {
                            int64_t x_198983;
                            
                            x_198983 = ((int64_t *) mem_201386)[i_200515 *
                                                                n_196692 +
                                                                i_200502];
                            
                            bool cond_198984 = sle64((int64_t) 0, x_198983);
                            float defunc_0_f_res_198985;
                            
                            if (cond_198984) {
                                bool y_198986 = slt64(x_198983, n_196692);
                                bool bounds_check_198987 = cond_198984 &&
                                     y_198986;
                                bool index_certs_198988;
                                
                                if (!bounds_check_198987) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) x_198983,
                                                  "] out of bounds for array of shape [",
                                                  (long long) n_196692, "].",
                                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:401:3-415:29\n   #8  stl.fut:385:1-415:29\n");
                                    if (memblock_unref(ctx, &mem_204570,
                                                       "mem_204570") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_204566,
                                                       "mem_204566") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204938,
                                                       "ext_mem_204938") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204946,
                                                       "ext_mem_204946") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205450,
                                                       "ext_mem_205450") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205458,
                                                       "ext_mem_205458") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_204522,
                                                       "mem_204522") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204511,
                                                       "ext_mem_204511") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204451,
                                                       "ext_mem_204451") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204459,
                                                       "ext_mem_204459") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203626,
                                                       "ext_mem_203626") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203512,
                                                       "ext_mem_203512") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203523,
                                                       "ext_mem_203523") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202158,
                                                       "mem_param_202158") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202150,
                                                       "mem_param_202150") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205518,
                                                       "ext_mem_205518") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205519,
                                                       "ext_mem_205519") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202136,
                                                       "mem_param_202136") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202128,
                                                       "mem_param_202128") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202120,
                                                       "mem_param_202120") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205847,
                                                       "ext_mem_205847") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205848,
                                                       "ext_mem_205848") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205849,
                                                       "ext_mem_205849") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_202112,
                                                       "mem_202112") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_202108,
                                                       "mem_202108") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206309,
                                                       "mem_out_206309") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206308,
                                                       "mem_out_206308") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206307,
                                                       "mem_out_206307") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                float defunc_0_f_res_t_res_198989;
                                
                                defunc_0_f_res_t_res_198989 =
                                    ((float *) mem_204583)[x_198983];
                                defunc_0_f_res_198985 =
                                    defunc_0_f_res_t_res_198989;
                            } else {
                                defunc_0_f_res_198985 = 0.0F;
                            }
                            
                            float defunc_0_f_res_198990;
                            
                            if (cond_198984) {
                                bool y_198991 = slt64(x_198983, n_196692);
                                bool bounds_check_198992 = cond_198984 &&
                                     y_198991;
                                bool index_certs_198993;
                                
                                if (!bounds_check_198992) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) x_198983,
                                                  "] out of bounds for array of shape [",
                                                  (long long) n_196692, "].",
                                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:401:3-415:29\n   #8  stl.fut:385:1-415:29\n");
                                    if (memblock_unref(ctx, &mem_204570,
                                                       "mem_204570") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_204566,
                                                       "mem_204566") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204938,
                                                       "ext_mem_204938") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204946,
                                                       "ext_mem_204946") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205450,
                                                       "ext_mem_205450") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205458,
                                                       "ext_mem_205458") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_204522,
                                                       "mem_204522") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204511,
                                                       "ext_mem_204511") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204451,
                                                       "ext_mem_204451") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204459,
                                                       "ext_mem_204459") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203626,
                                                       "ext_mem_203626") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203512,
                                                       "ext_mem_203512") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203523,
                                                       "ext_mem_203523") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202158,
                                                       "mem_param_202158") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202150,
                                                       "mem_param_202150") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205518,
                                                       "ext_mem_205518") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205519,
                                                       "ext_mem_205519") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202136,
                                                       "mem_param_202136") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202128,
                                                       "mem_param_202128") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202120,
                                                       "mem_param_202120") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205847,
                                                       "ext_mem_205847") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205848,
                                                       "ext_mem_205848") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205849,
                                                       "ext_mem_205849") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_202112,
                                                       "mem_202112") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_202108,
                                                       "mem_202108") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206309,
                                                       "mem_out_206309") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206308,
                                                       "mem_out_206308") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206307,
                                                       "mem_out_206307") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                float defunc_0_f_res_t_res_198994;
                                
                                defunc_0_f_res_t_res_198994 =
                                    ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                     (i_200515 *
                                                                      ctx_param_ext_202132 +
                                                                      x_198983 *
                                                                      ctx_param_ext_202134)];
                                defunc_0_f_res_198990 =
                                    defunc_0_f_res_t_res_198994;
                            } else {
                                defunc_0_f_res_198990 = 0.0F;
                            }
                            ((float *) mem_204598)[i_200502] =
                                defunc_0_f_res_198990;
                            ((float *) mem_204601)[i_200502] =
                                defunc_0_f_res_198985;
                        }
                        for (int64_t i_200511 = 0; i_200511 < t_n_m_196759;
                             i_200511++) {
                            int64_t x_198997;
                            
                            x_198997 = ((int64_t *) mem_202005)[i_200515 *
                                                                t_n_m_196759 +
                                                                i_200511];
                            
                            float x_198998;
                            
                            x_198998 = ((float *) mem_202009)[i_200515 *
                                                              t_n_m_196759 +
                                                              i_200511];
                            
                            int64_t min_arg_198999 = mul64(jump_t_196702,
                                                           i_200511);
                            int64_t min_res_199000 = smin64(i_196779,
                                                            min_arg_198999);
                            int64_t defunc_0_g_res_199001 = add64((int64_t) 1,
                                                                  min_res_199000);
                            float defunc_2_reduce_res_199002;
                            float redout_200505 = 0.0F;
                            
                            for (int64_t i_200506 = 0; i_200506 < q_t_196696;
                                 i_200506++) {
                                bool cond_199007 = sle64(x_198974, i_200506);
                                int64_t defunc_0_f_res_199008;
                                
                                if (cond_199007) {
                                    defunc_0_f_res_199008 = (int64_t) 0;
                                } else {
                                    int64_t i_199009 = add64(x_198997,
                                                             i_200506);
                                    int64_t defunc_0_add_arg_199010;
                                    
                                    defunc_0_add_arg_199010 =
                                        ((int64_t *) mem_201386)[i_200515 *
                                                                 n_196692 +
                                                                 i_199009];
                                    
                                    int64_t defunc_1_add_res_199011 =
                                            add64((int64_t) 1,
                                                  defunc_0_add_arg_199010);
                                    
                                    defunc_0_f_res_199008 =
                                        defunc_1_add_res_199011;
                                }
                                
                                float defunc_0_f_res_199012;
                                
                                if (cond_199007) {
                                    defunc_0_f_res_199012 = 0.0F;
                                } else {
                                    int64_t i_199013 = add64(x_198997,
                                                             i_200506);
                                    float defunc_0_add_arg_199014;
                                    
                                    defunc_0_add_arg_199014 =
                                        ((float *) mem_204598)[i_199013];
                                    defunc_0_f_res_199012 =
                                        defunc_0_add_arg_199014;
                                }
                                
                                int64_t binop_p_199015 =
                                        sub64(defunc_0_f_res_199008,
                                              defunc_0_g_res_199001);
                                float defunc_0_f_res_199016 =
                                      sitofp_i64_f32(binop_p_199015);
                                float abs_res_199017 =
                                      (float) fabs(defunc_0_f_res_199016);
                                float tmp1_199018 = abs_res_199017 / x_198998;
                                float x_199019 = tmp1_199018 * tmp1_199018;
                                float y_199020 = tmp1_199018 * x_199019;
                                float tmp2_199021 = 1.0F - y_199020;
                                float x_199022 = tmp2_199021 * tmp2_199021;
                                float tmp3_199023 = tmp2_199021 * x_199022;
                                float w_j_199024 = defunc_0_f_res_199012 *
                                      tmp3_199023;
                                float defunc_1_op_res_199005 = w_j_199024 +
                                      redout_200505;
                                float redout_tmp_206559 =
                                      defunc_1_op_res_199005;
                                
                                redout_200505 = redout_tmp_206559;
                            }
                            defunc_2_reduce_res_199002 = redout_200505;
                            
                            float a0_199025 = 1.0F / defunc_2_reduce_res_199002;
                            float defunc_2_reduce_res_199026;
                            float redout_200507 = 0.0F;
                            
                            for (int64_t i_200508 = 0; i_200508 < q_t_196696;
                                 i_200508++) {
                                bool cond_199031 = sle64(x_198974, i_200508);
                                int64_t defunc_0_f_res_199032;
                                
                                if (cond_199031) {
                                    defunc_0_f_res_199032 = (int64_t) 0;
                                } else {
                                    int64_t i_199033 = add64(x_198997,
                                                             i_200508);
                                    int64_t defunc_0_add_arg_199034;
                                    
                                    defunc_0_add_arg_199034 =
                                        ((int64_t *) mem_201386)[i_200515 *
                                                                 n_196692 +
                                                                 i_199033];
                                    
                                    int64_t defunc_1_add_res_199035 =
                                            add64((int64_t) 1,
                                                  defunc_0_add_arg_199034);
                                    
                                    defunc_0_f_res_199032 =
                                        defunc_1_add_res_199035;
                                }
                                
                                float defunc_0_f_res_199036;
                                
                                if (cond_199031) {
                                    defunc_0_f_res_199036 = 0.0F;
                                } else {
                                    int64_t i_199037 = add64(x_198997,
                                                             i_200508);
                                    float defunc_0_add_arg_199038;
                                    
                                    defunc_0_add_arg_199038 =
                                        ((float *) mem_204598)[i_199037];
                                    defunc_0_f_res_199036 =
                                        defunc_0_add_arg_199038;
                                }
                                
                                int64_t binop_p_199039 =
                                        sub64(defunc_0_f_res_199032,
                                              defunc_0_g_res_199001);
                                float defunc_0_f_res_199040 =
                                      sitofp_i64_f32(binop_p_199039);
                                float abs_res_199041 =
                                      (float) fabs(defunc_0_f_res_199040);
                                float tmp1_199042 = abs_res_199041 / x_198998;
                                float x_199043 = tmp1_199042 * tmp1_199042;
                                float y_199044 = tmp1_199042 * x_199043;
                                float tmp2_199045 = 1.0F - y_199044;
                                float x_199046 = tmp2_199045 * tmp2_199045;
                                float tmp3_199047 = tmp2_199045 * x_199046;
                                float tmp4_199048 = defunc_0_f_res_199036 *
                                      tmp3_199047;
                                float defunc_0_f_res_199049;
                                
                                if (cond_199031) {
                                    defunc_0_f_res_199049 = 0.0F;
                                } else {
                                    int64_t i_199050 = add64(x_198997,
                                                             i_200508);
                                    float defunc_0_add_arg_199051;
                                    
                                    defunc_0_add_arg_199051 =
                                        ((float *) mem_204601)[i_199050];
                                    defunc_0_f_res_199049 =
                                        defunc_0_add_arg_199051;
                                }
                                
                                float x_199052 = a0_199025 * tmp4_199048;
                                float defunc_9_fit_fun_res_199053 =
                                      defunc_0_f_res_199049 * x_199052;
                                float defunc_1_op_res_199029 =
                                      defunc_9_fit_fun_res_199053 +
                                      redout_200507;
                                float redout_tmp_206560 =
                                      defunc_1_op_res_199029;
                                
                                redout_200507 = redout_tmp_206560;
                            }
                            defunc_2_reduce_res_199026 = redout_200507;
                            ((float *) mem_204570.mem)[i_200515 * t_n_m_196759 +
                                                       i_200511] =
                                defunc_2_reduce_res_199026;
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_204946, &mem_204570,
                                     "mem_204570") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_204938, &mem_204566,
                                     "mem_204566") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_204570, "mem_204570") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_204566, "mem_204566") != 0)
                        return 1;
                } else {
                    bool match_lit_199056 = (int64_t) 1 == d_t_196699;
                    int64_t binop_y_204684 = (int64_t) 4 * n_196692;
                    int64_t bytes_204685 = smax64((int64_t) 0, binop_y_204684);
                    int64_t binop_y_204817 = (int64_t) 4 * n_196692;
                    int64_t bytes_204818 = smax64((int64_t) 0, binop_y_204817);
                    struct memblock ext_mem_204930;
                    
                    ext_mem_204930.references = NULL;
                    
                    struct memblock ext_mem_204922;
                    
                    ext_mem_204922.references = NULL;
                    if (match_lit_199056) {
                        struct memblock mem_204659;
                        
                        mem_204659.references = NULL;
                        if (memblock_alloc(ctx, &mem_204659, bytes_202008,
                                           "mem_204659")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_204663;
                        
                        mem_204663.references = NULL;
                        if (memblock_alloc(ctx, &mem_204663, bytes_202008,
                                           "mem_204663")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_204686_cached_sizze_206706 <
                            (size_t) bytes_204685) {
                            mem_204686 = realloc(mem_204686, bytes_204685);
                            mem_204686_cached_sizze_206706 = bytes_204685;
                        }
                        if (mem_204701_cached_sizze_206707 <
                            (size_t) bytes_204685) {
                            mem_204701 = realloc(mem_204701, bytes_204685);
                            mem_204701_cached_sizze_206707 = bytes_204685;
                        }
                        if (mem_204704_cached_sizze_206708 <
                            (size_t) bytes_204685) {
                            mem_204704 = realloc(mem_204704, bytes_204685);
                            mem_204704_cached_sizze_206708 = bytes_204685;
                        }
                        for (int64_t i_200546 = 0; i_200546 < m_196691;
                             i_200546++) {
                            int64_t x_199066;
                            
                            x_199066 = ((int64_t *) mem_201389)[i_200546];
                            for (int64_t i_200519 = 0; i_200519 < n_196692;
                                 i_200519++) {
                                float x_199070;
                                
                                x_199070 =
                                    ((float *) Y_mem_201382.mem)[i_200546 *
                                                                 n_196692 +
                                                                 i_200519];
                                
                                float x_199071;
                                
                                x_199071 = ((float *) mem_204522.mem)[i_200546 *
                                                                      n_196692 +
                                                                      i_200519];
                                
                                float defunc_1_f_res_199072 = x_199070 -
                                      x_199071;
                                
                                ((float *) mem_204686)[i_200519] =
                                    defunc_1_f_res_199072;
                            }
                            for (int64_t i_200525 = 0; i_200525 < n_196692;
                                 i_200525++) {
                                int64_t x_199075;
                                
                                x_199075 = ((int64_t *) mem_201386)[i_200546 *
                                                                    n_196692 +
                                                                    i_200525];
                                
                                bool cond_199076 = sle64((int64_t) 0, x_199075);
                                float defunc_0_f_res_199077;
                                
                                if (cond_199076) {
                                    bool y_199078 = slt64(x_199075, n_196692);
                                    bool bounds_check_199079 = cond_199076 &&
                                         y_199078;
                                    bool index_certs_199080;
                                    
                                    if (!bounds_check_199079) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_199075,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_196692,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:401:3-415:29\n   #8  stl.fut:385:1-415:29\n");
                                        if (memblock_unref(ctx, &mem_204663,
                                                           "mem_204663") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_204659,
                                                           "mem_204659") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204922,
                                                           "ext_mem_204922") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204930,
                                                           "ext_mem_204930") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204938,
                                                           "ext_mem_204938") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204946,
                                                           "ext_mem_204946") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205450,
                                                           "ext_mem_205450") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205458,
                                                           "ext_mem_205458") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_204522,
                                                           "mem_204522") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204511,
                                                           "ext_mem_204511") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204451,
                                                           "ext_mem_204451") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204459,
                                                           "ext_mem_204459") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203626,
                                                           "ext_mem_203626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203512,
                                                           "ext_mem_203512") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203523,
                                                           "ext_mem_203523") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202158,
                                                           "mem_param_202158") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202150,
                                                           "mem_param_202150") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205518,
                                                           "ext_mem_205518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205519,
                                                           "ext_mem_205519") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202136,
                                                           "mem_param_202136") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202128,
                                                           "mem_param_202128") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202120,
                                                           "mem_param_202120") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205847,
                                                           "ext_mem_205847") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205848,
                                                           "ext_mem_205848") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205849,
                                                           "ext_mem_205849") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202112,
                                                           "mem_202112") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202108,
                                                           "mem_202108") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206309,
                                                           "mem_out_206309") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206308,
                                                           "mem_out_206308") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206307,
                                                           "mem_out_206307") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    float defunc_0_f_res_t_res_199081;
                                    
                                    defunc_0_f_res_t_res_199081 =
                                        ((float *) mem_204686)[x_199075];
                                    defunc_0_f_res_199077 =
                                        defunc_0_f_res_t_res_199081;
                                } else {
                                    defunc_0_f_res_199077 = 0.0F;
                                }
                                
                                float defunc_0_f_res_199082;
                                
                                if (cond_199076) {
                                    bool y_199083 = slt64(x_199075, n_196692);
                                    bool bounds_check_199084 = cond_199076 &&
                                         y_199083;
                                    bool index_certs_199085;
                                    
                                    if (!bounds_check_199084) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_199075,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_196692,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:401:3-415:29\n   #8  stl.fut:385:1-415:29\n");
                                        if (memblock_unref(ctx, &mem_204663,
                                                           "mem_204663") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_204659,
                                                           "mem_204659") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204922,
                                                           "ext_mem_204922") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204930,
                                                           "ext_mem_204930") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204938,
                                                           "ext_mem_204938") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204946,
                                                           "ext_mem_204946") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205450,
                                                           "ext_mem_205450") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205458,
                                                           "ext_mem_205458") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_204522,
                                                           "mem_204522") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204511,
                                                           "ext_mem_204511") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204451,
                                                           "ext_mem_204451") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204459,
                                                           "ext_mem_204459") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203626,
                                                           "ext_mem_203626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203512,
                                                           "ext_mem_203512") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203523,
                                                           "ext_mem_203523") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202158,
                                                           "mem_param_202158") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202150,
                                                           "mem_param_202150") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205518,
                                                           "ext_mem_205518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205519,
                                                           "ext_mem_205519") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202136,
                                                           "mem_param_202136") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202128,
                                                           "mem_param_202128") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202120,
                                                           "mem_param_202120") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205847,
                                                           "ext_mem_205847") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205848,
                                                           "ext_mem_205848") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205849,
                                                           "ext_mem_205849") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202112,
                                                           "mem_202112") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202108,
                                                           "mem_202108") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206309,
                                                           "mem_out_206309") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206308,
                                                           "mem_out_206308") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206307,
                                                           "mem_out_206307") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    float defunc_0_f_res_t_res_199086;
                                    
                                    defunc_0_f_res_t_res_199086 =
                                        ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                         (i_200546 *
                                                                          ctx_param_ext_202132 +
                                                                          x_199075 *
                                                                          ctx_param_ext_202134)];
                                    defunc_0_f_res_199082 =
                                        defunc_0_f_res_t_res_199086;
                                } else {
                                    defunc_0_f_res_199082 = 0.0F;
                                }
                                ((float *) mem_204701)[i_200525] =
                                    defunc_0_f_res_199082;
                                ((float *) mem_204704)[i_200525] =
                                    defunc_0_f_res_199077;
                            }
                            for (int64_t i_200539 = 0; i_200539 < t_n_m_196759;
                                 i_200539++) {
                                int64_t x_199090;
                                
                                x_199090 = ((int64_t *) mem_202005)[i_200546 *
                                                                    t_n_m_196759 +
                                                                    i_200539];
                                
                                float x_199091;
                                
                                x_199091 = ((float *) mem_202009)[i_200546 *
                                                                  t_n_m_196759 +
                                                                  i_200539];
                                
                                int64_t min_arg_199092 = mul64(jump_t_196702,
                                                               i_200539);
                                int64_t min_res_199093 = smin64(i_196779,
                                                                min_arg_199092);
                                int64_t defunc_0_g_res_199094 =
                                        add64((int64_t) 1, min_res_199093);
                                float defunc_2_reduce_res_199095;
                                float defunc_2_reduce_res_199096;
                                float defunc_2_reduce_res_199097;
                                float redout_200528;
                                float redout_200529;
                                float redout_200530;
                                
                                redout_200528 = 0.0F;
                                redout_200529 = 0.0F;
                                redout_200530 = 0.0F;
                                for (int64_t i_200531 = 0; i_200531 <
                                     q_t_196696; i_200531++) {
                                    bool cond_199108 = sle64(x_199066,
                                                             i_200531);
                                    int64_t defunc_0_f_res_199109;
                                    
                                    if (cond_199108) {
                                        defunc_0_f_res_199109 = (int64_t) 0;
                                    } else {
                                        int64_t i_199110 = add64(x_199090,
                                                                 i_200531);
                                        int64_t defunc_0_add_arg_199111;
                                        
                                        defunc_0_add_arg_199111 =
                                            ((int64_t *) mem_201386)[i_200546 *
                                                                     n_196692 +
                                                                     i_199110];
                                        
                                        int64_t defunc_1_add_res_199112 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_199111);
                                        
                                        defunc_0_f_res_199109 =
                                            defunc_1_add_res_199112;
                                    }
                                    
                                    float defunc_0_f_res_199113;
                                    
                                    if (cond_199108) {
                                        defunc_0_f_res_199113 = 0.0F;
                                    } else {
                                        int64_t i_199114 = add64(x_199090,
                                                                 i_200531);
                                        float defunc_0_add_arg_199115;
                                        
                                        defunc_0_add_arg_199115 =
                                            ((float *) mem_204701)[i_199114];
                                        defunc_0_f_res_199113 =
                                            defunc_0_add_arg_199115;
                                    }
                                    
                                    int64_t binop_p_199116 =
                                            sub64(defunc_0_f_res_199109,
                                                  defunc_0_g_res_199094);
                                    float defunc_0_f_res_199117 =
                                          sitofp_i64_f32(binop_p_199116);
                                    float abs_res_199118 =
                                          (float) fabs(defunc_0_f_res_199117);
                                    float tmp1_199119 = abs_res_199118 /
                                          x_199091;
                                    float x_199120 = tmp1_199119 * tmp1_199119;
                                    float y_199121 = tmp1_199119 * x_199120;
                                    float tmp2_199122 = 1.0F - y_199121;
                                    float x_199123 = tmp2_199122 * tmp2_199122;
                                    float tmp3_199124 = tmp2_199122 * x_199123;
                                    float w_j_199125 = defunc_0_f_res_199113 *
                                          tmp3_199124;
                                    float xw_j_199126 = defunc_0_f_res_199117 *
                                          w_j_199125;
                                    float x2w_j_199127 = defunc_0_f_res_199117 *
                                          xw_j_199126;
                                    float defunc_1_op_res_199100 = w_j_199125 +
                                          redout_200528;
                                    float defunc_1_op_res_199103 = xw_j_199126 +
                                          redout_200529;
                                    float defunc_1_op_res_199106 =
                                          x2w_j_199127 + redout_200530;
                                    float redout_tmp_206568 =
                                          defunc_1_op_res_199100;
                                    float redout_tmp_206569 =
                                          defunc_1_op_res_199103;
                                    float redout_tmp_206570 =
                                          defunc_1_op_res_199106;
                                    
                                    redout_200528 = redout_tmp_206568;
                                    redout_200529 = redout_tmp_206569;
                                    redout_200530 = redout_tmp_206570;
                                }
                                defunc_2_reduce_res_199095 = redout_200528;
                                defunc_2_reduce_res_199096 = redout_200529;
                                defunc_2_reduce_res_199097 = redout_200530;
                                
                                float x_199128 = defunc_2_reduce_res_199095 *
                                      defunc_2_reduce_res_199097;
                                float y_199129 = defunc_2_reduce_res_199096 *
                                      defunc_2_reduce_res_199096;
                                float y_199130 = x_199128 - y_199129;
                                float det1_199131 = 1.0F / y_199130;
                                float a11_199132 = defunc_2_reduce_res_199097 *
                                      det1_199131;
                                float x_199133 = 0.0F -
                                      defunc_2_reduce_res_199096;
                                float b11_199134 = det1_199131 * x_199133;
                                float c11_199135 = defunc_2_reduce_res_199095 *
                                      det1_199131;
                                float defunc_2_reduce_res_199136;
                                float defunc_2_reduce_res_199137;
                                float redout_200532;
                                float redout_200533;
                                
                                redout_200532 = 0.0F;
                                redout_200533 = 0.0F;
                                for (int64_t i_200534 = 0; i_200534 <
                                     q_t_196696; i_200534++) {
                                    bool cond_199145 = sle64(x_199066,
                                                             i_200534);
                                    int64_t defunc_0_f_res_199146;
                                    
                                    if (cond_199145) {
                                        defunc_0_f_res_199146 = (int64_t) 0;
                                    } else {
                                        int64_t i_199147 = add64(x_199090,
                                                                 i_200534);
                                        int64_t defunc_0_add_arg_199148;
                                        
                                        defunc_0_add_arg_199148 =
                                            ((int64_t *) mem_201386)[i_200546 *
                                                                     n_196692 +
                                                                     i_199147];
                                        
                                        int64_t defunc_1_add_res_199149 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_199148);
                                        
                                        defunc_0_f_res_199146 =
                                            defunc_1_add_res_199149;
                                    }
                                    
                                    float defunc_0_f_res_199150;
                                    
                                    if (cond_199145) {
                                        defunc_0_f_res_199150 = 0.0F;
                                    } else {
                                        int64_t i_199151 = add64(x_199090,
                                                                 i_200534);
                                        float defunc_0_add_arg_199152;
                                        
                                        defunc_0_add_arg_199152 =
                                            ((float *) mem_204701)[i_199151];
                                        defunc_0_f_res_199150 =
                                            defunc_0_add_arg_199152;
                                    }
                                    
                                    int64_t binop_p_199153 =
                                            sub64(defunc_0_f_res_199146,
                                                  defunc_0_g_res_199094);
                                    float defunc_0_f_res_199154 =
                                          sitofp_i64_f32(binop_p_199153);
                                    float abs_res_199155 =
                                          (float) fabs(defunc_0_f_res_199154);
                                    float tmp1_199156 = abs_res_199155 /
                                          x_199091;
                                    float x_199157 = tmp1_199156 * tmp1_199156;
                                    float y_199158 = tmp1_199156 * x_199157;
                                    float tmp2_199159 = 1.0F - y_199158;
                                    float x_199160 = tmp2_199159 * tmp2_199159;
                                    float tmp3_199161 = tmp2_199159 * x_199160;
                                    float tmp4_199162 = defunc_0_f_res_199150 *
                                          tmp3_199161;
                                    float defunc_1_f_res_199163 =
                                          defunc_0_f_res_199154 * tmp4_199162;
                                    float defunc_0_f_res_199164;
                                    
                                    if (cond_199145) {
                                        defunc_0_f_res_199164 = 0.0F;
                                    } else {
                                        int64_t i_199165 = add64(x_199090,
                                                                 i_200534);
                                        float defunc_0_add_arg_199166;
                                        
                                        defunc_0_add_arg_199166 =
                                            ((float *) mem_204704)[i_199165];
                                        defunc_0_f_res_199164 =
                                            defunc_0_add_arg_199166;
                                    }
                                    
                                    float x_199167 = a11_199132 * tmp4_199162;
                                    float y_199168 = b11_199134 *
                                          defunc_1_f_res_199163;
                                    float x_199169 = x_199167 + y_199168;
                                    float defunc_9_fit_fun_res_199170 =
                                          defunc_0_f_res_199164 * x_199169;
                                    float x_199171 = b11_199134 * tmp4_199162;
                                    float y_199172 = c11_199135 *
                                          defunc_1_f_res_199163;
                                    float x_199173 = x_199171 + y_199172;
                                    float defunc_9_slope_fun_res_199174 =
                                          defunc_0_f_res_199164 * x_199173;
                                    float defunc_1_op_res_199140 =
                                          defunc_9_fit_fun_res_199170 +
                                          redout_200532;
                                    float defunc_1_op_res_199143 =
                                          defunc_9_slope_fun_res_199174 +
                                          redout_200533;
                                    float redout_tmp_206571 =
                                          defunc_1_op_res_199140;
                                    float redout_tmp_206572 =
                                          defunc_1_op_res_199143;
                                    
                                    redout_200532 = redout_tmp_206571;
                                    redout_200533 = redout_tmp_206572;
                                }
                                defunc_2_reduce_res_199136 = redout_200532;
                                defunc_2_reduce_res_199137 = redout_200533;
                                ((float *) mem_204659.mem)[i_200546 *
                                                           t_n_m_196759 +
                                                           i_200539] =
                                    defunc_2_reduce_res_199136;
                                ((float *) mem_204663.mem)[i_200546 *
                                                           t_n_m_196759 +
                                                           i_200539] =
                                    defunc_2_reduce_res_199137;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_204930, &mem_204659,
                                         "mem_204659") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_204922, &mem_204663,
                                         "mem_204663") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_204663, "mem_204663") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_204659, "mem_204659") != 0)
                            return 1;
                    } else {
                        struct memblock mem_204792;
                        
                        mem_204792.references = NULL;
                        if (memblock_alloc(ctx, &mem_204792, bytes_202008,
                                           "mem_204792")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_204796;
                        
                        mem_204796.references = NULL;
                        if (memblock_alloc(ctx, &mem_204796, bytes_202008,
                                           "mem_204796")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_204819_cached_sizze_206709 <
                            (size_t) bytes_204818) {
                            mem_204819 = realloc(mem_204819, bytes_204818);
                            mem_204819_cached_sizze_206709 = bytes_204818;
                        }
                        if (mem_204834_cached_sizze_206710 <
                            (size_t) bytes_204818) {
                            mem_204834 = realloc(mem_204834, bytes_204818);
                            mem_204834_cached_sizze_206710 = bytes_204818;
                        }
                        if (mem_204837_cached_sizze_206711 <
                            (size_t) bytes_204818) {
                            mem_204837 = realloc(mem_204837, bytes_204818);
                            mem_204837_cached_sizze_206711 = bytes_204818;
                        }
                        for (int64_t i_200580 = 0; i_200580 < m_196691;
                             i_200580++) {
                            int64_t x_199184;
                            
                            x_199184 = ((int64_t *) mem_201389)[i_200580];
                            for (int64_t i_200551 = 0; i_200551 < n_196692;
                                 i_200551++) {
                                float x_199188;
                                
                                x_199188 =
                                    ((float *) Y_mem_201382.mem)[i_200580 *
                                                                 n_196692 +
                                                                 i_200551];
                                
                                float x_199189;
                                
                                x_199189 = ((float *) mem_204522.mem)[i_200580 *
                                                                      n_196692 +
                                                                      i_200551];
                                
                                float defunc_1_f_res_199190 = x_199188 -
                                      x_199189;
                                
                                ((float *) mem_204819)[i_200551] =
                                    defunc_1_f_res_199190;
                            }
                            for (int64_t i_200557 = 0; i_200557 < n_196692;
                                 i_200557++) {
                                int64_t x_199193;
                                
                                x_199193 = ((int64_t *) mem_201386)[i_200580 *
                                                                    n_196692 +
                                                                    i_200557];
                                
                                bool cond_199194 = sle64((int64_t) 0, x_199193);
                                float defunc_0_f_res_199195;
                                
                                if (cond_199194) {
                                    bool y_199196 = slt64(x_199193, n_196692);
                                    bool bounds_check_199197 = cond_199194 &&
                                         y_199196;
                                    bool index_certs_199198;
                                    
                                    if (!bounds_check_199197) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_199193,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_196692,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:401:3-415:29\n   #8  stl.fut:385:1-415:29\n");
                                        if (memblock_unref(ctx, &mem_204796,
                                                           "mem_204796") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_204792,
                                                           "mem_204792") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204922,
                                                           "ext_mem_204922") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204930,
                                                           "ext_mem_204930") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204938,
                                                           "ext_mem_204938") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204946,
                                                           "ext_mem_204946") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205450,
                                                           "ext_mem_205450") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205458,
                                                           "ext_mem_205458") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_204522,
                                                           "mem_204522") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204511,
                                                           "ext_mem_204511") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204451,
                                                           "ext_mem_204451") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204459,
                                                           "ext_mem_204459") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203626,
                                                           "ext_mem_203626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203512,
                                                           "ext_mem_203512") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203523,
                                                           "ext_mem_203523") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202158,
                                                           "mem_param_202158") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202150,
                                                           "mem_param_202150") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205518,
                                                           "ext_mem_205518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205519,
                                                           "ext_mem_205519") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202136,
                                                           "mem_param_202136") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202128,
                                                           "mem_param_202128") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202120,
                                                           "mem_param_202120") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205847,
                                                           "ext_mem_205847") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205848,
                                                           "ext_mem_205848") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205849,
                                                           "ext_mem_205849") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202112,
                                                           "mem_202112") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202108,
                                                           "mem_202108") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206309,
                                                           "mem_out_206309") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206308,
                                                           "mem_out_206308") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206307,
                                                           "mem_out_206307") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    float defunc_0_f_res_t_res_199199;
                                    
                                    defunc_0_f_res_t_res_199199 =
                                        ((float *) mem_204819)[x_199193];
                                    defunc_0_f_res_199195 =
                                        defunc_0_f_res_t_res_199199;
                                } else {
                                    defunc_0_f_res_199195 = 0.0F;
                                }
                                
                                float defunc_0_f_res_199200;
                                
                                if (cond_199194) {
                                    bool y_199201 = slt64(x_199193, n_196692);
                                    bool bounds_check_199202 = cond_199194 &&
                                         y_199201;
                                    bool index_certs_199203;
                                    
                                    if (!bounds_check_199202) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_199193,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_196692,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:401:3-415:29\n   #8  stl.fut:385:1-415:29\n");
                                        if (memblock_unref(ctx, &mem_204796,
                                                           "mem_204796") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_204792,
                                                           "mem_204792") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204922,
                                                           "ext_mem_204922") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204930,
                                                           "ext_mem_204930") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204938,
                                                           "ext_mem_204938") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204946,
                                                           "ext_mem_204946") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205450,
                                                           "ext_mem_205450") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205458,
                                                           "ext_mem_205458") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_204522,
                                                           "mem_204522") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204511,
                                                           "ext_mem_204511") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204451,
                                                           "ext_mem_204451") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204459,
                                                           "ext_mem_204459") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203626,
                                                           "ext_mem_203626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203512,
                                                           "ext_mem_203512") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203523,
                                                           "ext_mem_203523") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202158,
                                                           "mem_param_202158") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202150,
                                                           "mem_param_202150") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205518,
                                                           "ext_mem_205518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205519,
                                                           "ext_mem_205519") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202136,
                                                           "mem_param_202136") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202128,
                                                           "mem_param_202128") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202120,
                                                           "mem_param_202120") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205847,
                                                           "ext_mem_205847") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205848,
                                                           "ext_mem_205848") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205849,
                                                           "ext_mem_205849") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202112,
                                                           "mem_202112") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202108,
                                                           "mem_202108") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206309,
                                                           "mem_out_206309") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206308,
                                                           "mem_out_206308") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206307,
                                                           "mem_out_206307") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    float defunc_0_f_res_t_res_199204;
                                    
                                    defunc_0_f_res_t_res_199204 =
                                        ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                         (i_200580 *
                                                                          ctx_param_ext_202132 +
                                                                          x_199193 *
                                                                          ctx_param_ext_202134)];
                                    defunc_0_f_res_199200 =
                                        defunc_0_f_res_t_res_199204;
                                } else {
                                    defunc_0_f_res_199200 = 0.0F;
                                }
                                ((float *) mem_204834)[i_200557] =
                                    defunc_0_f_res_199200;
                                ((float *) mem_204837)[i_200557] =
                                    defunc_0_f_res_199195;
                            }
                            for (int64_t i_200573 = 0; i_200573 < t_n_m_196759;
                                 i_200573++) {
                                int64_t x_199208;
                                
                                x_199208 = ((int64_t *) mem_202005)[i_200580 *
                                                                    t_n_m_196759 +
                                                                    i_200573];
                                
                                float x_199209;
                                
                                x_199209 = ((float *) mem_202009)[i_200580 *
                                                                  t_n_m_196759 +
                                                                  i_200573];
                                
                                int64_t min_arg_199210 = mul64(jump_t_196702,
                                                               i_200573);
                                int64_t min_res_199211 = smin64(i_196779,
                                                                min_arg_199210);
                                int64_t defunc_0_g_res_199212 =
                                        add64((int64_t) 1, min_res_199211);
                                float defunc_2_reduce_res_199213;
                                float defunc_2_reduce_res_199214;
                                float defunc_2_reduce_res_199215;
                                float defunc_2_reduce_res_199216;
                                float defunc_2_reduce_res_199217;
                                float redout_200560;
                                float redout_200561;
                                float redout_200562;
                                float redout_200563;
                                float redout_200564;
                                
                                redout_200560 = 0.0F;
                                redout_200561 = 0.0F;
                                redout_200562 = 0.0F;
                                redout_200563 = 0.0F;
                                redout_200564 = 0.0F;
                                for (int64_t i_200565 = 0; i_200565 <
                                     q_t_196696; i_200565++) {
                                    bool cond_199234 = sle64(x_199184,
                                                             i_200565);
                                    int64_t defunc_0_f_res_199235;
                                    
                                    if (cond_199234) {
                                        defunc_0_f_res_199235 = (int64_t) 0;
                                    } else {
                                        int64_t i_199236 = add64(x_199208,
                                                                 i_200565);
                                        int64_t defunc_0_add_arg_199237;
                                        
                                        defunc_0_add_arg_199237 =
                                            ((int64_t *) mem_201386)[i_200580 *
                                                                     n_196692 +
                                                                     i_199236];
                                        
                                        int64_t defunc_1_add_res_199238 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_199237);
                                        
                                        defunc_0_f_res_199235 =
                                            defunc_1_add_res_199238;
                                    }
                                    
                                    float defunc_0_f_res_199239;
                                    
                                    if (cond_199234) {
                                        defunc_0_f_res_199239 = 0.0F;
                                    } else {
                                        int64_t i_199240 = add64(x_199208,
                                                                 i_200565);
                                        float defunc_0_add_arg_199241;
                                        
                                        defunc_0_add_arg_199241 =
                                            ((float *) mem_204834)[i_199240];
                                        defunc_0_f_res_199239 =
                                            defunc_0_add_arg_199241;
                                    }
                                    
                                    int64_t binop_p_199242 =
                                            sub64(defunc_0_f_res_199235,
                                                  defunc_0_g_res_199212);
                                    float defunc_0_f_res_199243 =
                                          sitofp_i64_f32(binop_p_199242);
                                    float abs_res_199244 =
                                          (float) fabs(defunc_0_f_res_199243);
                                    float tmp1_199245 = abs_res_199244 /
                                          x_199209;
                                    float x_199246 = tmp1_199245 * tmp1_199245;
                                    float y_199247 = tmp1_199245 * x_199246;
                                    float tmp2_199248 = 1.0F - y_199247;
                                    float x_199249 = tmp2_199248 * tmp2_199248;
                                    float tmp3_199250 = tmp2_199248 * x_199249;
                                    float w_j_199251 = defunc_0_f_res_199239 *
                                          tmp3_199250;
                                    float xw_j_199252 = defunc_0_f_res_199243 *
                                          w_j_199251;
                                    float x2w_j_199253 = defunc_0_f_res_199243 *
                                          xw_j_199252;
                                    float x3w_j_199254 = defunc_0_f_res_199243 *
                                          x2w_j_199253;
                                    float x4w_j_199255 = defunc_0_f_res_199243 *
                                          x3w_j_199254;
                                    float defunc_1_op_res_199220 = w_j_199251 +
                                          redout_200560;
                                    float defunc_1_op_res_199223 = xw_j_199252 +
                                          redout_200561;
                                    float defunc_1_op_res_199226 =
                                          x2w_j_199253 + redout_200562;
                                    float defunc_1_op_res_199229 =
                                          x3w_j_199254 + redout_200563;
                                    float defunc_1_op_res_199232 =
                                          x4w_j_199255 + redout_200564;
                                    float redout_tmp_206580 =
                                          defunc_1_op_res_199220;
                                    float redout_tmp_206581 =
                                          defunc_1_op_res_199223;
                                    float redout_tmp_206582 =
                                          defunc_1_op_res_199226;
                                    float redout_tmp_206583 =
                                          defunc_1_op_res_199229;
                                    float redout_tmp_206584 =
                                          defunc_1_op_res_199232;
                                    
                                    redout_200560 = redout_tmp_206580;
                                    redout_200561 = redout_tmp_206581;
                                    redout_200562 = redout_tmp_206582;
                                    redout_200563 = redout_tmp_206583;
                                    redout_200564 = redout_tmp_206584;
                                }
                                defunc_2_reduce_res_199213 = redout_200560;
                                defunc_2_reduce_res_199214 = redout_200561;
                                defunc_2_reduce_res_199215 = redout_200562;
                                defunc_2_reduce_res_199216 = redout_200563;
                                defunc_2_reduce_res_199217 = redout_200564;
                                
                                float x_199256 = defunc_2_reduce_res_199215 *
                                      defunc_2_reduce_res_199217;
                                float y_199257 = defunc_2_reduce_res_199216 *
                                      defunc_2_reduce_res_199216;
                                float a12_199258 = x_199256 - y_199257;
                                float x_199259 = defunc_2_reduce_res_199215 *
                                      defunc_2_reduce_res_199216;
                                float y_199260 = defunc_2_reduce_res_199214 *
                                      defunc_2_reduce_res_199217;
                                float b12_199261 = x_199259 - y_199260;
                                float x_199262 = defunc_2_reduce_res_199214 *
                                      defunc_2_reduce_res_199216;
                                float y_199263 = defunc_2_reduce_res_199215 *
                                      defunc_2_reduce_res_199215;
                                float c12_199264 = x_199262 - y_199263;
                                float x_199265 = defunc_2_reduce_res_199213 *
                                      defunc_2_reduce_res_199217;
                                float b2_199266 = x_199265 - y_199263;
                                float x_199267 = defunc_2_reduce_res_199214 *
                                      defunc_2_reduce_res_199215;
                                float y_199268 = defunc_2_reduce_res_199213 *
                                      defunc_2_reduce_res_199216;
                                float c2_199269 = x_199267 - y_199268;
                                float x_199270 = defunc_2_reduce_res_199213 *
                                      a12_199258;
                                float y_199271 = defunc_2_reduce_res_199214 *
                                      b12_199261;
                                float x_199272 = x_199270 + y_199271;
                                float y_199273 = defunc_2_reduce_res_199215 *
                                      c12_199264;
                                float y_199274 = x_199272 + y_199273;
                                float det_199275 = 1.0F / y_199274;
                                float a12_199276 = a12_199258 * det_199275;
                                float b12_199277 = b12_199261 * det_199275;
                                float c12_199278 = c12_199264 * det_199275;
                                float b2_199279 = b2_199266 * det_199275;
                                float c2_199280 = c2_199269 * det_199275;
                                float defunc_2_reduce_res_199281;
                                float defunc_2_reduce_res_199282;
                                float redout_200566;
                                float redout_200567;
                                
                                redout_200566 = 0.0F;
                                redout_200567 = 0.0F;
                                for (int64_t i_200568 = 0; i_200568 <
                                     q_t_196696; i_200568++) {
                                    bool cond_199290 = sle64(x_199184,
                                                             i_200568);
                                    int64_t defunc_0_f_res_199291;
                                    
                                    if (cond_199290) {
                                        defunc_0_f_res_199291 = (int64_t) 0;
                                    } else {
                                        int64_t i_199292 = add64(x_199208,
                                                                 i_200568);
                                        int64_t defunc_0_add_arg_199293;
                                        
                                        defunc_0_add_arg_199293 =
                                            ((int64_t *) mem_201386)[i_200580 *
                                                                     n_196692 +
                                                                     i_199292];
                                        
                                        int64_t defunc_1_add_res_199294 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_199293);
                                        
                                        defunc_0_f_res_199291 =
                                            defunc_1_add_res_199294;
                                    }
                                    
                                    float defunc_0_f_res_199295;
                                    
                                    if (cond_199290) {
                                        defunc_0_f_res_199295 = 0.0F;
                                    } else {
                                        int64_t i_199296 = add64(x_199208,
                                                                 i_200568);
                                        float defunc_0_add_arg_199297;
                                        
                                        defunc_0_add_arg_199297 =
                                            ((float *) mem_204834)[i_199296];
                                        defunc_0_f_res_199295 =
                                            defunc_0_add_arg_199297;
                                    }
                                    
                                    int64_t binop_p_199298 =
                                            sub64(defunc_0_f_res_199291,
                                                  defunc_0_g_res_199212);
                                    float defunc_0_f_res_199299 =
                                          sitofp_i64_f32(binop_p_199298);
                                    float abs_res_199300 =
                                          (float) fabs(defunc_0_f_res_199299);
                                    float tmp1_199301 = abs_res_199300 /
                                          x_199209;
                                    float x_199302 = tmp1_199301 * tmp1_199301;
                                    float y_199303 = tmp1_199301 * x_199302;
                                    float tmp2_199304 = 1.0F - y_199303;
                                    float x_199305 = tmp2_199304 * tmp2_199304;
                                    float tmp3_199306 = tmp2_199304 * x_199305;
                                    float tmp4_199307 = defunc_0_f_res_199295 *
                                          tmp3_199306;
                                    float defunc_1_f_res_199308 =
                                          defunc_0_f_res_199299 * tmp4_199307;
                                    float defunc_1_f_res_199309 =
                                          defunc_0_f_res_199299 *
                                          defunc_1_f_res_199308;
                                    float defunc_0_f_res_199310;
                                    
                                    if (cond_199290) {
                                        defunc_0_f_res_199310 = 0.0F;
                                    } else {
                                        int64_t i_199311 = add64(x_199208,
                                                                 i_200568);
                                        float defunc_0_add_arg_199312;
                                        
                                        defunc_0_add_arg_199312 =
                                            ((float *) mem_204837)[i_199311];
                                        defunc_0_f_res_199310 =
                                            defunc_0_add_arg_199312;
                                    }
                                    
                                    float x_199313 = a12_199276 * tmp4_199307;
                                    float y_199314 = b12_199277 *
                                          defunc_1_f_res_199308;
                                    float x_199315 = x_199313 + y_199314;
                                    float y_199316 = c12_199278 *
                                          defunc_1_f_res_199309;
                                    float x_199317 = x_199315 + y_199316;
                                    float defunc_9_fit_fun_res_199318 =
                                          defunc_0_f_res_199310 * x_199317;
                                    float x_199319 = b12_199277 * tmp4_199307;
                                    float y_199320 = b2_199279 *
                                          defunc_1_f_res_199308;
                                    float x_199321 = x_199319 + y_199320;
                                    float y_199322 = c2_199280 *
                                          defunc_1_f_res_199309;
                                    float x_199323 = x_199321 + y_199322;
                                    float defunc_9_slope_fun_res_199324 =
                                          defunc_0_f_res_199310 * x_199323;
                                    float defunc_1_op_res_199285 =
                                          defunc_9_fit_fun_res_199318 +
                                          redout_200566;
                                    float defunc_1_op_res_199288 =
                                          defunc_9_slope_fun_res_199324 +
                                          redout_200567;
                                    float redout_tmp_206585 =
                                          defunc_1_op_res_199285;
                                    float redout_tmp_206586 =
                                          defunc_1_op_res_199288;
                                    
                                    redout_200566 = redout_tmp_206585;
                                    redout_200567 = redout_tmp_206586;
                                }
                                defunc_2_reduce_res_199281 = redout_200566;
                                defunc_2_reduce_res_199282 = redout_200567;
                                ((float *) mem_204792.mem)[i_200580 *
                                                           t_n_m_196759 +
                                                           i_200573] =
                                    defunc_2_reduce_res_199281;
                                ((float *) mem_204796.mem)[i_200580 *
                                                           t_n_m_196759 +
                                                           i_200573] =
                                    defunc_2_reduce_res_199282;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_204930, &mem_204792,
                                         "mem_204792") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_204922, &mem_204796,
                                         "mem_204796") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_204796, "mem_204796") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_204792, "mem_204792") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_204946, &ext_mem_204930,
                                     "ext_mem_204930") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_204938, &ext_mem_204922,
                                     "ext_mem_204922") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204922,
                                       "ext_mem_204922") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204930,
                                       "ext_mem_204930") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_205458, &ext_mem_204946,
                                 "ext_mem_204946") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_205450, &ext_mem_204938,
                                 "ext_mem_204938") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_204938, "ext_mem_204938") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_204946, "ext_mem_204946") != 0)
                    return 1;
            } else {
                bool match_lit_199327 = (int64_t) 0 == d_t_196699;
                int64_t binop_y_204972 = (int64_t) 4 * n_196692;
                int64_t bytes_204973 = smax64((int64_t) 0, binop_y_204972);
                int64_t binop_y_205028 = (int64_t) 4 * q_t_196696;
                int64_t bytes_205029 = smax64((int64_t) 0, binop_y_205028);
                struct memblock ext_mem_205442;
                
                ext_mem_205442.references = NULL;
                
                struct memblock ext_mem_205434;
                
                ext_mem_205434.references = NULL;
                if (match_lit_199327) {
                    struct memblock mem_204957;
                    
                    mem_204957.references = NULL;
                    if (memblock_alloc(ctx, &mem_204957, bytes_202008,
                                       "mem_204957")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_206587 = 0; i_206587 < m_196691;
                         i_206587++) {
                        for (int64_t i_206588 = 0; i_206588 < t_n_m_196759;
                             i_206588++) {
                            ((float *) mem_204957.mem)[i_206587 * t_n_m_196759 +
                                                       i_206588] = 0.0F;
                        }
                    }
                    
                    struct memblock mem_204961;
                    
                    mem_204961.references = NULL;
                    if (memblock_alloc(ctx, &mem_204961, bytes_202008,
                                       "mem_204961")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (mem_204974_cached_sizze_206712 <
                        (size_t) bytes_204973) {
                        mem_204974 = realloc(mem_204974, bytes_204973);
                        mem_204974_cached_sizze_206712 = bytes_204973;
                    }
                    if (mem_204989_cached_sizze_206713 <
                        (size_t) bytes_204973) {
                        mem_204989 = realloc(mem_204989, bytes_204973);
                        mem_204989_cached_sizze_206713 = bytes_204973;
                    }
                    if (mem_204992_cached_sizze_206714 <
                        (size_t) bytes_204973) {
                        mem_204992 = realloc(mem_204992, bytes_204973);
                        mem_204992_cached_sizze_206714 = bytes_204973;
                    }
                    if (mem_205030_cached_sizze_206715 <
                        (size_t) bytes_205029) {
                        mem_205030 = realloc(mem_205030, bytes_205029);
                        mem_205030_cached_sizze_206715 = bytes_205029;
                    }
                    for (int64_t i_200607 = 0; i_200607 < m_196691;
                         i_200607++) {
                        int64_t x_199337;
                        
                        x_199337 = ((int64_t *) mem_201389)[i_200607];
                        for (int64_t i_200585 = 0; i_200585 < n_196692;
                             i_200585++) {
                            float x_199341;
                            
                            x_199341 = ((float *) Y_mem_201382.mem)[i_200607 *
                                                                    n_196692 +
                                                                    i_200585];
                            
                            float x_199342;
                            
                            x_199342 = ((float *) mem_204522.mem)[i_200607 *
                                                                  n_196692 +
                                                                  i_200585];
                            
                            float defunc_1_f_res_199343 = x_199341 - x_199342;
                            
                            ((float *) mem_204974)[i_200585] =
                                defunc_1_f_res_199343;
                        }
                        for (int64_t i_200591 = 0; i_200591 < n_196692;
                             i_200591++) {
                            int64_t x_199346;
                            
                            x_199346 = ((int64_t *) mem_201386)[i_200607 *
                                                                n_196692 +
                                                                i_200591];
                            
                            bool cond_199347 = sle64((int64_t) 0, x_199346);
                            float defunc_0_f_res_199348;
                            
                            if (cond_199347) {
                                bool y_199349 = slt64(x_199346, n_196692);
                                bool bounds_check_199350 = cond_199347 &&
                                     y_199349;
                                bool index_certs_199351;
                                
                                if (!bounds_check_199350) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) x_199346,
                                                  "] out of bounds for array of shape [",
                                                  (long long) n_196692, "].",
                                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:401:3-415:29\n   #8  stl.fut:385:1-415:29\n");
                                    if (memblock_unref(ctx, &mem_204961,
                                                       "mem_204961") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_204957,
                                                       "mem_204957") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205434,
                                                       "ext_mem_205434") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205442,
                                                       "ext_mem_205442") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205450,
                                                       "ext_mem_205450") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205458,
                                                       "ext_mem_205458") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_204522,
                                                       "mem_204522") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204511,
                                                       "ext_mem_204511") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204451,
                                                       "ext_mem_204451") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204459,
                                                       "ext_mem_204459") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203626,
                                                       "ext_mem_203626") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203512,
                                                       "ext_mem_203512") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203523,
                                                       "ext_mem_203523") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202158,
                                                       "mem_param_202158") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202150,
                                                       "mem_param_202150") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205518,
                                                       "ext_mem_205518") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205519,
                                                       "ext_mem_205519") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202136,
                                                       "mem_param_202136") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202128,
                                                       "mem_param_202128") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202120,
                                                       "mem_param_202120") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205847,
                                                       "ext_mem_205847") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205848,
                                                       "ext_mem_205848") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205849,
                                                       "ext_mem_205849") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_202112,
                                                       "mem_202112") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_202108,
                                                       "mem_202108") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206309,
                                                       "mem_out_206309") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206308,
                                                       "mem_out_206308") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206307,
                                                       "mem_out_206307") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                float defunc_0_f_res_t_res_199352;
                                
                                defunc_0_f_res_t_res_199352 =
                                    ((float *) mem_204974)[x_199346];
                                defunc_0_f_res_199348 =
                                    defunc_0_f_res_t_res_199352;
                            } else {
                                defunc_0_f_res_199348 = 0.0F;
                            }
                            
                            float defunc_0_f_res_199353;
                            
                            if (cond_199347) {
                                bool y_199354 = slt64(x_199346, n_196692);
                                bool bounds_check_199355 = cond_199347 &&
                                     y_199354;
                                bool index_certs_199356;
                                
                                if (!bounds_check_199355) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) x_199346,
                                                  "] out of bounds for array of shape [",
                                                  (long long) n_196692, "].",
                                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:401:3-415:29\n   #8  stl.fut:385:1-415:29\n");
                                    if (memblock_unref(ctx, &mem_204961,
                                                       "mem_204961") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_204957,
                                                       "mem_204957") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205434,
                                                       "ext_mem_205434") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205442,
                                                       "ext_mem_205442") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205450,
                                                       "ext_mem_205450") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205458,
                                                       "ext_mem_205458") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_204522,
                                                       "mem_204522") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204511,
                                                       "ext_mem_204511") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204451,
                                                       "ext_mem_204451") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_204459,
                                                       "ext_mem_204459") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203626,
                                                       "ext_mem_203626") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203512,
                                                       "ext_mem_203512") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_203523,
                                                       "ext_mem_203523") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202158,
                                                       "mem_param_202158") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202150,
                                                       "mem_param_202150") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205518,
                                                       "ext_mem_205518") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205519,
                                                       "ext_mem_205519") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202136,
                                                       "mem_param_202136") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202128,
                                                       "mem_param_202128") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_202120,
                                                       "mem_param_202120") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205847,
                                                       "ext_mem_205847") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205848,
                                                       "ext_mem_205848") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_205849,
                                                       "ext_mem_205849") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_202112,
                                                       "mem_202112") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_202108,
                                                       "mem_202108") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206309,
                                                       "mem_out_206309") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206308,
                                                       "mem_out_206308") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_206307,
                                                       "mem_out_206307") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                float defunc_0_f_res_t_res_199357;
                                
                                defunc_0_f_res_t_res_199357 =
                                    ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                     (i_200607 *
                                                                      ctx_param_ext_202132 +
                                                                      x_199346 *
                                                                      ctx_param_ext_202134)];
                                defunc_0_f_res_199353 =
                                    defunc_0_f_res_t_res_199357;
                            } else {
                                defunc_0_f_res_199353 = 0.0F;
                            }
                            ((float *) mem_204989)[i_200591] =
                                defunc_0_f_res_199353;
                            ((float *) mem_204992)[i_200591] =
                                defunc_0_f_res_199348;
                        }
                        for (int64_t i_200603 = 0; i_200603 < t_n_m_196759;
                             i_200603++) {
                            int64_t x_199360;
                            
                            x_199360 = ((int64_t *) mem_202005)[i_200607 *
                                                                t_n_m_196759 +
                                                                i_200603];
                            
                            float x_199361;
                            
                            x_199361 = ((float *) mem_202009)[i_200607 *
                                                              t_n_m_196759 +
                                                              i_200603];
                            
                            int64_t min_arg_199362 = mul64(jump_t_196702,
                                                           i_200603);
                            int64_t min_res_199363 = smin64(i_196779,
                                                            min_arg_199362);
                            int64_t defunc_0_g_res_199364 = add64((int64_t) 1,
                                                                  min_res_199363);
                            float defunc_2_reduce_res_199365;
                            float redout_200595 = 0.0F;
                            
                            for (int64_t i_200597 = 0; i_200597 < q_t_196696;
                                 i_200597++) {
                                bool cond_199371 = sle64(x_199337, i_200597);
                                int64_t defunc_0_f_res_199372;
                                
                                if (cond_199371) {
                                    defunc_0_f_res_199372 = (int64_t) 0;
                                } else {
                                    int64_t i_199373 = add64(x_199360,
                                                             i_200597);
                                    int64_t defunc_0_add_arg_199374;
                                    
                                    defunc_0_add_arg_199374 =
                                        ((int64_t *) mem_201386)[i_200607 *
                                                                 n_196692 +
                                                                 i_199373];
                                    
                                    int64_t defunc_1_add_res_199375 =
                                            add64((int64_t) 1,
                                                  defunc_0_add_arg_199374);
                                    
                                    defunc_0_f_res_199372 =
                                        defunc_1_add_res_199375;
                                }
                                
                                float defunc_0_f_res_199376;
                                
                                if (cond_199371) {
                                    defunc_0_f_res_199376 = 0.0F;
                                } else {
                                    int64_t i_199377 = add64(x_199360,
                                                             i_200597);
                                    float defunc_0_add_arg_199378;
                                    
                                    defunc_0_add_arg_199378 =
                                        ((float *) mem_204989)[i_199377];
                                    defunc_0_f_res_199376 =
                                        defunc_0_add_arg_199378;
                                }
                                
                                int64_t binop_p_199379 =
                                        sub64(defunc_0_f_res_199372,
                                              defunc_0_g_res_199364);
                                float defunc_0_f_res_199380 =
                                      sitofp_i64_f32(binop_p_199379);
                                float abs_res_199381 =
                                      (float) fabs(defunc_0_f_res_199380);
                                float tmp1_199382 = abs_res_199381 / x_199361;
                                float x_199383 = tmp1_199382 * tmp1_199382;
                                float y_199384 = tmp1_199382 * x_199383;
                                float tmp2_199385 = 1.0F - y_199384;
                                float x_199386 = tmp2_199385 * tmp2_199385;
                                float tmp3_199387 = tmp2_199385 * x_199386;
                                float tmp4_199388 = defunc_0_f_res_199376 *
                                      tmp3_199387;
                                float defunc_1_op_res_199369 = tmp4_199388 +
                                      redout_200595;
                                
                                ((float *) mem_205030)[i_200597] = tmp4_199388;
                                
                                float redout_tmp_206594 =
                                      defunc_1_op_res_199369;
                                
                                redout_200595 = redout_tmp_206594;
                            }
                            defunc_2_reduce_res_199365 = redout_200595;
                            
                            float a0_199389 = 1.0F / defunc_2_reduce_res_199365;
                            float defunc_2_reduce_res_199390;
                            float redout_200599 = 0.0F;
                            
                            for (int64_t i_200600 = 0; i_200600 < q_t_196696;
                                 i_200600++) {
                                float x_199395;
                                
                                x_199395 = ((float *) mem_205030)[i_200600];
                                
                                bool cond_199396 = sle64(x_199337, i_200600);
                                float defunc_0_f_res_199397;
                                
                                if (cond_199396) {
                                    defunc_0_f_res_199397 = 0.0F;
                                } else {
                                    int64_t i_199398 = add64(x_199360,
                                                             i_200600);
                                    float defunc_0_add_arg_199399;
                                    
                                    defunc_0_add_arg_199399 =
                                        ((float *) mem_204992)[i_199398];
                                    defunc_0_f_res_199397 =
                                        defunc_0_add_arg_199399;
                                }
                                
                                float x_199400 = a0_199389 * x_199395;
                                float defunc_9_fit_fun_res_199401 =
                                      defunc_0_f_res_199397 * x_199400;
                                float defunc_1_op_res_199393 =
                                      defunc_9_fit_fun_res_199401 +
                                      redout_200599;
                                float redout_tmp_206596 =
                                      defunc_1_op_res_199393;
                                
                                redout_200599 = redout_tmp_206596;
                            }
                            defunc_2_reduce_res_199390 = redout_200599;
                            ((float *) mem_204961.mem)[i_200607 * t_n_m_196759 +
                                                       i_200603] =
                                defunc_2_reduce_res_199390;
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_205442, &mem_204961,
                                     "mem_204961") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_205434, &mem_204957,
                                     "mem_204957") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_204961, "mem_204961") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_204957, "mem_204957") != 0)
                        return 1;
                } else {
                    bool match_lit_199404 = (int64_t) 1 == d_t_196699;
                    int64_t binop_y_205090 = (int64_t) 4 * n_196692;
                    int64_t bytes_205091 = smax64((int64_t) 0, binop_y_205090);
                    int64_t binop_y_205157 = (int64_t) 4 * q_t_196696;
                    int64_t bytes_205158 = smax64((int64_t) 0, binop_y_205157);
                    int64_t binop_y_205253 = (int64_t) 4 * n_196692;
                    int64_t bytes_205254 = smax64((int64_t) 0, binop_y_205253);
                    int64_t binop_y_205320 = (int64_t) 4 * q_t_196696;
                    int64_t bytes_205321 = smax64((int64_t) 0, binop_y_205320);
                    struct memblock ext_mem_205426;
                    
                    ext_mem_205426.references = NULL;
                    
                    struct memblock ext_mem_205418;
                    
                    ext_mem_205418.references = NULL;
                    if (match_lit_199404) {
                        struct memblock mem_205065;
                        
                        mem_205065.references = NULL;
                        if (memblock_alloc(ctx, &mem_205065, bytes_202008,
                                           "mem_205065")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_205069;
                        
                        mem_205069.references = NULL;
                        if (memblock_alloc(ctx, &mem_205069, bytes_202008,
                                           "mem_205069")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_205092_cached_sizze_206716 <
                            (size_t) bytes_205091) {
                            mem_205092 = realloc(mem_205092, bytes_205091);
                            mem_205092_cached_sizze_206716 = bytes_205091;
                        }
                        if (mem_205107_cached_sizze_206717 <
                            (size_t) bytes_205091) {
                            mem_205107 = realloc(mem_205107, bytes_205091);
                            mem_205107_cached_sizze_206717 = bytes_205091;
                        }
                        if (mem_205110_cached_sizze_206718 <
                            (size_t) bytes_205091) {
                            mem_205110 = realloc(mem_205110, bytes_205091);
                            mem_205110_cached_sizze_206718 = bytes_205091;
                        }
                        if (mem_205159_cached_sizze_206719 <
                            (size_t) bytes_205158) {
                            mem_205159 = realloc(mem_205159, bytes_205158);
                            mem_205159_cached_sizze_206719 = bytes_205158;
                        }
                        if (mem_205162_cached_sizze_206720 <
                            (size_t) bytes_205158) {
                            mem_205162 = realloc(mem_205162, bytes_205158);
                            mem_205162_cached_sizze_206720 = bytes_205158;
                        }
                        for (int64_t i_200644 = 0; i_200644 < m_196691;
                             i_200644++) {
                            int64_t x_199414;
                            
                            x_199414 = ((int64_t *) mem_201389)[i_200644];
                            for (int64_t i_200611 = 0; i_200611 < n_196692;
                                 i_200611++) {
                                float x_199418;
                                
                                x_199418 =
                                    ((float *) Y_mem_201382.mem)[i_200644 *
                                                                 n_196692 +
                                                                 i_200611];
                                
                                float x_199419;
                                
                                x_199419 = ((float *) mem_204522.mem)[i_200644 *
                                                                      n_196692 +
                                                                      i_200611];
                                
                                float defunc_1_f_res_199420 = x_199418 -
                                      x_199419;
                                
                                ((float *) mem_205092)[i_200611] =
                                    defunc_1_f_res_199420;
                            }
                            for (int64_t i_200617 = 0; i_200617 < n_196692;
                                 i_200617++) {
                                int64_t x_199423;
                                
                                x_199423 = ((int64_t *) mem_201386)[i_200644 *
                                                                    n_196692 +
                                                                    i_200617];
                                
                                bool cond_199424 = sle64((int64_t) 0, x_199423);
                                float defunc_0_f_res_199425;
                                
                                if (cond_199424) {
                                    bool y_199426 = slt64(x_199423, n_196692);
                                    bool bounds_check_199427 = cond_199424 &&
                                         y_199426;
                                    bool index_certs_199428;
                                    
                                    if (!bounds_check_199427) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_199423,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_196692,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:401:3-415:29\n   #8  stl.fut:385:1-415:29\n");
                                        if (memblock_unref(ctx, &mem_205069,
                                                           "mem_205069") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_205065,
                                                           "mem_205065") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205418,
                                                           "ext_mem_205418") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205426,
                                                           "ext_mem_205426") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205434,
                                                           "ext_mem_205434") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205442,
                                                           "ext_mem_205442") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205450,
                                                           "ext_mem_205450") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205458,
                                                           "ext_mem_205458") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_204522,
                                                           "mem_204522") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204511,
                                                           "ext_mem_204511") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204451,
                                                           "ext_mem_204451") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204459,
                                                           "ext_mem_204459") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203626,
                                                           "ext_mem_203626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203512,
                                                           "ext_mem_203512") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203523,
                                                           "ext_mem_203523") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202158,
                                                           "mem_param_202158") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202150,
                                                           "mem_param_202150") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205518,
                                                           "ext_mem_205518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205519,
                                                           "ext_mem_205519") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202136,
                                                           "mem_param_202136") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202128,
                                                           "mem_param_202128") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202120,
                                                           "mem_param_202120") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205847,
                                                           "ext_mem_205847") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205848,
                                                           "ext_mem_205848") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205849,
                                                           "ext_mem_205849") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202112,
                                                           "mem_202112") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202108,
                                                           "mem_202108") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206309,
                                                           "mem_out_206309") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206308,
                                                           "mem_out_206308") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206307,
                                                           "mem_out_206307") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    float defunc_0_f_res_t_res_199429;
                                    
                                    defunc_0_f_res_t_res_199429 =
                                        ((float *) mem_205092)[x_199423];
                                    defunc_0_f_res_199425 =
                                        defunc_0_f_res_t_res_199429;
                                } else {
                                    defunc_0_f_res_199425 = 0.0F;
                                }
                                
                                float defunc_0_f_res_199430;
                                
                                if (cond_199424) {
                                    bool y_199431 = slt64(x_199423, n_196692);
                                    bool bounds_check_199432 = cond_199424 &&
                                         y_199431;
                                    bool index_certs_199433;
                                    
                                    if (!bounds_check_199432) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_199423,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_196692,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:401:3-415:29\n   #8  stl.fut:385:1-415:29\n");
                                        if (memblock_unref(ctx, &mem_205069,
                                                           "mem_205069") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_205065,
                                                           "mem_205065") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205418,
                                                           "ext_mem_205418") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205426,
                                                           "ext_mem_205426") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205434,
                                                           "ext_mem_205434") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205442,
                                                           "ext_mem_205442") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205450,
                                                           "ext_mem_205450") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205458,
                                                           "ext_mem_205458") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_204522,
                                                           "mem_204522") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204511,
                                                           "ext_mem_204511") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204451,
                                                           "ext_mem_204451") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204459,
                                                           "ext_mem_204459") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203626,
                                                           "ext_mem_203626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203512,
                                                           "ext_mem_203512") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203523,
                                                           "ext_mem_203523") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202158,
                                                           "mem_param_202158") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202150,
                                                           "mem_param_202150") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205518,
                                                           "ext_mem_205518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205519,
                                                           "ext_mem_205519") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202136,
                                                           "mem_param_202136") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202128,
                                                           "mem_param_202128") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202120,
                                                           "mem_param_202120") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205847,
                                                           "ext_mem_205847") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205848,
                                                           "ext_mem_205848") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205849,
                                                           "ext_mem_205849") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202112,
                                                           "mem_202112") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202108,
                                                           "mem_202108") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206309,
                                                           "mem_out_206309") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206308,
                                                           "mem_out_206308") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206307,
                                                           "mem_out_206307") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    float defunc_0_f_res_t_res_199434;
                                    
                                    defunc_0_f_res_t_res_199434 =
                                        ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                         (i_200644 *
                                                                          ctx_param_ext_202132 +
                                                                          x_199423 *
                                                                          ctx_param_ext_202134)];
                                    defunc_0_f_res_199430 =
                                        defunc_0_f_res_t_res_199434;
                                } else {
                                    defunc_0_f_res_199430 = 0.0F;
                                }
                                ((float *) mem_205107)[i_200617] =
                                    defunc_0_f_res_199430;
                                ((float *) mem_205110)[i_200617] =
                                    defunc_0_f_res_199425;
                            }
                            for (int64_t i_200637 = 0; i_200637 < t_n_m_196759;
                                 i_200637++) {
                                int64_t x_199438;
                                
                                x_199438 = ((int64_t *) mem_202005)[i_200644 *
                                                                    t_n_m_196759 +
                                                                    i_200637];
                                
                                float x_199439;
                                
                                x_199439 = ((float *) mem_202009)[i_200644 *
                                                                  t_n_m_196759 +
                                                                  i_200637];
                                
                                int64_t min_arg_199440 = mul64(jump_t_196702,
                                                               i_200637);
                                int64_t min_res_199441 = smin64(i_196779,
                                                                min_arg_199440);
                                int64_t defunc_0_g_res_199442 =
                                        add64((int64_t) 1, min_res_199441);
                                float defunc_2_reduce_res_199466;
                                float defunc_2_reduce_res_199467;
                                float defunc_2_reduce_res_199468;
                                float redout_200622;
                                float redout_200623;
                                float redout_200624;
                                
                                redout_200622 = 0.0F;
                                redout_200623 = 0.0F;
                                redout_200624 = 0.0F;
                                for (int64_t i_200627 = 0; i_200627 <
                                     q_t_196696; i_200627++) {
                                    bool cond_199481 = sle64(x_199414,
                                                             i_200627);
                                    int64_t defunc_0_f_res_199482;
                                    
                                    if (cond_199481) {
                                        defunc_0_f_res_199482 = (int64_t) 0;
                                    } else {
                                        int64_t i_199483 = add64(x_199438,
                                                                 i_200627);
                                        int64_t defunc_0_add_arg_199484;
                                        
                                        defunc_0_add_arg_199484 =
                                            ((int64_t *) mem_201386)[i_200644 *
                                                                     n_196692 +
                                                                     i_199483];
                                        
                                        int64_t defunc_1_add_res_199485 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_199484);
                                        
                                        defunc_0_f_res_199482 =
                                            defunc_1_add_res_199485;
                                    }
                                    
                                    float defunc_0_f_res_199486;
                                    
                                    if (cond_199481) {
                                        defunc_0_f_res_199486 = 0.0F;
                                    } else {
                                        int64_t i_199487 = add64(x_199438,
                                                                 i_200627);
                                        float defunc_0_add_arg_199488;
                                        
                                        defunc_0_add_arg_199488 =
                                            ((float *) mem_205107)[i_199487];
                                        defunc_0_f_res_199486 =
                                            defunc_0_add_arg_199488;
                                    }
                                    
                                    int64_t binop_p_199489 =
                                            sub64(defunc_0_f_res_199482,
                                                  defunc_0_g_res_199442);
                                    float defunc_0_f_res_199490 =
                                          sitofp_i64_f32(binop_p_199489);
                                    float abs_res_199491 =
                                          (float) fabs(defunc_0_f_res_199490);
                                    float tmp1_199492 = abs_res_199491 /
                                          x_199439;
                                    float x_199493 = tmp1_199492 * tmp1_199492;
                                    float y_199494 = tmp1_199492 * x_199493;
                                    float tmp2_199495 = 1.0F - y_199494;
                                    float x_199496 = tmp2_199495 * tmp2_199495;
                                    float tmp3_199497 = tmp2_199495 * x_199496;
                                    float tmp4_199498 = defunc_0_f_res_199486 *
                                          tmp3_199497;
                                    float defunc_1_f_res_199499 =
                                          defunc_0_f_res_199490 * tmp4_199498;
                                    float defunc_1_f_res_199500 =
                                          defunc_0_f_res_199490 *
                                          defunc_1_f_res_199499;
                                    float defunc_1_op_res_199473 = tmp4_199498 +
                                          redout_200622;
                                    float defunc_1_op_res_199476 =
                                          defunc_1_f_res_199499 + redout_200623;
                                    float defunc_1_op_res_199479 =
                                          defunc_1_f_res_199500 + redout_200624;
                                    
                                    ((float *) mem_205159)[i_200627] =
                                        defunc_1_f_res_199499;
                                    ((float *) mem_205162)[i_200627] =
                                        tmp4_199498;
                                    
                                    float redout_tmp_206604 =
                                          defunc_1_op_res_199473;
                                    float redout_tmp_206605 =
                                          defunc_1_op_res_199476;
                                    float redout_tmp_206606 =
                                          defunc_1_op_res_199479;
                                    
                                    redout_200622 = redout_tmp_206604;
                                    redout_200623 = redout_tmp_206605;
                                    redout_200624 = redout_tmp_206606;
                                }
                                defunc_2_reduce_res_199466 = redout_200622;
                                defunc_2_reduce_res_199467 = redout_200623;
                                defunc_2_reduce_res_199468 = redout_200624;
                                
                                float x_199506 = defunc_2_reduce_res_199466 *
                                      defunc_2_reduce_res_199468;
                                float y_199507 = defunc_2_reduce_res_199467 *
                                      defunc_2_reduce_res_199467;
                                float y_199508 = x_199506 - y_199507;
                                float det1_199509 = 1.0F / y_199508;
                                float a11_199510 = defunc_2_reduce_res_199468 *
                                      det1_199509;
                                float x_199511 = 0.0F -
                                      defunc_2_reduce_res_199467;
                                float b11_199512 = det1_199509 * x_199511;
                                float c11_199513 = defunc_2_reduce_res_199466 *
                                      det1_199509;
                                float defunc_2_reduce_res_199514;
                                float defunc_2_reduce_res_199515;
                                float redout_200630;
                                float redout_200631;
                                
                                redout_200630 = 0.0F;
                                redout_200631 = 0.0F;
                                for (int64_t i_200632 = 0; i_200632 <
                                     q_t_196696; i_200632++) {
                                    float x_199523;
                                    
                                    x_199523 = ((float *) mem_205162)[i_200632];
                                    
                                    float x_199524;
                                    
                                    x_199524 = ((float *) mem_205159)[i_200632];
                                    
                                    bool cond_199525 = sle64(x_199414,
                                                             i_200632);
                                    float defunc_0_f_res_199526;
                                    
                                    if (cond_199525) {
                                        defunc_0_f_res_199526 = 0.0F;
                                    } else {
                                        int64_t i_199527 = add64(x_199438,
                                                                 i_200632);
                                        float defunc_0_add_arg_199528;
                                        
                                        defunc_0_add_arg_199528 =
                                            ((float *) mem_205110)[i_199527];
                                        defunc_0_f_res_199526 =
                                            defunc_0_add_arg_199528;
                                    }
                                    
                                    float x_199529 = a11_199510 * x_199523;
                                    float y_199530 = b11_199512 * x_199524;
                                    float x_199531 = x_199529 + y_199530;
                                    float defunc_9_fit_fun_res_199532 =
                                          defunc_0_f_res_199526 * x_199531;
                                    float x_199533 = b11_199512 * x_199523;
                                    float y_199534 = c11_199513 * x_199524;
                                    float x_199535 = x_199533 + y_199534;
                                    float defunc_9_slope_fun_res_199536 =
                                          defunc_0_f_res_199526 * x_199535;
                                    float defunc_1_op_res_199518 =
                                          defunc_9_fit_fun_res_199532 +
                                          redout_200630;
                                    float defunc_1_op_res_199521 =
                                          defunc_9_slope_fun_res_199536 +
                                          redout_200631;
                                    float redout_tmp_206609 =
                                          defunc_1_op_res_199518;
                                    float redout_tmp_206610 =
                                          defunc_1_op_res_199521;
                                    
                                    redout_200630 = redout_tmp_206609;
                                    redout_200631 = redout_tmp_206610;
                                }
                                defunc_2_reduce_res_199514 = redout_200630;
                                defunc_2_reduce_res_199515 = redout_200631;
                                ((float *) mem_205065.mem)[i_200644 *
                                                           t_n_m_196759 +
                                                           i_200637] =
                                    defunc_2_reduce_res_199514;
                                ((float *) mem_205069.mem)[i_200644 *
                                                           t_n_m_196759 +
                                                           i_200637] =
                                    defunc_2_reduce_res_199515;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_205426, &mem_205065,
                                         "mem_205065") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_205418, &mem_205069,
                                         "mem_205069") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_205069, "mem_205069") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_205065, "mem_205065") != 0)
                            return 1;
                    } else {
                        struct memblock mem_205228;
                        
                        mem_205228.references = NULL;
                        if (memblock_alloc(ctx, &mem_205228, bytes_202008,
                                           "mem_205228")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_205232;
                        
                        mem_205232.references = NULL;
                        if (memblock_alloc(ctx, &mem_205232, bytes_202008,
                                           "mem_205232")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_205255_cached_sizze_206721 <
                            (size_t) bytes_205254) {
                            mem_205255 = realloc(mem_205255, bytes_205254);
                            mem_205255_cached_sizze_206721 = bytes_205254;
                        }
                        if (mem_205270_cached_sizze_206722 <
                            (size_t) bytes_205254) {
                            mem_205270 = realloc(mem_205270, bytes_205254);
                            mem_205270_cached_sizze_206722 = bytes_205254;
                        }
                        if (mem_205273_cached_sizze_206723 <
                            (size_t) bytes_205254) {
                            mem_205273 = realloc(mem_205273, bytes_205254);
                            mem_205273_cached_sizze_206723 = bytes_205254;
                        }
                        if (mem_205322_cached_sizze_206724 <
                            (size_t) bytes_205321) {
                            mem_205322 = realloc(mem_205322, bytes_205321);
                            mem_205322_cached_sizze_206724 = bytes_205321;
                        }
                        if (mem_205325_cached_sizze_206725 <
                            (size_t) bytes_205321) {
                            mem_205325 = realloc(mem_205325, bytes_205321);
                            mem_205325_cached_sizze_206725 = bytes_205321;
                        }
                        if (mem_205352_cached_sizze_206726 <
                            (size_t) bytes_205321) {
                            mem_205352 = realloc(mem_205352, bytes_205321);
                            mem_205352_cached_sizze_206726 = bytes_205321;
                        }
                        if (mem_205355_cached_sizze_206727 <
                            (size_t) bytes_205321) {
                            mem_205355 = realloc(mem_205355, bytes_205321);
                            mem_205355_cached_sizze_206727 = bytes_205321;
                        }
                        for (int64_t i_200691 = 0; i_200691 < m_196691;
                             i_200691++) {
                            int64_t x_199546;
                            
                            x_199546 = ((int64_t *) mem_201389)[i_200691];
                            for (int64_t i_200649 = 0; i_200649 < n_196692;
                                 i_200649++) {
                                float x_199550;
                                
                                x_199550 =
                                    ((float *) Y_mem_201382.mem)[i_200691 *
                                                                 n_196692 +
                                                                 i_200649];
                                
                                float x_199551;
                                
                                x_199551 = ((float *) mem_204522.mem)[i_200691 *
                                                                      n_196692 +
                                                                      i_200649];
                                
                                float defunc_1_f_res_199552 = x_199550 -
                                      x_199551;
                                
                                ((float *) mem_205255)[i_200649] =
                                    defunc_1_f_res_199552;
                            }
                            for (int64_t i_200655 = 0; i_200655 < n_196692;
                                 i_200655++) {
                                int64_t x_199555;
                                
                                x_199555 = ((int64_t *) mem_201386)[i_200691 *
                                                                    n_196692 +
                                                                    i_200655];
                                
                                bool cond_199556 = sle64((int64_t) 0, x_199555);
                                float defunc_0_f_res_199557;
                                
                                if (cond_199556) {
                                    bool y_199558 = slt64(x_199555, n_196692);
                                    bool bounds_check_199559 = cond_199556 &&
                                         y_199558;
                                    bool index_certs_199560;
                                    
                                    if (!bounds_check_199559) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_199555,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_196692,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:401:3-415:29\n   #8  stl.fut:385:1-415:29\n");
                                        if (memblock_unref(ctx, &mem_205232,
                                                           "mem_205232") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_205228,
                                                           "mem_205228") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205418,
                                                           "ext_mem_205418") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205426,
                                                           "ext_mem_205426") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205434,
                                                           "ext_mem_205434") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205442,
                                                           "ext_mem_205442") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205450,
                                                           "ext_mem_205450") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205458,
                                                           "ext_mem_205458") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_204522,
                                                           "mem_204522") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204511,
                                                           "ext_mem_204511") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204451,
                                                           "ext_mem_204451") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204459,
                                                           "ext_mem_204459") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203626,
                                                           "ext_mem_203626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203512,
                                                           "ext_mem_203512") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203523,
                                                           "ext_mem_203523") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202158,
                                                           "mem_param_202158") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202150,
                                                           "mem_param_202150") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205518,
                                                           "ext_mem_205518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205519,
                                                           "ext_mem_205519") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202136,
                                                           "mem_param_202136") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202128,
                                                           "mem_param_202128") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202120,
                                                           "mem_param_202120") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205847,
                                                           "ext_mem_205847") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205848,
                                                           "ext_mem_205848") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205849,
                                                           "ext_mem_205849") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202112,
                                                           "mem_202112") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202108,
                                                           "mem_202108") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206309,
                                                           "mem_out_206309") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206308,
                                                           "mem_out_206308") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206307,
                                                           "mem_out_206307") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    float defunc_0_f_res_t_res_199561;
                                    
                                    defunc_0_f_res_t_res_199561 =
                                        ((float *) mem_205255)[x_199555];
                                    defunc_0_f_res_199557 =
                                        defunc_0_f_res_t_res_199561;
                                } else {
                                    defunc_0_f_res_199557 = 0.0F;
                                }
                                
                                float defunc_0_f_res_199562;
                                
                                if (cond_199556) {
                                    bool y_199563 = slt64(x_199555, n_196692);
                                    bool bounds_check_199564 = cond_199556 &&
                                         y_199563;
                                    bool index_certs_199565;
                                    
                                    if (!bounds_check_199564) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_199555,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_196692,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:401:3-415:29\n   #8  stl.fut:385:1-415:29\n");
                                        if (memblock_unref(ctx, &mem_205232,
                                                           "mem_205232") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_205228,
                                                           "mem_205228") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205418,
                                                           "ext_mem_205418") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205426,
                                                           "ext_mem_205426") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205434,
                                                           "ext_mem_205434") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205442,
                                                           "ext_mem_205442") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205450,
                                                           "ext_mem_205450") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205458,
                                                           "ext_mem_205458") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_204522,
                                                           "mem_204522") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204511,
                                                           "ext_mem_204511") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204451,
                                                           "ext_mem_204451") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_204459,
                                                           "ext_mem_204459") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203626,
                                                           "ext_mem_203626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203512,
                                                           "ext_mem_203512") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_203523,
                                                           "ext_mem_203523") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202158,
                                                           "mem_param_202158") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202150,
                                                           "mem_param_202150") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205518,
                                                           "ext_mem_205518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205519,
                                                           "ext_mem_205519") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202136,
                                                           "mem_param_202136") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202128,
                                                           "mem_param_202128") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_202120,
                                                           "mem_param_202120") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205847,
                                                           "ext_mem_205847") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205848,
                                                           "ext_mem_205848") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_205849,
                                                           "ext_mem_205849") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202112,
                                                           "mem_202112") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_202108,
                                                           "mem_202108") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206309,
                                                           "mem_out_206309") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206308,
                                                           "mem_out_206308") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_206307,
                                                           "mem_out_206307") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    float defunc_0_f_res_t_res_199566;
                                    
                                    defunc_0_f_res_t_res_199566 =
                                        ((float *) mem_param_202136.mem)[ctx_param_ext_202131 +
                                                                         (i_200691 *
                                                                          ctx_param_ext_202132 +
                                                                          x_199555 *
                                                                          ctx_param_ext_202134)];
                                    defunc_0_f_res_199562 =
                                        defunc_0_f_res_t_res_199566;
                                } else {
                                    defunc_0_f_res_199562 = 0.0F;
                                }
                                ((float *) mem_205270)[i_200655] =
                                    defunc_0_f_res_199562;
                                ((float *) mem_205273)[i_200655] =
                                    defunc_0_f_res_199557;
                            }
                            for (int64_t i_200684 = 0; i_200684 < t_n_m_196759;
                                 i_200684++) {
                                int64_t x_199570;
                                
                                x_199570 = ((int64_t *) mem_202005)[i_200691 *
                                                                    t_n_m_196759 +
                                                                    i_200684];
                                
                                float x_199571;
                                
                                x_199571 = ((float *) mem_202009)[i_200691 *
                                                                  t_n_m_196759 +
                                                                  i_200684];
                                
                                int64_t min_arg_199572 = mul64(jump_t_196702,
                                                               i_200684);
                                int64_t min_res_199573 = smin64(i_196779,
                                                                min_arg_199572);
                                int64_t defunc_0_g_res_199574 =
                                        add64((int64_t) 1, min_res_199573);
                                
                                for (int64_t i_200662 = 0; i_200662 <
                                     q_t_196696; i_200662++) {
                                    bool cond_199578 = sle64(x_199546,
                                                             i_200662);
                                    int64_t defunc_0_f_res_199579;
                                    
                                    if (cond_199578) {
                                        defunc_0_f_res_199579 = (int64_t) 0;
                                    } else {
                                        int64_t i_199580 = add64(x_199570,
                                                                 i_200662);
                                        int64_t defunc_0_add_arg_199581;
                                        
                                        defunc_0_add_arg_199581 =
                                            ((int64_t *) mem_201386)[i_200691 *
                                                                     n_196692 +
                                                                     i_199580];
                                        
                                        int64_t defunc_1_add_res_199582 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_199581);
                                        
                                        defunc_0_f_res_199579 =
                                            defunc_1_add_res_199582;
                                    }
                                    
                                    float defunc_0_f_res_199583;
                                    
                                    if (cond_199578) {
                                        defunc_0_f_res_199583 = 0.0F;
                                    } else {
                                        int64_t i_199584 = add64(x_199570,
                                                                 i_200662);
                                        float defunc_0_add_arg_199585;
                                        
                                        defunc_0_add_arg_199585 =
                                            ((float *) mem_205270)[i_199584];
                                        defunc_0_f_res_199583 =
                                            defunc_0_add_arg_199585;
                                    }
                                    
                                    int64_t binop_p_199586 =
                                            sub64(defunc_0_f_res_199579,
                                                  defunc_0_g_res_199574);
                                    float defunc_0_f_res_199587 =
                                          sitofp_i64_f32(binop_p_199586);
                                    float abs_res_199588 =
                                          (float) fabs(defunc_0_f_res_199587);
                                    float tmp1_199589 = abs_res_199588 /
                                          x_199571;
                                    float x_199590 = tmp1_199589 * tmp1_199589;
                                    float y_199591 = tmp1_199589 * x_199590;
                                    float tmp2_199592 = 1.0F - y_199591;
                                    float x_199593 = tmp2_199592 * tmp2_199592;
                                    float tmp3_199594 = tmp2_199592 * x_199593;
                                    float tmp4_199595 = defunc_0_f_res_199583 *
                                          tmp3_199594;
                                    
                                    ((float *) mem_205322)[i_200662] =
                                        defunc_0_f_res_199587;
                                    ((float *) mem_205325)[i_200662] =
                                        tmp4_199595;
                                }
                                
                                float defunc_2_reduce_res_199602;
                                float defunc_2_reduce_res_199603;
                                float defunc_2_reduce_res_199604;
                                float defunc_2_reduce_res_199605;
                                float defunc_2_reduce_res_199606;
                                float redout_200667;
                                float redout_200668;
                                float redout_200669;
                                float redout_200670;
                                float redout_200671;
                                
                                redout_200667 = 0.0F;
                                redout_200668 = 0.0F;
                                redout_200669 = 0.0F;
                                redout_200670 = 0.0F;
                                redout_200671 = 0.0F;
                                for (int64_t i_200674 = 0; i_200674 <
                                     q_t_196696; i_200674++) {
                                    float x_199624;
                                    
                                    x_199624 = ((float *) mem_205322)[i_200674];
                                    
                                    float x_199625;
                                    
                                    x_199625 = ((float *) mem_205325)[i_200674];
                                    
                                    float defunc_1_f_res_199626 = x_199624 *
                                          x_199625;
                                    float defunc_1_f_res_199627 = x_199624 *
                                          defunc_1_f_res_199626;
                                    float defunc_1_f_res_199628 = x_199624 *
                                          defunc_1_f_res_199627;
                                    float defunc_1_f_res_199629 = x_199624 *
                                          defunc_1_f_res_199628;
                                    float defunc_1_op_res_199611 = x_199625 +
                                          redout_200667;
                                    float defunc_1_op_res_199614 =
                                          defunc_1_f_res_199626 + redout_200668;
                                    float defunc_1_op_res_199617 =
                                          defunc_1_f_res_199627 + redout_200669;
                                    float defunc_1_op_res_199620 =
                                          defunc_1_f_res_199628 + redout_200670;
                                    float defunc_1_op_res_199623 =
                                          defunc_1_f_res_199629 + redout_200671;
                                    
                                    ((float *) mem_205352)[i_200674] =
                                        defunc_1_f_res_199627;
                                    ((float *) mem_205355)[i_200674] =
                                        defunc_1_f_res_199626;
                                    
                                    float redout_tmp_206620 =
                                          defunc_1_op_res_199611;
                                    float redout_tmp_206621 =
                                          defunc_1_op_res_199614;
                                    float redout_tmp_206622 =
                                          defunc_1_op_res_199617;
                                    float redout_tmp_206623 =
                                          defunc_1_op_res_199620;
                                    float redout_tmp_206624 =
                                          defunc_1_op_res_199623;
                                    
                                    redout_200667 = redout_tmp_206620;
                                    redout_200668 = redout_tmp_206621;
                                    redout_200669 = redout_tmp_206622;
                                    redout_200670 = redout_tmp_206623;
                                    redout_200671 = redout_tmp_206624;
                                }
                                defunc_2_reduce_res_199602 = redout_200667;
                                defunc_2_reduce_res_199603 = redout_200668;
                                defunc_2_reduce_res_199604 = redout_200669;
                                defunc_2_reduce_res_199605 = redout_200670;
                                defunc_2_reduce_res_199606 = redout_200671;
                                
                                float x_199637 = defunc_2_reduce_res_199604 *
                                      defunc_2_reduce_res_199606;
                                float y_199638 = defunc_2_reduce_res_199605 *
                                      defunc_2_reduce_res_199605;
                                float a12_199639 = x_199637 - y_199638;
                                float x_199640 = defunc_2_reduce_res_199604 *
                                      defunc_2_reduce_res_199605;
                                float y_199641 = defunc_2_reduce_res_199603 *
                                      defunc_2_reduce_res_199606;
                                float b12_199642 = x_199640 - y_199641;
                                float x_199643 = defunc_2_reduce_res_199603 *
                                      defunc_2_reduce_res_199605;
                                float y_199644 = defunc_2_reduce_res_199604 *
                                      defunc_2_reduce_res_199604;
                                float c12_199645 = x_199643 - y_199644;
                                float x_199646 = defunc_2_reduce_res_199602 *
                                      defunc_2_reduce_res_199606;
                                float b2_199647 = x_199646 - y_199644;
                                float x_199648 = defunc_2_reduce_res_199603 *
                                      defunc_2_reduce_res_199604;
                                float y_199649 = defunc_2_reduce_res_199602 *
                                      defunc_2_reduce_res_199605;
                                float c2_199650 = x_199648 - y_199649;
                                float x_199651 = defunc_2_reduce_res_199602 *
                                      a12_199639;
                                float y_199652 = defunc_2_reduce_res_199603 *
                                      b12_199642;
                                float x_199653 = x_199651 + y_199652;
                                float y_199654 = defunc_2_reduce_res_199604 *
                                      c12_199645;
                                float y_199655 = x_199653 + y_199654;
                                float det_199656 = 1.0F / y_199655;
                                float a12_199657 = a12_199639 * det_199656;
                                float b12_199658 = b12_199642 * det_199656;
                                float c12_199659 = c12_199645 * det_199656;
                                float b2_199660 = b2_199647 * det_199656;
                                float c2_199661 = c2_199650 * det_199656;
                                float defunc_2_reduce_res_199662;
                                float defunc_2_reduce_res_199663;
                                float redout_200677;
                                float redout_200678;
                                
                                redout_200677 = 0.0F;
                                redout_200678 = 0.0F;
                                for (int64_t i_200679 = 0; i_200679 <
                                     q_t_196696; i_200679++) {
                                    float x_199671;
                                    
                                    x_199671 = ((float *) mem_205325)[i_200679];
                                    
                                    float x_199672;
                                    
                                    x_199672 = ((float *) mem_205355)[i_200679];
                                    
                                    float x_199673;
                                    
                                    x_199673 = ((float *) mem_205352)[i_200679];
                                    
                                    bool cond_199674 = sle64(x_199546,
                                                             i_200679);
                                    float defunc_0_f_res_199675;
                                    
                                    if (cond_199674) {
                                        defunc_0_f_res_199675 = 0.0F;
                                    } else {
                                        int64_t i_199676 = add64(x_199570,
                                                                 i_200679);
                                        float defunc_0_add_arg_199677;
                                        
                                        defunc_0_add_arg_199677 =
                                            ((float *) mem_205273)[i_199676];
                                        defunc_0_f_res_199675 =
                                            defunc_0_add_arg_199677;
                                    }
                                    
                                    float x_199678 = a12_199657 * x_199671;
                                    float y_199679 = b12_199658 * x_199672;
                                    float x_199680 = x_199678 + y_199679;
                                    float y_199681 = c12_199659 * x_199673;
                                    float x_199682 = x_199680 + y_199681;
                                    float defunc_9_fit_fun_res_199683 =
                                          defunc_0_f_res_199675 * x_199682;
                                    float x_199684 = b12_199658 * x_199671;
                                    float y_199685 = b2_199660 * x_199672;
                                    float x_199686 = x_199684 + y_199685;
                                    float y_199687 = c2_199661 * x_199673;
                                    float x_199688 = x_199686 + y_199687;
                                    float defunc_9_slope_fun_res_199689 =
                                          defunc_0_f_res_199675 * x_199688;
                                    float defunc_1_op_res_199666 =
                                          defunc_9_fit_fun_res_199683 +
                                          redout_200677;
                                    float defunc_1_op_res_199669 =
                                          defunc_9_slope_fun_res_199689 +
                                          redout_200678;
                                    float redout_tmp_206627 =
                                          defunc_1_op_res_199666;
                                    float redout_tmp_206628 =
                                          defunc_1_op_res_199669;
                                    
                                    redout_200677 = redout_tmp_206627;
                                    redout_200678 = redout_tmp_206628;
                                }
                                defunc_2_reduce_res_199662 = redout_200677;
                                defunc_2_reduce_res_199663 = redout_200678;
                                ((float *) mem_205228.mem)[i_200691 *
                                                           t_n_m_196759 +
                                                           i_200684] =
                                    defunc_2_reduce_res_199662;
                                ((float *) mem_205232.mem)[i_200691 *
                                                           t_n_m_196759 +
                                                           i_200684] =
                                    defunc_2_reduce_res_199663;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_205426, &mem_205228,
                                         "mem_205228") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_205418, &mem_205232,
                                         "mem_205232") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_205232, "mem_205232") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_205228, "mem_205228") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_205442, &ext_mem_205426,
                                     "ext_mem_205426") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_205434, &ext_mem_205418,
                                     "ext_mem_205418") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205418,
                                       "ext_mem_205418") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205426,
                                       "ext_mem_205426") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_205458, &ext_mem_205442,
                                 "ext_mem_205442") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_205450, &ext_mem_205434,
                                 "ext_mem_205434") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_205434, "ext_mem_205434") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_205442, "ext_mem_205442") != 0)
                    return 1;
            }
            
            struct memblock ext_mem_205510;
            
            ext_mem_205510.references = NULL;
            if (cond_197221) {
                bool zzero_199693 = jump_t_196702 == (int64_t) 0;
                bool nonzzero_199694 = !zzero_199693;
                bool nonzzero_cert_199695;
                
                if (!nonzzero_199694) {
                    ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                           "division by zero",
                                           "-> #0  loess.fut:546:20-27\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:545:3-549:9\n   #5  stl.fut:304:23-75\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:303:15-305:43\n   #9  stl.fut:401:3-415:29\n   #10 stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &ext_mem_205510,
                                       "ext_mem_205510") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205450,
                                       "ext_mem_205450") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205458,
                                       "ext_mem_205458") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_204522, "mem_204522") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204511,
                                       "ext_mem_204511") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204451,
                                       "ext_mem_204451") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204459,
                                       "ext_mem_204459") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203626,
                                       "ext_mem_203626") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203512,
                                       "ext_mem_203512") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203523,
                                       "ext_mem_203523") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202158,
                                       "mem_param_202158") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202150,
                                       "mem_param_202150") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205518,
                                       "ext_mem_205518") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205519,
                                       "ext_mem_205519") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202136,
                                       "mem_param_202136") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202128,
                                       "mem_param_202128") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202120,
                                       "mem_param_202120") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205847,
                                       "ext_mem_205847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205848,
                                       "ext_mem_205848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205849,
                                       "ext_mem_205849") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t y_199696 = sub64(t_n_m_196759, (int64_t) 1);
                struct memblock mem_205469;
                
                mem_205469.references = NULL;
                if (memblock_alloc(ctx, &mem_205469, bytes_202107,
                                   "mem_205469")) {
                    err = 1;
                    goto cleanup;
                }
                for (int64_t i_200700 = 0; i_200700 < m_196691; i_200700++) {
                    for (int64_t i_200696 = 0; i_200696 < n_196692;
                         i_200696++) {
                        int64_t m_v_199702 = sdiv64(i_200696, jump_t_196702);
                        bool cond_199703 = m_v_199702 == y_199696;
                        int64_t j_199704;
                        
                        if (cond_199703) {
                            int64_t j_t_res_199705 = sub64(m_v_199702,
                                                           (int64_t) 1);
                            
                            j_199704 = j_t_res_199705;
                        } else {
                            j_199704 = m_v_199702;
                        }
                        
                        int64_t min_arg_199706 = mul64(jump_t_196702, j_199704);
                        int64_t min_res_199707 = smin64(i_196779,
                                                        min_arg_199706);
                        int64_t defunc_0_m_fun_arg_199708 = add64((int64_t) 1,
                                                                  j_199704);
                        int64_t min_arg_199709 = mul64(jump_t_196702,
                                                       defunc_0_m_fun_arg_199708);
                        int64_t min_res_199710 = smin64(i_196779,
                                                        min_arg_199709);
                        int64_t i64_arg_199711 = sub64(min_res_199710,
                                                       min_res_199707);
                        float i64_res_199712 = sitofp_i64_f32(i64_arg_199711);
                        int64_t i64_arg_199713 = sub64(i_200696,
                                                       min_res_199707);
                        float i64_res_199714 = sitofp_i64_f32(i64_arg_199713);
                        float u_199715 = i64_res_199714 / i64_res_199712;
                        float u2_199716 = u_199715 * u_199715;
                        float u3_199717 = u_199715 * u2_199716;
                        float x_199718 = 2.0F * u3_199717;
                        float y_199719 = 3.0F * u2_199716;
                        float x_199720 = x_199718 - y_199719;
                        float x_199721 = 1.0F + x_199720;
                        bool x_199722 = sle64((int64_t) 0, j_199704);
                        bool y_199723 = slt64(j_199704, t_n_m_196759);
                        bool bounds_check_199724 = x_199722 && y_199723;
                        bool index_certs_199725;
                        
                        if (!bounds_check_199724) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) j_199704,
                                          "] out of bounds for array of shape [",
                                          (long long) t_n_m_196759, "].",
                                          "-> #0  loess.fut:535:27-33\n   #1  loess.fut:548:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:545:3-549:9\n   #6  stl.fut:304:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:303:15-305:43\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                            if (memblock_unref(ctx, &mem_205469,
                                               "mem_205469") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205510,
                                               "ext_mem_205510") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205450,
                                               "ext_mem_205450") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205458,
                                               "ext_mem_205458") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_204522,
                                               "mem_204522") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_204511,
                                               "ext_mem_204511") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_204451,
                                               "ext_mem_204451") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_204459,
                                               "ext_mem_204459") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203626,
                                               "ext_mem_203626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203512,
                                               "ext_mem_203512") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203523,
                                               "ext_mem_203523") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202158,
                                               "mem_param_202158") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202150,
                                               "mem_param_202150") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205518,
                                               "ext_mem_205518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205519,
                                               "ext_mem_205519") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202136,
                                               "mem_param_202136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202128,
                                               "mem_param_202128") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202120,
                                               "mem_param_202120") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205847,
                                               "ext_mem_205847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205848,
                                               "ext_mem_205848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205849,
                                               "ext_mem_205849") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202112,
                                               "mem_202112") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202108,
                                               "mem_202108") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206309,
                                               "mem_out_206309") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206308,
                                               "mem_out_206308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206307,
                                               "mem_out_206307") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        float y_199726;
                        
                        y_199726 = ((float *) ext_mem_205458.mem)[i_200700 *
                                                                  t_n_m_196759 +
                                                                  j_199704];
                        
                        float x_199727 = x_199721 * y_199726;
                        float x_199728 = y_199719 - x_199718;
                        bool x_199729 = sle64((int64_t) 0,
                                              defunc_0_m_fun_arg_199708);
                        bool y_199730 = slt64(defunc_0_m_fun_arg_199708,
                                              t_n_m_196759);
                        bool bounds_check_199731 = x_199729 && y_199730;
                        bool index_certs_199732;
                        
                        if (!bounds_check_199731) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [",
                                          (long long) defunc_0_m_fun_arg_199708,
                                          "] out of bounds for array of shape [",
                                          (long long) t_n_m_196759, "].",
                                          "-> #0  loess.fut:536:27-37\n   #1  loess.fut:548:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:545:3-549:9\n   #6  stl.fut:304:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:303:15-305:43\n   #10 stl.fut:401:3-415:29\n   #11 stl.fut:385:1-415:29\n");
                            if (memblock_unref(ctx, &mem_205469,
                                               "mem_205469") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205510,
                                               "ext_mem_205510") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205450,
                                               "ext_mem_205450") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205458,
                                               "ext_mem_205458") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_204522,
                                               "mem_204522") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_204511,
                                               "ext_mem_204511") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_204451,
                                               "ext_mem_204451") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_204459,
                                               "ext_mem_204459") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203626,
                                               "ext_mem_203626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203512,
                                               "ext_mem_203512") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_203523,
                                               "ext_mem_203523") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202158,
                                               "mem_param_202158") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202150,
                                               "mem_param_202150") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205518,
                                               "ext_mem_205518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205519,
                                               "ext_mem_205519") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202136,
                                               "mem_param_202136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202128,
                                               "mem_param_202128") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202120,
                                               "mem_param_202120") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205847,
                                               "ext_mem_205847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205848,
                                               "ext_mem_205848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205849,
                                               "ext_mem_205849") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202112,
                                               "mem_202112") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202108,
                                               "mem_202108") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206309,
                                               "mem_out_206309") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206308,
                                               "mem_out_206308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206307,
                                               "mem_out_206307") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        float y_199733;
                        
                        y_199733 = ((float *) ext_mem_205458.mem)[i_200700 *
                                                                  t_n_m_196759 +
                                                                  defunc_0_m_fun_arg_199708];
                        
                        float y_199734 = x_199728 * y_199733;
                        float x_199735 = x_199727 + y_199734;
                        float y_199736 = 2.0F * u2_199716;
                        float x_199737 = u3_199717 - y_199736;
                        float x_199738 = u_199715 + x_199737;
                        float y_199739;
                        
                        y_199739 = ((float *) ext_mem_205450.mem)[i_200700 *
                                                                  t_n_m_196759 +
                                                                  j_199704];
                        
                        float x_199740 = x_199738 * y_199739;
                        float y_199741 = i64_res_199712 * x_199740;
                        float x_199742 = x_199735 + y_199741;
                        float x_199743 = u3_199717 - u2_199716;
                        float y_199744;
                        
                        y_199744 = ((float *) ext_mem_205450.mem)[i_200700 *
                                                                  t_n_m_196759 +
                                                                  defunc_0_m_fun_arg_199708];
                        
                        float x_199745 = x_199743 * y_199744;
                        float y_199746 = i64_res_199712 * x_199745;
                        float defunc_4_interpolate_proc_res_199747 = x_199742 +
                              y_199746;
                        
                        ((float *) mem_205469.mem)[i_200700 * n_196692 +
                                                   i_200696] =
                            defunc_4_interpolate_proc_res_199747;
                    }
                }
                if (memblock_set(ctx, &ext_mem_205510, &mem_205469,
                                 "mem_205469") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_205469, "mem_205469") != 0)
                    return 1;
            } else {
                bool dim_match_199749 = n_196692 == t_n_m_196759;
                bool empty_or_match_cert_199750;
                
                if (!dim_match_199749) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Value of (core language) shape (",
                                  (long long) m_196691, ", ",
                                  (long long) t_n_m_196759,
                                  ") cannot match shape of type `[",
                                  (long long) m_196691, "][",
                                  (long long) n_196692, "]t`.",
                                  "-> #0  stl.fut:307:15-36\n   #1  stl.fut:401:3-415:29\n   #2  stl.fut:385:1-415:29\n");
                    if (memblock_unref(ctx, &ext_mem_205510,
                                       "ext_mem_205510") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205450,
                                       "ext_mem_205450") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205458,
                                       "ext_mem_205458") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_204522, "mem_204522") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204511,
                                       "ext_mem_204511") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204451,
                                       "ext_mem_204451") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_204459,
                                       "ext_mem_204459") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203626,
                                       "ext_mem_203626") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203512,
                                       "ext_mem_203512") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_203523,
                                       "ext_mem_203523") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202158,
                                       "mem_param_202158") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202150,
                                       "mem_param_202150") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205518,
                                       "ext_mem_205518") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205519,
                                       "ext_mem_205519") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202136,
                                       "mem_param_202136") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202128,
                                       "mem_param_202128") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_202120,
                                       "mem_param_202120") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205847,
                                       "ext_mem_205847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205848,
                                       "ext_mem_205848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_205849,
                                       "ext_mem_205849") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206309,
                                       "mem_out_206309") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206308,
                                       "mem_out_206308") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_206307,
                                       "mem_out_206307") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                if (memblock_set(ctx, &ext_mem_205510, &ext_mem_205458,
                                 "ext_mem_205458") != 0)
                    return 1;
            }
            if (memblock_unref(ctx, &ext_mem_205450, "ext_mem_205450") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_205458, "ext_mem_205458") != 0)
                return 1;
            
            int64_t ctx_param_ext_tmp_206384 = ext_205514;
            int64_t ctx_param_ext_tmp_206385 = ext_205513;
            struct memblock mem_param_tmp_206386;
            
            mem_param_tmp_206386.references = NULL;
            if (memblock_set(ctx, &mem_param_tmp_206386, &mem_204522,
                             "mem_204522") != 0)
                return 1;
            
            struct memblock mem_param_tmp_206387;
            
            mem_param_tmp_206387.references = NULL;
            if (memblock_set(ctx, &mem_param_tmp_206387, &ext_mem_205510,
                             "ext_mem_205510") != 0)
                return 1;
            ctx_param_ext_202152 = ctx_param_ext_tmp_206384;
            ctx_param_ext_202154 = ctx_param_ext_tmp_206385;
            if (memblock_set(ctx, &mem_param_202150, &mem_param_tmp_206386,
                             "mem_param_tmp_206386") != 0)
                return 1;
            if (memblock_set(ctx, &mem_param_202158, &mem_param_tmp_206387,
                             "mem_param_tmp_206387") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_tmp_206387,
                               "mem_param_tmp_206387") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_tmp_206386,
                               "mem_param_tmp_206386") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_205510, "ext_mem_205510") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_205450, "ext_mem_205450") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_205458, "ext_mem_205458") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_204522, "mem_204522") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_204511, "ext_mem_204511") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_204451, "ext_mem_204451") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_204459, "ext_mem_204459") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_203626, "ext_mem_203626") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_203512, "ext_mem_203512") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_203523, "ext_mem_203523") != 0)
                return 1;
        }
        ext_205525 = ctx_param_ext_202152;
        ext_205523 = ctx_param_ext_202154;
        if (memblock_set(ctx, &ext_mem_205519, &mem_param_202150,
                         "mem_param_202150") != 0)
            return 1;
        if (memblock_set(ctx, &ext_mem_205518, &mem_param_202158,
                         "mem_param_202158") != 0)
            return 1;
        
        bool cond_199752 = slt64(i_outer_197305, y_197222);
        int64_t ext_205846;
        
        if (cond_199752) {
            ext_205846 = m_196691;
        } else {
            ext_205846 = ctx_param_ext_202133;
        }
        
        int64_t ext_205845;
        
        if (cond_199752) {
            ext_205845 = n_196692;
        } else {
            ext_205845 = ctx_param_ext_202135;
        }
        
        int64_t ext_205844;
        
        if (cond_199752) {
            ext_205844 = m_196691;
        } else {
            ext_205844 = ctx_param_ext_202129;
        }
        
        int64_t ext_205843;
        
        if (cond_199752) {
            ext_205843 = n_196692;
        } else {
            ext_205843 = ctx_param_ext_202130;
        }
        
        int64_t ext_205842;
        
        if (cond_199752) {
            ext_205842 = n_196692;
        } else {
            ext_205842 = ctx_param_ext_202132;
        }
        
        int64_t ext_205841;
        
        if (cond_199752) {
            ext_205841 = (int64_t) 1;
        } else {
            ext_205841 = ctx_param_ext_202134;
        }
        
        int64_t ext_205840;
        
        if (cond_199752) {
            ext_205840 = (int64_t) 0;
        } else {
            ext_205840 = ctx_param_ext_202131;
        }
        
        struct memblock ext_mem_205839;
        
        ext_mem_205839.references = NULL;
        if (cond_199752) {
            if (mem_205537_cached_sizze_206728 < (size_t) bytes_202107) {
                mem_205537 = realloc(mem_205537, bytes_202107);
                mem_205537_cached_sizze_206728 = bytes_202107;
            }
            if (mem_205541_cached_sizze_206729 < (size_t) bytes_202107) {
                mem_205541 = realloc(mem_205541, bytes_202107);
                mem_205541_cached_sizze_206729 = bytes_202107;
            }
            for (int64_t i_200714 = 0; i_200714 < m_196691; i_200714++) {
                for (int64_t i_200704 = 0; i_200704 < n_196692; i_200704++) {
                    float x_199761;
                    
                    x_199761 = ((float *) Y_mem_201382.mem)[i_200714 *
                                                            n_196692 +
                                                            i_200704];
                    
                    float x_199762;
                    
                    x_199762 = ((float *) ext_mem_205519.mem)[i_200714 *
                                                              n_196692 +
                                                              i_200704];
                    
                    float x_199763;
                    
                    x_199763 = ((float *) ext_mem_205518.mem)[i_200714 *
                                                              ext_205523 +
                                                              i_200704];
                    
                    float x_199764 = x_199761 - x_199762;
                    float defunc_2_f_res_199765 = x_199764 - x_199763;
                    bool isnan_res_199766;
                    
                    isnan_res_199766 = futrts_isnan32(defunc_2_f_res_199765);
                    
                    float defunc_0_f_res_199767;
                    
                    if (isnan_res_199766) {
                        defunc_0_f_res_199767 = defunc_2_f_res_199765;
                    } else {
                        float abs_res_199768 =
                              (float) fabs(defunc_2_f_res_199765);
                        
                        defunc_0_f_res_199767 = abs_res_199768;
                    }
                    ((float *) mem_205541)[i_200714 * n_196692 + i_200704] =
                        defunc_0_f_res_199767;
                }
                for (int64_t i_200708 = 0; i_200708 < n_196692; i_200708++) {
                    int64_t x_199770;
                    
                    x_199770 = ((int64_t *) mem_201386)[i_200714 * n_196692 +
                                                        i_200708];
                    
                    bool cond_199771 = sle64((int64_t) 0, x_199770);
                    float defunc_0_f_res_199772;
                    
                    if (cond_199771) {
                        bool y_199773 = slt64(x_199770, n_196692);
                        bool bounds_check_199774 = cond_199771 && y_199773;
                        bool index_certs_199775;
                        
                        if (!bounds_check_199774) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) x_199770,
                                          "] out of bounds for array of shape [",
                                          (long long) n_196692, "].",
                                          "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:334:21-49\n   #3  /prelude/soacs.fut:67:19-23\n   #4  /prelude/soacs.fut:67:3-37\n   #5  stl.fut:332:13-335:35\n   #6  stl.fut:401:3-415:29\n   #7  stl.fut:385:1-415:29\n");
                            if (memblock_unref(ctx, &ext_mem_205839,
                                               "ext_mem_205839") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202158,
                                               "mem_param_202158") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202150,
                                               "mem_param_202150") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205518,
                                               "ext_mem_205518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205519,
                                               "ext_mem_205519") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202136,
                                               "mem_param_202136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202128,
                                               "mem_param_202128") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_202120,
                                               "mem_param_202120") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205847,
                                               "ext_mem_205847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205848,
                                               "ext_mem_205848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_205849,
                                               "ext_mem_205849") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202112,
                                               "mem_202112") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_202108,
                                               "mem_202108") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206309,
                                               "mem_out_206309") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206308,
                                               "mem_out_206308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_206307,
                                               "mem_out_206307") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        float defunc_0_f_res_t_res_199776;
                        
                        defunc_0_f_res_t_res_199776 =
                            ((float *) mem_205541)[i_200714 * n_196692 +
                                                   x_199770];
                        defunc_0_f_res_199772 = defunc_0_f_res_t_res_199776;
                    } else {
                        defunc_0_f_res_199772 = INFINITY;
                    }
                    ((float *) mem_205537)[i_200714 * n_196692 + i_200708] =
                        defunc_0_f_res_199772;
                }
            }
            
            bool loop_nonempty_199779 = slt32(0, iters_199778);
            bool loop_not_taken_199780 = !loop_nonempty_199779;
            bool protect_assert_disj_199781 = bounds_check_196782 ||
                 loop_not_taken_199780;
            bool index_certs_199782;
            
            if (!protect_assert_disj_199781) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) i_196779,
                              "] out of bounds for array of shape [",
                              (long long) n_196692, "].",
                              "-> #0  /prelude/array.fut:26:29-34\n   #1  lib/github.com/diku-dk/sorts/radix_sort.fut:25:24-35\n   #2  lib/github.com/diku-dk/sorts/radix_sort.fut:53:31-62\n   #3  lib/github.com/diku-dk/sorts/radix_sort.fut:104:6-36\n   #4  stl.fut:338:35-77\n   #5  stl.fut:337:28-339:40\n   #6  stl.fut:401:3-415:29\n   #7  stl.fut:385:1-415:29\n");
                if (memblock_unref(ctx, &ext_mem_205839, "ext_mem_205839") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_202158,
                                   "mem_param_202158") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_202150,
                                   "mem_param_202150") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_205518, "ext_mem_205518") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_205519, "ext_mem_205519") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_202136,
                                   "mem_param_202136") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_202128,
                                   "mem_param_202128") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_202120,
                                   "mem_param_202120") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_205847, "ext_mem_205847") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_205848, "ext_mem_205848") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_205849, "ext_mem_205849") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            if (mem_205625_cached_sizze_206730 < (size_t) bytes_202107) {
                mem_205625 = realloc(mem_205625, bytes_202107);
                mem_205625_cached_sizze_206730 = bytes_202107;
            }
            if (mem_205646_cached_sizze_206731 < (size_t) bytes_205645) {
                mem_205646 = realloc(mem_205646, bytes_205645);
                mem_205646_cached_sizze_206731 = bytes_205645;
            }
            if (mem_205649_cached_sizze_206732 < (size_t) bytes_205645) {
                mem_205649 = realloc(mem_205649, bytes_205645);
                mem_205649_cached_sizze_206732 = bytes_205645;
            }
            if (mem_205652_cached_sizze_206733 < (size_t) bytes_205645) {
                mem_205652 = realloc(mem_205652, bytes_205645);
                mem_205652_cached_sizze_206733 = bytes_205645;
            }
            if (mem_205655_cached_sizze_206734 < (size_t) bytes_205645) {
                mem_205655 = realloc(mem_205655, bytes_205645);
                mem_205655_cached_sizze_206734 = bytes_205645;
            }
            if (mem_205658_cached_sizze_206735 < (size_t) bytes_205657) {
                mem_205658 = realloc(mem_205658, bytes_205657);
                mem_205658_cached_sizze_206735 = bytes_205657;
            }
            if (mem_205721_cached_sizze_206736 < (size_t) bytes_205657) {
                mem_205721 = realloc(mem_205721, bytes_205657);
                mem_205721_cached_sizze_206736 = bytes_205657;
            }
            for (int64_t i_200752 = 0; i_200752 < m_196691; i_200752++) {
                if (n_196692 * (int64_t) 4 > 0)
                    memmove(mem_205625 + i_200752 * n_196692 * (int64_t) 4,
                            mem_205537 + ((int64_t) 0 + i_200752 * n_196692) *
                            (int64_t) 4, n_196692 * (int64_t) 4);
                for (int32_t i_199786 = 0; i_199786 < iters_199778;
                     i_199786++) {
                    int32_t defunc_2_radix_sort_step_arg_199788 = mul32(2,
                                                                        i_199786);
                    int32_t defunc_0_get_bit_arg_199789 = add32(1,
                                                                defunc_2_radix_sort_step_arg_199788);
                    bool cond_f_res_199790 = defunc_0_get_bit_arg_199789 == 31;
                    bool cond_f_res_199791 =
                         defunc_2_radix_sort_step_arg_199788 == 31;
                    int64_t discard_200737;
                    int64_t discard_200738;
                    int64_t discard_200739;
                    int64_t discard_200740;
                    int64_t scanacc_200722;
                    int64_t scanacc_200723;
                    int64_t scanacc_200724;
                    int64_t scanacc_200725;
                    
                    scanacc_200722 = (int64_t) 0;
                    scanacc_200723 = (int64_t) 0;
                    scanacc_200724 = (int64_t) 0;
                    scanacc_200725 = (int64_t) 0;
                    for (int64_t i_200731 = 0; i_200731 < n_196692;
                         i_200731++) {
                        float x_199830;
                        
                        x_199830 = ((float *) mem_205625)[i_200752 * n_196692 +
                                                          i_200731];
                        
                        int32_t i32_arg_199831;
                        
                        i32_arg_199831 = futrts_to_bits32(x_199830);
                        
                        int32_t unsign_arg_199832 = ashr32(i32_arg_199831,
                                                           defunc_0_get_bit_arg_199789);
                        int32_t unsign_arg_199833 = 1 & unsign_arg_199832;
                        int32_t unsign_arg_199834 = ashr32(i32_arg_199831, 31);
                        int32_t unsign_arg_199835 = 1 & unsign_arg_199834;
                        bool cond_199836 = unsign_arg_199835 == 1;
                        bool x_199837 = !cond_199836;
                        bool y_199838 = cond_f_res_199790 && x_199837;
                        bool cond_199839 = cond_199836 || y_199838;
                        int32_t defunc_1_get_bit_res_199840;
                        
                        if (cond_199839) {
                            int32_t defunc_1_get_bit_res_t_res_199841 = 1 ^
                                    unsign_arg_199833;
                            
                            defunc_1_get_bit_res_199840 =
                                defunc_1_get_bit_res_t_res_199841;
                        } else {
                            defunc_1_get_bit_res_199840 = unsign_arg_199833;
                        }
                        
                        int32_t x_199842 = mul32(2,
                                                 defunc_1_get_bit_res_199840);
                        int32_t unsign_arg_199843 = ashr32(i32_arg_199831,
                                                           defunc_2_radix_sort_step_arg_199788);
                        int32_t unsign_arg_199844 = 1 & unsign_arg_199843;
                        bool y_199845 = cond_f_res_199791 && x_199837;
                        bool cond_199846 = cond_199836 || y_199845;
                        int32_t defunc_1_get_bit_res_199847;
                        
                        if (cond_199846) {
                            int32_t defunc_1_get_bit_res_t_res_199848 = 1 ^
                                    unsign_arg_199844;
                            
                            defunc_1_get_bit_res_199847 =
                                defunc_1_get_bit_res_t_res_199848;
                        } else {
                            defunc_1_get_bit_res_199847 = unsign_arg_199844;
                        }
                        
                        int32_t defunc_0_f_res_199849 = add32(x_199842,
                                                              defunc_1_get_bit_res_199847);
                        bool cond_199850 = defunc_0_f_res_199849 == 0;
                        int64_t defunc_0_f_res_199851 =
                                btoi_bool_i64(cond_199850);
                        int64_t defunc_0_f_res_199852;
                        int64_t defunc_0_f_res_199853;
                        int64_t defunc_0_f_res_199854;
                        
                        if (cond_199850) {
                            defunc_0_f_res_199852 = (int64_t) 0;
                            defunc_0_f_res_199853 = (int64_t) 0;
                            defunc_0_f_res_199854 = (int64_t) 0;
                        } else {
                            bool cond_199855 = defunc_0_f_res_199849 == 1;
                            int64_t defunc_0_f_res_f_res_199856 =
                                    btoi_bool_i64(cond_199855);
                            int64_t defunc_0_f_res_f_res_199857;
                            int64_t defunc_0_f_res_f_res_199858;
                            
                            if (cond_199855) {
                                defunc_0_f_res_f_res_199857 = (int64_t) 0;
                                defunc_0_f_res_f_res_199858 = (int64_t) 0;
                            } else {
                                bool cond_199859 = defunc_0_f_res_199849 == 2;
                                int64_t defunc_0_f_res_f_res_f_res_199860 =
                                        btoi_bool_i64(cond_199859);
                                bool cond_neg_199861 = !cond_199859;
                                int64_t defunc_0_f_res_f_res_f_res_199862 =
                                        btoi_bool_i64(cond_neg_199861);
                                
                                defunc_0_f_res_f_res_199857 =
                                    defunc_0_f_res_f_res_f_res_199860;
                                defunc_0_f_res_f_res_199858 =
                                    defunc_0_f_res_f_res_f_res_199862;
                            }
                            defunc_0_f_res_199852 = defunc_0_f_res_f_res_199856;
                            defunc_0_f_res_199853 = defunc_0_f_res_f_res_199857;
                            defunc_0_f_res_199854 = defunc_0_f_res_f_res_199858;
                        }
                        
                        int64_t defunc_1_op_res_199826 =
                                add64(defunc_0_f_res_199851, scanacc_200722);
                        int64_t defunc_1_op_res_199827 =
                                add64(defunc_0_f_res_199852, scanacc_200723);
                        int64_t defunc_1_op_res_199828 =
                                add64(defunc_0_f_res_199853, scanacc_200724);
                        int64_t defunc_1_op_res_199829 =
                                add64(defunc_0_f_res_199854, scanacc_200725);
                        
                        ((int64_t *) mem_205646)[i_200731] =
                            defunc_1_op_res_199826;
                        ((int64_t *) mem_205649)[i_200731] =
                            defunc_1_op_res_199827;
                        ((int64_t *) mem_205652)[i_200731] =
                            defunc_1_op_res_199828;
                        ((int64_t *) mem_205655)[i_200731] =
                            defunc_1_op_res_199829;
                        ((int32_t *) mem_205658)[i_200731] =
                            defunc_0_f_res_199849;
                        
                        int64_t scanacc_tmp_206637 = defunc_1_op_res_199826;
                        int64_t scanacc_tmp_206638 = defunc_1_op_res_199827;
                        int64_t scanacc_tmp_206639 = defunc_1_op_res_199828;
                        int64_t scanacc_tmp_206640 = defunc_1_op_res_199829;
                        
                        scanacc_200722 = scanacc_tmp_206637;
                        scanacc_200723 = scanacc_tmp_206638;
                        scanacc_200724 = scanacc_tmp_206639;
                        scanacc_200725 = scanacc_tmp_206640;
                    }
                    discard_200737 = scanacc_200722;
                    discard_200738 = scanacc_200723;
                    discard_200739 = scanacc_200724;
                    discard_200740 = scanacc_200725;
                    
                    int64_t last_res_199868;
                    
                    last_res_199868 = ((int64_t *) mem_205646)[i_196779];
                    
                    int64_t last_res_199869;
                    
                    last_res_199869 = ((int64_t *) mem_205649)[i_196779];
                    
                    int64_t last_res_199870;
                    
                    last_res_199870 = ((int64_t *) mem_205652)[i_196779];
                    if (n_196692 * (int64_t) 4 > 0)
                        memmove(mem_205721 + (int64_t) 0, mem_205625 +
                                ((int64_t) 0 + i_200752 * n_196692) *
                                (int64_t) 4, n_196692 * (int64_t) 4);
                    for (int64_t write_iter_200741 = 0; write_iter_200741 <
                         n_196692; write_iter_200741++) {
                        int32_t write_iv_200743;
                        
                        write_iv_200743 =
                            ((int32_t *) mem_205658)[write_iter_200741];
                        
                        int64_t write_iv_200744;
                        
                        write_iv_200744 =
                            ((int64_t *) mem_205646)[write_iter_200741];
                        
                        int64_t write_iv_200745;
                        
                        write_iv_200745 =
                            ((int64_t *) mem_205649)[write_iter_200741];
                        
                        int64_t write_iv_200746;
                        
                        write_iv_200746 =
                            ((int64_t *) mem_205652)[write_iter_200741];
                        
                        int64_t write_iv_200747;
                        
                        write_iv_200747 =
                            ((int64_t *) mem_205655)[write_iter_200741];
                        
                        bool match_lit_199879 = 0 == write_iv_200743;
                        int64_t defunc_1_f_res_199880;
                        
                        if (match_lit_199879) {
                            int64_t case_res_199881 = sub64(write_iv_200744,
                                                            (int64_t) 1);
                            
                            defunc_1_f_res_199880 = case_res_199881;
                        } else {
                            bool match_lit_199882 = 1 == write_iv_200743;
                            int64_t x_199883;
                            
                            if (match_lit_199882) {
                                int64_t x_199884 = add64(last_res_199868,
                                                         write_iv_200745);
                                int64_t case_res_199885 = sub64(x_199884,
                                                                (int64_t) 1);
                                
                                x_199883 = case_res_199885;
                            } else {
                                bool match_lit_199886 = 2 == write_iv_200743;
                                int64_t x_199887;
                                
                                if (match_lit_199886) {
                                    int64_t x_199888 = add64(last_res_199868,
                                                             last_res_199869);
                                    int64_t x_199889 = add64(x_199888,
                                                             write_iv_200746);
                                    int64_t case_res_199890 = sub64(x_199889,
                                                                    (int64_t) 1);
                                    
                                    x_199887 = case_res_199890;
                                } else {
                                    int64_t x_199891 = add64(last_res_199868,
                                                             last_res_199869);
                                    int64_t x_199892 = add64(last_res_199870,
                                                             x_199891);
                                    int64_t x_199893 = add64(x_199892,
                                                             write_iv_200747);
                                    int64_t defunc_1_f_res_res_199894 =
                                            sub64(x_199893, (int64_t) 1);
                                    
                                    x_199887 = defunc_1_f_res_res_199894;
                                }
                                x_199883 = x_199887;
                            }
                            defunc_1_f_res_199880 = x_199883;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_199880) &&
                            slt64(defunc_1_f_res_199880, n_196692)) {
                            if ((int64_t) 4 > 0)
                                memmove(mem_205721 + defunc_1_f_res_199880 *
                                        (int64_t) 4, mem_205625 + ((int64_t) 0 +
                                                                   i_200752 *
                                                                   n_196692 +
                                                                   (int64_t) 1 *
                                                                   write_iter_200741) *
                                        (int64_t) 4, (int64_t) 4);
                        }
                    }
                    if (n_196692 * (int64_t) 4 > 0)
                        memmove(mem_205625 + i_200752 * n_196692 * (int64_t) 4,
                                mem_205721 + (int64_t) 0, n_196692 *
                                (int64_t) 4);
                }
            }
            
            bool empty_slice_199896 = j_m_i_197246 == (int64_t) 0;
            int64_t m_199897 = sub64(j_m_i_197246, (int64_t) 1);
            int64_t i_p_m_t_s_199898 = add64(stl_res_196773, m_199897);
            bool zzero_leq_i_p_m_t_s_199899 = sle64((int64_t) 0,
                                                    i_p_m_t_s_199898);
            bool i_p_m_t_s_leq_w_199900 = slt64(i_p_m_t_s_199898, n_196692);
            bool zzero_lte_i_199901 = sle64((int64_t) 0, stl_res_196773);
            bool i_lte_j_199902 = sle64(stl_res_196773, stl_res_196774);
            bool y_199903 = i_p_m_t_s_leq_w_199900 && zzero_lte_i_199901;
            bool y_199904 = zzero_leq_i_p_m_t_s_199899 && y_199903;
            bool y_199905 = i_lte_j_199902 && y_199904;
            bool forwards_ok_199906 = zzero_lte_i_199901 && y_199905;
            bool ok_or_empty_199907 = empty_slice_199896 || forwards_ok_199906;
            bool index_certs_199908;
            
            if (!ok_or_empty_199907) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) stl_res_196773, ":",
                              (long long) stl_res_196774,
                              "] out of bounds for array of shape [",
                              (long long) n_196692, "].",
                              "-> #0  stl.fut:344:33-51\n   #1  stl.fut:342:13-349:28\n   #2  stl.fut:401:3-415:29\n   #3  stl.fut:385:1-415:29\n");
                if (memblock_unref(ctx, &ext_mem_205839, "ext_mem_205839") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_202158,
                                   "mem_param_202158") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_202150,
                                   "mem_param_202150") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_205518, "ext_mem_205518") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_205519, "ext_mem_205519") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_202136,
                                   "mem_param_202136") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_202128,
                                   "mem_param_202128") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_202120,
                                   "mem_param_202120") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_205847, "ext_mem_205847") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_205848, "ext_mem_205848") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_205849, "ext_mem_205849") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t binop_y_205750 = (int64_t) 4 * m_196691;
            int64_t bytes_205751 = smax64((int64_t) 0, binop_y_205750);
            
            if (mem_205752_cached_sizze_206737 < (size_t) bytes_205751) {
                mem_205752 = realloc(mem_205752, bytes_205751);
                mem_205752_cached_sizze_206737 = bytes_205751;
            }
            if (mem_205755_cached_sizze_206738 < (size_t) bytes_205751) {
                mem_205755 = realloc(mem_205755, bytes_205751);
                mem_205755_cached_sizze_206738 = bytes_205751;
            }
            if (mem_205758_cached_sizze_206739 < (size_t) bytes_205751) {
                mem_205758 = realloc(mem_205758, bytes_205751);
                mem_205758_cached_sizze_206739 = bytes_205751;
            }
            for (int64_t i_200762 = 0; i_200762 < m_196691; i_200762++) {
                float defunc_2_reduce_res_199914;
                float redout_200754 = 0.0F;
                
                for (int64_t i_200755 = 0; i_200755 < j_m_i_197246;
                     i_200755++) {
                    int64_t slice_200782 = stl_res_196773 + i_200755;
                    float x_199918;
                    
                    x_199918 = ((float *) mem_205625)[i_200762 * n_196692 +
                                                      slice_200782];
                    
                    float defunc_1_op_res_199917 = x_199918 + redout_200754;
                    float redout_tmp_206650 = defunc_1_op_res_199917;
                    
                    redout_200754 = redout_tmp_206650;
                }
                defunc_2_reduce_res_199914 = redout_200754;
                
                float h_199919 = 3.0F * defunc_2_reduce_res_199914;
                float h9_199920 = 0.999F * h_199919;
                float h1_199921 = 1.0e-3F * h_199919;
                
                ((float *) mem_205752)[i_200762] = h_199919;
                ((float *) mem_205755)[i_200762] = h9_199920;
                ((float *) mem_205758)[i_200762] = h1_199921;
            }
            
            struct memblock mem_205798;
            
            mem_205798.references = NULL;
            if (memblock_alloc(ctx, &mem_205798, bytes_202107, "mem_205798")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_200772 = 0; i_200772 < m_196691; i_200772++) {
                float x_199927;
                
                x_199927 = ((float *) mem_205752)[i_200772];
                
                float x_199928;
                
                x_199928 = ((float *) mem_205755)[i_200772];
                
                float x_199929;
                
                x_199929 = ((float *) mem_205758)[i_200772];
                for (int64_t i_200768 = 0; i_200768 < n_196692; i_200768++) {
                    float x_199931;
                    
                    x_199931 = ((float *) mem_205541)[i_200772 * n_196692 +
                                                      i_200768];
                    
                    float x_199932 = x_199931 / x_199927;
                    float y_199933 = fpow32(x_199932, 2.0F);
                    float x_199934 = 1.0F - y_199933;
                    float bicube_199935 = fpow32(x_199934, 2.0F);
                    bool isnan_res_199936;
                    
                    isnan_res_199936 = futrts_isnan32(x_199931);
                    
                    bool cond_f_res_199937 = x_199931 <= x_199929;
                    bool x_199938 = !isnan_res_199936;
                    bool y_199939 = cond_f_res_199937 && x_199938;
                    bool cond_199940 = isnan_res_199936 || y_199939;
                    float defunc_0_f_res_199941;
                    
                    if (cond_199940) {
                        defunc_0_f_res_199941 = 1.0F;
                    } else {
                        bool cond_199942 = x_199928 <= x_199931;
                        bool cond_f_res_199943 = x_199931 <= 1.0e-6F;
                        bool x_199944 = !cond_199942;
                        bool y_199945 = cond_f_res_199943 && x_199944;
                        bool cond_199946 = cond_199942 || y_199945;
                        float defunc_0_f_res_f_res_199947;
                        
                        if (cond_199946) {
                            defunc_0_f_res_f_res_199947 = 1.0e-6F;
                        } else {
                            defunc_0_f_res_f_res_199947 = bicube_199935;
                        }
                        defunc_0_f_res_199941 = defunc_0_f_res_f_res_199947;
                    }
                    ((float *) mem_205798.mem)[i_200772 * n_196692 + i_200768] =
                        defunc_0_f_res_199941;
                }
            }
            if (memblock_set(ctx, &ext_mem_205839, &mem_205798, "mem_205798") !=
                0)
                return 1;
            if (memblock_unref(ctx, &mem_205798, "mem_205798") != 0)
                return 1;
        } else {
            if (memblock_set(ctx, &ext_mem_205839, &mem_param_202136,
                             "mem_param_202136") != 0)
                return 1;
        }
        
        int64_t ctx_param_ext_tmp_206369 = ext_205525;
        int64_t ctx_param_ext_tmp_206370 = ext_205523;
        int64_t ctx_param_ext_tmp_206371 = ext_205844;
        int64_t ctx_param_ext_tmp_206372 = ext_205843;
        int64_t ctx_param_ext_tmp_206373 = ext_205840;
        int64_t ctx_param_ext_tmp_206374 = ext_205842;
        int64_t ctx_param_ext_tmp_206375 = ext_205846;
        int64_t ctx_param_ext_tmp_206376 = ext_205841;
        int64_t ctx_param_ext_tmp_206377 = ext_205845;
        struct memblock mem_param_tmp_206378;
        
        mem_param_tmp_206378.references = NULL;
        if (memblock_set(ctx, &mem_param_tmp_206378, &ext_mem_205519,
                         "ext_mem_205519") != 0)
            return 1;
        
        struct memblock mem_param_tmp_206379;
        
        mem_param_tmp_206379.references = NULL;
        if (memblock_set(ctx, &mem_param_tmp_206379, &ext_mem_205518,
                         "ext_mem_205518") != 0)
            return 1;
        
        struct memblock mem_param_tmp_206380;
        
        mem_param_tmp_206380.references = NULL;
        if (memblock_set(ctx, &mem_param_tmp_206380, &ext_mem_205839,
                         "ext_mem_205839") != 0)
            return 1;
        ctx_param_ext_202122 = ctx_param_ext_tmp_206369;
        ctx_param_ext_202124 = ctx_param_ext_tmp_206370;
        ctx_param_ext_202129 = ctx_param_ext_tmp_206371;
        ctx_param_ext_202130 = ctx_param_ext_tmp_206372;
        ctx_param_ext_202131 = ctx_param_ext_tmp_206373;
        ctx_param_ext_202132 = ctx_param_ext_tmp_206374;
        ctx_param_ext_202133 = ctx_param_ext_tmp_206375;
        ctx_param_ext_202134 = ctx_param_ext_tmp_206376;
        ctx_param_ext_202135 = ctx_param_ext_tmp_206377;
        if (memblock_set(ctx, &mem_param_202120, &mem_param_tmp_206378,
                         "mem_param_tmp_206378") != 0)
            return 1;
        if (memblock_set(ctx, &mem_param_202128, &mem_param_tmp_206379,
                         "mem_param_tmp_206379") != 0)
            return 1;
        if (memblock_set(ctx, &mem_param_202136, &mem_param_tmp_206380,
                         "mem_param_tmp_206380") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_tmp_206380,
                           "mem_param_tmp_206380") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_tmp_206379,
                           "mem_param_tmp_206379") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_tmp_206378,
                           "mem_param_tmp_206378") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_205839, "ext_mem_205839") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_202158, "mem_param_202158") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_202150, "mem_param_202150") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_205518, "ext_mem_205518") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_205519, "ext_mem_205519") != 0)
            return 1;
    }
    ext_205862 = ctx_param_ext_202122;
    ext_205860 = ctx_param_ext_202124;
    ext_205856 = ctx_param_ext_202129;
    ext_205855 = ctx_param_ext_202130;
    ext_205854 = ctx_param_ext_202131;
    ext_205853 = ctx_param_ext_202132;
    ext_205852 = ctx_param_ext_202133;
    ext_205851 = ctx_param_ext_202134;
    ext_205850 = ctx_param_ext_202135;
    if (memblock_set(ctx, &ext_mem_205849, &mem_param_202120,
                     "mem_param_202120") != 0)
        return 1;
    if (memblock_set(ctx, &ext_mem_205848, &mem_param_202128,
                     "mem_param_202128") != 0)
        return 1;
    if (memblock_set(ctx, &ext_mem_205847, &mem_param_202136,
                     "mem_param_202136") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
        return 1;
    if (mem_205874_cached_sizze_206740 < (size_t) bytes_202107) {
        mem_205874 = realloc(mem_205874, bytes_202107);
        mem_205874_cached_sizze_206740 = bytes_202107;
    }
    for (int64_t i_200780 = 0; i_200780 < m_196691; i_200780++) {
        for (int64_t i_200776 = 0; i_200776 < n_196692; i_200776++) {
            float x_199954;
            
            x_199954 = ((float *) Y_mem_201382.mem)[i_200780 * n_196692 +
                                                    i_200776];
            
            float x_199955;
            
            x_199955 = ((float *) ext_mem_205849.mem)[i_200780 * n_196692 +
                                                      i_200776];
            
            float x_199956;
            
            x_199956 = ((float *) ext_mem_205848.mem)[i_200780 * ext_205860 +
                                                      i_200776];
            
            float x_199957 = x_199954 - x_199955;
            float defunc_2_f_res_199958 = x_199957 - x_199956;
            
            ((float *) mem_205874)[i_200780 * n_196692 + i_200776] =
                defunc_2_f_res_199958;
        }
    }
    
    struct memblock mem_205918;
    
    mem_205918.references = NULL;
    if (memblock_alloc(ctx, &mem_205918, bytes_202107, "mem_205918")) {
        err = 1;
        goto cleanup;
    }
    if (m_196691 * n_196692 * (int64_t) 4 > 0)
        memmove(mem_205918.mem + (int64_t) 0, ext_mem_205849.mem + (int64_t) 0,
                m_196691 * n_196692 * (int64_t) 4);
    if (memblock_unref(ctx, &ext_mem_205849, "ext_mem_205849") != 0)
        return 1;
    
    struct memblock mem_205923;
    
    mem_205923.references = NULL;
    if (memblock_alloc(ctx, &mem_205923, bytes_202107, "mem_205923")) {
        err = 1;
        goto cleanup;
    }
    if (m_196691 * n_196692 * (int64_t) 4 > 0)
        memmove(mem_205923.mem + (int64_t) 0, ext_mem_205848.mem + (int64_t) 0,
                m_196691 * n_196692 * (int64_t) 4);
    if (memblock_unref(ctx, &ext_mem_205848, "ext_mem_205848") != 0)
        return 1;
    
    struct memblock mem_205928;
    
    mem_205928.references = NULL;
    if (memblock_alloc(ctx, &mem_205928, bytes_202107, "mem_205928")) {
        err = 1;
        goto cleanup;
    }
    if (m_196691 * n_196692 * (int64_t) 4 > 0)
        memmove(mem_205928.mem + (int64_t) 0, mem_205874 + (int64_t) 0,
                m_196691 * n_196692 * (int64_t) 4);
    if (memblock_set(ctx, &mem_out_206307, &mem_205918, "mem_205918") != 0)
        return 1;
    if (memblock_set(ctx, &mem_out_206308, &mem_205923, "mem_205923") != 0)
        return 1;
    if (memblock_set(ctx, &mem_out_206309, &mem_205928, "mem_205928") != 0)
        return 1;
    (*mem_out_p_206655).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_206655, &mem_out_206307,
                     "mem_out_206307") != 0)
        return 1;
    (*mem_out_p_206656).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_206656, &mem_out_206308,
                     "mem_out_206308") != 0)
        return 1;
    (*mem_out_p_206657).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_206657, &mem_out_206309,
                     "mem_out_206309") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_205928, "mem_205928") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_205923, "mem_205923") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_205918, "mem_205918") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_param_202136, "mem_param_202136") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_param_202128, "mem_param_202128") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_param_202120, "mem_param_202120") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_205847, "ext_mem_205847") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_205848, "ext_mem_205848") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_205849, "ext_mem_205849") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_202112, "mem_202112") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_202108, "mem_202108") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_206309, "mem_out_206309") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_206308, "mem_out_206308") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_206307, "mem_out_206307") != 0)
        return 1;
    
  cleanup:
    { }
    free(mem_201386);
    free(mem_201389);
    free(mem_201409);
    free(mem_201424);
    free(mem_201461);
    free(mem_201553);
    free(mem_201557);
    free(mem_201610);
    free(mem_201625);
    free(mem_201704);
    free(mem_201709);
    free(mem_201770);
    free(mem_201902);
    free(mem_201906);
    free(mem_201929);
    free(mem_202005);
    free(mem_202009);
    free(mem_202032);
    free(mem_202162);
    free(mem_202207);
    free(mem_202212);
    free(mem_202956);
    free(mem_203115);
    free(mem_203118);
    free(mem_203329);
    free(mem_203332);
    free(mem_203359);
    free(mem_203362);
    free(mem_203637);
    free(mem_203680);
    free(mem_203696);
    free(mem_203709);
    free(mem_203732);
    free(mem_203748);
    free(mem_203761);
    free(mem_203784);
    free(mem_203800);
    free(mem_203813);
    free(mem_204121);
    free(mem_204205);
    free(mem_204208);
    free(mem_204323);
    free(mem_204326);
    free(mem_204353);
    free(mem_204356);
    free(mem_204583);
    free(mem_204598);
    free(mem_204601);
    free(mem_204686);
    free(mem_204701);
    free(mem_204704);
    free(mem_204819);
    free(mem_204834);
    free(mem_204837);
    free(mem_204974);
    free(mem_204989);
    free(mem_204992);
    free(mem_205030);
    free(mem_205092);
    free(mem_205107);
    free(mem_205110);
    free(mem_205159);
    free(mem_205162);
    free(mem_205255);
    free(mem_205270);
    free(mem_205273);
    free(mem_205322);
    free(mem_205325);
    free(mem_205352);
    free(mem_205355);
    free(mem_205537);
    free(mem_205541);
    free(mem_205625);
    free(mem_205646);
    free(mem_205649);
    free(mem_205652);
    free(mem_205655);
    free(mem_205658);
    free(mem_205721);
    free(mem_205752);
    free(mem_205755);
    free(mem_205758);
    free(mem_205874);
    return err;
}

int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f32_2d **out0,
                       struct futhark_f32_2d **out1,
                       struct futhark_f32_2d **out2, const
                       struct futhark_f32_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5, const int64_t in6, const int64_t in7, const
                       int64_t in8, const int64_t in9, const int64_t in10, const
                       int64_t in11, const int64_t in12, const int64_t in13,
                       const int64_t in14)
{
    struct memblock Y_mem_201382;
    
    Y_mem_201382.references = NULL;
    
    int64_t m_196691;
    int64_t n_196692;
    int64_t n_p_196694;
    int64_t q_s_196695;
    int64_t q_t_196696;
    int64_t q_l_196697;
    int64_t d_s_196698;
    int64_t d_t_196699;
    int64_t d_l_196700;
    int64_t jump_s_196701;
    int64_t jump_t_196702;
    int64_t jump_l_196703;
    int64_t n_inner_196704;
    int64_t n_outer_196705;
    int64_t jump_threshold_196706;
    int64_t q_threshold_196707;
    struct memblock mem_out_206307;
    
    mem_out_206307.references = NULL;
    
    struct memblock mem_out_206308;
    
    mem_out_206308.references = NULL;
    
    struct memblock mem_out_206309;
    
    mem_out_206309.references = NULL;
    
    int ret = 0;
    
    lock_lock(&ctx->lock);
    Y_mem_201382 = in0->mem;
    m_196691 = in0->shape[0];
    n_196692 = in0->shape[1];
    n_p_196694 = in1;
    q_s_196695 = in2;
    q_t_196696 = in3;
    q_l_196697 = in4;
    d_s_196698 = in5;
    d_t_196699 = in6;
    d_l_196700 = in7;
    jump_s_196701 = in8;
    jump_t_196702 = in9;
    jump_l_196703 = in10;
    n_inner_196704 = in11;
    n_outer_196705 = in12;
    jump_threshold_196706 = in13;
    q_threshold_196707 = in14;
    if (!(m_196691 == in0->shape[0] && n_196692 == in0->shape[1])) {
        ret = 1;
        if (!ctx->error)
            ctx->error =
                msgprintf("Error: entry point arguments have invalid sizes.\n");
    }
    if (ret == 0) {
        ret = futrts_entry_main(ctx, &mem_out_206307, &mem_out_206308,
                                &mem_out_206309, Y_mem_201382, m_196691,
                                n_196692, n_p_196694, q_s_196695, q_t_196696,
                                q_l_196697, d_s_196698, d_t_196699, d_l_196700,
                                jump_s_196701, jump_t_196702, jump_l_196703,
                                n_inner_196704, n_outer_196705,
                                jump_threshold_196706, q_threshold_196707);
        if (ret == 0) {
            assert((*out0 =
                    (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d))) !=
                NULL);
            (*out0)->mem = mem_out_206307;
            (*out0)->shape[0] = m_196691;
            (*out0)->shape[1] = n_196692;
            assert((*out1 =
                    (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d))) !=
                NULL);
            (*out1)->mem = mem_out_206308;
            (*out1)->shape[0] = m_196691;
            (*out1)->shape[1] = n_196692;
            assert((*out2 =
                    (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d))) !=
                NULL);
            (*out2)->mem = mem_out_206309;
            (*out2)->shape[0] = m_196691;
            (*out2)->shape[1] = n_196692;
        }
    }
    lock_unlock(&ctx->lock);
    return ret;
}
  
